<!--
{% comment %}
Licensed to the Apache Software Foundation (ASF) under one or more
contributor license agreements.  See the NOTICE file distributed with
this work for additional information regarding copyright ownership.
The ASF licenses this file to you under the Apache License, Version 2.0
(the "License"); you may not use this file except in compliance with
the License.  You may obtain a copy of the License at

http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
{% end comment %}
-->

# Apache SystemDS

**Overview:** Apache SystemDS is an open-source machine learning (ML) system for the end-to-end 
data science lifecycle from data preparation and cleaning, over efficient ML model training, 
to debugging and serving. ML algorithms or pipelines are specified in a high-level language 
with R-like syntax or related Python and Java APIs (with many builtin primitives), and the 
system automatically generates hybrid runtime plans of local, in-memory operations and distributed
operations on Apache Spark. Additional backends exist for GPUs and federated learning. 

Resource | Links
---------|------
**Quick Start** | [Install, Quick Start and Hello World](https://apache.github.io/systemds/site/install.html)
**Documentation:** | [SystemDS Documentation](https://apache.github.io/systemds/)
**Python Documentation** | [Python SystemDS Documentation](https://apache.github.io/systemds/api/python/index.html)
**Issue Tracker** | [Jira Dashboard](https://issues.apache.org/jira/secure/Dashboard.jspa?selectPageId=12335852)


**Status and Build:** SystemDS is renamed from SystemML which is an **Apache Top Level Project**.
To build from source visit [SystemDS Install from source](https://apache.github.io/systemds/site/install.html)

[![Build](https://github.com/apache/systemds/actions/workflows/build.yml/badge.svg?branch=main)](https://github.com/apache/systemds/actions/workflows/build.yml)
[![Documentation](https://github.com/apache/systemds/actions/workflows/documentation.yml/badge.svg?branch=main)](https://github.com/apache/systemds/actions/workflows/documentation.yml)
[![LicenseCheck](https://github.com/apache/systemds/actions/workflows/license.yml/badge.svg?branch=main)](https://github.com/apache/systemds/actions/workflows/license.yml)
[![Java Tests](https://github.com/apache/systemds/actions/workflows/javaTests.yml/badge.svg?branch=main)](https://github.com/apache/systemds/actions/workflows/javaTests.yml)
[![codecov](https://codecov.io/gh/apache/systemds/graph/badge.svg?token=4YfvX8s6Dz)](https://codecov.io/gh/apache/systemds)
[![Python Test](https://github.com/apache/systemds/actions/workflows/python.yml/badge.svg?branch=main)](https://github.com/apache/systemds/actions/workflows/python.yml)
[![Total PyPI downloads](https://static.pepy.tech/personalized-badge/systemds?units=abbreviation&period=total&left_color=grey&right_color=blue&left_text=Total%20PyPI%20Downloads)](https://pepy.tech/project/systemds)
[![Monthly PyPI downloads](https://static.pepy.tech/personalized-badge/systemds?units=abbreviation&left_color=grey&right_color=blue&left_text=Monthly%20PyPI%20Downloads)](https://pepy.tech/project/systemds)

<!--
{% comment %}
Licensed to the Apache Software Foundation (ASF) under one or more
contributor license agreements.  See the NOTICE file distributed with
this work for additional information regarding copyright ownership.
The ASF licenses this file to you under the Apache License, Version 2.0
(the "License"); you may not use this file except in compliance with
the License.  You may obtain a copy of the License at

http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
{% end comment %}
-->

# Docker guide

To use docker and systemDS there are two options.
The first is to build your own docker image.
The other option is to download the already build image from docker.

## Build

To Build the docker image simply run the build script.

```bash
./docker/build.sh
```

Afterwards you should have a local image with the id `apache/systemds:latest`.
To execute any given DML script follow the step Run.

## Run

Running SystemDS in a docker container is as simple as constructing any DML script.
Then download the docker image `apache/systemds:latest` or build your own.

```bash
docker pull apache/systemds:latest
```

Verify that the docker image correctly works simply by running it.

```bash
docker run --rm apache/systemds:latest
```

It should respond with something like:

```txt
Hello, World!
SystemDS Statistics:
Total execution time:  0.010 sec.
```

To run specific scripts mount a folder(s) containing the scripts and data,
and execute the script inside the folder using the docker container.

You can mount any such folder and execute systemds by changing the first part of the -v argument of the following command:

```bash
docker run \
  -v $(pwd)/docker/mountFolder:/input \
  --rm apache/systemds:latest
```

Default behavior is to run the script located at /input/main.dml.
To run any other script use:

```bash
docker run \
  -v $(pwd)/folder/to/share:/any/path/in/docker/instance \
  --rm apache/systemds:latest \
  systemds /any/path/to/a/script.dml
```

### Docker run worker node

To run a federated worker in a docker container simply use:

```bash
docker run -p 8000:8000 --rm apache/systemds:latest systemds WORKER 8000
```

This port forwards the worker to port 8000 on the host and starts a worker in the instance on port 8000.

Note that the worker does not have any data, since no data is mounted in the worker image.
To add a folder containing the data needed in the worker do the following:

```bash
docker run \
  -p 8000:8000 \
  -v $(pwd)/data/folder/path/locally:/data/folder/path/in/container \
  --rm apache/systemds:latest systemds WORKER 8000
```

### Docker run python script

To run a python script the `pythonsysds` image is used.

```bash
docker run --rm apache/systemds:python-nightly
```

User provided scripts have to be mounted into the image.

```bash
docker run \
  -v $(pwd)/data/folder/path/locally:/data/folder/path/in/container \
  --rm apache/systemds:latest \
  python3 path/to/script/to/execute.py
```

## Testing image

We also have a docker image for execution of tests.
This enables faster test execution on the github actions.
To build this image simply run the same command as above.

```bash
./docker/build.sh
```

Because the github action pulls the image from docker hub the image has to be pushed to docker hub to produce any change in the behavior of the testing.

```bash
docker push apache/systemds:testing-latest
```

For each of the tests that require R, this image is simply used, because it skips the installation of the R packages, since they are installed in this image.

Test your testing image locally by running the following command:

```bash
docker run \
  -v $(pwd):/github/workspace \
  -v $HOME/.m2/repository:/root/.m2/repository \
  apache/systemds:testing-latest \
  org.apache.sysds.test.component.**
```

<!--
{% comment %}
Licensed to the Apache Software Foundation (ASF) under one or more
contributor license agreements.  See the NOTICE file distributed with
this work for additional information regarding copyright ownership.
The ASF licenses this file to you under the Apache License, Version 2.0
(the "License"); you may not use this file except in compliance with
the License.  You may obtain a copy of the License at

http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
{% endcomment %}
-->

## Administrator setup


### With [`Cloud Shell`](https://console.aws.amazon.com/cloudshell/home):

Assumed variables,

| Name | Value |
| --- | --- |
| `UserName` | `systemds-bot` |
| `GroupName` | `systemds-group` |

#### 1. Create a user and a group

Create a user and a group, and join user to the created group.

[`create-user`](https://awscli.amazonaws.com/v2/documentation/api/latest/reference/iam/create-user.html)
```sh
[cloudshell-user@host ~]$ aws iam create-user --user-name systemds-bot
{
    "User": {
        "Path": "/",
        "UserName": "systemds-bot",
        "UserId": "AIDAQSHHX7DDAODFXYZ3",
        "Arn": "arn:aws:iam::12345:user/systemds-bot",
        "CreateDate": "2021-04-10T20:36:59+00:00"
    }
}
```

[`create-group`](https://awscli.amazonaws.com/v2/documentation/api/latest/reference/iam/create-group.html)

```sh
[cloudshell-user@host ~]$aws iam create-group --group-name systemds-group
{
    "Group": {
        "Path": "/",
        "GroupName": "systemds-group",
        "GroupId": "AGPAQSHHX7DDB3XYZABCW",
        "Arn": "arn:aws:iam::12345:group/systemds-group",
        "CreateDate": "2021-04-10T20:41:58+00:00"
    }
}
```

#### 2. Attach roles to the group

[`attach-group-policy`](https://awscli.amazonaws.com/v2/documentation/api/latest/reference/iam/attach-group-policy.html)

```sh
aws iam attach-group-policy --policy-arn arn:aws:iam::aws:policy/service-role/AmazonElasticMapReduceRole --group-name systemds-group
aws iam attach-group-policy --policy-arn arn:aws:iam::aws:policy/service-role/AmazonElasticMapReduceforEC2Role --group-name systemds-group
aws iam attach-group-policy --policy-arn arn:aws:iam::aws:policy/AmazonElasticMapReduceFullAccess --group-name systemds-group
aws iam attach-group-policy --policy-arn arn:aws:iam::aws:policy/AWSKeyManagementServicePowerUser --group-name systemds-group
aws iam attach-group-policy --policy-arn arn:aws:iam::aws:policy/IAMUserSSHKeys --group-name systemds-group

# Grant cloud shell access too.
aws iam attach-group-policy --policy-arn arn:aws:iam::aws:policy/AWSCloudShellFullAccess --group-name systemds-group

# To create EC2 keys
aws iam attach-group-policy --policy-arn arn:aws:iam::aws:policy/AmazonEC2FullAccess --group-name systemds-group
```

#### 3. Add user to the group

```sh
aws iam add-user-to-group --user-name systemds-bot --group-name systemds-group
```

#### 4. Create the login-profile with credentials

```sh
$ aws iam create-login-profile --generate-cli-skeleton > login-profile.json
```

`login-profile.json` contains

```json
{
    "LoginProfile": {
        "UserName": "",
        "Password": "",
        "PasswordResetRequired": false
    }
}
```

Create the credentials manually by editing `login-profile.json`.

| Name | Value |
| --- | --- |
| `UserName` | `systemds-bot` |
| `Password` | For example, `9U*tYP` |
| `PasswordResetRequired` | `false` |

Now, create the login profile.

```sh
aws iam create-login-profile --cli-input-json file://login-profile.json
```

---
### With [`AWS CLI`](https://docs.aws.amazon.com/cli/latest/userguide/install-cliv2.html):

1. Create aws account / use your existing aws account

2. Install `aws-cli` specific to your Operating System.

3. Create a user
    
    * Create a new user (https://console.aws.amazon.com/iam/home?#/users)

    * Create new group and add the following policies to it:
         
         - AmazonElasticMapReduceRole
         
         - AmazonElasticMapReduceforEC2Role
         
         - AdministratorAccess
         
         - AmazonElasticMapReduceFullAccess
         
         - AWSKeyManagementServicePowerUser
         
         - IAMUserSSHKeys 

4. Configure your aws-cli (https://docs.aws.amazon.com/cli/latest/userguide/cli-chap-configure.html#cli-quick-configuration)

## User Setup

5. Spin up an EMR cluster with SystemDS
    
    * Put your SystemDS artifacts (dml-scripts, jars, config-file) in the directory systemds 
    
    * Edit configuration in: systemds_cluster.config
    
    * Run: ./spinup_systemds_cluster.sh
    
6. Run a SystemDS script
    
    * Run: ./run_systemds_script.sh path/to/script.dml 
         With args: ./run_systemds_script.sh path/to/script.dml "1.0, 2.6"  
    
7. Terminate the EMR cluster: ./terminate_systemds_cluster.sh
    
#### Further work

* Finetune the memory 
    
    https://aws.amazon.com/blogs/big-data/best-practices-for-successfully-managing-memory-for-apache-spark-applications-on-amazon-emr/
    https://docs.aws.amazon.com/emr/latest/ReleaseGuide/emr-spark-configure.html#spark-defaults
* Test if Scale to 100 nodes

* Make the cluster WebUIs (Ganglia, SparkUI,..) accessible from outside

* Integrate spot up instances 

<!--
{% comment %}
Licensed to the Apache Software Foundation (ASF) under one or more
contributor license agreements.  See the NOTICE file distributed with
this work for additional information regarding copyright ownership.
The ASF licenses this file to you under the Apache License, Version 2.0
(the "License"); you may not use this file except in compliance with
the License.  You may obtain a copy of the License at

http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
{% endcomment %}
-->

# SystemDS-NN

This folder contains different primitives for neural network training, and predictions.
## Neural net for regression with vanilla SGD:

```R
# Imports
source("nn/layers/affine.dml") as affine
source("nn/layers/l2_loss.dml") as l2_loss
source("nn/layers/relu.dml") as relu
source("nn/optim/sgd.dml") as sgd

# Generate input data
N = 1024 # num examples
D = 100 # num features
t = 1 # num targets
X = rand(rows=N, cols=D, pdf="normal")
y = rand(rows=N, cols=t)

# Create 2-layer network:
## affine1 -> relu1 -> affine2
M = 64 # number of neurons
[W1, b1] = affine::init(D, M, -1)
[W2, b2] = affine::init(M, t, -1)

# Initialize optimizer
lr = 0.05  # learning rate
mu = 0.9  # momentum
decay = 0.99  # learning rate decay constant

# Optimize
print("Starting optimization")
batch_size = 32
epochs = 5
iters = 1024 / batch_size
for (e in 1:epochs) {
  for(i in 1:iters) {
    # Get next batch
    X_batch = X[i:i+batch_size-1,]
    y_batch = y[i:i+batch_size-1,]

    # Compute forward pass
    out1 = affine::forward(X_batch, W1, b1)
    outr1 = relu::forward(out1)
    out2 = affine::forward(outr1, W2, b2)

    # Compute loss
    loss = l2_loss::forward(out2, y_batch)
    print("L2 loss: " + loss)

    # Compute backward pass
    dout2 = l2_loss::backward(out2, y_batch)
    [doutr1, dW2, db2] = affine::backward(dout2, outr1, W2, b2)
    dout1 = relu::backward(doutr1, out1)
    [dX_batch, dW1, db1] = affine::backward(dout1, X_batch, W1, b1)

    # Optimize with vanilla SGD
    W1 = sgd::update(W1, dW1, lr)
    b1 = sgd::update(b1, db1, lr)
    W2 = sgd::update(W2, dW2, lr)
    b2 = sgd::update(b2, db2, lr)
  }
  # Decay learning rate
  lr = lr * decay
}
```

## Neural net for multi-class classification with dropout and SGD w/ Nesterov momentum

```R
# Imports
source("nn/layers/affine.dml") as affine
source("nn/layers/cross_entropy_loss.dml") as cross_entropy_loss
source("nn/layers/dropout.dml") as dropout
source("nn/layers/relu.dml") as relu
source("nn/layers/softmax.dml") as softmax
source("nn/optim/sgd_nesterov.dml") as sgd_nesterov

# Generate input data
N = 1024 # num examples
D = 100 # num features
t = 5 # num targets
X = rand(rows=N, cols=D, pdf="normal")
classes = round(rand(rows=N, cols=1, min=1, max=t, pdf="uniform"))
y = matrix(0, rows=N, cols=t)
parfor (i in 1:N) {
  y[i, as.scalar(classes[i,1])] = 1  # one-hot encoding
}

# Create network:
# affine1 -> relu1 -> dropout1 -> affine2 -> relu2 -> dropout2 -> affine3 -> softmax
H1 = 64 # number of neurons in 1st hidden layer
H2 = 64 # number of neurons in 2nd hidden layer
p = 0.5  # dropout probability
[W1, b1] = affine::init(D, H1, -1)
[W2, b2] = affine::init(H1, H2, -1)
[W3, b3] = affine::init(H2, t, -1)

# Initialize SGD w/ Nesterov momentum optimizer
lr = 0.05  # learning rate
mu = 0.5  # momentum
decay = 0.99  # learning rate decay constant
vW1 = sgd_nesterov::init(W1); vb1 = sgd_nesterov::init(b1)
vW2 = sgd_nesterov::init(W2); vb2 = sgd_nesterov::init(b2)
vW3 = sgd_nesterov::init(W3); vb3 = sgd_nesterov::init(b3)

# Optimize
print("Starting optimization")
batch_size = 64
epochs = 10
iters = 1024 / batch_size
for (e in 1:epochs) {
  for(i in 1:iters) {
    # Get next batch
    X_batch = X[i:i+batch_size-1,]
    y_batch = y[i:i+batch_size-1,]

    # Compute forward pass
    ## layer 1:
    out1 = affine::forward(X_batch, W1, b1)
    outr1 = relu::forward(out1)
    [outd1, maskd1] = dropout::forward(outr1, p, -1)
    ## layer 2:
    out2 = affine::forward(outd1, W2, b2)
    outr2 = relu::forward(out2)
    [outd2, maskd2] = dropout::forward(outr2, p, -1)
    ## layer 3:
    out3 = affine::forward(outd2, W3, b3)
    probs = softmax::forward(out3)

    # Compute loss
    loss = cross_entropy_loss::forward(probs, y_batch)
    print("Cross entropy loss: " + loss)

    # Compute backward pass
    ## loss:
    dprobs = cross_entropy_loss::backward(probs, y_batch)
    ## layer 3:
    dout3 = softmax::backward(dprobs, out3)
    [doutd2, dW3, db3] = affine::backward(dout3, outd2, W3, b3)
    ## layer 2:
    doutr2 = dropout::backward(doutd2, outr2, p, maskd2)
    dout2 = relu::backward(doutr2, out2)
    [doutd1, dW2, db2] = affine::backward(dout2, outd1, W2, b2)
    ## layer 1:
    doutr1 = dropout::backward(doutd1, outr1, p, maskd1)
    dout1 = relu::backward(doutr1, out1)
    [dX_batch, dW1, db1] = affine::backward(dout1, X_batch, W1, b1)

    # Optimize with SGD w/ Nesterov momentum
    [W1, vW1] = sgd_nesterov::update(W1, dW1, lr, mu, vW1)
    [b1, vb1] = sgd_nesterov::update(b1, db1, lr, mu, vb1)
    [W2, vW2] = sgd_nesterov::update(W2, dW2, lr, mu, vW2)
    [b2, vb2] = sgd_nesterov::update(b2, db2, lr, mu, vb2)
    [W3, vW3] = sgd_nesterov::update(W3, dW3, lr, mu, vW3)
    [b3, vb3] = sgd_nesterov::update(b3, db3, lr, mu, vb3)
  }
  # Anneal momentum towards 0.999
  mu = mu + (0.999 - mu)/(1+epochs-e)
  # Decay learning rate
  lr = lr * decay
}
```

<!--
{% comment %}
Licensed to the Apache Software Foundation (ASF) under one or more
contributor license agreements.  See the NOTICE file distributed with
this work for additional information regarding copyright ownership.
The ASF licenses this file to you under the Apache License, Version 2.0
(the "License"); you may not use this file except in compliance with
the License.  You may obtain a copy of the License at

http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
{% end comment %}
-->

### Requirements

**Software:**

1. OS: Linux based OS
2. Apache Maven 3.8+
3. [gpg](https://www.gnupg.org)

**Credentials:**

1. Publish release manager's gpg key to [`release dist repo`](https://dist.apache.org/repos/dist/release/systemds/KEYS)
2. GitHub PAT ([`Personal Access Token`](https://docs.github.com/en/authentication/keeping-your-account-and-data-secure/creating-a-personal-access-token))
3. Apache credentials (Make sure your id is at [`SystemDS committers`](https://people.apache.org/committers-by-project.html#systemds))
4. Confirm access to Nexus repo at https://repository.apache.org/#stagingProfiles;1486a6e8f50cdf

### Usage

Set gpg home as

```bash
export GNUPGHOME="$HOME/.gnupg"
```

Dry run:

```sh
./dev/release/do-release.sh -n
```

Release: (irreversible operation)

```sh
./dev/release/do-release.sh
```

### Architecture of the release pipeline

The following diagram illustrates the steps building and publishing release.


![Release Architecture](./release-architecture.svg)

<!--
{% comment %}
Licensed to the Apache Software Foundation (ASF) under one or more
contributor license agreements.  See the NOTICE file distributed with
this work for additional information regarding copyright ownership.
The ASF licenses this file to you under the Apache License, Version 2.0
(the "License"); you may not use this file except in compliance with
the License.  You may obtain a copy of the License at

http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
{% endcomment %}
-->

# Running SystemDS on Databricks

Scripts and demo notebooks for deploying and running SystemDS on a Databricks
cluster. Tested against DBR 16.4 LTS (Spark 3.5.2 / Scala 2.12), where the
SystemDS jar runs unchanged.

## Contents

| File | Purpose |
| --- | --- |
| `deploy.sh` | Create a UC volume, upload `SystemDS.jar`, create a single-user cluster, install the Delta Kernel libraries, and import the demo notebooks. |
| `SystemDS_MLContext_Demo.scala` | Notebook: Unity Catalog round-trip using the SystemDS MLContext (Scala) API. Reads a table, runs a configurable DML script, writes the result back. |
| `SystemDS_Delta_E2E.scala` | Notebook: end-to-end Delta → linear regression on one Delta table. SystemDS reads it natively as a frame (`read(format="delta")`) → `transformencode` → `lm`; Spark ML reads the same table → `OneHotEncoder` → `LinearRegression`. Times read + encode + train for both. |
| `demo.dml` | Standalone DML smoke test: reads a matrix from storage, computes column sums and a Gram-matrix trace. |
| `.env.example` | Template for your local configuration. |

## Prerequisites

- The [Databricks CLI](https://docs.databricks.com/dev-tools/cli/) installed and
  authenticated once interactively:

  ```bash
  databricks auth login --profile <your-profile>
  ```

- A built SystemDS jar at `<repo-root>/target/SystemDS.jar`
  (`mvn -q -DskipTests package`), or set `JAR_LOCAL` to point at one.
- `python3` on your `PATH` (used to parse CLI JSON output).

## Configuration

All settings are read from environment variables. The easiest way is a `.env`
file:

```bash
cp scripts/databricks/.env.example scripts/databricks/.env
# then edit scripts/databricks/.env
```

`deploy.sh` looks for a `.env` file by:

1. `ENV_FILE=/abs/path/to/.env` if you set it explicitly, otherwise
2. searching upward from the script's own directory (script dir → repo root →
   any parent directory) for the first `.env` it finds.

Anything already exported in your shell overrides values from `.env`.

| Variable | Default | Description |
| --- | --- | --- |
| `PROFILE` | `DEFAULT` | Databricks CLI profile. |
| `CATALOG` / `SCHEMA` / `VOLUME` | `main` / `default` / `systemds` | UC location for the jar volume (and notebook defaults). |
| `POLICY_ID` | _(empty)_ | Compute policy id; leave empty for none. |
| `SPARK_VERSION` | `16.4.x-scala2.12` | DBR runtime. |
| `NODE_TYPE` | `i3.xlarge` | Node type. |
| `NUM_WORKERS` | `0` | Worker count (0 = single node). |
| `AUTOTERMINATION_MINUTES` | `30` | Auto-terminate idle minutes. |
| `CLUSTER_NAME` | `systemds` | Cluster name. |
| `JAR_LOCAL` | `<repo-root>/target/SystemDS.jar` | Jar to upload. |
| `NB_DIR` | `/Users/<you>` | Workspace folder to import notebooks into. |
| `NB_FILES` | _(the 2 demo notebooks)_ | Space-separated notebooks to import; language detected from extension. |
| `DELTA_KERNEL_VERSION` | `3.3.2` | Delta Kernel Maven library version installed by `deploy.sh libs` (>= 3.3.2; must match `pom.xml`). |
| `USER_NAME` | _(auto-detected)_ | Databricks user. |

### Choosing a node type

`NODE_TYPE` is a cloud instance type. The default `i3.xlarge` is a small,
storage-optimized AWS node (4 vCPU / 30.5 GiB RAM / 950 GB local NVMe SSD); the
fast local disk is handy because the notebook spills SystemDS scratch to
`/local_disk0`. With `NUM_WORKERS=0` this single node is both driver and
executor, so it bounds the total memory available to SystemDS.

Some common AWS options (pick more cores/RAM for larger workloads):

| Node type | vCPU | RAM | Local SSD | Notes |
| --- | --- | --- | --- | --- |
| `i3.xlarge` | 4 | 30.5 GiB | 950 GB | Default; storage-optimized. |
| `i3.2xlarge` | 8 | 61 GiB | 1900 GB | Same family, 2× bigger. |
| `i4i.xlarge` | 4 | 32 GiB | 937 GB | Newer gen, faster storage. |
| `m5d.xlarge` | 4 | 16 GiB | 150 GB | General purpose w/ local SSD. |
| `r5d.2xlarge` | 8 | 64 GiB | 300 GB | Memory-optimized w/ local SSD. |

The exact set depends on your cloud (AWS / Azure / GCP) and workspace. List what
your workspace actually offers with:

```bash
databricks clusters list-node-types -p "$PROFILE" -o json
```

References:
[AWS EC2 instance types](https://aws.amazon.com/ec2/instance-types/),
[Azure VM sizes](https://learn.microsoft.com/azure/virtual-machines/sizes),
[GCP machine families](https://cloud.google.com/compute/docs/machine-resource).

## Usage

```bash
cd scripts/databricks
./deploy.sh upload     # create UC volume + copy SystemDS.jar into it
./deploy.sh cluster    # create the single-user cluster + install the jar
./deploy.sh libs       # install the Delta Kernel Maven libraries on the cluster
./deploy.sh import     # import the demo notebooks
./deploy.sh all        # all of the above
```

The created cluster id is written to `scripts/databricks/.cluster_id`.

### Delta Kernel libraries

The Delta notebook (`SystemDS_Delta_E2E`) reads Delta tables natively through the
Spark-free Delta Kernel, which is not on the DBR classpath. `./deploy.sh libs`
installs `io.delta:delta-kernel-defaults` (version `DELTA_KERNEL_VERSION`, default
`3.3.2`) as a cluster Maven library. Use **>= 3.3.2**: earlier releases trip a
classloader conflict with DBR's bundled parquet. The version must match the
`delta-kernel.version` property in the SystemDS `pom.xml`.

## Notebook configuration (`SystemDS_MLContext_Demo`)

The Scala notebook is driven by widgets, so nothing is hardcoded — set them in
the notebook UI or pass them as job parameters:

| Widget | Default | Description |
| --- | --- | --- |
| `catalog` / `schema` | `main` / `default` | Where the input/output tables live. |
| `input_table` / `output_table` | `systemds_input` / `systemds_output` | Table names. |
| `dml_path` | _(blank)_ | DML script to run. Blank uses the built-in z-score demo; otherwise a path readable from the driver (UC volume, `/Workspace`, or `dbfs:`). |
| `exec_type` | `DEFAULT` | SystemDS execution mode. `DEFAULT` lets SystemDS choose the plan; `DRIVER`, `SPARK`, or `DRIVER_AND_SPARK` force a mode. |

Custom DML contract: the script receives the input matrix as `X` and must
produce a matrix `Y` and a scalar `checksum`.

## Notebook configuration (`SystemDS_Delta_E2E`)

| Widget | Default | Description |
| --- | --- | --- |
| `catalog` / `schema` / `volume` | `main` / `default` / `systemds` | UC location; the Delta table is written under the volume. |
| `rows` | `1000000` | Rows in the generated Delta table. |
| `num_numeric` / `num_categorical` / `cardinality` | `100` / `20` / `30` | Feature shape. Defaults are deliberately encode-heavy (700 features) so the SystemDS-vs-Spark difference is visible. |
| `reg` | `1e-3` | L2 regularization for `lm`. |
| `recreate` | `true` | Rewrite the Delta table before running. |
| `statistics` | `true` | Print the SystemDS per-instruction breakdown. |

The encode complexity (categoricals × cardinality), not the row count, drives the
gap: more categoricals blow up Spark's `StringIndexer` + `OneHotEncoder` (each a
shuffle stage), while SystemDS dummycodes in-memory. On a single node, raw rows
instead favor Spark, and very large tables can exhaust driver memory.

Indicative single-node (`i3.xlarge`, 1M rows) numbers — single cold run, no warmup:

| workload | Spark ML | SystemDS | speedup |
| --- | --- | --- | --- |
| `SystemDS_Delta_E2E`, 700 features (read + encode + train) | 116.6 s | 55.4 s | ~2.1× |

The Spark side is the same speed on Spark 3.5.2 (DBR 16.4) and Spark 4.0.0
(DBR 17.3 LTS), so the comparison is not an artifact of an old runtime.

## Notes / gotchas baked into the scripts

- UC clusters only accept JAR libraries from a **UC Volume** (not DBFS, not
  `/Workspace`).
- The cluster must be **SINGLE_USER** (Assigned) mode; shared / USER_ISOLATION
  blocks JAR libraries.
- SystemDS needs the Vector API module plus a full `--add-opens` set at JVM
  launch (configured via `spark.{driver,executor}.extraJavaOptions`), and an
  absolute scratch dir (the notebook pins `sysds.scratch`).

`.env` and `.cluster_id` are git-ignored — they hold personal config and local
state and should never be committed.

<!--
{% comment %}
Licensed to the Apache Software Foundation (ASF) under one or more
contributor license agreements.  See the NOTICE file distributed with
this work for additional information regarding copyright ownership.
The ASF licenses this file to you under the Apache License, Version 2.0
(the "License"); you may not use this file except in compliance with
the License.  You may obtain a copy of the License at

http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
{% end comment %}
-->

# Resource Optimizer
The **Resource Optimizer** is an extension that allows for automatic generation of (near) optimal cluster configurations for
executing a given SystemDS script in a cloud environment - currently only AWS.
The target execution platform on AWS is EMR (Elastic MapReduce), but single node executions run on EC2 (Elastic Cloud Compute). In both cases files are expected to be pulled from Amazon S3 (Simple Storage Service).

## Functionality

The Resource Optimizer is extension of SystemDS and while employing the systems' general tools for program compilation and execution, this extension does not operate in execution time but is rather a separate executable program meant to be used upon running a DML script (program) in the cloud (AWS). The extension runs an optimization algorithm for finding the optimal cluster configurations for executing the target SystemDS program considering the following properties:

* The input dataset properties (providing metadata files is required)
* A defined set of available machine type for running the program in the cloud  
* The resulting execution plan of the program for the corresponding combination of dataset characteristics and hardware characteristics
* The optimization objective: user-defined goal of optimization with options to aim for shortest execution time, lowest monetary cost or (by default) for configuration set fairly balancing both objectives. 

The result is a set of configuration files with all options needed for launching SystemDS in the cloud environment. 

For complete the automation process of running SystemDS program in the cloud, the extension is complimented with corresponding scripts to allow the user to launch the program with the generated optimal configurations with minimal additional effort.

## User Manual

### Installation
The extension, although not part of the execution time of SystemDS, is fully integrated with the project and is compiled 
as part of the general compilation process using Maven. Check [here](../../README.md) for more information about that.

Maven compiles a JAR file which is to be used for running the extension. 
The path to the file is `<SystemDS root folder>\target\ResourceOptimizer.jar`, 
but for easier usage you can complete the following steps from the project root folder to configure it on path:
```shell
# general step for SystemDS
export SYSTEMDS_ROOT=$(pwd)
# specific steps for the extension
export PATH=$PATH:$SYSTEMDS_ROOT/scripts/resource/bin
```
The proper execution requires JDK 17 so make sure to export the correct JDK version to `$JAVA_HOME` environmental variable.

### Usage

The extension is installed as a separate java executable files, so it can be launched with `java -jar <SystemDS root folder>\target\ResourceOptimizer.jar ...`, but if you completed all additional steps from the **Installation** section then you can run directly the extension using the `systemds-ropt` command globally without specifying a target jar-file.

The executable takes the following arguments:
```txt
 -args <argN>          specifies positional parameters; first value will replace $1 in DML program, $2 will replace 2nd and so on

 -f <filename>         specifies DML file to execute; path should be local

 -help                 shows usage message

 -nvargs <key=value>   parameterizes DML script with named parameters of the form <key=value>; <key> should be a valid identifier in DML

 -options <arg>        specifies options file for the resource optimization

```
Either `-help` or `-f` is required, where `-f` lead to the actual program execution. In that case if `-options` is not provided, that program will look for a default `options.properties` in the current directory and if no file found the program will fail. Like for SystemDS program execution, `-args` and `-nvargs` provide additional script arguments and they cannot be specified simultaneously. The `-options` arguments point to a file with options to customize further the optimization process. These options provide paths to further properties files and a optional optimization configurations and constraints.

It is important for program arguments being dataset filepaths to be specified with their URI address that will be actually used by the SystemDS program later. Currently the only supported and tested option is S3 for storing input and outputs on AWS. Check [Required Options](#required-options) for further details.

## Providing Options

Although automatic, the optimization process requires providing certain properties beyond the SystemDS program and the dataset characteristics. These are in general hardware characteristics for potential resources available on the target cloud platform. In addition to that, the user can (and in some cases should) provide a further set of constraints options for to limit ensure that the resulting configuration would be feasible for the target scenario. All properties and constraints are provided with the options file (using the `-options` argument) and a full set all possible options can be found in the default options file: `./scripts/resource/options.properties`

### Required Options

For the proper operation certain options should be always provided:

* `REGION` - AWS region which is crucial for the monetary estimations
* `INFO_TABLE` - a `.csv` table providing the needed hardware and price characteristics for each of the potential server machines (instances) for consideration
* `REGION_TABLE` - another `.csv` table providing additional pricing parameters (EMR fee, EBS Storage prices)
* `OUTPUT_FOLDER` - path for the resulting configuration files

Depending on the chosen optimization objective method further options could be required:
* `MAX_TIME` - in case of choosing optimizing for monetary cost only
* `MAX_PRICE` - in case of choosing optimizing for execution time only

The enumeration strategy and optimization functions has defaults values and are not required to be further set in the options:
* Default for enumeration strategy is: grid
* Default for optimization function is: costs

We provide a table comprising the relevant EC2 instances characteristics supported currently by the resource optimizer 
and table with pricing parameters for all regions supported by EMR. The python script from `update_prcies.py` provides and automation
for updating the prices of the EC2 instances in the fist mention table be setting a target AWS region.

As mentioned in [Usage](#usage), the filepath s for the input datasets should be the URI addresses for the distributed S3 file. This allows Resource Optimizer to account for the costs of fetching these external files. To allow greater flexibility at using the extension, the user is provided with the possibility of omitting this requirement in certain scenarios: the user provides the program arguments as S3 URI paths but with an imaginary name (and leading S3 URI schema - `s3://`) and then fills the `LOCAL_INPUTS` property. This property holds key-value pairs where the key is the imaginary S3 file paths and the value is the local path for these files. The local path could also point to a non existing file as long as a corresponding metadata (`.mtd`) file is locally available on this path. 

### Further Options 

As mentioned above, the user can decide to switch between different options for the enumeration strategy (option `ENUMERATION`) and the optimization functions (options `OPTIMIZATION_FUNCTION`). 

The enumeration strategy has influence mostly on the speed of completing the process of finding the optimal configuration. The default value is `grid` and this sets a grid-based enumeration where each configuration combination within the configured constraints is being evaluated. The next possible option value is `prune` which prunes dynamically certain configuration during the progress of the enumeration process based on the intermediate results for the already evaluated configurations. In theory this should deliver the same optimal result as the grid-based enumeration and the experiments so far proved that while showed great speed-up. The last possibility is fot that option is `interest`, which uses a interest-based enumeration which uses several (configurable) criterias for statically reducing the search space for the optimal configuration base on program and hardware properties.

Here is a list of all the rest of the options available:

* `CPU_QUOTA` (default 1152) - specifies the limit of (virtual) CPU cores allowed for evaluation. This corresponds to the EC2 service quota for limiting the running instances within the same region at the same moment.
* `COSTS_WEIGHT` (default 0.01) - specifies the weighing factor for the multi-objective function for optimization
* `MIN_EXECUTORS` (default 0) - specifies minimum desired executors, where 0 includes single node execution. Allows configuring minimum cluster size.
* `MAX_EXECUTORS` (default 200) - specifies maximum desired executors. The maximum number of executors can be limited dynamically further more in case of reaching the CPU quota number.
* `INSTANCE_FAMILIES` - specifies VM instance types for consideration at searching for optimal configuration. If not specified, all instances from the table with instance metadata are considered
* `INSTANCE_SIZES` - specifies VM instance sizes for consideration at searching for optimal configuration. If not specified, all instances from the table with instance metadata are considered 
* `STEP_SIZE` (default 1) - specific to grid-based enumeration strategy: specifies step size for enumerating number of executors
* `EXPONENTIAL_BASE` - specific to grid-based enumeration strategy: specifies exponential base for increasing the number of executors exponentially if a value greater than 1 given
* `USE_LARGEST_ESTIMATE` (default *true*) - specific to the enumeration strategy with interest criterias: boolean ('true'/'false') to indicate if single node execution should be considered only in case of sufficient memory budget for the driver
* `USE_CP_ESTIMATES` (default *true*) - specific to the enumeration strategy with interest criterias: boolean ('true'/'false') to indicate if the CP memory is an interest for the enumeration
* `USE_BROADCASTS` (default *true*) - specific to the enumeration strategy with interest criterias: boolean ('true'/'false') to indicate if potential broadcast variables' sizes is an interest for driver and executors memory budget
* `USE_OUTPUTS` (default *false*) - specific to the enumeration strategy with interest criterias: boolean ('true'/'false') to indicate if the size of the outputs (potentially cached) is an interest for the enumerated number of executors. False by default since the caching process is not considered by the current version of the Resource Optimizer.

## Launching Program in the Cloud

For optimal solution with single node, the target environment in AWS is an EC2 instance and the resulting file from the optimization process is a single file: `ec2_configurations.json`. This files store the all values required for launching an EC2 instance and running SystemDS on it. The file has a custom format is not supported by AWS CLI.

For optimal solution with Spark cluster, the target environment is EMR cluster. The Resource optimizer generates in this case two files: 
* `emr_instance_groups.json` - contains hardware configurations for machines in the cluster
* `emr_configurations.json` - contains Spark-specific configurations for the cluster

Both files follow a structure supported by AWS CLI so they can be directly passed in a command for launching an EMR cluster in combination with all further required options.

*Note: For proper execution of all of the shell scripts mentioned bellow, please do not delete any of the optional variables in the corresponding `.env` files but just leave them empty, otherwise the scripts could fail due to "unbound variable" error*

### Launching in Single-node Mode Automatically

For saving additional user effort and the need of background knowledge for Amazon EC2, the project includes scripts for automating the processes of launching an instance based on the output configurations and running the target SystemDS script on it. 

The shell script `./scripts/resource/launch/single_node_launch.sh` is used for launching the EC2 instance based in a corresponding `ec2_configurations.json`. All configuration and options should be specified in `./scripts/resource/launch/single_node.env` and the script expects no arguments passed. The options file includes all required and optional configurations and explanations for their functionality. The launch process utilizes AWS CLI and executes automatically the following steps:
1. Query the AWS API for an OS image with Ubuntu 24.04 for the corresponding processor architecture and AWS region.
2. Generates instance profile for accessing S3 by the instance
3. Launches the target EC2 with all additional options needed in our case and with providing a bootstrap script for SystemDS installation
4. Waits for the instance to enter state `RUNNING` 
5. Waits for the completion of the SystemDS installation

*Note: the SSH key generation is not automated and an existing key should be provided in the options file before executing the scripts, otherwise the launch will fail.*

After the script completes without any errors, the instance is already fully prepared for running SystemDS programs. However, before running the script for automated program execution, the user needs to manually uploads the needed files (including the DML script) to S3.

Once all files are uploaded to S3, the user can execute the `./scripts/resource/launch/single_node_run_script.sh` script. All configurations are again provided via the same options file like for the launch. This scripts does the following:
1. Prepare a command for executing the SystemDS program with all the required arguments and with optimal JVM configurations.
2. Submits the command to the target machine and additionally sets simple a logging mechanism: the execution writes directly to log files that are compressed after program completion/fail to S3.
3. Optionally (depending on the option `AUTO_TERMINATION`) the scripts sets that the instance should be stopped after the program completes/fails and the log files are uploaded to S3. In that case the script wait for the machine to enters state `STOPPED` and trigger its termination.

The provided URI addresses for S3 files should always use the `s3a://` prefix to allow for the proper functionality
of the Hadoop-AWS S3 connector. 

*Note 1: if automatic termination is disabled the user should manually check for program completion and terminate the EC2 instance*

*Note 2: if automatic termination is enabled the user should ensure that all the output files are written to S3 because the EC2 instance storage is always configured to be ephemeral.*

### Launching in Cluster (Hybrid) Mode Automatically 

The project includes also the equivalent script files to automate the launching process of EMR cluster 
and the submission of steps for executing SystemDS programs.

The shell script `./scripts/resource/launch/cluster_launch.sh` is used ofr launching the cluster 
based on the auto-generated files from the Resource Optimizer. Additional configurations regarding the launching
process or submitting steps should be defined in `./scripts/resource/launch/cluster.env` and the script does not
expect any passed arguments. Like for EC2 launch, the script uses AWC CLI and executed the following steps:
1. Queries the default subnet in the user have not defined one
2. In case of provided SystemDS script for execution in the configuration file, it prepares the whole step definition
3. Launched the cluster with all provided configurations. Depending on the set value for `AUTO_TERMINATION_TIME` the cluster can be set 
to be automatically terminated after the completion of the initially provided step (of one provided at all) or terminate automatically 
after staying for a given period of time in idle state.
4. The script waits until the cluster enter state `RUNNING` and completes.

The script `./scripts/resource/launch/cluster_run_script.sh` can be used for submitting
steps to running EMR cluster, again by getting all its arguments from the file `./scripts/resource/launch/cluster.env`.
The script will for the completion of the step by polling for the step's state and 
if `AUTO_TERMINATION_TIME` is set to 0 the cluster will be automatically terminated.


The provided URI addresses for S3 files should always use the `s3://` prefix to allow for the proper functionality
of the EMR-specific S3 connector. 

*The same notes as for the launch on programs as EC2 are valid here as well!*

<!--
{% comment %}
Licensed to the Apache Software Foundation (ASF) under one or more
contributor license agreements.  See the NOTICE file distributed with
this work for additional information regarding copyright ownership.
The ASF licenses this file to you under the Apache License, Version 2.0
(the "License"); you may not use this file except in compliance with
the License.  You may obtain a copy of the License at

http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
{% end comment %}
-->

# Frontend for monitoring tool of federated infrastrucuture

A frontend application, used to visualize and manipulate the backend application functionality of the monitoring tool

## Backend requirements

A running instance of the backend application is required for the frontend to function, default port of the backend is **8080**.

## Install & Run

To install and run the app do the following:

```bash
  cd scripts/monitoring
  npm install
  npm run start
```

To view the app Navigate to `http://localhost:4200/`.

## Running Tests

To run tests, run the following command:

```bash
  npm run test
```

## API Reference

Get all registered workers

```http
  GET /workers
```

Get specific worker

```http
  GET /workers/${id}
```

| Parameter | Type     | Description                       |
| :-------- | :------- | :-------------------------------- |
| `id`      | `int` | **Required**. Id of the worker to fetch |

Register worker for monitoring

```http
  POST /workers
```

Request body in **JSON** format:

| Body parameter | Type     | Description                       |
| :-------- | :------- | :-------------------------------- |
| `name`    | `string` | **Required**. Name of the worker to register |
| `address` | `string` | **Required**. Address of the worker to register |

Example:

```json
{
  "name": "Worker 1",
  "address": "localhost:8001"
}
```

Edit registered worker

```http
  PUT /workers/${id}
```

| Parameter | Type     | Description                       |
| :-------- | :------- | :-------------------------------- |
| `id`      | `int` | **Required**. Id of the worker to edit |

Request body in **JSON** format:

| Body parameter | Type     | Description                       |
| :-------- | :------- | :-------------------------------- |
| `name`    | `string` | Changed name of the worker |
| `address` | `string` | Changed address of the worker |

Example:

```json
{
  "name": "Worker 42",
  "address": "localhost:8005"
}
```

Deregister specific worker

```http
  DELETE /workers/${id}
```

| Parameter | Type     | Description                       |
| :-------- | :------- | :-------------------------------- |
| `id`      | `int` | **Required**. Id of the worker to deregister |

---

Get all registered coordinators

```http
  GET /coordinators
```

Get specific coordinator

```http
  GET /coordinators/${id}
```

| Parameter | Type     | Description                       |
| :-------- | :------- | :-------------------------------- |
| `id`      | `int` | **Required**. Id of the coordinator to fetch |

Register coordinator for monitoring

```http
  POST /coordinators
```

Request body in **JSON** format:

| Body parameter | Type     | Description                       |
| :-------- | :------- | :-------------------------------- |
| `name`    | `string` | **Required**. Name of the coordinator to register |
| `address` | `string` | **Required**. Address of the coordinator to register |

Example:

```json
{
  "name": "Coordinator 1",
  "address": "localhost:8441"
}
```

Edit registered coordinator

```http
  PUT /coordinators/${id}
```

| Parameter | Type     | Description                       |
| :-------- | :------- | :-------------------------------- |
| `id`      | `int` | **Required**. Id of the coordinator to edit |

Request body in **JSON** format:

| Body parameter | Type     | Description                       |
| :-------- | :------- | :-------------------------------- |
| `name`    | `string` | Changed name of the coordinator |
| `address` | `string` | Changed address of the coordinator |

Example:

```json
{
  "name": "Coordinator 4",
  "address": "localhost:8445"
}
```

Deregister specific coordinator

```http
  DELETE /coordinators/${id}
```

| Parameter | Type     | Description                       |
| :-------- | :------- | :-------------------------------- |
| `id`      | `int` | **Required**. Id of the coordinator to deregister |

<!--
{% comment %}
Licensed to the Apache Software Foundation (ASF) under one or more
contributor license agreements.  See the NOTICE file distributed with
this work for additional information regarding copyright ownership.
The ASF licenses this file to you under the Apache License, Version 2.0
(the "License"); you may not use this file except in compliance with
the License.  You may obtain a copy of the License at

http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
{% endcomment %}
-->

# SystemDS

## Overview

SystemDS is a versatile system for the end-to-end data science lifecycle from data integration, cleaning, and feature engineering, over efficient, local and distributed ML model training, to deployment and serving. To this end, we aim to provide a stack of declarative languages with R-like syntax for (1) the different tasks of the data-science lifecycle, and (2) users with different expertise. These high-level scripts are compiled into hybrid execution plans of local, in-memory CPU and GPU operations, as well as distributed operations on Apache Spark. In contrast to existing systems - that either provide homogeneous tensors or 2D Datasets - and in order to serve the entire data science lifecycle, the underlying data model are DataTensors, i.e., tensors (multi-dimensional arrays) whose first dimension may have a heterogeneous and nested schema.

**Documentation:** [SystemDS Documentation](https://github.com/apache/systemds/tree/main/docs)

## Getting started

Requirements for running SystemDS are a bash shell and OpenJDK 17 or a Spark 3.5.x cluster installation (to run distributed jobs).
These requirements should be available via standard system packages in all major Linux distributions
(make sure to have the right JDK version enabled, if you have multiple versions in your system).
For Windows, a bash comes with [git for windows](http://git-scm.com) and OpenJDK builds can be obtained at <http://adoptopenjdk.net>
(tested version [jdk8u232-b09](https://adoptopenjdk.net/archive.html))  

To start out with an example after having installed the requirements mentioned above, create a text file  
`hello.dml` in your unzipped SystemDS directory containing the following content:

```shell script
X = rand(rows=$1, cols=$2, min=0, max=10, sparsity=$3)
Y = rand(rows=$2, cols=$1, min=0, max=10, sparsity=$3)
Z = X %*% Y
print("Your hello world matrix contains:")
print(toString(Z))
write(Z, "Z")
```

**Explanation:** The script takes three parameters for the creation of your matrices X and Y: rows, columns and degree
of sparsity. As you can see, DML can access these parameters by specifying $1, $2, ... etc

**Execution:** Now run that first script you created by running one of the following commands depending on your operating system:

### Running a script locally

``` bash
./bin/systemds hello.dml -args 10 10 1.0
```

### Running a script locally, providing your own SystemDS.jar file

If you compiled SystemDS from source, you can of course use the created JAR file with the run script.

``` bash
./bin/systemds path/to/the/SystemDS.jar hello.dml -args 10 10 1.0
```

### Running a script locally, in your SystemDS source environment

If you have cloned the SystemDS source repository and want to run your DML script with that, you can point the
shell script to the source directory by setting the `SYSTEMDS_ROOT` environment variable.

``` bash
SYSTEMDS_ROOT=../../code/my-systemds/source
./bin/systemds hello.dml -args 10 10 1.0
```

More about the environment setup can be found on : [running Systemds](http://apache.github.io/systemds/site/run).

### Running a script distributed on a Spark cluster

For running on a Spark cluster, the env variable SYSDS_DISTRIBUTED needs to be set (to something other than 0).
Per default, SystemDS will run in hybrid mode, pushing some instructions to the cluster and running others locally.
To force cluster mode in this little test, we will increase the matrix size to give the worker nodes in the cluster
something to do and force SystemDS to only generate Spark instructions by adding -exec spark to the command line
parameters:

``` bash
SYSDS_DISTRIBUTED=1
./bin/systemds hello.dml -args 10000 10000 1.0 -exec spark
```

The output should read something similar to this (the warning can be safely ignored):

``` bash
20/03/09 16:40:29 INFO api.DMLScript: BEGIN DML run 03/09/2020 16:40:29
20/03/09 16:40:30 WARN util.NativeCodeLoader: Unable to load native-hadoop library for your platform... using builtin-java classes where applicable
Your hello world matrix contains:
250,902 207,246 305,621 182,892 234,394 258,587 132,225 259,684 255,774 228,338
296,740 261,475 379,148 156,640 304,543 267,684 191,867 258,826 373,633 276,497
215,877 186,171 332,165 201,091 289,179 265,160 125,890 289,836 320,434 287,394
389,057 332,681 336,182 285,432 310,218 340,838 301,308 354,130 410,698 282,453
325,903 264,745 377,086 242,436 277,836 285,519 190,167 358,228 332,295 288,034
360,858 301,739 398,514 265,299 333,124 321,178 240,755 299,871 428,856 300,128
368,983 291,729 303,091 191,586 231,050 280,335 266,906 278,203 395,130 203,706
173,610 114,076 157,683 140,927 145,605 145,654 143,674 192,044 196,735 166,428
310,329 258,840 286,302 231,136 305,804 300,016 266,434 297,557 392,566 281,211
249,234 196,488 216,662 180,294 165,482 169,318 172,686 204,275 296,595 148,888

SystemDS Statistics:
Total execution time:           0,122 sec.

20/03/09 16:40:30 INFO api.DMLScript: END DML run 03/09/2020 16:40:30
```

## Further reading

More documentation is available in the [SystemDS Homepage](https://systemds.apache.org/documentation)

<!--
{% comment %}
Licensed to the Apache Software Foundation (ASF) under one or more
contributor license agreements.  See the NOTICE file distributed with
this work for additional information regarding copyright ownership.
The ASF licenses this file to you under the Apache License, Version 2.0
(the "License"); you may not use this file except in compliance with
the License.  You may obtain a copy of the License at

http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
{% end comment %}
-->

# Backend for monitoring tool of federated infrastructure

A backend application, used to collect, store, aggregate and return metrics data from coordinators and workers in the cluster

## Install & Run

The backend process can be started in a similar manner with how a worker is started:

```bash
  cd systemds
  mvn package
  ./bin/systemds [-r] FEDMONITORING [SystemDS.jar] <portnumber> [arguments]
```

Or with the specified **-fedMonitoring 8080** flag indicating the start of the backend process on the specified port, in our case **8080**.

## Main components

### Architecture

The following diagram illustrates the processes running in the backend.

![Backend Architecture](./Backend-architecture.svg)

#### Controller

Serves as the main integration point between the frontend and backend.

#### Service

Holds the business logic of the backend application.

#### Repository

serves as the main integration point between the backend and the chosen persistent storage. It can be extended to persist data in the file system, by extending the **IRepository** class and changing the instance in the service classes.

### Database schema

The following diagram illustrates the current state of the database schema.

![Database Schema](./DB-diagram.svg)

### Important to note

- There is no foreign key constraint between the worker and statistics tables.
- The field for **coordinatorTraffic** is parsed into JSON format upon retrieval and saved as a string in the database. Example:

```json
{
  "datetime": "2022-06-24T17:08:56.897188", 
  "coordinatorAddress": "localhost:8445", 
  "byteAmount": 45000
}
```

- The field for **heavyHitters** is parsed into JSON format upon retrieval and saved as a string in the database. Example:

```json
{
  "instruction": "fed_uamin", 
  "count": 4, 
  "duration": 0.5
}
```

### Processes

The following diagram illustrates the processes running in the backend.

![Backend Processes](./Backend-processes.svg)

#### Statistics collection thread

There is a dedicated thread for the communication between the backend and the workers and statistics are gathered periodically (every 3 seconds by default).

#### Request processing

The main logic of the application listens for REST requests coming from the frontend.  

<!--
{% comment %}
Licensed to the Apache Software Foundation (ASF) under one or more
contributor license agreements.  See the NOTICE file distributed with
this work for additional information regarding copyright ownership.
The ASF licenses this file to you under the Apache License, Version 2.0
(the "License"); you may not use this file except in compliance with
the License.  You may obtain a copy of the License at

http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
{% endcomment %}
-->

# SystemDS-NN Examples

## MNIST Softmax Classifier

* This example trains a softmax classifier, which is essentially a multi-class logistic regression model, on the MNIST data.
The model will be trained on the *training* images, validated on the *validation* images, and tested for final performance metrics on the *test* images.
* DML Functions: `mnist_softmax.dml`
* Training script: `mnist_softmax-train.dml`
* Prediction script: `mnist_softmax-predict.dml`

## MNIST "LeNet" Neural Net

* This example trains a neural network on the MNIST data using a ["LeNet" architecture](http://yann.lecun.com/exdb/publis/pdf/lecun-98.pdf).
The model will be trained on the *training* images, validated on the *validation* images, and tested for final performance metrics on the *test* images.
* DML Functions: `mnist_lenet.dml`
* Training script: `mnist_lenet-train.dml`
* Prediction script: `mnist_lenet-predict.dml`

### Neural Collaborative Filtering

* This example trains a neural network on the MovieLens data set using the concept of [Neural Collaborative Filtering (NCF)](https://dl.acm.org/doi/abs/10.1145/3038912.3052569)
that is aimed at approaching recommendation problems using deep neural networks as opposed to common matrix factorization approaches.
* As in the original paper, the targets are binary and only indicate whether a user has rated a movie or not.
This makes the recommendation problem harder than working with the values of the ratings, but interaction data is in practice easier to collect.
* MovieLens only provides positive interactions in form of ratings. We therefore randomly sample negative interactions as suggested by the original paper.
* The implementation works with a fixed layer architecture with two embedding layers at the beginning for users and items,
three dense layers with ReLu activations in the middle and a sigmoid activation for the final classification.

<!--
{% comment %}
Licensed to the Apache Software Foundation (ASF) under one or more
contributor license agreements.  See the NOTICE file distributed with
this work for additional information regarding copyright ownership.
The ASF licenses this file to you under the Apache License, Version 2.0
(the "License"); you may not use this file except in compliance with
the License.  You may obtain a copy of the License at

http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
{% end comment %}
-->

# Performance tests

To compile:

```bash
mvn package
```

Example of running it:

```bash
java -jar target/systemds-3.4.0-SNAPSHOT-perf.jar 1
```

example result of the above job:

```txt
Running Steam Compression Test
      StreamCompress  Repetitions: 100 GenMatrices rand(10000, 100, 32, 1.0) Seed: 42
               In Memory Block Size,    0.010+-  0.010 ms, 8000152.00
                Write Blocks Stream,   16.272+-  4.027 ms, 8000009.00
               Write Stream Deflate,  444.453+- 37.761 ms, 1037452.78
        Write Stream Deflate Speedy,  276.331+- 24.461 ms, 1362222.20
 In Memory Compress Individual (CI),   29.070+-  2.083 ms, 1041744.00
                    Write CI Stream,   31.607+-  1.722 ms, 1027621.00
            Write CI Deflate Stream,   63.826+-  1.693 ms,  655801.16
     Write CI Deflate Stream Speedy,   54.482+-  1.266 ms,  678390.92
```

With profiler:

```bash
java -jar -agentpath:$HOME/Programs/profiler/lib/libasyncProfiler.so=start,event=cpu,file=temp/log.html target/systemds-3.4.0-SNAPSHOT-perf.jar 12 10000 100 4 1.0 16 1000 -1
```

Take a Matrix and perform serialization

```bash 
java -jar -agentpath:$HOME/Programs/profiler/lib/libasyncProfiler.so=start,event=cpu,file=temp/log.html target/systemds-3.4.0-SNAPSHOT-perf.jar 13 16 100 "temp/test.csv" -1
```

Take a Frame and transform into a Matrix and perform serialization.

```bash 
java -jar -agentpath:$HOME/Programs/profiler/lib/libasyncProfiler.so=start,event=cpu,file=temp/log.html target/systemds-3.4.0-SNAPSHOT-perf.jar 14 16 1000 "src/test/resources/datasets/titanic/titanic.csv" "src/test/resources/datasets/titanic/tfspec.json" -1
```

Frame Operation timings

```bash
java -jar -agentpath:$HOME/Programs/profiler/lib/libasyncProfiler.so=start,event=cpu,file=temp/log.html target/systemds-3.4.0-SNAPSHOT-perf.jar 15 16 10 "src/test/resources/datasets/titanic/titanic.csv" "src/test/resources/datasets/titanic/tfspec.json"
```

Reshape Sparse

```bash
java -cp "target/systemds-3.4.0-SNAPSHOT-perf.jar:target/lib/*" -agentpath:$HOME/Programs/profiler/lib/libasyncProfiler.so=start,event=cpu,file=temp/log.html  org.apache.sysds.performance.Main 1005
```


Binary Operations

```bash
java -jar -agentpath:$HOME/Programs/profiler/lib/libasyncProfiler.so=start,event=cpu,file=temp/log.html -XX:+UseNUMA target/systemds-3.4.0-SNAPSHOT-perf.jar 1006 500
```


transform encode 

```bash
java -jar -agentpath:$HOME/Programs/profiler/lib/libasyncProfiler.so=start,event=cpu,file=temp/log.html -XX:+UseNUMA target/systemds-3.4.0-SNAPSHOT-perf.jar 1007
```


append matrix sequence 

```bash
./src/test/scripts/performance/append.sh
```


matrix multiplication 

```bash
./src/test/scripts/performance/matrixMultiplication.sh
```

#-------------------------------------------------------------
#
# Licensed to the Apache Software Foundation (ASF) under one
# or more contributor license agreements.  See the NOTICE file
# distributed with this work for additional information
# regarding copyright ownership.  The ASF licenses this file
# to you under the Apache License, Version 2.0 (the
# "License"); you may not use this file except in compliance
# with the License.  You may obtain a copy of the License at
#
#   http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing,
# software distributed under the License is distributed on an
# "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
# KIND, either express or implied.  See the License for the
# specific language governing permissions and limitations
# under the License.
#
#-------------------------------------------------------------

args = commandArgs(TRUE)
options(digits=22)
library("Matrix")


reverseMatrix = function(M)
{
  out = matrix(0, nrow(M), ncol(M));
  for( i in 1:ncol(M) ) 
  {
    col = as.vector(M[,i])
    col = rev(col);
    out[,i] = col;
  }
  return(out)
}

X = as.matrix(readMM(paste(args[1], "A.mtx", sep="")))

Bx = reverseMatrix(X)
writeMM(as(Bx, "CsparseMatrix"), paste(args[2], "Bx", sep=""));

By = t(reverseMatrix(t(X)))
writeMM(as(By, "CsparseMatrix"), paste(args[2], "By", sep=""));

#-------------------------------------------------------------
#
# Licensed to the Apache Software Foundation (ASF) under one
# or more contributor license agreements.  See the NOTICE file
# distributed with this work for additional information
# regarding copyright ownership.  The ASF licenses this file
# to you under the Apache License, Version 2.0 (the
# "License"); you may not use this file except in compliance
# with the License.  You may obtain a copy of the License at
# 
#   http://www.apache.org/licenses/LICENSE-2.0
# 
# Unless required by applicable law or agreed to in writing,
# software distributed under the License is distributed on an
# "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
# KIND, either express or implied.  See the License for the
# specific language governing permissions and limitations
# under the License.
#
#-------------------------------------------------------------



args <- commandArgs(TRUE)
library(Matrix)

qtle = qexp(as.numeric(args[1])); # default rate = 1.0
p = pexp(qtle);
pl = pexp(qtle, lower.tail=F);

out = matrix(0,nrow=3, ncol=1);
out[1,1] = qtle;
out[2,1] = p;
out[3,1] = pl;

writeMM(as(out, "CsparseMatrix"), args[2]); 

#-------------------------------------------------------------
#
# Licensed to the Apache Software Foundation (ASF) under one
# or more contributor license agreements.  See the NOTICE file
# distributed with this work for additional information
# regarding copyright ownership.  The ASF licenses this file
# to you under the Apache License, Version 2.0 (the
# "License"); you may not use this file except in compliance
# with the License.  You may obtain a copy of the License at
# 
#   http://www.apache.org/licenses/LICENSE-2.0
# 
# Unless required by applicable law or agreed to in writing,
# software distributed under the License is distributed on an
# "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
# KIND, either express or implied.  See the License for the
# specific language governing permissions and limitations
# under the License.
#
#-------------------------------------------------------------

# JUnit test class: dml.test.integration.descriptivestats.BivariateOrdinalOrdinalWithWeightsTest.java
# command line invocation assuming $OO_HOME is set to the home of the R script
# Rscript $OO_HOME/OrdinalOrdinal.R $OO_HOME/in/ $OO_HOME/expected/
args <- commandArgs(TRUE)
options(digits=22)

library("Matrix")

Atemp  = readMM(paste(args[1], "A.mtx", sep=""))
Btemp  = readMM(paste(args[1], "B.mtx", sep=""))
WMtemp = readMM(paste(args[1], "WM.mtx", sep=""))

#Atemp  = readMM(file="$$indir$$A.mtx"); #readMM(paste(args[1], "A.mtx", sep=""))
#Btemp  = readMM(file="$$indir$$B.mtx"); #readMM(paste(args[1], "B.mtx", sep=""))
#WMtemp = readMM(file="$$indir$$WM.mtx"); #readMM(paste(args[1], "WM.mtx", sep=""))

A = rep(Atemp[,1],WMtemp[,1])
B = rep(Btemp[,1],WMtemp[,1])

spearman = cor(A, B, method="spearman");

#paste("Weighted R value", spearman);

write(spearman, paste(args[2], "Spearman", sep=""));

#-------------------------------------------------------------
#
# Licensed to the Apache Software Foundation (ASF) under one
# or more contributor license agreements.  See the NOTICE file
# distributed with this work for additional information
# regarding copyright ownership.  The ASF licenses this file
# to you under the Apache License, Version 2.0 (the
# "License"); you may not use this file except in compliance
# with the License.  You may obtain a copy of the License at
#
#   http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing,
# software distributed under the License is distributed on an
# "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
# KIND, either express or implied.  See the License for the
# specific language governing permissions and limitations
# under the License.
#
#-------------------------------------------------------------

args<-commandArgs(TRUE)
options(digits=22)
library("Matrix")
library("DescTools")


Salaries <- read.csv(args[1], header=TRUE, na.strings = "19")

mode = Mode(Salaries$yrs.since.phd, na.rm = TRUE)

Salaries$yrs.since.phd[is.na(Salaries$yrs.since.phd)]<-mode

t = Salaries$yrs.service

mean = mean(t, na.rm = TRUE)

Salaries$yrs.service[is.na(Salaries$yrs.service)]<-mean
output = cbind(Salaries$yrs.since.phd, Salaries$yrs.service)

Mode <- function(x, na.rm = FALSE) {
  if(na.rm){
    x = x[!is.na(x)]
  }

  ux <- unique(x)
  return(ux[which.max(tabulate(match(x, ux)))])
}

writeMM(as(output, "CsparseMatrix"), paste(args[2], "B", sep=""));

#-------------------------------------------------------------
#
# Licensed to the Apache Software Foundation (ASF) under one
# or more contributor license agreements.  See the NOTICE file
# distributed with this work for additional information
# regarding copyright ownership.  The ASF licenses this file
# to you under the Apache License, Version 2.0 (the
# "License"); you may not use this file except in compliance
# with the License.  You may obtain a copy of the License at
# 
#   http://www.apache.org/licenses/LICENSE-2.0
# 
# Unless required by applicable law or agreed to in writing,
# software distributed under the License is distributed on an
# "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
# KIND, either express or implied.  See the License for the
# specific language governing permissions and limitations
# under the License.
#
#-------------------------------------------------------------

args <- commandArgs(TRUE)

library("Matrix")
library("moments")

A <- as.matrix(readMM(paste(args[1], "A.mtx", sep="")))
B <- as.matrix(readMM(paste(args[1], "B.mtx", sep="")));
fn = as.integer(args[2]);


R = matrix(0,17,ncol(A));
for( j in 1:ncol(A) )
{
Ai = A[,j];

if( fn==0 )
{
   C = aggregate(as.vector(Ai), by=list(as.vector(B)), FUN=sum)[,2]
}

if( fn==1 ) 
{
   C = aggregate(as.vector(Ai), by=list(as.vector(B)), FUN=length)[,2]
}

if( fn==2 ) 
{
   C = aggregate(as.vector(Ai), by=list(as.vector(B)), FUN=mean)[,2]
}

if( fn==3 ) 
{
   C = aggregate(as.vector(Ai), by=list(as.vector(B)), FUN=var)[,2]
}

if( fn==4 ) 
{
   C = aggregate(as.vector(Ai), by=list(as.vector(B)), FUN=moment, order=3, central=TRUE)[,2]
}

if( fn==5 ) 
{
   C = aggregate(as.vector(Ai), by=list(as.vector(B)), FUN=moment, order=4, central=TRUE)[,2]
}

if( fn==6 )
{
   C = aggregate(as.vector(Ai), by=list(as.vector(B)), FUN=min)[,2]
}

if( fn==7 )
{
   C = aggregate(as.vector(Ai), by=list(as.vector(B)), FUN=max)[,2]
}

R[,j] = C;
}

writeMM(as(R, "CsparseMatrix"), paste(args[3], "C", sep="")); 

#-------------------------------------------------------------
#
# Licensed to the Apache Software Foundation (ASF) under one
# or more contributor license agreements.  See the NOTICE file
# distributed with this work for additional information
# regarding copyright ownership.  The ASF licenses this file
# to you under the Apache License, Version 2.0 (the
# "License"); you may not use this file except in compliance
# with the License.  You may obtain a copy of the License at
# 
#   http://www.apache.org/licenses/LICENSE-2.0
# 
# Unless required by applicable law or agreed to in writing,
# software distributed under the License is distributed on an
# "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
# KIND, either express or implied.  See the License for the
# specific language governing permissions and limitations
# under the License.
#
#-------------------------------------------------------------

args <- commandArgs(TRUE)

library("Matrix")

X = as.matrix(readMM(paste(args[1], "X.mtx", sep="")))

check_X = sum(X)
if(check_X == 0){
	print("X has no non-zeros")
}else{
	Y = as.matrix(readMM(paste(args[1], "Y.mtx", sep="")))
	intercept = as.integer(args[6])
	num_classes = as.integer(args[2])
	epsilon = as.double(args[3])
	lambda = as.double(args[4])
	max_iterations = as.integer(args[5])
 
	num_samples = nrow(X)
	num_features = ncol(X)

	if (intercept == 1) {
 		ones  = matrix(1, num_samples, 1);
 		X = cbind(X, ones);
	}

	num_rows_in_w = num_features
	if(intercept == 1){
		num_rows_in_w = num_rows_in_w + 1
	}
	w = matrix(0, num_rows_in_w, num_classes)

	debug_mat = matrix(-1, max_iterations, num_classes)
	for(iter_class in 1:num_classes){		  
		Y_local = 2 * (Y == iter_class) - 1
		w_class = matrix(0, num_features, 1)
		if (intercept == 1) {
			zero_matrix = matrix(0, 1, 1);
 			w_class = t(cbind(t(w_class), zero_matrix));
 		}
 
		g_old = t(X) %*% Y_local
 		s = g_old

		Xw = matrix(0, nrow(X), 1)
		iter = 0
 		continue = 1
 		while(continue == 1)  {
  			# minimizing primal obj along direction s
  			step_sz = 0
  			Xd = X %*% s
  			wd = lambda * sum(w_class * s)
  			dd = lambda * sum(s * s)
  			continue1 = 1
  			while(continue1 == 1){
   				tmp_Xw = Xw + step_sz*Xd
   				out = 1 - Y_local * (tmp_Xw)
   				sv = (out > 0)
   				out = out * sv
   				g = wd + step_sz*dd - sum(out * Y_local * Xd)
   				h = dd + sum(Xd * sv * Xd)
   				step_sz = step_sz - g/h
   				if (g*g/h < 0.0000000001){
    				continue1 = 0
   				}
  			}
 
  			#update weights
  			w_class = w_class + step_sz*s
 			Xw = Xw + step_sz*Xd
 
  			out = 1 - Y_local * Xw
  			sv = (out > 0)
  			out = sv * out
  			obj = 0.5 * sum(out * out) + lambda/2 * sum(w_class * w_class)
  			g_new = t(X) %*% (out * Y_local) - lambda * w_class

  			tmp = sum(s * g_old)
  
  			train_acc = sum(Y_local*(X%*%w_class) >= 0)/num_samples*100
  			print(paste("For class ", iter_class, " iteration ", iter, " training accuracy: ", train_acc, sep=""))
  			debug_mat[iter+1,iter_class] = obj	   
   
  			if((step_sz*tmp < epsilon*obj) | (iter >= max_iterations-1)){
   				continue = 0
  			}
 
  			#non-linear CG step
  			be = sum(g_new * g_new)/sum(g_old * g_old)
  			s = be * s + g_new
  			g_old = g_new

  			iter = iter + 1
 		}

		w[,iter_class] = w_class
	}

	writeMM(as(w, "CsparseMatrix"), paste(args[7], "w", sep=""))
}

#-------------------------------------------------------------
#
# Licensed to the Apache Software Foundation (ASF) under one
# or more contributor license agreements.  See the NOTICE file
# distributed with this work for additional information
# regarding copyright ownership.  The ASF licenses this file
# to you under the Apache License, Version 2.0 (the
# "License"); you may not use this file except in compliance
# with the License.  You may obtain a copy of the License at
#
#   http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing,
# software distributed under the License is distributed on an
# "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
# KIND, either express or implied.  See the License for the
# specific language governing permissions and limitations
# under the License.
#
#-------------------------------------------------------------


args <- commandArgs(TRUE)
options(digits=22)
library("Matrix")

X = readMM(paste(args[1], "X.mtx", sep=""))
y = readMM(paste(args[1], "y.mtx", sep=""))

intercept_status = as.integer(args[2]);
tolerance = as.double(args[3]);
max_iteration = as.double(args[4]);
regularization = as.double(args[5]);

n = nrow (X);
m = ncol (X);
ones_n = matrix (1, n, 1);
zero_cell = matrix (0, 1, 1);

m_ext = m;
if (intercept_status == 1 | intercept_status == 2)  # add the intercept column
{
    X = cbind (X, ones_n);
    m_ext = ncol (X);
}

scale_lambda = matrix (1, m_ext, 1);
if (intercept_status == 1 | intercept_status == 2)
{
    scale_lambda [m_ext, 1] = 0;
}

if (intercept_status == 2) {
    avg_X_cols = colSums(X) / n;
    var_X_cols = (colSums (X ^ 2) - n * (avg_X_cols ^ 2)) / (n - 1);
    is_unsafe = (var_X_cols <= 0);
    scale_X = 1.0 / sqrt (var_X_cols * (1 - is_unsafe) + is_unsafe);
    scale_X [m_ext] = 1;
    shift_X = - avg_X_cols * scale_X;
    shift_X [m_ext] = 0;
    scale_X = as.matrix(scale_X);
    shift_X = as.matrix(shift_X);
} else {
    scale_X = matrix (1, m_ext, 1);
    shift_X = matrix (0, m_ext, 1);
}

lambda = scale_lambda * regularization;
beta_unscaled = matrix (0, m_ext, 1);

if (max_iteration == 0) {
    max_iteration = m_ext;
}
i = 0;
r = - t(X) %*% y;

if (intercept_status == 2) {
    r = scale_X * r + shift_X %*% r [m_ext, ];
}

p = - r;
norm_r2 = sum (r ^ 2);
norm_r2_initial = norm_r2;
norm_r2_target = norm_r2_initial * tolerance ^ 2;

while (i < max_iteration & norm_r2 > norm_r2_target)
{
    if (intercept_status == 2) {
        ssX_p = scale_X * p;
        ssX_p [m_ext, ] = ssX_p [m_ext, ] + t(shift_X) %*% p;
    } else {
        ssX_p = p;
    }

    q = t(X) %*% (X %*% ssX_p);

    if (intercept_status == 2) {
        q = scale_X * q + shift_X %*% q [m_ext, ];
    }

	q = q + lambda * p;
	a = norm_r2 / sum (p * q);
	beta_unscaled = beta_unscaled + a * p;
	r = r + a * q;
	old_norm_r2 = norm_r2;
	norm_r2 = sum (r ^ 2);
	p = -r + (norm_r2 / old_norm_r2) * p;
	i = i + 1;
}

if (intercept_status == 2) {
    beta = scale_X * beta_unscaled;
    beta [m_ext, ] = beta [m_ext, ] + t(shift_X) %*% beta_unscaled;
} else {
    beta = beta_unscaled;
}

avg_tot = sum (y) / n;
ss_tot = sum (y ^ 2);
ss_avg_tot = ss_tot - n * avg_tot ^ 2;
var_tot = ss_avg_tot / (n - 1);
y_residual = y - X %*% beta;
avg_res = sum (y_residual) / n;
ss_res = sum (y_residual ^ 2);
ss_avg_res = ss_res - n * avg_res ^ 2;

plain_R2 = 1 - ss_res / ss_avg_tot;
if (n > m_ext) {
    dispersion  = ss_res / (n - m_ext);
    adjusted_R2 = 1 - dispersion / (ss_avg_tot / (n - 1));
} else {
    dispersion  = NaN;
    adjusted_R2 = NaN;
}

plain_R2_nobias = 1 - ss_avg_res / ss_avg_tot;
deg_freedom = n - m - 1;
if (deg_freedom > 0) {
    var_res = ss_avg_res / deg_freedom;
    adjusted_R2_nobias = 1 - var_res / (ss_avg_tot / (n - 1));
} else {
    var_res = NaN;
    adjusted_R2_nobias = NaN;
}

plain_R2_vs_0 = 1 - ss_res / ss_tot;
if (n > m) {
    adjusted_R2_vs_0 = 1 - (ss_res / (n - m)) / (ss_tot / n);
} else {
    adjusted_R2_vs_0 = NaN;
}

beta_out = beta;

writeMM(as(beta_out,"CsparseMatrix"), paste(args[6], "w", sep=""))

#-------------------------------------------------------------
#
# Licensed to the Apache Software Foundation (ASF) under one
# or more contributor license agreements.  See the NOTICE file
# distributed with this work for additional information
# regarding copyright ownership.  The ASF licenses this file
# to you under the Apache License, Version 2.0 (the
# "License"); you may not use this file except in compliance
# with the License.  You may obtain a copy of the License at
# 
#   http://www.apache.org/licenses/LICENSE-2.0
# 
# Unless required by applicable law or agreed to in writing,
# software distributed under the License is distributed on an
# "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
# KIND, either express or implied.  See the License for the
# specific language governing permissions and limitations
# under the License.
#
#-------------------------------------------------------------
args <- commandArgs(TRUE)
library("Matrix")
library("matrixStats") 
imgSize=as.integer(args[1])
numImg=as.integer(args[2])
numChannels=as.integer(args[3])
poolSize1=as.integer(args[4])
poolSize2=as.integer(args[5])
stride=as.integer(args[6])
pad=as.integer(args[7])
P=as.integer(args[8])
Q=as.integer(args[9])

# Assumption: NCHW image format
x=matrix(seq(1, numImg*numChannels*imgSize*imgSize), numImg, numChannels*imgSize*imgSize, byrow=TRUE)
dout=matrix(seq(1, numImg*numChannels*P*Q), numImg, numChannels*P*Q, byrow=TRUE)
if(as.logical(args[11])) {
	zero_mask = (x - mean(x)*1.5) > 0 
	x = x * zero_mask
} else {
	x = x - mean(x)
}
if(as.logical(args[12])) {
	zero_mask = (dout - mean(dout)*1.5) > 0 
	dout = dout * zero_mask
} else {
	dout = dout - mean(dout)
}
max_pool_backward <- function(dout, Hout, Wout, X, C,
                    Hin, Win, Hf, Wf, strideh, stridew)
     {
  N = nrow(X)
  
  # Create gradient volume
  dX = matrix(0, N, C*Hin*Win, byrow=TRUE)
  
  # Gradient of max pooling
  for (n in 1:N) {  # all examples
    img = matrix(X[n,], C, Hin*Win, byrow=TRUE)
    dimg = matrix(0, C, Hin*Win, byrow=TRUE)
    for (c in 1:C) {  # all channels
      img_slice = matrix(img[c,], Hin, Win, byrow=TRUE)
      dimg_slice = matrix(0, Hin, Win, byrow=TRUE)
      for (hout in 1:Hout) {  # all output rows
        hin = (hout-1) * strideh + 1
        for (wout in 1:Wout) {  # all output columns
          win = (wout-1) * stridew + 1
          img_slice_patch = img_slice[hin:(hin+Hf-1), win:(win+Wf-1)]
          max_val = max(img_slice_patch)
          max_val_ind = matrix(0, nrow(img_slice_patch), ncol(img_slice_patch))
          max_val_ind[which.max(img_slice_patch)] = 1  # first max value indicator
          # gradient passes through only for the max value in this patch
          dimg_slice_patch = max_val_ind * dout[n, (c-1)*Hout*Wout + (hout-1)*Wout + wout]
          dimg_slice[hin:(hin+Hf-1), win:(win+Wf-1)] =
            dimg_slice[hin:(hin+Hf-1), win:(win+Wf-1)] + dimg_slice_patch
        }
      }
      dimg[c,] = matrix(t(dimg_slice), 1, Hin*Win)
    }
    dX[n,] = matrix(t(dimg), 1, C*Hin*Win)
  }
  
  dX
}

output = max_pool_backward(dout, P, Q, x, numChannels, imgSize, imgSize, poolSize1, poolSize2, stride, stride)
writeMM(as(output,"CsparseMatrix"), paste(args[10], "B", sep=""))

#-------------------------------------------------------------
#
# Licensed to the Apache Software Foundation (ASF) under one
# or more contributor license agreements.  See the NOTICE file
# distributed with this work for additional information
# regarding copyright ownership.  The ASF licenses this file
# to you under the Apache License, Version 2.0 (the
# "License"); you may not use this file except in compliance
# with the License.  You may obtain a copy of the License at
# 
#   http://www.apache.org/licenses/LICENSE-2.0
# 
# Unless required by applicable law or agreed to in writing,
# software distributed under the License is distributed on an
# "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
# KIND, either express or implied.  See the License for the
# specific language governing permissions and limitations
# under the License.
#
#-------------------------------------------------------------

args <- commandArgs(TRUE)

library("Matrix")
options(digits=22)

filename <- args[1]
dimensionality <- as.integer(args[2])
sep <- args[3]
indSep <- args[4]

if(sep == 'NULL'){
  sep=" "
}

content = readLines( filename )
num_lines = length( content )
A = matrix( 0, num_lines, dimensionality + 1 )

# loop over lines
for ( i in 1:num_lines ) {
  # split by sep
  line = as.vector( strsplit( content[i], sep )[[1]])
  # save label
  A[i,1] = as.numeric( line[[1]] )
  # loop over values
  for ( j in 2:length( line )) {
    # split by colon
    index_value = strsplit( line[j], indSep )[[1]]
    index = as.numeric( index_value[1] ) + 1
     value = as.numeric( index_value[2] )
     A[i, index] = value
     }
  }
A[is.na(A)] = 0
A <- A+1
x =  sum(A)
write(x, args[5])

#-------------------------------------------------------------
#
# Licensed to the Apache Software Foundation (ASF) under one
# or more contributor license agreements.  See the NOTICE file
# distributed with this work for additional information
# regarding copyright ownership.  The ASF licenses this file
# to you under the Apache License, Version 2.0 (the
# "License"); you may not use this file except in compliance
# with the License.  You may obtain a copy of the License at
# 
#   http://www.apache.org/licenses/LICENSE-2.0
# 
# Unless required by applicable law or agreed to in writing,
# software distributed under the License is distributed on an
# "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
# KIND, either express or implied.  See the License for the
# specific language governing permissions and limitations
# under the License.
#
#-------------------------------------------------------------

args <- commandArgs(TRUE)

library("Matrix")
library("matrixStats")

options(warn=-1)


id3_learn = function(X, y, X_subset, attributes, minsplit)
{
	#try the two base cases first

	#of the remaining samples, compute a histogram for labels
	hist_labels_helper = as.matrix(aggregate(as.vector(X_subset), by=list(as.vector(y)), FUN=sum))
	hist_labels = as.matrix(hist_labels_helper[,2])

	#go through the histogram to compute the number of labels
	#with non-zero samples
	#and to pull out the most popular label
	
	num_non_zero_labels = sum(hist_labels > 0);
	most_popular_label = which.max(t(hist_labels));
	num_remaining_attrs = sum(attributes)
	
	num_samples = sum(X_subset)
	mpl = as.numeric(most_popular_label)
	
	nodes = matrix(0, 1, 1)
	edges = matrix(0, 1, 1)
	
	#if all samples have the same label then return a leaf node
	#if no attributes remain then return a leaf node with the most popular label	
	if(num_non_zero_labels == 1 | num_remaining_attrs == 0 | num_samples < minsplit){
		nodes = matrix(0, 1, 2)
		nodes[1,1] = -1
		nodes[1,2] = most_popular_label
		edges = matrix(-1, 1, 1)
	}else{
		#computing gains for all available attributes using parfor
		hist_labels2_helper = as.matrix(aggregate(as.vector(X_subset), by=list(as.vector(y)), FUN=sum))
		hist_labels2 = as.matrix(hist_labels2_helper[,2])
		num_samples2 = sum(X_subset)
		zero_entries_in_hist1 = (hist_labels2 == 0)
		pi1 = hist_labels2/num_samples2
		log_term1 = zero_entries_in_hist1*1 + (1-zero_entries_in_hist1)*pi1
		entropy_vector1 = -pi1*log(log_term1)
		ht = sum(entropy_vector1)
		
		sz = nrow(attributes)
		gains = matrix(0, sz, 1)
		for(i in 1:nrow(attributes)){
			if(as.numeric(attributes[i,1]) == 1){
				attr_vals = X[,i]
				attr_domain_helper = as.matrix(aggregate(as.vector(X_subset), by=list(as.vector(attr_vals)), FUN=sum))
				attr_domain = as.matrix(attr_domain_helper[,2])

				hxt_vector = matrix(0, nrow(attr_domain), 1)
				
				for(j in 1:nrow(attr_domain)){
					if(as.numeric(attr_domain[j,1]) != 0){
						val = j
						Tj = X_subset * (X[,i] == val)
						
						#entropy = compute_entropy(Tj, y)
						hist_labels1_helper = as.matrix(aggregate(as.vector(Tj), by=list(as.vector(y)), FUN=sum))
						hist_labels1 = as.matrix(hist_labels1_helper[,2])
						num_samples1 = sum(Tj)
						zero_entries_in_hist = (hist_labels1 == 0)
						piv = hist_labels1/num_samples1
						log_term = zero_entries_in_hist*1 + (1-zero_entries_in_hist)*piv
						entropy_vector = -piv*log(log_term)
						entropy = sum(entropy_vector)
	
						hxt_vector[j,1] = sum(Tj)/sum(X_subset)*entropy
					}
				}
				hxt = sum(hxt_vector)
				gains[i,1] = (ht - hxt)
			}
		}
		
		#pick out attr with highest gain
		best_attr = -1
		max_gain = 0
		for(i4 in 1:nrow(gains)){
			if(as.numeric(attributes[i4,1]) == 1){
				g = as.numeric(gains[i4,1])
				if(best_attr == -1 | max_gain <= g){
					max_gain = g
					best_attr = i4
				}
			}
		}		
		
		attr_vals = X[,best_attr]
		attr_domain_helper = as.matrix(aggregate(as.vector(X_subset), by=list(as.vector(attr_vals)), FUN=sum))
		attr_domain = as.matrix(attr_domain_helper[,2])

		new_attributes = attributes
		new_attributes[best_attr, 1] = 0
		
		max_sz_subtree = 2*sum(X_subset)
		sz2 = nrow(attr_domain)
		sz1 = sz2*max_sz_subtree
		
		tempNodeStore = matrix(0, 2, sz1)
		tempEdgeStore = matrix(0, 3, sz1)
		numSubtreeNodes = matrix(0, sz2, 1)
		numSubtreeEdges = matrix(0, sz2, 1)
		
		for(i1 in 1:nrow(attr_domain)){
			
			Ti = X_subset * (X[,best_attr] == i1)
			num_nodes_Ti = sum(Ti)
			
			if(num_nodes_Ti > 0){
				tmpRet <- id3_learn(X, y, Ti, new_attributes, minsplit)
			  nodesi = as.matrix(tmpRet$a);
        edgesi = as.matrix(tmpRet$b);
      
				start_pt = 1+(i1-1)*max_sz_subtree
        tempNodeStore[,start_pt:(start_pt+nrow(nodesi)-1)] = t(nodesi)
			
        numSubtreeNodes[i1,1] = nrow(nodesi)
				if(nrow(edgesi)!=1 | ncol(edgesi)!=1 | as.numeric(edgesi[1,1])!=-1){
					tempEdgeStore[,start_pt:(start_pt+nrow(edgesi)-1)] = t(edgesi)
					numSubtreeEdges[i1,1] = nrow(edgesi)
				}else{
					numSubtreeEdges[i1,1] = 0
				}
			}
		}
		
		num_nodes_in_subtrees = sum(numSubtreeNodes)
		num_edges_in_subtrees = sum(numSubtreeEdges)
		
		#creating root node
		sz = 1+num_nodes_in_subtrees
		
		nodes = matrix(0, sz, 2)
		nodes[1,1] = best_attr
		numNodes = 1
		
		#edges from root to children
		sz = sum(numSubtreeNodes > 0) + num_edges_in_subtrees
		
		edges = matrix(1, sz, 3)
		numEdges = 0
		for(i6 in 1:nrow(attr_domain)){
			num_nodesi = as.numeric(numSubtreeNodes[i6,1])
			if(num_nodesi > 0){
				edges[numEdges+1,2] = i6
				numEdges = numEdges + 1
			}
		}
		
		nonEmptyAttri = 0
		for(i7 in 1:nrow(attr_domain)){
			numNodesInSubtree = as.numeric(numSubtreeNodes[i7,1])
		
			if(numNodesInSubtree > 0){
				start_pt1 = 1 + (i7-1)*max_sz_subtree
				nodes[(numNodes+1):(numNodes+numNodesInSubtree),] = t(tempNodeStore[,start_pt1:(start_pt1+numNodesInSubtree-1)])
			
				numEdgesInSubtree = as.numeric(numSubtreeEdges[i7,1])
			
				if(numEdgesInSubtree!=0){
					edgesi1 = t(tempEdgeStore[,start_pt1:(start_pt1+numEdgesInSubtree-1)])
					edgesi1[,1] = edgesi1[,1] + numNodes
					edgesi1[,3] = edgesi1[,3] + numNodes
          
					edges[(numEdges+1):(numEdges+numEdgesInSubtree),] = edgesi1
					numEdges = numEdges + numEdgesInSubtree
				}
			
				edges[nonEmptyAttri+1,3] = numNodes + 1
				nonEmptyAttri = nonEmptyAttri + 1
				
				numNodes = numNodes + numNodesInSubtree
			}
		}
	}
  
  return ( list(a=nodes, b=edges) );
}

X = readMM(paste(args[1], "X.mtx", sep=""));
y = readMM(paste(args[1], "y.mtx", sep=""));

n = nrow(X)
m = ncol(X)

minsplit = 2


X_subset = matrix(1, n, 1)
attributes = matrix(1, m, 1)
# recoding inputs
featureCorrections = as.vector(1 - colMins(as.matrix(X)))
onesMat = matrix(1, n, m)

X = onesMat %*% diag(featureCorrections) + X
labelCorrection = 1 - min(y)
y = y + labelCorrection + 0

tmpRet <- id3_learn(X, y, X_subset, attributes, minsplit)
nodes = as.matrix(tmpRet$a)
edges = as.matrix(tmpRet$b)

# decoding outputs
nodes[,2] = nodes[,2] - labelCorrection * (nodes[,1] == -1)
for(i3 in 1:nrow(edges)){
	e_parent = as.numeric(edges[i3,1])
	parent_feature = as.numeric(nodes[e_parent,1])
	correction = as.numeric(featureCorrections[parent_feature])
	edges[i3,2] = edges[i3,2] - correction
}

writeMM(as(nodes,"CsparseMatrix"), paste(args[2],"nodes", sep=""), format = "text")
writeMM(as(edges,"CsparseMatrix"), paste(args[2],"edges", sep=""), format = "text")

#-------------------------------------------------------------
#
# Licensed to the Apache Software Foundation (ASF) under one
# or more contributor license agreements.  See the NOTICE file
# distributed with this work for additional information
# regarding copyright ownership.  The ASF licenses this file
# to you under the Apache License, Version 2.0 (the
# "License"); you may not use this file except in compliance
# with the License.  You may obtain a copy of the License at
#
#   http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing,
# software distributed under the License is distributed on an
# "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
# KIND, either express or implied.  See the License for the
# specific language governing permissions and limitations
# under the License.
#
#-------------------------------------------------------------

args<-commandArgs(TRUE)
library(mice)
library("Matrix")
library(dplyr)

d <- read.csv(args[1], header=FALSE )
mass <- as.matrix(readMM(paste(args[2], "M.mtx", sep="")));
if(sum(mass) == ncol(d))
{
  d = d[,3:4]
  d[] <- lapply(d, factor)
  d
  mass = mass[1,3:4]
  meth = meth= rep("polyreg", ncol(d))
  #impute
  imputeD <- mice(d,where = is.na(d), method = meth, m=3)
  imputeD
  R = as.matrix(complete(imputeD,3))
  writeMM(as(R, "CsparseMatrix"), paste(args[3], "C", sep=""));
 } else if (sum(mass) == 0)
{
  imputeD <- mice(d,where = is.na(d), method = "norm.predict", m=3)
  R = as.matrix(complete(imputeD,3))
  writeMM(as(as.matrix(R), "CsparseMatrix"), paste(args[3], "N", sep=""));  
} else {
  meth=""
  for(i in 1: ncol(mass)) {
    if(as.integer(mass[1,i]) == 1)  {
      d[[names(d)[i]]] =  as.factor(d[[names(d)[i]]]); 
      meth = c(meth, "polyreg")
    } else meth = c(meth, "norm.predict")
  }

  meth=meth[-1]
  # set the prediction matrix
  pred <- make.predictorMatrix(d)
  pred = pred * diag(1, ncol(mass))

  pred[names(d)[1], names(d)[2]] = 1
  pred[names(d)[2], names(d)[1]] = 1

  pred[names(d)[1], names(d)[4]] = 1
  pred[names(d)[4], names(d)[1]] = 1

  pred[names(d)[2], names(d)[4]] = 1
  pred[names(d)[4], names(d)[2]] = 1

  pred[names(d)[3], names(d)[4]] = 1
  pred[names(d)[4], names(d)[3]] = 1

  
  #impute
  imputeD <- mice(d,where = is.na(d), method = meth, m=3,  pred = pred)
  R = data.frame(complete(imputeD,3))
  c = select_if(R, is.factor)
  # convert factor into numeric before casting to matrix
  c =  sapply(c, function(x) as.numeric(as.character(x)))
  n = select_if(R, is.numeric)
  writeMM(as(as.matrix(c), "CsparseMatrix"), paste(args[3], "C", sep=""));
  writeMM(as(as.matrix(n), "CsparseMatrix"), paste(args[3], "N", sep=""));
}

#-------------------------------------------------------------
#
# Licensed to the Apache Software Foundation (ASF) under one
# or more contributor license agreements.  See the NOTICE file
# distributed with this work for additional information
# regarding copyright ownership.  The ASF licenses this file
# to you under the Apache License, Version 2.0 (the
# "License"); you may not use this file except in compliance
# with the License.  You may obtain a copy of the License at
#
#   http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing,
# software distributed under the License is distributed on an
# "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
# KIND, either express or implied.  See the License for the
# specific language governing permissions and limitations
# under the License.
#
#-------------------------------------------------------------

args <- commandArgs(TRUE)

library("Matrix")
library("naivebayes")

D = as.matrix(readMM(paste(args[1], "D.mtx", sep="")))
C = as.matrix(readMM(paste(args[1], "C.mtx", sep="")))
laplace <- as.numeric(args[3])

# divide D into "train" and "test" data
numRows = nrow(D)
trainSize = numRows * 0.8

trainData = D[1:trainSize, ]
testData = D[(trainSize+1):numRows, ]
y <- factor(C[1:trainSize])

# The Naive Bayes Predict need to unique column name
features <- paste0("V", seq_len(ncol(trainData)))
colnames(trainData) <- features
colnames(testData) <- features

# Create model base on train data
model <- multinomial_naive_bayes(x = trainData, y = y, laplace = laplace)

# The SystemDS DML scripts based on YRaw data
# and the "naivebayes" predict function in R
# return probabilities matrix
# Example: YRaw <- predict(model, newdata = testData, type = "prob")

# We need to return "Raw" values
lev <- model$levels
prior <- model$prior
params <- t(model$params)
YRaw <- tcrossprod(testData, log(params))

for (ith_class in seq_along(lev)) {
  YRaw[ ,ith_class] <- YRaw[ ,ith_class] + log(prior[ith_class])
}

Y <- max.col(YRaw, ties.method="last")

# write out the predict
writeMM(as(YRaw, "CsparseMatrix"), paste(args[4], "YRaw", sep=""))
writeMM(as(Y, "CsparseMatrix"), paste(args[4], "Y", sep=""))

#-------------------------------------------------------------
#
# Licensed to the Apache Software Foundation (ASF) under one
# or more contributor license agreements.  See the NOTICE file
# distributed with this work for additional information
# regarding copyright ownership.  The ASF licenses this file
# to you under the Apache License, Version 2.0 (the
# "License"); you may not use this file except in compliance
# with the License.  You may obtain a copy of the License at
# 
#   http://www.apache.org/licenses/LICENSE-2.0
# 
# Unless required by applicable law or agreed to in writing,
# software distributed under the License is distributed on an
# "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
# KIND, either express or implied.  See the License for the
# specific language governing permissions and limitations
# under the License.
#
#-------------------------------------------------------------


args <- commandArgs(TRUE)
options(digits=22)

library("Matrix")

factorial <- function(arr, pos){
	if(pos == 1){
     arr[1, pos] = 1
	} else {
		arr = factorial(arr, pos-1)
		arr[1, pos] = pos * arr[1, pos-1]
	}

  return(arr);	
}

n = as.integer(args[1])
arr = matrix(0, 1, n)
arr = factorial(arr, n)

R = matrix(0, 1, n);
for(i in 1:n)
{
   R[1,i] = arr[1, i];
}

writeMM(as(R, "CsparseMatrix"), paste(args[2], "R", sep="")); 

#-------------------------------------------------------------
#
# Licensed to the Apache Software Foundation (ASF) under one
# or more contributor license agreements.  See the NOTICE file
# distributed with this work for additional information
# regarding copyright ownership.  The ASF licenses this file
# to you under the Apache License, Version 2.0 (the
# "License"); you may not use this file except in compliance
# with the License.  You may obtain a copy of the License at
# 
#   http://www.apache.org/licenses/LICENSE-2.0
# 
# Unless required by applicable law or agreed to in writing,
# software distributed under the License is distributed on an
# "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
# KIND, either express or implied.  See the License for the
# specific language governing permissions and limitations
# under the License.
#
#-------------------------------------------------------------

args<-commandArgs(TRUE)
options(digits=22)
library("Matrix")

V = matrix(seq(0,14), 5, 3, byrow=TRUE);
X = matrix(seq(1,15), 5, 3, byrow=TRUE);
Y = matrix(seq(2,16), 5, 3, byrow=TRUE);
Z = matrix(seq(3,17), 5, 3, byrow=TRUE);

#disjoint partitions with transitive partial shared reads
r1 = sum(V * X);
r2 = sum(Y * Z);
r3 = sum(X * Y * Z);
S = as.matrix(r1+r2+r3);

writeMM(as(S, "CsparseMatrix"), paste(args[2], "S", sep="")); 

#-------------------------------------------------------------
#
# Licensed to the Apache Software Foundation (ASF) under one
# or more contributor license agreements.  See the NOTICE file
# distributed with this work for additional information
# regarding copyright ownership.  The ASF licenses this file
# to you under the Apache License, Version 2.0 (the
# "License"); you may not use this file except in compliance
# with the License.  You may obtain a copy of the License at
# 
#   http://www.apache.org/licenses/LICENSE-2.0
# 
# Unless required by applicable law or agreed to in writing,
# software distributed under the License is distributed on an
# "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
# KIND, either express or implied.  See the License for the
# specific language governing permissions and limitations
# under the License.
#
#-------------------------------------------------------------

args<-commandArgs(TRUE)
options(digits=22)
library("Matrix")
X = matrix(  c(1,2,3,4,5,6,7,8,9,10,11,12,13,14,15), nrow=5, ncol=3, byrow = TRUE)
v=matrix(1,3,1)

###############Test0
#lamda = sum(X)
#S=t(X)%*%X%*%(lamda*v)
#writeMM(as(S, "CsparseMatrix"), paste(args[2], "S", sep="")); 

###############Test1
#lamda=sum(X)
#S=t(X)%*%(lamda*(X%*%v))
#writeMM(as(S, "CsparseMatrix"), paste(args[2], "S", sep="")); 

###############Test2
#w=matrix(  c(1,2,3,4,5), nrow=5, ncol=1, byrow = TRUE)
#S=t(X)%*%(w*(X%*%v))
#writeMM(as(S, "CsparseMatrix"), paste(args[2], "S", sep="")); 

###############Test3
S=colSums(X/rowSums(X))
writeMM(as(S, "CsparseMatrix"), paste(args[2], "S", sep="")); 

#-------------------------------------------------------------
#
# Licensed to the Apache Software Foundation (ASF) under one
# or more contributor license agreements.  See the NOTICE file
# distributed with this work for additional information
# regarding copyright ownership.  The ASF licenses this file
# to you under the Apache License, Version 2.0 (the
# "License"); you may not use this file except in compliance
# with the License.  You may obtain a copy of the License at
#
#   http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing,
# software distributed under the License is distributed on an
# "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
# KIND, either express or implied.  See the License for the
# specific language governing permissions and limitations
# under the License.
#
#-------------------------------------------------------------

# JUnit test class: dml.test.integration.applications.L2SVMTest.java
# command line invocation assuming $L2SVM_HOME is set to the home of the R script
# Rscript $L2SVM_HOME/L2SVM.R $L2SVM_HOME/in/ 0.00000001 1 100 $L2SVM_HOME/expected/

args <- commandArgs(TRUE)
library("Matrix")

X = readMM(paste(args[1], "X.mtx", sep=""));
Y = readMM(paste(args[1], "Y.mtx", sep=""));

check_min = min(Y)
check_max = max(Y)
num_min = sum(Y == check_min)
num_max = sum(Y == check_max)
if(num_min + num_max != nrow(Y)){
	print("please check Y, it should contain only 2 labels")
}else{
	if(check_min != -1 | check_max != +1)
		Y = 2/(check_max - check_min)*Y - (check_min + check_max)/(check_max - check_min)
}

intercept = as.logical(args[2]);
epsilon = as.double(args[3]);
lambda = as.double(args[4]);
maxiterations = as.integer(args[5]);

N = nrow(X)
D = ncol(X)

if (intercept) {
	ones  = matrix(1,N,1)
	X = cbind(X, ones);
}

num_rows_in_w = D
if(intercept){
	num_rows_in_w = num_rows_in_w + 1
}
w = matrix(0, num_rows_in_w, 1)

g_old = t(X) %*% Y
s = g_old

Xw = matrix(0,nrow(X),1)
iter = 0
continue = TRUE
while(continue && iter < maxiterations){
	t = 0
	Xd = X %*% s
	wd = lambda * sum(w * s)
	dd = lambda * sum(s * s)
	continue1 = TRUE
	while(continue1){
		tmp_Xw = Xw + t*Xd
		out = 1 - Y * (tmp_Xw)
		sv = which(out > 0)
		g = wd + t*dd - sum(out[sv] * Y[sv] * Xd[sv])
		h = dd + sum(Xd[sv] * Xd[sv])
		t = t - g/h
		continue1 = (g*g/h >= epsilon)
	}

	w = w + t*s
	Xw = Xw + t*Xd

	out = 1 - Y * (X %*% w)
	sv = which(out > 0)
	obj = 0.5 * sum(out[sv] * out[sv]) + lambda/2 * sum(w * w)
	g_new = t(X[sv,]) %*% (out[sv] * Y[sv]) - lambda * w

	#print(paste("OBJ : ", obj))

	continue = (t*sum(s * g_old) >= epsilon*obj)

	be = sum(g_new * g_new)/sum(g_old * g_old)
	s = be * s + g_new
	g_old = g_new

	iter = iter + 1
}

writeMM(as(w,"CsparseMatrix"), paste(args[6], "model", sep=""));

#-------------------------------------------------------------
#
# Licensed to the Apache Software Foundation (ASF) under one
# or more contributor license agreements.  See the NOTICE file
# distributed with this work for additional information
# regarding copyright ownership.  The ASF licenses this file
# to you under the Apache License, Version 2.0 (the
# "License"); you may not use this file except in compliance
# with the License.  You may obtain a copy of the License at
# 
#   http://www.apache.org/licenses/LICENSE-2.0
# 
# Unless required by applicable law or agreed to in writing,
# software distributed under the License is distributed on an
# "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
# KIND, either express or implied.  See the License for the
# specific language governing permissions and limitations
# under the License.
#
#-------------------------------------------------------------
args <- commandArgs(TRUE)
library("Matrix")
imgSize=as.integer(args[1])
numImg=as.integer(args[2])
numChannels=as.integer(args[3])
numFilters=as.integer(args[4])
filterSize=as.integer(args[5])
stride=as.integer(args[6])
pad=as.integer(args[7])
P=as.integer(args[8])
Q=as.integer(args[9])

# Assumption: NCHW image format
w=matrix(seq(1, numFilters*numChannels*filterSize*filterSize), numFilters, numChannels*filterSize*filterSize, byrow=TRUE)
dout=matrix(seq(1, numImg*numFilters*P*Q), numImg, numFilters*P*Q, byrow=TRUE)

if(as.logical(args[11])) {
	zero_mask = (w - mean(w)) > 0 
	w = w * zero_mask
} else {
	w = w - mean(w)
}
if(as.logical(args[12])) {
	zero_mask = (dout - mean(dout)) > 0 
	dout = dout * zero_mask
} else {
	dout = dout - mean(dout)
}
col2im <- function(img_cols, C, Hin, Win, Hf, Wf,
                  strideh, stridew, reduction) {

  Hout = as.integer((Hin - Hf) / strideh + 1)
  Wout = as.integer((Win - Wf) / stridew + 1)

  img = matrix(0, C, Hin*Win, byrow=TRUE)  # zeros
  for (hout in 1:Hout) {  # all output rows
    hin = (hout-1) * strideh + 1
    for (wout in 1:Wout) {  # all output columns
      win = (wout-1) * stridew + 1
      # Extract a local patch of the input image corresponding spatially to the filter sizes.
      img_patch = matrix(img_cols[,(hout-1)*Wout + wout], C, Hf*Wf, byrow=TRUE)  # zeros
      for (c in 1:C) {  # all channels
        img_patch_slice = matrix(img_patch[c,], Hf, Wf, byrow=TRUE)  # reshape
        if (reduction == "add") {
          img_slice = matrix(0, Hin, Win, byrow=TRUE)
          img_slice[hin:(hin+Hf-1), win:(win+Wf-1)] = img_patch_slice
          img[c,] = img[c,] + matrix(t(img_slice), 1, Hin*Win)
        } else {
          img_slice = matrix(img[c,], Hin, Win, byrow=TRUE)
          img_slice[hin:(hin+Hf-1), win:(win+Wf-1)] = img_patch_slice
          img[c,] = matrix(t(img_slice), 1, Hin*Win)
        }
      }
    }
  }
  img
}

unpad_image <- function(img_padded, Hin, Win, padh, padw) {
  C = nrow(img_padded)
  img = matrix(0, C, Hin*Win, byrow=TRUE)
  for (c in 1:C) {
    img_padded_slice = matrix(img_padded[c,], (Hin+2*padh), (Win+2*padw), byrow=TRUE)
    img_slice = img_padded_slice[(padh+1):(padh+Hin), (padw+1):(padw+Win)]
    img[c,] = matrix(t(img_slice), 1, Hin*Win)
  }
  img
}

conv2d_backward_data <- function(dout, Hout, Wout,
                    W, N, C, Hin, Win, Hf, Wf,
                    strideh, stridew, padh, padw) {

  F = nrow(W)
  
  # Create gradient volumes
  dX = matrix(0, N, C*Hin*Win, byrow=TRUE)
  
  # Partial derivatives for convolution - im2col implementation
  for (n in 1:N) {  # all examples
    doutn = matrix(dout[n,], F, Hout*Wout, byrow=TRUE)

    # Compute dX
    dXn_padded_cols = t(W) %*% doutn  # shape (C*Hf*Wf, Hout*Wout)
    dXn_padded = col2im(dXn_padded_cols, C, Hin+2*padh, Win+2*padw, Hf, Wf, strideh, stridew, "add")
    dXn = unpad_image(dXn_padded, Hin, Win, padh, padw)
    dX[n,] = matrix(t(dXn), 1, C*Hin*Win)  # reshape
  }
  
  dX
}

dx = conv2d_backward_data(dout, P, Q, w, numImg, numChannels, imgSize, imgSize, filterSize, filterSize, stride, stride, pad, pad);

writeMM(as(dx,"CsparseMatrix"), paste(args[10], "B", sep=""))

#-------------------------------------------------------------
#
# Licensed to the Apache Software Foundation (ASF) under one
# or more contributor license agreements.  See the NOTICE file
# distributed with this work for additional information
# regarding copyright ownership.  The ASF licenses this file
# to you under the Apache License, Version 2.0 (the
# "License"); you may not use this file except in compliance
# with the License.  You may obtain a copy of the License at
# 
#   http://www.apache.org/licenses/LICENSE-2.0
# 
# Unless required by applicable law or agreed to in writing,
# software distributed under the License is distributed on an
# "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
# KIND, either express or implied.  See the License for the
# specific language governing permissions and limitations
# under the License.
#
#-------------------------------------------------------------

args <- commandArgs(TRUE)
library(Matrix)

# Rscript ./test/scripts/functions/unary/matrix/QRsolve.R ./test/scripts/functions/unary/matrix/in/A.mtx ./test/scripts/functions/unary/matrix/in/y.mtx ./test/scripts/functions/unary/matrix/expected/x

A = readMM(args[1]); #paste(args[1], "A.mtx", sep=""));
b = readMM(args[2]); #paste(args[1], "b.mtx", sep=""));

m = nrow(A);
n = ncol(A);

Ab = cbind(as.matrix(A), as.matrix(b));

Ab_qr = qr(Ab);
Rb = qr.R(Ab_qr); 

R = Rb[1:n, 1:n];
c = Rb[1:n, (n+1)];

x = solve(R,c);

writeMM(as(x, "CsparseMatrix"), args[3]); #paste(args[2], "x.mtx", sep=""));

#-------------------------------------------------------------
#
# Licensed to the Apache Software Foundation (ASF) under one
# or more contributor license agreements.  See the NOTICE file
# distributed with this work for additional information
# regarding copyright ownership.  The ASF licenses this file
# to you under the Apache License, Version 2.0 (the
# "License"); you may not use this file except in compliance
# with the License.  You may obtain a copy of the License at
#
#   http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing,
# software distributed under the License is distributed on an
# "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
# KIND, either express or implied.  See the License for the
# specific language governing permissions and limitations
# under the License.
#
#-------------------------------------------------------------

args<-commandArgs(TRUE)
options(digits=22)
library("Matrix")
library("matrixStats")

# library("doMC")
# registerDoMC(NULL) # physical cores

################################################################################

slicefinder = function(X, e,
  k = 4, maxL = 0, minSup = 32, alpha = 0.5,
  tpEval = TRUE, tpBlksz = 16, verbose = FALSE)
{
  # init debug matrix: levelID, enumerated S, valid S, TKmax, TKmin
  D = matrix(0, 0, 5);
  m = nrow(X);
  n = ncol(X);
  
  # prepare offset vectors and one-hot encoded X
  fdom = colMaxs(X);
  foffb = t(cumsum(t(fdom))) - fdom;
  foffe = t(cumsum(t(fdom)))
  rix = matrix(seq(1,m)%*%matrix(1,1,n), m*n, 1)
  cix = matrix(X + (matrix(1,nrow(X),1) %*% foffb), m*n, 1);
  X2 = table(rix, cix); #one-hot encoded

  # initialize statistics and basic slices
  n2 = ncol(X2);     # one-hot encoded features
  eAvg = sum(e) / m; # average error
  TMP1 = createAndScoreBasicSlices(X2, e, eAvg, minSup, alpha, verbose); 
  S = TMP1[["S"]];
  R = TMP1[["R"]];

  # initialize top-k
  TMP2 = maintainTopK(S, R, matrix(0,0,n2), matrix(0,0,4), k, minSup);
  TK = TMP2[["TK"]]; TKC = TMP2[["TKC"]];

  if( verbose ) {
    TMP3 = analyzeTopK(TKC);
    maxsc = TMP3[["maxsc"]]; minsc = TMP3[["minsc"]];
    print(paste("SliceFinder: initial top-K: count=",nrow(TK),", max=",maxsc,", min=",minsc,sep=""))
    D = rbind(D, t(as.matrix(list(1, n2, nrow(S), maxsc, minsc))));
  }

  # lattice enumeration w/ size/error pruning, one iteration per level
  # termination condition (max #feature levels)
  maxL = ifelse(maxL<=0, n, maxL)
  level = 1;
  while( nrow(S) > 0 & sum(S) > 0 & level < n & level < maxL ) {
    level = level + 1;

    # enumerate candidate join pairs, incl size/error pruning 
    nrS = nrow(S);
    S = getPairedCandidates(S, R, TK, TKC, k, level, eAvg, minSup, alpha, n2, foffb, foffe); 

    if(verbose) {
      print(paste("SliceFinder: level ",level,":",sep=""))
      print(paste(" -- generated paired slice candidates: ",nrS," -> ",nrow(S),sep=""));
    }

    # extract and evaluate candidate slices
    if( tpEval ) { # task-parallel
      #R = foreach( i=1:nrow(S), .combine=rbind) %dopar% {
      #  return (evalSlice(X2, e, eAvg, as.matrix(S[i,]), level, alpha))
      #}
      R = matrix(0, nrow(S), 4)
      for(i in 1:nrow(S)) {
        R[i,] = evalSlice(X2, e, eAvg, as.matrix(S[i,]), level, alpha)
      }
    }
    else { # data-parallel
      R = evalSlice(X2, e, eAvg, t(S), level, alpha);
    }
    
    # maintain top-k after evaluation
    TMP2 = maintainTopK(S, R, TK, TKC, k, minSup);
    TK = TMP2[["TK"]]; TKC = TMP2[["TKC"]];

    if(verbose) {
      TMP3 = analyzeTopK(TKC);
      maxsc = TMP3[["maxsc"]]; minsc = TMP3[["minsc"]];
      valid = as.integer(sum(R[,2]>0 & R[,4]>=minSup));
      print(paste(" -- valid slices after eval: ",valid,"/",nrow(S),sep=""));
      print(paste(" -- top-K: count=",nrow(TK),", max=",maxsc,", min=",minsc,sep=""));
      D = rbind(D, t(as.matrix(list(level, nrow(S), valid, maxsc, minsc))));
    }
  }

  TK = decodeTopK(TK, foffb, foffe);

  if( verbose ) {
    print(paste("SliceFinder: terminated at level ",level,":"));
    print(TK); print(TKC);
  }
  
  return (list("TK"=TK, "TKC"=TKC, "D"=D))
}

rexpand = function(v, n2=max(v)) {
  R = matrix(0, nrow(v), n2)
  for( i in 1:nrow(v) ) {
    R[i,] = tabulate(v[i,], nbins=n2);
  }
  return (R)
} 

createAndScoreBasicSlices = function(X2, e, eAvg, minSup, alpha, verbose) {
  n2 = ncol(X2);
  cCnts = colSums(X2);    # column counts
  err = t(t(e) %*% X2);   # total error vector
  merr = t(colMaxs(X2 * (e %*% matrix(1,1,ncol(X2))))); # maximum error vector

  if( verbose ) {
    drop = as.integer(sum(cCnts < minSup | err == 0));
    print(paste("SliceFinder: dropping ",drop,"/",n2," features below minSup = ",minSup,".", sep=""));
  }

  # working set of active slices (#attr x #slices) and top k
  selCols = (cCnts >= minSup & err > 0);
  attr = as.matrix(seq(1,n2)[selCols])
  ss = as.matrix(cCnts[selCols])
  se = as.matrix(err[selCols])
  sm = as.matrix(merr[selCols])
  S = rexpand(attr, n2);
  
  # score 1-slices and create initial top-k 
  sc = score(ss, se, eAvg, alpha, nrow(X2));
  R = as.matrix(cbind(sc, se, sm, ss));

  return (list("S"=S,"R"=R))
}

score = function(ss, se, eAvg, alpha, n) {
  sc = alpha * ((se/ss) / eAvg - 1) - (1-alpha) * (n/ss - 1);
  sc = replace(sc, NaN, -Inf);
  return (sc)
}

scoreUB = function(ss, se, sm, eAvg, minSup, alpha, n) {
  # Since sc is either monotonically increasing or decreasing, we
  # probe interesting points of sc in the interval [minSup, ss],
  # and compute the maximum to serve as the upper bound 
  s = cbind(matrix(minSup,nrow(ss),1), pmax(se/sm,minSup), ss)
  ex = matrix(1,1,3)
  sc = rowMaxs(alpha * ((pmin(s*(sm%*%ex),se%*%ex)/s) / eAvg - 1) - (1-alpha) * (1/s*n - 1));
  sc = replace(sc, NaN, -Inf);
  return (sc)
}


maintainTopK = function(S, R, TK, TKC, k, minSup) {
  # prune invalid minSup and scores
  I = as.matrix((R[,1] > 0) & (R[,4] >= minSup));

  if( sum(I)!=0 ) {
    S = as.matrix(S[I,])
    R = as.matrix(R[I,])
    if( ncol(S) != ncol(TK) & ncol(S)==1 ) {
      S = t(S); R = t(R);
    }

    # evaluated candidated and previous top-k
    slices = as.matrix(rbind(TK, S));
    scores = as.matrix(rbind(TKC, R));

    # extract top-k
    IX = as.matrix(order(scores[,1], decreasing=TRUE));
    IX = as.matrix(IX[1:min(k,nrow(IX)),]);
    TK = as.matrix(slices[IX,]);
    TKC = as.matrix(scores[IX,]);
  }
  return (list("TK"=TK, "TKC"=TKC))
}

analyzeTopK = function(TKC) {
  maxsc = -Inf;
  minsc = -Inf;
  if( nrow(TKC)>0 ) {
    maxsc = TKC[1,1];
    minsc = TKC[nrow(TKC),1];
  }
  return (list("maxsc"=maxsc, "minsc"=minsc))
}

getPairedCandidates = function(S, R, TK, TKC, k,
  level, eAvg, minSup, alpha, n2, foffb, foffe)
{
  # prune invalid slices (possible without affecting overall
  # pruning effectiveness due to handling of missing parents)
  pI = (R[,4] >= minSup & R[,2] > 0);
  S = S[pI,]; R = R[pI,];

  # join compatible slices (without self)
  join = S %*% t(S) == (level-2)
  I = upper.tri(join, diag=FALSE) * join;

  # pair construction
  nr = nrow(I); nc = ncol(I);
  rix = matrix(I * (seq(1,nr)%*%matrix(1,1,ncol(I))), nr*nc, 1);
  cix = matrix(I * (matrix(1,nrow(I),1) %*% t(seq(1,nc))), nr*nc, 1);
  rix = as.matrix(rix[rix!=0,])
  cix = as.matrix(cix[cix!=0,])
  
  P = matrix(0, 0, ncol(S))
  if( sum(rix)!=0 ) {
    P1 = rexpand(rix, nrow(S));
    P2 = rexpand(cix, nrow(S));
    P12 = P1 + P2; # combined slice
    P = ((P1 %*% S + P2 %*% S) != 0) * 1;
    se = pmin(P1 %*% R[,2], P2 %*% R[,2])
    sm = pmin(P1 %*% R[,3], P2 %*% R[,3])
    ss = pmin(P1 %*% R[,4], P2 %*% R[,4])

    # prune invalid self joins (>1 bit per feature)
    I = matrix(1, nrow(P), 1);
    for( j in 1:ncol(foffb) ) {
      beg = foffb[1,j]+1;
      end = foffe[1,j];
      I = I & (rowSums(P[,beg:end]) <= 1);
    }
    P12 = P12[I,]
    P = P[I,]
    ss = as.matrix(ss[I])
    se = as.matrix(se[I])
    sm = as.matrix(sm[I])
    
    # prepare IDs for deduplication and pruning
    ID = matrix(0, nrow(P), 1);
    dom = foffe-foffb+1;
    for( j in 1:ncol(dom) ) {
      beg = foffb[1,j]+1;
      end = foffe[1,j];
      I = max.col(P[,beg:end],ties.method="last") * rowSums(P[,beg:end]);
      prod = 1;
      if(j<ncol(dom))
        prod = prod(dom[1,(j+1):ncol(dom)])
      ID = ID + I * prod;
    }

    # size pruning, with rowMin-rowMax transform 
    # to avoid densification (ignored zeros)
    map = table(ID, seq(1,nrow(P)))
    ex = matrix(1,nrow(map),1)
    ubSizes = 1/rowMaxs(map * (1/ex%*%t(ss)));
    ubSizes = as.matrix(replace(ubSizes, Inf, 0));
    fSizes = (ubSizes >= minSup)

    # error pruning
    ubError = 1/rowMaxs(map * (1/ex%*%t(se)));
    ubError = as.matrix(replace(ubError, Inf, 0));
    ubMError = 1/rowMaxs(map * (1/ex%*%t(sm)));
    ubMError = as.matrix(replace(ubMError, Inf, 0));
    ubScores = scoreUB(ubSizes, ubError, ubMError, eAvg, minSup, alpha, n2);
    TMP3 = analyzeTopK(TKC);
    minsc = TMP3[["minsc"]]
    fScores = (ubScores > minsc & ubScores > 0)

    # missing parents pruning
    numParents = rowSums((map %*% P12) != 0)
    fParents = (numParents == level);

    # apply all pruning
    map = map * ((fSizes & fScores & fParents) %*% matrix(1,1,ncol(map)));

    # deduplication of join outputs
    Dedup = as.matrix(map[rowMaxs(map)!=0,] != 0)
    P = (Dedup %*% P) != 0
  }
  return (P)
}

evalSlice = function(X, e, eAvg, tS, l, alpha) {
  I = (X %*% tS) == l;           # slice indicator
  ss = as.matrix(colSums(I));    # absolute slice size (nnz)
  se = as.matrix(t(t(e) %*% I)); # absolute slice error
  sm = as.matrix(colMaxs(I * e%*%matrix(1,1,ncol(I)))); # maximum tuple error in slice

  # score of relative error and relative size
  sc = score(ss, se, eAvg, alpha, nrow(X));
  R = as.matrix(cbind(sc, se, sm, ss));
  return (R)
}

decodeTopK = function(TK, foffb, foffe) {
  R = matrix(1, nrow(TK), ncol(foffb));
  if( nrow(TK) > 0 ) {
    for( j in 1:ncol(foffb) ) {
      beg = foffb[1,j]+1;
      end = foffe[1,j];
      I = rowSums(TK[,beg:end]) * max.col(TK[,beg:end],ties.method="last");
      R[, j] = I;
    }
  }
  return (R)
}

################################################################################
X = as.matrix(readMM(paste(args[1], "X.mtx", sep="")))
e = as.matrix(readMM(paste(args[1], "e.mtx", sep="")))
k = as.integer(args[2]);
tpEval = as.logical(args[3])

TMP = slicefinder(X=X, e=e, k=k, alpha=0.95, minSup=4, tpEval=tpEval, verbose=TRUE);
R = TMP[["TKC"]]

writeMM(as(R, "CsparseMatrix"), paste(args[4], "R", sep="")); 

#-------------------------------------------------------------
#
# Licensed to the Apache Software Foundation (ASF) under one
# or more contributor license agreements.  See the NOTICE file
# distributed with this work for additional information
# regarding copyright ownership.  The ASF licenses this file
# to you under the Apache License, Version 2.0 (the
# "License"); you may not use this file except in compliance
# with the License.  You may obtain a copy of the License at
# 
#   http://www.apache.org/licenses/LICENSE-2.0
# 
# Unless required by applicable law or agreed to in writing,
# software distributed under the License is distributed on an
# "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
# KIND, either express or implied.  See the License for the
# specific language governing permissions and limitations
# under the License.
#
#-------------------------------------------------------------

args <- commandArgs(TRUE)
library("Matrix")
library("matrixStats")

X = readMM(paste(args[1], "X.mtx", sep=""));
Y_vec = readMM(paste(args[1], "Y.mtx", sep=""));
intercept = as.integer(args[2]);
tol = as.double(args[3]);
maxiter = as.integer(args[4]);
regularization = as.double(args[5]);

intercept_status = intercept;
maxinneriter = 20;

print ("BEGIN MULTINOMIAL LOGISTIC REGRESSION SCRIPT");

eta0 = 0.0001;
eta1 = 0.25;
eta2 = 0.75;
sigma1 = 0.25;
sigma2 = 0.5;
sigma3 = 4.0;
psi = 0.1;

N = nrow (X);
D = ncol (X);

# Introduce the intercept, shift and rescale the columns of X if needed
if (intercept_status == 1 | intercept_status == 2)  # add the intercept column
{
    X = cbind (X, matrix (1, N, 1));
    D = ncol (X);
}

scale_lambda = matrix (1, D, 1);
if (intercept_status == 1 | intercept_status == 2)
{
    scale_lambda [D, 1] = 0;
}

if (intercept_status == 2)  # scale-&-shift X columns to mean 0, variance 1
{                           # Important assumption: X [, D] = matrix (1, rows = N, cols = 1)
    avg_X_cols = colSums(X) / N;
    var_X_cols = (colSums (X ^ 2) - N * (avg_X_cols ^ 2)) / (N - 1);
    is_unsafe = (var_X_cols <= 0.0);
    scale_X = 1.0 / sqrt (var_X_cols * (1 - is_unsafe) + is_unsafe);
    scale_X [D] = 1;
    shift_X = - avg_X_cols * scale_X;
    shift_X [D] = 0;
    scale_X = as.matrix(scale_X);
    shift_X = as.matrix(shift_X);
    rowSums_X_sq = (X ^ 2) %*% (scale_X ^ 2) + X %*% (2 * scale_X * shift_X) + sum (shift_X ^ 2);
} else {
    scale_X = matrix (1, D, 1);
    shift_X = matrix (0, D, 1);
    rowSums_X_sq = rowSums (X ^ 2);
}

# Henceforth we replace "X" with "X %*% (SHIFT/SCALE TRANSFORM)" and rowSums(X ^ 2)
# with "rowSums_X_sq" in order to preserve the sparsity of X under shift and scale.
# The transform is then associatively applied to the other side of the expression,
# and is rewritten via "scale_X" and "shift_X" as follows:
#
# ssX_A  = (SHIFT/SCALE TRANSFORM) %*% A    --- is rewritten as:
# ssX_A  = diag (scale_X) %*% A;
# ssX_A [D, ] = ssX_A [D, ] + t(shift_X) %*% A;
#
# tssX_A = t(SHIFT/SCALE TRANSFORM) %*% A   --- is rewritten as:
# tssX_A = diag (scale_X) %*% A + shift_X %*% A [D, ];

# Convert "Y_vec" into indicator matrice:
if (min (Y_vec) <= 0) { 
    # Category labels "0", "-1" etc. are converted into the largest label
    max_y = max (Y_vec);
    Y_vec  = Y_vec  + (- Y_vec  + max_y + 1) * (Y_vec <= 0.0);
}
Y = table (seq (1, N, 1), as.vector(Y_vec));
Y = as.matrix(as.data.frame.matrix(Y)) #this is required due to different table semantics

K = ncol (Y) - 1;   # The number of  non-baseline categories

lambda = (scale_lambda %*% matrix (1, 1, K)) * regularization;
delta = 0.5 * sqrt (D) / max (sqrt (rowSums_X_sq));

B = matrix (0, D, K);     ### LT = X %*% (SHIFT/SCALE TRANSFORM) %*% B;
                                        ### LT = append (LT, matrix (0, rows = N, cols = 1));
                                        ### LT = LT - rowMaxs (LT) %*% matrix (1, rows = 1, cols = K+1);
P = matrix (1, N, K+1);   ### exp_LT = exp (LT);
P = P / (K + 1);                        ### P =  exp_LT / (rowSums (exp_LT) %*% matrix (1, rows = 1, cols = K+1));
obj = N * log (K + 1);                  ### obj = - sum (Y * LT) + sum (log (rowSums (exp_LT))) + 0.5 * sum (lambda * (B_new ^ 2));

Grad = t(X) %*% (P [, 1:K] - Y [, 1:K]);
if (intercept_status == 2) {
    Grad = diag (as.vector(scale_X)) %*% Grad + shift_X %*% t(Grad [D, ]);
}
Grad = Grad + lambda * B;
norm_Grad = sqrt (sum (Grad ^ 2));
norm_Grad_initial = norm_Grad;

if (maxinneriter == 0) {
    maxinneriter = D * K;
}
iter = 1;

# boolean for convergence check
converge = (norm_Grad < tol) | (iter > maxiter);

print (paste("-- Initially:  Objective = ", obj, ",  Gradient Norm = ", norm_Grad , ",  Trust Delta = " , delta));

while (! converge)
{
	# SOLVE TRUST REGION SUB-PROBLEM
	S = matrix (0, D, K);
	R = - Grad;
	V = R;
	delta2 = delta ^ 2;
	inneriter = 1;
	norm_R2 = sum (R ^ 2);
	innerconverge = (sqrt (norm_R2) <= psi * norm_Grad);
	is_trust_boundary_reached = 0;

	while (! innerconverge)
	{
	    if (intercept_status == 2) {
	        ssX_V = diag (as.vector(scale_X)) %*% V;
	        ssX_V [D, ] = ssX_V [D, ] + t(shift_X) %*% V;
	    } else {
	        ssX_V = V;
	    }
        Q = P [, 1:K] * (X %*% ssX_V);
        HV = t(X) %*% (Q - P [, 1:K] * (rowSums (Q) %*% matrix (1, 1, K)));
        if (intercept_status == 2) {
            HV = diag (as.vector(scale_X)) %*% HV + shift_X %*% HV [D, ];
        }
        HV = HV + lambda * V;
		alpha = norm_R2 / sum (V * HV);
		Snew = S + alpha * V;
		norm_Snew2 = sum (Snew ^ 2);
		if (norm_Snew2 <= delta2)
		{
			S = Snew;
			R = R - alpha * HV;
			old_norm_R2 = norm_R2 
			norm_R2 = sum (R ^ 2);
			V = R + (norm_R2 / old_norm_R2) * V;
			innerconverge = (sqrt (norm_R2) <= psi * norm_Grad);
		} else {
	        is_trust_boundary_reached = 1;
			sv = sum (S * V);
			v2 = sum (V ^ 2);
			s2 = sum (S ^ 2);
			rad = sqrt (sv ^ 2 + v2 * (delta2 - s2));
			if (sv >= 0) {
				alpha = (delta2 - s2) / (sv + rad);
			} else {
				alpha = (rad - sv) / v2;
			}
			S = S + alpha * V;
			R = R - alpha * HV;
			innerconverge = TRUE;
		}
	    inneriter = inneriter + 1;
	    innerconverge = innerconverge | (inneriter > maxinneriter);
	}  
	
	# END TRUST REGION SUB-PROBLEM
	
	# compute rho, update B, obtain delta
	gs = sum (S * Grad);
	qk = - 0.5 * (gs - sum (S * R));
	B_new = B + S;
	if (intercept_status == 2) {
        ssX_B_new = diag (as.vector(scale_X)) %*% B_new;
        ssX_B_new [D, ] = ssX_B_new [D, ] + t(shift_X) %*% B_new;
    } else {
        ssX_B_new = B_new;
    }
    
    LT = as.matrix(cbind ((X %*% ssX_B_new), matrix (0, N, 1)));
    LT = LT - rowMaxs (LT) %*% matrix (1, 1, K+1);
    exp_LT = exp (LT);
    P_new  = exp_LT / (rowSums (exp_LT) %*% matrix (1, 1, K+1));
    obj_new = - sum (Y * LT) + sum (log (rowSums (exp_LT))) + 0.5 * sum (lambda * (B_new ^ 2));
    	
	# Consider updating LT in the inner loop
	# Consider the big "obj" and "obj_new" rounding-off their small difference below:

	actred = (obj - obj_new);

	rho = actred / qk;
	is_rho_accepted = (rho > eta0);
	snorm = sqrt (sum (S ^ 2));

	if (iter == 1) {
	   delta = min (delta, snorm);
	}

	alpha2 = obj_new - obj - gs;
	if (alpha2 <= 0) {
	   alpha = sigma3;
	} 
	else {
	   alpha = max (sigma1, -0.5 * gs / alpha2);
	}
	
	if (rho < eta0) {
		delta = min (max (alpha, sigma1) * snorm, sigma2 * delta);
	}
	else {
		if (rho < eta1) {
			delta = max (sigma1 * delta, min (alpha * snorm, sigma2 * delta));
		}
		else { 
			if (rho < eta2) {
				delta = max (sigma1 * delta, min (alpha * snorm, sigma3 * delta));
			}
			else {
				delta = max (delta, min (alpha * snorm, sigma3 * delta));
			}
		}
	} 
	
	if (is_trust_boundary_reached == 1)
	{
	    print (paste("-- Outer Iteration " , iter , ": Had " , (inneriter - 1) , " CG iterations, trust bound REACHED"));
	} else {
	    print (paste("-- Outer Iteration " , iter , ": Had " , (inneriter - 1) , " CG iterations"));
	}
	print (paste("   -- Obj.Reduction:  Actual = " , actred , ",  Predicted = " , qk , 
	       "  (A/P: " , (round (10000.0 * rho) / 10000.0) , "),  Trust Delta = " , delta));
	       
	if (is_rho_accepted)
	{
		B = B_new;
		P = P_new;
		Grad = t(X) %*% (P [, 1:K] - Y [, 1:K]);
		if (intercept_status == 2) {
		    Grad = diag (as.vector(scale_X)) %*% Grad + shift_X %*% t(Grad [D, ]);
		}
		Grad = Grad + lambda * B;
		norm_Grad = sqrt (sum (Grad ^ 2));
		obj = obj_new;
	    print (paste("   -- New Objective = " , obj , ",  Beta Change Norm = " , snorm , ",  Gradient Norm = " , norm_Grad));
	} 
	
	iter = iter + 1;
	converge = ((norm_Grad < (tol * norm_Grad_initial)) | (iter > maxiter) |
	    ((is_trust_boundary_reached == 0) & (abs (actred) < (abs (obj) + abs (obj_new)) * 0.00000000000001)));
    if (converge) { print ("Termination / Convergence condition satisfied."); } else { print (" "); }
} 

if (intercept_status == 2) {
    B_out = diag (as.vector(scale_X)) %*% B;
    B_out [D, ] = B_out [D, ] + t(shift_X) %*% B;
} else {
    B_out = B;
}

writeMM(as(B_out,"CsparseMatrix"), paste(args[6], "w", sep=""));

#-------------------------------------------------------------
#
# Licensed to the Apache Software Foundation (ASF) under one
# or more contributor license agreements.  See the NOTICE file
# distributed with this work for additional information
# regarding copyright ownership.  The ASF licenses this file
# to you under the Apache License, Version 2.0 (the
# "License"); you may not use this file except in compliance
# with the License.  You may obtain a copy of the License at
# 
#   http://www.apache.org/licenses/LICENSE-2.0
# 
# Unless required by applicable law or agreed to in writing,
# software distributed under the License is distributed on an
# "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
# KIND, either express or implied.  See the License for the
# specific language governing permissions and limitations
# under the License.
#
#-------------------------------------------------------------

args <- commandArgs(TRUE)
options(digits=22)

library("Matrix")
library("matrixStats") 



################################################################################

printFoldStatistics = function(stats)
{
   mean_correct_pct = mean( stats[,1])

   #print (" Mean Correct Percentage of the " + nrow( stats) + " Folds: " + mean_correct_pct);
}

################################################################################

scoreMultiClassSVM = function( X, y, W, intercept) 
{
   Nt = nrow(X);
   num_classes = ncol(W)
   b = matrix( 0, 1, num_classes)
   n = ncol(X);

   if (intercept == 1) 
   {
      b = W[n+1,]
   }
       
   ones = matrix( 1, Nt, 1 )
   scores = X %*% W[1:n,] + ones %*% b;                          
                                 
   #predicted_y = which(scores == rowMaxs(scores));
   predicted_y = matrix(0,nrow(scores),1);
   for( i in 1:nrow(scores) )
   {      
      predicted_y[i,1]<-which.max(scores[i,]); 
   }
   
   correct_percentage = sum( ((predicted_y - y)==0.0)) / Nt * 100;
   out_correct_pct = correct_percentage;

   return (out_correct_pct);
}


################################################################################

multiClassSVM = function (X, Y, intercept, num_classes, epsilon, lambda, max_iterations) 
{
   check_X <- sum(X)
   if(check_X == 0){

     print("X has no non-zeros")

   } else {

      num_samples <- nrow(X)
      num_features <- ncol(X)
      
      if (intercept == 1) {
        ones <- matrix( 1, num_samples, 1);
        X <- cbind( X, ones);
      }
      
      iter_class = 1
      
      Y_local <- 2 * ( Y == iter_class ) - 1
      w_class <- matrix( 0, num_features, 1 )
   
      if (intercept == 1) {
         zero_matrix <- matrix( 0, 1, 1 );
         w_class <- t( cbind( t( w_class), zero_matrix));
      }
      
      g_old <- t(X) %*% Y_local
      s <- g_old
      iter <- 0
      continue <- 1
   
      while(continue == 1) {
        # minimizing primal obj along direction s
        step_sz <- 0
        Xd <- X %*% s
        wd <- lambda * sum(w_class * s)
        dd <- lambda * sum(s * s)
        continue1 <- 1
        
        while(continue1 == 1){
         tmp_w <- w_class + step_sz*s
         out <- 1 - Y_local * (X %*% tmp_w)
         sv <- (out > 0)
         out <- out * sv
         g <- wd + step_sz*dd - sum(out * Y_local * Xd)
         h <- dd + sum(Xd * sv * Xd)
         step_sz <- step_sz - g/h
         if (g*g/h < 0.0000000001){
          continue1 = 0
         }
         
        }
       
        #update weights
        w_class <- w_class + step_sz*s
       
        out <- 1 - Y_local * (X %*% w_class)
        sv <- (out > 0)
        out <- sv * out
        obj <- 0.5 * sum(out * out) + lambda/2 * sum(w_class * w_class)
        g_new <- t(X) %*% (out * Y_local) - lambda * w_class
      
        tmp <- sum(s * g_old)
        
        train_acc <- sum( ((Y_local*(X%*%w_class)) >= 0))/num_samples*100
        #print("For class " + iter_class + " iteration " + iter + " training accuracy: " + train_acc)
         
        if((step_sz*tmp < epsilon*obj) | (iter >= max_iterations-1)){
         continue = 0
        }
       
        #non-linear CG step
        be <- sum(g_new * g_new)/sum(g_old * g_old)
        s <- be * s + g_new
        g_old <- g_new
      
        iter <- iter + 1
       }
      
      
      w <- w_class
      iter_class <- iter_class + 1
      
      while(iter_class <= num_classes){
       Y_local <- 2 * (Y == iter_class) - 1
       w_class <- matrix(0, ncol(X), 1)
       if (intercept == 1) {
       	zero_matrix <- matrix(0, 1, 1);
       	w_class <- t(cbind(t(w_class), zero_matrix));
       }
       
       g_old <- t(X) %*% Y_local
       s <- g_old
      
       iter <- 0
       continue <- 1
       while(continue == 1)  {
        # minimizing primal obj along direction s
        step_sz = 0
        Xd <- X %*% s
        wd <- lambda * sum(w_class * s)
        dd <- lambda * sum(s * s)
        continue1 = 1
        while(continue1 == 1){
         tmp_w <- w_class + step_sz*s
         out <- 1 - Y_local * (X %*% tmp_w)
         sv <- (out > 0)
         out <- out * sv
         g <- wd + step_sz*dd - sum(out * Y_local * Xd)
         h <- dd + sum(Xd * sv * Xd)
         step_sz <- step_sz - g/h
         if (g*g/h < 0.0000000001){
          continue1 <- 0
         }
        }
       
        #update weights
        w_class <- w_class + step_sz*s
       
        out <- 1 - Y_local * (X %*% w_class)
        sv <- (out > 0)
        out <- sv * out
        obj <- 0.5 * sum(out * out) + lambda/2 * sum(w_class * w_class)
        g_new <- t(X) %*% (out * Y_local) - lambda * w_class
      
        tmp <- sum(s * g_old)
        
        train_acc <- sum( ((Y_local*(X%*%w_class)) >= 0) )/num_samples*100
        #print("For class " + iter_class + " iteration " + iter + " training accuracy: " + train_acc)
         
        if( ((step_sz*tmp < epsilon*obj) | (iter >= max_iterations-1)) ){
         continue <- 0
        }
       
        #non-linear CG step
        be <- sum(g_new * g_new)/sum(g_old * g_old)
        s <- be * s + g_new
        g_old <- g_new
      
        iter <- iter + 1
       }
      
       w <- cbind(w, w_class) 
       iter_class <- iter_class + 1 
      }
      ret_W <- w
   }
   
   return (ret_W);
}




X <- as.matrix(readMM(paste(args[1], "X.mtx", sep="")))
y <- as.matrix(readMM(paste(args[1], "y.mtx", sep="")))

m = nrow(X);
n = ncol(X);

k = as.numeric(args[2]);

#parameters for model training
intercept = as.numeric(args[3]);
num_classes = as.numeric(args[4]);
epsilon = as.numeric(args[5]);
lambda = as.numeric(args[6]); 
maxiter = as.numeric(args[7]);

#CV
P = as.matrix(readMM(paste(args[1], "P.mtx", sep="")))

ones = matrix(1, 1, n);
stats = matrix(0, k, 1); #k-folds x 1-stats
   
for( i in 1:k )
{
   #prepare train/test fold projections
   vPxi <- (P == i);   #  Select 1/k fraction of the rows   
   mPxi <- (vPxi %*% ones);       #  for the i-th fold TEST set
   #nvPxi <- (P != i);
   #nmPxi <- (nvPxi %*% ones);  #note: inefficient for sparse data  

   #create train/test folds
   Xi <- X * mPxi;  #  Create the TEST set with 1/k of all the rows
   yi <- y * vPxi;  #  Create the labels for the TEST set
   
   nXi <- X - Xi;   #  Create the TRAINING set with (k-1)/k of the rows
   nyi <- y - yi;   #  Create the labels for the TRAINING set
   Xyi <- cbind(Xi,yi); #keep alignment on removeEmpty
   #Xyi <- removeEmpty( target=Xyi, margin="rows" );
   Xyi <- Xyi[rowSums((Xyi==0) | is.na(Xyi)) != ncol(Xyi),];
   Xi <- Xyi[ , 1:n];
   yi <- Xyi[ , n+1];   
   
   nXyi = cbind(nXi,nyi); #keep alignment on removeEmpty
   #nXyi = removeEmpty( target=nXyi, margin="rows" );
   nXyi = nXyi[rowSums((nXyi==0) | is.na(nXyi)) != ncol(nXyi),];
   nXi = nXyi[ , 1:n];
   nyi = nXyi[ , n+1];

   #train multiclass SVM model per fold, use the TRAINING set
   wi = multiClassSVM( nXi, nyi, intercept, num_classes, epsilon, lambda, maxiter)

   #score multiclass SVM model per fold, use the TEST set
   out_correct_pct = scoreMultiClassSVM( Xi, yi, wi, intercept);
   
   stats[i,1] <- out_correct_pct;
}

# print output of stats
printFoldStatistics( stats );

writeMM(as(stats, "CsparseMatrix"), paste(args[8], "stats", sep=""));

#-------------------------------------------------------------
#
# Licensed to the Apache Software Foundation (ASF) under one
# or more contributor license agreements.  See the NOTICE file
# distributed with this work for additional information
# regarding copyright ownership.  The ASF licenses this file
# to you under the Apache License, Version 2.0 (the
# "License"); you may not use this file except in compliance
# with the License.  You may obtain a copy of the License at
# 
#   http://www.apache.org/licenses/LICENSE-2.0
# 
# Unless required by applicable law or agreed to in writing,
# software distributed under the License is distributed on an
# "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
# KIND, either express or implied.  See the License for the
# specific language governing permissions and limitations
# under the License.
#
#-------------------------------------------------------------

# JUnit test class: dml.test.integration.applications.LinearRegressionTest.java
# command line invocation assuming $LR_HOME is set to the home of the R script
# Rscript $LR_HOME/LinearRegression.R $LR_HOME/in/ 0.00000001 $LR_HOME/expected/
args <- commandArgs(TRUE);

library("Matrix");

V = readMM(paste(args[1], "v.mtx", sep=""));
y = readMM(paste(args[1], "y.mtx", sep=""));

eps  = as.double(args[2]);

r = -(t(V) %*% y);
p = -r;
norm_r2 = sum(r * r);
w = 0;

max_iteration = 3;
i = 0;
while(i < max_iteration) {
	q = ((t(V) %*% (V %*% p)) + eps * p);
	alpha = norm_r2 / ((t(p) %*% q)[1:1]);
	w = w + alpha * p;
	old_norm_r2 = norm_r2;
	r = r + alpha * q;
	norm_r2 = sum(r * r);
	beta = norm_r2 / old_norm_r2;
	p = -r + beta * p;
	i = i + 1;
}

writeMM(w, paste(args[3], "w", sep=""));

#-------------------------------------------------------------
#
# Licensed to the Apache Software Foundation (ASF) under one
# or more contributor license agreements.  See the NOTICE file
# distributed with this work for additional information
# regarding copyright ownership.  The ASF licenses this file
# to you under the Apache License, Version 2.0 (the
# "License"); you may not use this file except in compliance
# with the License.  You may obtain a copy of the License at
# 
#   http://www.apache.org/licenses/LICENSE-2.0
# 
# Unless required by applicable law or agreed to in writing,
# software distributed under the License is distributed on an
# "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
# KIND, either express or implied.  See the License for the
# specific language governing permissions and limitations
# under the License.
#
#-------------------------------------------------------------
# Intended to solve cubic natural spline, using R, in order to compare against the DML implementation
# INPUT 1: Matrix X [rows, 1]
# INPUT 2: Matrix Y [rows, 1]
# OUTPUT : 1x1 matrix of value of the interpolated y for given input x
#
# Assume that $CSPLINE_HOME is set to the home of the R script
# Assume input and output directories are $CSPLINE_HOME/in/ and $CSPLINE_HOME/expected/
# Rscript $CSPLINE_HOME/CsplineDs.R $CSPLINE_HOME/in/X.mtx $CSPLINE_HOME/in/Y.mtx 4.5 $CSPLINE_HOME/expected/y.mtx

args <- commandArgs (TRUE);

library ("Matrix");

X_here <- readMM (args[1]); # (paste (args[1], "X.mtx", sep=""));
Y_here <- readMM (args[2]); # (paste (args[2], "Y.mtx", sep=""));

inp_x <- args[3]

pred_y_here <- args[4]

X_matrix = as.matrix (X_here);
Y_matrix = as.matrix (Y_here);

sf<-splinefun(X_matrix, Y_matrix, method="natural")

pred_y = sf(inp_x)

print(paste("For inp_x = ", inp_x, " Calculated y = ", pred_y))

writeMM(as(pred_y, "CsparseMatrix") , pred_y_here);

#-------------------------------------------------------------
#
# Licensed to the Apache Software Foundation (ASF) under one
# or more contributor license agreements.  See the NOTICE file
# distributed with this work for additional information
# regarding copyright ownership.  The ASF licenses this file
# to you under the Apache License, Version 2.0 (the
# "License"); you may not use this file except in compliance
# with the License.  You may obtain a copy of the License at
#
#   http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing,
# software distributed under the License is distributed on an
# "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
# KIND, either express or implied.  See the License for the
# specific language governing permissions and limitations
# under the License.
#
#-------------------------------------------------------------


# Generate various HDF5 test files with different formats.
# Creates test files in the 'in' directory.

if (!require("rhdf5", quietly = TRUE)) {
  cat("Error: rhdf5 is not installed.\n")
  quit(status = 1)
}

SMALL_MATRIX_2D <- c(200, 40)
SMALL_MATRIX_3D <- c(15, 15, 5)
SMALL_TENSOR_4D_A <- c(120, 16, 16, 4)
SMALL_TENSOR_4D_B <- c(120, 16, 16, 5)
SMALL_LABEL_MATRIX <- c(120, 12)

VECTOR_LENGTH <- 200
STRING_ARRAY_LENGTH <- 30

CHUNK_SHAPE <- c(100, 20)

write_matrix <- function(file_path, dataset_name, shape, generator = function(n) rnorm(n), storage.mode = "double", H5type = NULL) {
  values <- generator(prod(shape))
  h5createDataset(
    file_path,
    dataset_name,
    dims = rev(shape),
    chunk = NULL,
    filter = "NONE", # contiguous, uncompressed layout
    level = 0,
    shuffle = FALSE,
    storage.mode = storage.mode,
    H5type = H5type,
    native = TRUE # use R column-major order, same in h5read(..., native=TRUE) in tests.
  )
  h5write(array(values, dim = shape), file_path, dataset_name, native = TRUE)
}

generate_test_file_single_dataset <- function(dir) {
  file_path <- file.path(dir, "test_single_dataset.h5")
  h5createFile(file_path)
  write_matrix(file_path, "data", SMALL_MATRIX_2D)
  cat("Created test_single_dataset.h5 (single 2D dataset)\n")
}

generate_test_file_multiple_datasets <- function(dir) {
  file_path <- file.path(dir, "test_multiple_datasets.h5")
  h5createFile(file_path)
  write_matrix(file_path, "matrix_2d", SMALL_MATRIX_2D)
  # Create 1D vector without compression/filters
  h5createDataset(file_path, "vector_1d", dims = VECTOR_LENGTH, chunk = NULL, filter = "NONE", level = 0, shuffle = FALSE)
  h5write(rnorm(VECTOR_LENGTH), file_path, "vector_1d", native = TRUE)
  write_matrix(file_path, "matrix_3d", SMALL_MATRIX_3D)
  cat("Created test_multiple_datasets.h5 (1D/2D/3D datasets)\n")
}

generate_test_file_different_dtypes <- function(dir) {
  file_path <- file.path(dir, "test_different_dtypes.h5")
  h5createFile(file_path)
  # H5T_IEEE_F64LE (64-bit float)
  write_matrix(file_path, "double_primary", SMALL_MATRIX_2D, storage.mode = "double")
  # H5T_IEEE_F32LE (32-bit float)
  write_matrix(file_path, "float32", SMALL_MATRIX_2D, H5type = "H5T_IEEE_F32LE")
  # H5T_STD_I32LE (32-bit integer)
  write_matrix(
    file_path,
    "int32",
    SMALL_MATRIX_2D,
    generator = function(n) as.integer(sample(-100:100, n, replace = TRUE)),
    storage.mode = "integer"
  )
  # H5T_STD_I64LE (64-bit integer)
  write_matrix(
    file_path,
    "int64",
    SMALL_MATRIX_2D,
    generator = function(n) as.integer(sample(-100:100, n, replace = TRUE)),
    H5type = "H5T_STD_I64LE"
  )
  cat("Created test_different_dtypes.h5 (double/float/int32/int64 datasets)\n")
}

# https://support.hdfgroup.org/documentation/hdf5-docs/advanced_topics/chunking_in_hdf5.html
generate_test_file_chunked <- function(dir) {
  file_path <- file.path(dir, "test_chunked.h5")
  h5createFile(file_path)

  data <- array(rnorm(prod(SMALL_MATRIX_2D)), dim = SMALL_MATRIX_2D)

  h5createDataset(file_path, "chunked_data", dims = SMALL_MATRIX_2D, chunk = CHUNK_SHAPE,
                  filter = "NONE", level = 0, shuffle = FALSE)
  h5write(data, file_path, "chunked_data", native = TRUE)

  write_matrix(file_path, "non_chunked_data", SMALL_MATRIX_2D)
  cat("Created test_chunked.h5 (chunked dataset)\n")
}

generate_test_file_compressed <- function(dir) {
  file_path <- file.path(dir, "test_compressed.h5")
  h5createFile(file_path)
  data <- array(rnorm(prod(SMALL_MATRIX_2D)), dim = SMALL_MATRIX_2D)
  h5createDataset(file_path, "gzip_compressed_9", dims = SMALL_MATRIX_2D,
                  chunk = SMALL_MATRIX_2D, level = 9)
  h5write(data, file_path, "gzip_compressed_9", native = TRUE)
  h5createDataset(file_path, "gzip_compressed_1", dims = SMALL_MATRIX_2D,
                  chunk = SMALL_MATRIX_2D, level = 1)
  h5write(data, file_path, "gzip_compressed_1", native = TRUE)
  cat("Created test_compressed.h5 (gzip compression)\n")
}

generate_test_file_multi_tensor_samples <- function(dir) {
  file_path <- file.path(dir, "test_multi_tensor_samples.h5")
  h5createFile(file_path)
  write_matrix(
    file_path,
    "sen1",
    SMALL_TENSOR_4D_A
  )
  write_matrix(
    file_path,
    "sen2",
    SMALL_TENSOR_4D_B
  )
  write_matrix(
    file_path,
    "label",
    SMALL_LABEL_MATRIX,
    generator = function(n) as.integer(sample(0:1, n, replace = TRUE))
  )
  cat("Created test_multi_tensor_samples.h5 (multi-input tensors)\n")
}

generate_test_file_nested_groups <- function(dir) {
  file_path <- file.path(dir, "test_nested_groups.h5")
  h5createFile(file_path)
  write_matrix(file_path, "root_data", SMALL_MATRIX_2D)
  h5createGroup(file_path, "group1")
  write_matrix(file_path, "group1/data1", SMALL_MATRIX_2D)
  h5createGroup(file_path, "group1/subgroup")
  write_matrix(file_path, "group1/subgroup/data2", SMALL_MATRIX_2D)
  cat("Created test_nested_groups.h5 (nested group hierarchy)\n")
}

generate_test_file_with_attributes <- function(dir) {
  file_path <- file.path(dir, "test_with_attributes.h5")
  h5createFile(file_path)
  write_matrix(file_path, "data", SMALL_MATRIX_2D)

  fid <- H5Fopen(file_path)
  did <- H5Dopen(fid, "data")
  h5writeAttribute("Test dataset with attributes", did, "description")
  h5writeAttribute(1.0, did, "version")
  h5writeAttribute(SMALL_MATRIX_2D, did, "shape")
  H5Dclose(did)

  h5writeAttribute("2025-11-26", fid, "file_created")
  h5writeAttribute("attributes", fid, "test_type")
  H5Fclose(fid)
  cat("Created test_with_attributes.h5 (dataset + file attributes)\n")
}

generate_test_file_empty_datasets <- function(dir) {
  file_path <- file.path(dir, "test_empty_datasets.h5")
  h5createFile(file_path)
  h5createDataset(file_path, "empty", dims = c(0, SMALL_MATRIX_2D[2]),
                  filter = "NONE", level = 0, shuffle = FALSE)

  h5createDataset(file_path, "scalar", dims = 1,
                  filter = "NONE", level = 0, shuffle = FALSE, chunk = 1)
  h5write(1.0, file_path, "scalar", native = TRUE)
  h5createDataset(file_path, "vector", dims = VECTOR_LENGTH,
                  filter = "NONE", level = 0, shuffle = FALSE, chunk = VECTOR_LENGTH)
  h5write(rnorm(VECTOR_LENGTH), file_path, "vector", native = TRUE)
  cat("Created test_empty_datasets.h5 (empty/scalar/vector)\n")
}

generate_test_file_string_datasets <- function(dir) {
  file_path <- file.path(dir, "test_string_datasets.h5")
  h5createFile(file_path)
  strings <- paste0("string_", 0:(STRING_ARRAY_LENGTH - 1))
  # Create string dataset without compression/filters
  h5createDataset(file_path, "string_array", dims = STRING_ARRAY_LENGTH,
                  storage.mode = "character", filter = "NONE", level = 0,
                  shuffle = FALSE, chunk = STRING_ARRAY_LENGTH)
  h5write(strings, file_path, "string_array", native = TRUE)
  cat("Created test_string_datasets.h5 (string datasets)\n")
}

main <- function() {
  if (basename(getwd()) != "hdf5") {
    cat("You must execute this script from the 'hdf5' directory\n")
    quit(status = 1)
  }

  testdir <- "in"
  if (!dir.exists(testdir)) {
    dir.create(testdir)
  }

  test_functions <- list(
    generate_test_file_single_dataset,
    generate_test_file_multiple_datasets,
    generate_test_file_different_dtypes,
    generate_test_file_chunked,
    generate_test_file_compressed,
    generate_test_file_multi_tensor_samples,
    generate_test_file_nested_groups,
    generate_test_file_with_attributes,
    generate_test_file_empty_datasets,
    generate_test_file_string_datasets
  )

  for (test_func in test_functions) {
    tryCatch({
      test_func(testdir)
    }, error = function(e) {
      cat(sprintf("  ✗ Error: %s\n", conditionMessage(e)))
    })
  }

  files <- sort(list.files(testdir, pattern = "\\.h5$", full.names = TRUE))
  cat(sprintf("\nGenerated %d HDF5 test files in %s\n", length(files), normalizePath(testdir)))
}

if (!interactive()) {
  main()
}

#-------------------------------------------------------------
#
# Licensed to the Apache Software Foundation (ASF) under one
# or more contributor license agreements.  See the NOTICE file
# distributed with this work for additional information
# regarding copyright ownership.  The ASF licenses this file
# to you under the Apache License, Version 2.0 (the
# "License"); you may not use this file except in compliance
# with the License.  You may obtain a copy of the License at
#
#   http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing,
# software distributed under the License is distributed on an
# "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
# KIND, either express or implied.  See the License for the
# specific language governing permissions and limitations
# under the License.
#
#-------------------------------------------------------------

print("Starting install RScripts")

args <- commandArgs(TRUE)

options(repos=structure(c(CRAN="http://cran.r-project.org")))

custom_install <- function(pkg) {
    if(!is.element(pkg, installed.packages()[,1])) {
		# Installing to temp folder, if you want to permenently install change lib path
		if (length(args)==0) {
 			install.packages(pkg);
		} else if (length(args) == 1){
			install.packages(pkg, lib= args[1]);
		}
	}
} 

list_user_pkgs <- function() {
	print("List of user installed packages:")

	ip <- as.data.frame(installed.packages()[,c(1,3:4)])
	rownames(ip) <- NULL
	ip <- ip[is.na(ip$Priority),1:2,drop=FALSE]
	print(ip, row.names=FALSE)
}

custom_install("Matrix");
custom_install("psych");
custom_install("moments");
custom_install("boot");
custom_install("matrixStats");
custom_install("outliers");
custom_install("caret");
custom_install("sigmoid");
custom_install("DescTools");
custom_install("mice");
custom_install("mclust");
custom_install("dbscan");
custom_install("imputeTS");
custom_install("FNN");
custom_install("class");
custom_install("unbalanced");
custom_install("naivebayes");
custom_install("BiocManager");
custom_install("mltools");
custom_install("einsum");
BiocManager::install("rhdf5");

print("Installation Done")


# supply any two parameters to list all user installed packages
# e.g. "sudo Rscript installDependencies.R a b"
if (length(args) == 2) {
	list_user_pkgs()
}

#-------------------------------------------------------------
#
# Licensed to the Apache Software Foundation (ASF) under one
# or more contributor license agreements.  See the NOTICE file
# distributed with this work for additional information
# regarding copyright ownership.  The ASF licenses this file
# to you under the Apache License, Version 2.0 (the
# "License"); you may not use this file except in compliance
# with the License.  You may obtain a copy of the License at
# 
#   http://www.apache.org/licenses/LICENSE-2.0
# 
# Unless required by applicable law or agreed to in writing,
# software distributed under the License is distributed on an
# "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
# KIND, either express or implied.  See the License for the
# specific language governing permissions and limitations
# under the License.
#
#-------------------------------------------------------------

args <- commandArgs(TRUE)
library("Matrix")

X = readMM(paste(args[1], "X.mtx", sep=""));
Y = readMM(paste(args[1], "Y.mtx", sep=""));
intercept = as.integer(args[2]);
epsilon = as.double(args[3]);
lambda = 0.001;
max_iterations = as.integer(args[4]);


if(nrow(X) < 2)
	stop("Stopping due to invalid inputs: Not possible to learn a classifier without at least 2 rows")

lambda = 0.001
num_samples = nrow(X)
dimensions = ncol(X)
num_features = ncol(X)

min_y = min(Y)
num_classes = max(Y)
mod1 = Y %% 1
mod1_should_be_nrow = sum(abs(mod1==0))
	

if (intercept == 1) {
	ones  = matrix(1, num_samples, 1);
	X = append(X, ones);
}

num_rows_in_w = num_features
if(intercept == 1){
	num_rows_in_w = num_rows_in_w + 1
}
w = matrix(0, num_rows_in_w, num_classes)

debug_mat = matrix(-1, max_iterations, num_classes)
for(iter_class in 1:num_classes){		  
	Y_local = 2 * (Y == iter_class) - 1
	w_class = matrix(0, num_features, 1)
	if (intercept == 1) {
		zero_matrix = matrix(0, 1, 1);
		w_class = t(append(t(w_class), zero_matrix));
	}
 
	g_old = t(X) %*% Y_local
	s = g_old

	Xw = matrix(0, nrow(X), 1)
	iter = 0
	continue = 1
	while(continue == 1)  {
		# minimizing primal obj along direction s
 		step_sz = 0
 		Xd = X %*% s
 		wd = lambda * sum(w_class * s)
		dd = lambda * sum(s * s)
		continue1 = 1
		while(continue1 == 1){
 			tmp_Xw = Xw + step_sz*Xd
 			out = 1 - Y_local * (tmp_Xw)
 			sv = (out > 0)
 			out = out * sv
 			g = wd + step_sz*dd - sum(out * Y_local * Xd)
 			h = dd + sum(Xd * sv * Xd)
 			step_sz = step_sz - g/h
 			if (g*g/h < 0.0000000001){
			continue1 = 0
		}
	}
 
		#update weights
		w_class = w_class + step_sz*s
		Xw = Xw + step_sz*Xd
 
		out = 1 - Y_local * Xw
		sv = (out > 0)
		out = sv * out
		obj = 0.5 * sum(out * out) + lambda/2 * sum(w_class * w_class)
  		g_new = t(X) %*% (out * Y_local) - lambda * w_class

  		tmp = sum(s * g_old)
  
  		train_acc = sum( (Y_local*(X%*%w_class))>= 0)/num_samples*100
  		print(paste("For class " , iter_class , " iteration " , iter , " training accuracy: " , train_acc))
  		debug_mat[iter+1,iter_class] = obj	   
   
  		if((step_sz*tmp < epsilon*obj) | (iter >= max_iterations-1)){
   			continue = 0
  		}
 
  		#non-linear CG step
  		be = sum(g_new * g_new)/sum(g_old * g_old)
  		s = be * s + g_new
  		g_old = g_new

		if(sum(s^2) == 0){
	    	continue = 0
		}

  		iter = iter + 1
 	}

  w[,iter_class] = as.matrix(w_class)
}

writeMM(as(w,"CsparseMatrix"), paste(args[5], "w", sep=""));

#-------------------------------------------------------------
#
# Licensed to the Apache Software Foundation (ASF) under one
# or more contributor license agreements.  See the NOTICE file
# distributed with this work for additional information
# regarding copyright ownership.  The ASF licenses this file
# to you under the Apache License, Version 2.0 (the
# "License"); you may not use this file except in compliance
# with the License.  You may obtain a copy of the License at
# 
#   http://www.apache.org/licenses/LICENSE-2.0
# 
# Unless required by applicable law or agreed to in writing,
# software distributed under the License is distributed on an
# "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
# KIND, either express or implied.  See the License for the
# specific language governing permissions and limitations
# under the License.
#
#-------------------------------------------------------------


args <- commandArgs(TRUE)
options(digits=22)

library("Matrix")

A1 <- readMM(paste(args[1], "A.mtx", sep=""))
A <- as.matrix(A1);

type = as.integer(args[2])
constant = as.double(args[3]);

if( type == 0 )
{
   B = (constant > A)
}
if( type == 1 )
{
   B = (constant < A)
}
if( type == 2 )
{
   B = (constant == A)
}
if( type == 3 )
{
   B = (constant != A)
}
if( type == 4 )
{
   B = (constant >= A)
}
if( type == 5 )
{
   B = (constant <= A)
}


writeMM(as(B, "CsparseMatrix"), paste(args[4], "B", sep="")); 

#-------------------------------------------------------------
#
# Licensed to the Apache Software Foundation (ASF) under one
# or more contributor license agreements.  See the NOTICE file
# distributed with this work for additional information
# regarding copyright ownership.  The ASF licenses this file
# to you under the Apache License, Version 2.0 (the
# "License"); you may not use this file except in compliance
# with the License.  You may obtain a copy of the License at
#
#   http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing,
# software distributed under the License is distributed on an
# "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
# KIND, either express or implied.  See the License for the
# specific language governing permissions and limitations
# under the License.
#
#-------------------------------------------------------------

args = commandArgs(TRUE)
options(digits=22)
library("Matrix")

adjustBrightness = function(M, val, chan_max) {
  out = pmax(0, pmin(M + val, chan_max))
  out = matrix(out, nrow(M), ncol(M), byrow=FALSE)
  return(out)
}

images = as.matrix(readMM(paste(args[1], "A.mtx", sep="")))
width = as.integer(args[3])
height = as.integer(args[4])
brightness_adjustments = as.matrix(readMM(paste(args[1], "brightness_adjustments.mtx", sep="")))
num_augmentations = nrow(brightness_adjustments)
augmented_images = matrix(0, num_augmentations * nrow(images), ncol(images))
max_value=255

for (idx in 0:(nrow(images)-1)) {
  i = idx + 1

  image2d = matrix(images[i,], width, height, byrow=TRUE)

  for(a in 1:num_augmentations) {
    # do augmentation
    img_out = adjustBrightness(image2d, as.integer(brightness_adjustments[a,1]), max_value)
    
    # reshape and store augmentation
    augmented_images[idx*num_augmentations+a,] = matrix(t(img_out), 1, width * height, byrow=TRUE)
  }
}

writeMM(as(augmented_images, "CsparseMatrix"), paste(args[2], "B", sep=""))

#-------------------------------------------------------------
#
# Licensed to the Apache Software Foundation (ASF) under one
# or more contributor license agreements.  See the NOTICE file
# distributed with this work for additional information
# regarding copyright ownership.  The ASF licenses this file
# to you under the Apache License, Version 2.0 (the
# "License"); you may not use this file except in compliance
# with the License.  You may obtain a copy of the License at
#
#   http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing,
# software distributed under the License is distributed on an
# "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
# KIND, either express or implied.  See the License for the
# specific language governing permissions and limitations
# under the License.
#
#-------------------------------------------------------------


args <- commandArgs(TRUE)
options(digits=22)

library("Matrix")

v <- as.vector(readMM(paste(args[1], "vR.mtx", sep="")))
w <- as.vector(readMM(paste(args[1], "wR.mtx", sep="")))
weights <- as.vector(readMM(paste(args[1], "weightsR.mtx", sep="")))

res = xtabs(weights ~ v + w)
res = as.matrix(as.data.frame.matrix(res));

writeMM(as(res, "CsparseMatrix"), paste(args[2], "resR", sep=""));

#-------------------------------------------------------------
#
# Licensed to the Apache Software Foundation (ASF) under one
# or more contributor license agreements.  See the NOTICE file
# distributed with this work for additional information
# regarding copyright ownership.  The ASF licenses this file
# to you under the Apache License, Version 2.0 (the
# "License"); you may not use this file except in compliance
# with the License.  You may obtain a copy of the License at
# 
#   http://www.apache.org/licenses/LICENSE-2.0
# 
# Unless required by applicable law or agreed to in writing,
# software distributed under the License is distributed on an
# "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
# KIND, either express or implied.  See the License for the
# specific language governing permissions and limitations
# under the License.
#
#-------------------------------------------------------------

# JUnit test class: dml.test.integration.descriptivestats.CategoricalCategoricalTest.java
# command line invocation assuming $CC_HOME is set to the home of the R script
# Rscript $CC_HOME/CategoricalCategorical.R $CC_HOME/in/ $CC_HOME/expected/
args <- commandArgs(TRUE)
options(digits=22)

library("Matrix")

A = readMM(paste(args[1], "A.mtx", sep=""));
B = readMM(paste(args[1], "B.mtx", sep=""));

F = table(A[,1],B[,1]);

# chisq.test returns a list containing statistic, p-value, etc.
cst = chisq.test(F);

# get the chi-squared coefficient from the list
chi_squared = as.numeric(cst[1]);
pValue = as.numeric(cst[3]);

write(pValue, paste(args[2], "PValue", sep=""));

q = min(dim(F));
W = sum(F);
cramers_v = sqrt(chi_squared/(W*(q-1)));

write(cramers_v, paste(args[2], "CramersV", sep=""));

#-------------------------------------------------------------
#
# Licensed to the Apache Software Foundation (ASF) under one
# or more contributor license agreements.  See the NOTICE file
# distributed with this work for additional information
# regarding copyright ownership.  The ASF licenses this file
# to you under the Apache License, Version 2.0 (the
# "License"); you may not use this file except in compliance
# with the License.  You may obtain a copy of the License at
# 
#   http://www.apache.org/licenses/LICENSE-2.0
# 
# Unless required by applicable law or agreed to in writing,
# software distributed under the License is distributed on an
# "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
# KIND, either express or implied.  See the License for the
# specific language governing permissions and limitations
# under the License.
#
#-------------------------------------------------------------

# JUnit test class: dml.test.integration.descriptivestats.UnivariateStatsTest.java
# command line invocation assuming $S_HOME is set to the home of the R script
# Rscript $S_HOME/WeightedScaleTest.R $S_HOME/in/ $S_HOME/expected/
args <- commandArgs(TRUE)
options(digits=22)

library("psych")
library("moments")
library("Matrix")

# Usage: R --vanilla -args Xfile X < DescriptiveStatistics.R

#parseCommandArgs()
######################

Temp = readMM(paste(args[1], "vector.mtx", sep=""))
W = readMM(paste(args[1], "weight.mtx", sep=""))
P = readMM(paste(args[1], "prob.mtx", sep=""))

W = round(W)

V=rep(Temp[,1],W[,1])

n = sum(W)

# sum
s1 = sum(V)

# mean
mu = s1/n

# variances
var = var(V)

# standard deviations
std_dev = sd(V, na.rm = FALSE)

# standard errors of mean
SE = sd(V)/sqrt(sum(!is.na(V)))

# coefficients of variation
cv = std_dev/mu

# harmonic means (note: may generate out of memory for large sparse matrices becauses of NaNs)
#har_mu = harmonic.mean(V)

# geometric means is not currently supported.
#geom_mu = geometric.mean(V)

# min and max
mn=min(V)
mx=max(V)

# range
rng = mx - mn

# Skewness
g1 = n^2*moment(V, order=3, central=TRUE)/((n-1)*(n-2)*std_dev^3)

# standard error of skewness (not sure how it is defined without the weight)
se_g1=sqrt( 6*n*(n-1.0) / ((n-2.0)*(n+1.0)*(n+3.0)) )

m2 = moment(V, order=2, central=TRUE)
m4 = moment(V, order=4, central=TRUE)

# Kurtosis (using binomial formula)
g2 = (n^2*(n+1)*m4-3*m2^2*n^2*(n-1))/((n-1)*(n-2)*(n-3)*var^2)

# Standard error of Kurtosis (not sure how it is defined without the weight)
se_g2= sqrt( (4*(n^2-1)*se_g1^2)/((n+5)*(n-3)) )

# median
md = median(V) #quantile(V, 0.5, type = 1)

# quantile
Q = t(quantile(V, P[,1], type = 1))

# inter-quartile mean
S=c(sort(V))

q25d=n*0.25
q75d=n*0.75
q25i=ceiling(q25d)
q75i=ceiling(q75d)

iqm = sum(S[(q25i+1):q75i])
iqm = iqm + (q25i-q25d)*S[q25i] - (q75i-q75d)*S[q75i]
iqm = iqm/(n*0.5)

#print(paste("IQM ", iqm));

out_minus = t(as.numeric(Temp < mu-5*std_dev)*Temp) 
out_plus = t(as.numeric(Temp > mu+5*std_dev)*Temp)

write(mu, paste(args[2], "mean", sep=""));
write(std_dev, paste(args[2], "std", sep=""));
write(SE, paste(args[2], "se", sep=""));
write(var, paste(args[2], "var", sep=""));
write(cv, paste(args[2], "cv", sep=""));
# write(har_mu),paste(args[2], "har", sep=""));
# write(geom_mu, paste(args[2], "geom", sep=""));
write(mn, paste(args[2], "min", sep=""));
write(mx, paste(args[2], "max", sep=""));
write(rng, paste(args[2], "rng", sep=""));
write(g1, paste(args[2], "g1", sep=""));
write(se_g1, paste(args[2], "se_g1", sep=""));
write(g2, paste(args[2], "g2", sep=""));
write(se_g2, paste(args[2], "se_g2", sep=""));
write(md, paste(args[2], "median", sep=""));
write(iqm, paste(args[2], "iqm", sep=""));
writeMM(as(t(out_minus),"CsparseMatrix"), paste(args[2], "out_minus", sep=""), format="text");
writeMM(as(t(out_plus),"CsparseMatrix"), paste(args[2], "out_plus", sep=""), format="text");
writeMM(as(t(Q),"CsparseMatrix"), paste(args[2], "quantile", sep=""), format="text");

#-------------------------------------------------------------
#
# Licensed to the Apache Software Foundation (ASF) under one
# or more contributor license agreements.  See the NOTICE file
# distributed with this work for additional information
# regarding copyright ownership.  The ASF licenses this file
# to you under the Apache License, Version 2.0 (the
# "License"); you may not use this file except in compliance
# with the License.  You may obtain a copy of the License at
# 
#   http://www.apache.org/licenses/LICENSE-2.0
# 
# Unless required by applicable law or agreed to in writing,
# software distributed under the License is distributed on an
# "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
# KIND, either express or implied.  See the License for the
# specific language governing permissions and limitations
# under the License.
#
#-------------------------------------------------------------


args <- commandArgs(TRUE)
options(digits=22)

library("Matrix")

A <- as.matrix(readMM(paste(args[1], "A.mtx", sep="")))
B <- as.matrix(readMM(paste(args[1], "B.mtx", sep="")))

if( as.integer(args[2])==1 ){
  # MIN
  if( nrow(A)>1 | nrow(B)>1 ){
     if( nrow(B)>nrow(A) ) {
       C <- pmin(B, A);
     }  
     else {
       C <- pmin(A, B);
     }
  }else{
     C <- min(A, B);
  }    
} else{
  # MAX  
  if( nrow(A)>1 | nrow(B)>1 ){
     if( nrow(B)>nrow(A) ){
       C <- pmax(B, A);
     }else{
       C <- pmax(A, B);
     }  
  }else{
     C <- max(A, B);
  } 
}

writeMM(as(as.matrix(C), "CsparseMatrix"), paste(args[3], "C", sep="")); 

#-------------------------------------------------------------
#
# Licensed to the Apache Software Foundation (ASF) under one
# or more contributor license agreements.  See the NOTICE file
# distributed with this work for additional information
# regarding copyright ownership.  The ASF licenses this file
# to you under the Apache License, Version 2.0 (the
# "License"); you may not use this file except in compliance
# with the License.  You may obtain a copy of the License at
#
#   http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing,
# software distributed under the License is distributed on an
# "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
# KIND, either express or implied.  See the License for the
# specific language governing permissions and limitations
# under the License.
#
#-------------------------------------------------------------

args = commandArgs(TRUE)
options(digits=22)
library("Matrix")

image_transform = function(img_in, out_w, out_h, a, b, c, d, e, f, fill_value) {
  divisor = a * e - b * d
  if (divisor == 0) {
    print("Inverse matrix does not exist! Returning input.")
    img_out = img_in
  }
  else {
    orig_w = ncol(img_in)
    orig_h = nrow(img_in)
    T.inv = matrix(0, nrow=3, ncol=3)
    T.inv[1, 1] = e / divisor
    T.inv[1, 2] = -b / divisor
    T.inv[1, 3] = (b * f - c * e) / divisor
    T.inv[2, 1] = -d / divisor
    T.inv[2, 2] = a / divisor
    T.inv[2, 3] = (c * d - a * f) / divisor
    T.inv[3, 3] = 1

    img_out = matrix(fill_value, nrow=out_w*out_h, ncol=1)
    coords = matrix(1, nrow=3, ncol=out_w*out_h)
    coords[1,] = t((seq(0, out_w*out_h-1) %% out_w) + 0.5)
    coords[2,] = t((seq(0, out_w*out_h-1) %/% out_w) + 0.5)
    coords = floor(T.inv %*% coords) + 1

    for (cell in 1:(out_w*out_h)) {
      inx = coords[1, cell]
      iny = coords[2, cell]
      if ((0 < inx) & (inx <= orig_w) & (0 < iny) & (iny <= orig_h)) {
        img_out[cell] = img_in[iny, inx]
      }
    }
    img_out = matrix(img_out, nrow=out_h, ncol=out_w, byrow=TRUE)
  }

  img_out
}

input = as.matrix(readMM(paste(args[1], "A.mtx", sep="")))
input = matrix(input, ncol=as.integer(args[3]), nrow=as.integer(args[4]))

transformed = image_transform(input, as.integer(args[5]), as.integer(args[6]), as.double(args[7]), as.double(args[8]), as.double(args[9]), as.double(args[10]), as.double(args[11]), as.double(args[12]), 0);
writeMM(as(transformed, "CsparseMatrix"), paste(args[2], "B", sep=""))

#-------------------------------------------------------------
#
# Licensed to the Apache Software Foundation (ASF) under one
# or more contributor license agreements.  See the NOTICE file
# distributed with this work for additional information
# regarding copyright ownership.  The ASF licenses this file
# to you under the Apache License, Version 2.0 (the
# "License"); you may not use this file except in compliance
# with the License.  You may obtain a copy of the License at
#
#   http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing,
# software distributed under the License is distributed on an
# "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
# KIND, either express or implied.  See the License for the
# specific language governing permissions and limitations
# under the License.
#
#-------------------------------------------------------------


args <- commandArgs(TRUE)

# Set options for numeric precision
options(digits=22)

# Load required libraries
library("Matrix")
library("matrixStats")

# Read matrices X, Y, Z, v from Matrix Market format files
X = as.matrix(readMM(paste(args[1], "X.mtx", sep="")))
Y = as.matrix(readMM(paste(args[1], "Y.mtx", sep="")))
Z = as.matrix(readMM(paste(args[1], "Z.mtx", sep="")))
v = as.matrix(readMM(paste(args[1], "v.mtx", sep="")))

# Select type of operation
type = as.integer(args[2])

# Perform the operations
if( type == 1 ) {
    R = t(Z)%*%(X*(Y*(Z%*%v)))
} else if( type == 2 ) {
    R = t(Z)%*%(X+(Y+(Z%*%v)))
}

writeMM(as(R, "CsparseMatrix"), paste(args[3], "R", sep=""))

#-------------------------------------------------------------
#
# Licensed to the Apache Software Foundation (ASF) under one
# or more contributor license agreements.  See the NOTICE file
# distributed with this work for additional information
# regarding copyright ownership.  The ASF licenses this file
# to you under the Apache License, Version 2.0 (the
# "License"); you may not use this file except in compliance
# with the License.  You may obtain a copy of the License at
# 
#   http://www.apache.org/licenses/LICENSE-2.0
# 
# Unless required by applicable law or agreed to in writing,
# software distributed under the License is distributed on an
# "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
# KIND, either express or implied.  See the License for the
# specific language governing permissions and limitations
# under the License.
#
#-------------------------------------------------------------

args <- commandArgs(TRUE)
library("Matrix")

X = readMM(paste(args[1], "X.mtx", sep=""));
W = readMM(paste(args[1], "W.mtx", sep=""));
H = readMM(paste(args[1], "H.mtx", sep=""));

k = as.integer(args[2]);
eps = as.double(args[3]);
max_iter = as.integer(args[4]);
iter = 1;

while( iter < max_iter ) {
   H = (H*(t(W)%*%(X/(W%*%H+eps)))) / (colSums(W)%*%matrix(1,1,ncol(H)));
   W = (W*((X/(W%*%H+eps))%*%t(H))) / (matrix(1,nrow(W),1)%*%t(rowSums(H)));
   obj = sum(W%*%H) - sum(X*log(W%*%H+eps));
   print(paste("obj=", obj))
   iter = iter + 1;
}

writeMM(as(W,"CsparseMatrix"), paste(args[5], "W", sep=""));
writeMM(as(H,"CsparseMatrix"), paste(args[5], "H", sep=""));

#-------------------------------------------------------------
#
# Licensed to the Apache Software Foundation (ASF) under one
# or more contributor license agreements.  See the NOTICE file
# distributed with this work for additional information
# regarding copyright ownership.  The ASF licenses this file
# to you under the Apache License, Version 2.0 (the
# "License"); you may not use this file except in compliance
# with the License.  You may obtain a copy of the License at
# 
#   http://www.apache.org/licenses/LICENSE-2.0
# 
# Unless required by applicable law or agreed to in writing,
# software distributed under the License is distributed on an
# "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
# KIND, either express or implied.  See the License for the
# specific language governing permissions and limitations
# under the License.
#
#-------------------------------------------------------------

args <- commandArgs(TRUE)
options(digits=22)

library("Matrix")
library("moments")

A1 <- readMM(paste(args[1], "D.mtx", sep=""))
K1 <- readMM(paste(args[1], "K.mtx", sep=""))
A <- as.matrix(A1);
K <- as.matrix(K1);
maxC = args[2];  


# number of features/attributes
n = ncol(A);

# number of data records
m = nrow(A);

# number of statistics
numBaseStats = 17; # (14 scale stats, 3 categorical stats)

max_kind = max(K);
  
# matrices to store computed statistics
baseStats = array(0,dim=c(numBaseStats,n)); 

if (maxC > 0) {
  countsArray = array(0,dim=c(maxC,n)); 
}
  
for(i in 1:n) {

	# project out the i^th column
	F = as.matrix(A[,i]);

	kind = K[1,i];

	if ( kind == 1 ) {
		print("scale");
		# compute SCALE statistics on the projected column
		minimum = min(F);
		maximum = max(F);
		rng = maximum - minimum;

		mu = mean(F);
		m2 = moment(F, order=2, central=TRUE);
		m3 = moment(F, order=3, central=TRUE);
		m4 = moment(F, order=4, central=TRUE);

		var = m/(m-1.0)*m2;
    
		std_dev = sqrt(var);
		se = std_dev/sqrt(m);
		cv = std_dev/mu;

		g1 = m3/(std_dev^3);
		g2 = m4/(std_dev^4) - 3;
		#se_g1=sqrt( 6*m*(m-1.0) / ((m-2.0)*(m+1.0)*(m+3.0)) ); 
		se_g1=sqrt( (6/(m-2.0)) * (m/(m+1.0)) * ((m-1.0)/(m+3.0)) ); 

		#se_g2= sqrt( (4*(m^2-1)*se_g1^2)/((m+5.0)*(m-3.0)) );  
		se_g2=sqrt( (4/(m+5.0)) * ((m^2-1)/(m-3.0)) * se_g1^2 ); 

		md = median(F); #quantile(F, 0.5, type = 1);

		S = sort(F)
		q25d=m*0.25
		q75d=m*0.75
		q25i=ceiling(q25d)
		q75i=ceiling(q75d)

		iqm = sum(S[(q25i+1):q75i])
		iqm = iqm + (q25i-q25d)*S[q25i] - (q75i-q75d)*S[q75i]
		iqm = iqm/(m*0.5)

		#iqm = mean( subset(F, F>quantile(F,1/4,type = 1) & F<=quantile(F,3/4,type = 1) ) )
    
		# place the computed statistics in output matrices
		baseStats[1,i] = minimum;
		baseStats[2,i] = maximum;
		baseStats[3,i] = rng;

		baseStats[4,i] = mu;
		baseStats[5,i] = var;
		baseStats[6,i] = std_dev;
		baseStats[7,i] = se;
		baseStats[8,i] = cv;

		baseStats[9,i] = g1;
		baseStats[10,i] = g2;
		baseStats[11,i] = se_g1;
		baseStats[12,i] = se_g2;

		baseStats[13,i] = md;
		baseStats[14,i] = iqm;
	}
	else {
		if (kind == 2 | kind == 3) {
			print("categorical");
			
			# check if the categorical column has valid values
			minF = min(F);
			if (minF <=0) {
				print("ERROR: Categorical attributes can only take values starting from 1.");
			}
			else {
				# compute CATEGORICAL statistics on the projected column
				cat_counts = table(F);  # counts for each category
				num_cat = nrow(cat_counts); # number of categories

        mx = max(t(as.vector(cat_counts)))
        mode = which(cat_counts == mx)    
        
      	numModes = length(cat_counts[ cat_counts==mx ]);

				# place the computed statistics in output matrices
				baseStats[15,i] = num_cat;
				baseStats[16,i] = mode;
				baseStats[17,i] = numModes;

        if (max_kind > 1) {
				  countsArray[1:length(cat_counts),i] = cat_counts;
				}
			}
		}
	}
}

writeMM(as(baseStats, "CsparseMatrix"), paste(args[3], "base.stats", sep=""));
if (max_kind > 1) {
  writeMM(as(countsArray, "CsparseMatrix"), paste(args[3], "categorical.counts", sep=""));
}

#-------------------------------------------------------------
#
# Licensed to the Apache Software Foundation (ASF) under one
# or more contributor license agreements.  See the NOTICE file
# distributed with this work for additional information
# regarding copyright ownership.  The ASF licenses this file
# to you under the Apache License, Version 2.0 (the
# "License"); you may not use this file except in compliance
# with the License.  You may obtain a copy of the License at
# 
#   http://www.apache.org/licenses/LICENSE-2.0
# 
# Unless required by applicable law or agreed to in writing,
# software distributed under the License is distributed on an
# "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
# KIND, either express or implied.  See the License for the
# specific language governing permissions and limitations
# under the License.
#
#-------------------------------------------------------------

args <- commandArgs(TRUE)
options(digits=22)
library("Matrix")

A=read.csv(paste(args[1], "A.csv", sep=""), header = FALSE, stringsAsFactors=FALSE)
B=read.csv(paste(args[1], "B.csv", sep=""), header = FALSE, stringsAsFactors=FALSE)
t1=rbind(A, B, B)
C=cbind(t1, t1, t1)
write.csv(C, paste(args[2], "C.csv", sep=""), row.names = FALSE, quote = FALSE)

#-------------------------------------------------------------
#
# Licensed to the Apache Software Foundation (ASF) under one
# or more contributor license agreements.  See the NOTICE file
# distributed with this work for additional information
# regarding copyright ownership.  The ASF licenses this file
# to you under the Apache License, Version 2.0 (the
# "License"); you may not use this file except in compliance
# with the License.  You may obtain a copy of the License at
# 
#   http://www.apache.org/licenses/LICENSE-2.0
# 
# Unless required by applicable law or agreed to in writing,
# software distributed under the License is distributed on an
# "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
# KIND, either express or implied.  See the License for the
# specific language governing permissions and limitations
# under the License.
#
#-------------------------------------------------------------
# 
# Intended to solve GLM Regression using R, in order to compare against the DML implementation
# INPUT 1: Matrix X [rows, columns]
# and Matrix y [rows, 1]
# INPUT 2-5: Distribution family and link, see below:
# ---------------------------------------------
#   Dst Var Lnk Lnk   Distribution       Cano-
#   typ pow typ pow   Family.link        nical?
# ---------------------------------------------
#    1  0.0  1 -1.0   Gaussian.inverse
#    1  0.0  1  0.0   Gaussian.log
#    1  0.0  1  1.0   Gaussian.id         Yes
#    1  1.0  1  0.0   Poisson.log         Yes
#    1  1.0  1  0.5   Poisson.sqrt
#    1  1.0  1  1.0   Poisson.id
#    1  2.0  1 -1.0   Gamma.inverse       Yes
#    1  2.0  1  0.0   Gamma.log
#    1  2.0  1  1.0   Gamma.id
#    1  3.0  1 -2.0   InvGaussian.1/mu^2  Yes
#    1  3.0  1 -1.0   InvGaussian.inverse
#    1  3.0  1  0.0   InvGaussian.log
#    1  3.0  1  1.0   InvGaussian.id
#    1   *   1   *    AnyVariance.AnyLink
# ---------------------------------------------
#    2 -1.0  *   *    Binomial {-1, 1}
#    2  0.0  *   *    Binomial { 0, 1}
#    2  1.0  *   *    Binomial two-column
#    2   *   1  0.0   Binomial.log
#    2   *   2   *    Binomial.logit      Yes
#    2   *   3   *    Binomial.probit
#    2   *   4   *    Binomial.cloglog
#    2   *   5   *    Binomial.cauchit
# ---------------------------------------------
# INPUT 2: (int) Distribution type
# INPUT 3: (double) For Power families: Variance power of the mean
# INPUT 4: (int) Link function type
# INPUT 5: (double) Link as power of the mean
# INPUT 6: (int) Intercept: 0 = no, 1 = yes
# INPUT 7: (double) tolerance (epsilon)
# INPUT 8: the regression coefficients output file
# OUTPUT : Matrix beta [columns, 1]
#
# Assume that $GLMR_HOME is set to the home of the R script
# Assume input and output directories are $GLMR_HOME/in/ and $GLMR_HOME/expected/
# Rscript $GLMR_HOME/GLM.R $GLMR_HOME/in/X.mtx $GLMR_HOME/in/y.mtx 2 0.0 2 0.0 1 0.00000001 $GLMR_HOME/expected/w.mtx

args <- commandArgs (TRUE);

library ("Matrix");
# library ("batch");

options (warn = -1);

X_here <- as.matrix(readMM(args[1]))
y_here <- as.matrix(readMM(args[2]))

num_records  <- nrow (X_here);
num_features <- ncol (X_here);
dist_type  <- as.integer (args[3]);
dist_param <- as.numeric (args[4]);
link_type  <- as.integer (args[5]);
link_power <- as.numeric (args[6]);
icept <- as.integer (args[7]);
eps_n <- as.numeric (args[8]);

f_ly <- gaussian ();
var_power <- dist_param;

if (dist_type == 1 & var_power == 0.0 & link_type == 1 & link_power ==  1.0) { f_ly <- gaussian (link = "identity");         } else
if (dist_type == 1 & var_power == 0.0 & link_type == 1 & link_power == -1.0) { f_ly <- gaussian (link = "inverse");          } else
if (dist_type == 1 & var_power == 0.0 & link_type == 1 & link_power ==  0.0) { f_ly <- gaussian (link = "log");              } else
if (dist_type == 1 & var_power == 1.0 & link_type == 1 & link_power ==  1.0) { f_ly <-  poisson (link = "identity");         } else
if (dist_type == 1 & var_power == 1.0 & link_type == 1 & link_power ==  0.0) { f_ly <-  poisson (link = "log");              } else
if (dist_type == 1 & var_power == 1.0 & link_type == 1 & link_power ==  0.5) { f_ly <-  poisson (link = "sqrt");             } else
if (dist_type == 1 & var_power == 2.0 & link_type == 1 & link_power ==  1.0) { f_ly <-    Gamma (link = "identity");         } else
if (dist_type == 1 & var_power == 2.0 & link_type == 1 & link_power == -1.0) { f_ly <-    Gamma (link = "inverse");          } else
if (dist_type == 1 & var_power == 2.0 & link_type == 1 & link_power ==  0.0) { f_ly <-    Gamma (link = "log");              } else
if (dist_type == 1 & var_power == 3.0 & link_type == 1 & link_power ==  1.0) { f_ly <- inverse.gaussian (link = "identity"); } else
if (dist_type == 1 & var_power == 3.0 & link_type == 1 & link_power == -1.0) { f_ly <- inverse.gaussian (link = "inverse");  } else
if (dist_type == 1 & var_power == 3.0 & link_type == 1 & link_power ==  0.0) { f_ly <- inverse.gaussian (link = "log");      } else
if (dist_type == 1 & var_power == 3.0 & link_type == 1 & link_power == -2.0) { f_ly <- inverse.gaussian (link = "1/mu^2");   } else
if (dist_type == 2                    & link_type == 1 & link_power ==  0.0) { f_ly <- binomial (link = "log");              } else
if (dist_type == 2                    & link_type == 1 & link_power ==  1.0) { f_ly <- binomial (link = "identity");         } else
if (dist_type == 2                    & link_type == 1 & link_power ==  0.5) { f_ly <- binomial (link = "sqrt");             } else
if (dist_type == 2                    & link_type == 2                     ) { f_ly <- binomial (link = "logit");            } else
if (dist_type == 2                    & link_type == 3                     ) { f_ly <- binomial (link = "probit");           } else
if (dist_type == 2                    & link_type == 4                     ) { f_ly <- binomial (link = "cloglog");          } else
if (dist_type == 2                    & link_type == 5                     ) { f_ly <- binomial (link = "cauchit");          }

# quasi(link = "identity", variance = "constant")
# quasibinomial(link = "logit")
# quasipoisson(link = "log")

if (dist_type == 2 & dist_param != 1.0) {
    y_here <- (y_here - dist_param) / (1.0 - dist_param);
}

# epsilon 	tolerance: the iterations converge when |dev - devold|/(|dev| + 0.1) < epsilon.
# maxit 	integer giving the maximal number of IWLS iterations.
# trace 	logical indicating if output should be produced for each iteration.
#
c_rol <- glm.control (epsilon = eps_n, maxit = 100, trace = FALSE);

X_matrix = as.matrix (X_here);
y_matrix = as.matrix (y_here);

if (icept == 0) {
    glmOut <- glm (y_matrix ~ X_matrix - 1, family = f_ly, control = c_rol); # zero intercept
    betas <- coef (glmOut);
} else {
    glmOut <- glm (y_matrix ~ X_matrix    , family = f_ly, control = c_rol);
    betas <- coef (glmOut);
    beta_intercept = betas [1];
    betas [1 : num_features] = betas [2 : (num_features + 1)];
    betas [num_features + 1] = beta_intercept;
}

print (c("Deviance", glmOut$deviance));
writeMM (as (betas, "CsparseMatrix"), args[9], format = "text");

#-------------------------------------------------------------
#
# Licensed to the Apache Software Foundation (ASF) under one
# or more contributor license agreements.  See the NOTICE file
# distributed with this work for additional information
# regarding copyright ownership.  The ASF licenses this file
# to you under the Apache License, Version 2.0 (the
# "License"); you may not use this file except in compliance
# with the License.  You may obtain a copy of the License at
# 
#   http://www.apache.org/licenses/LICENSE-2.0
# 
# Unless required by applicable law or agreed to in writing,
# software distributed under the License is distributed on an
# "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
# KIND, either express or implied.  See the License for the
# specific language governing permissions and limitations
# under the License.
#
#-------------------------------------------------------------

args <- commandArgs(TRUE)
library(Matrix)

posSamples = readMM(paste(args[1], "posSamples.mtx", sep=""))
negSamples = readMM(paste(args[1], "negSamples.mtx", sep=""))

#computing sample sizes
posSampleSize = nrow(posSamples)
negSampleSize = nrow(negSamples)

#computing means
posSampleMeans = colMeans(posSamples)
negSampleMeans = colMeans(negSamples)

#computing (unbiased) variances
posSampleVariances = (colSums(posSamples^2) - posSampleSize * posSampleMeans^2) / (posSampleSize-1)
negSampleVariances = (colSums(negSamples^2) - negSampleSize * negSampleMeans^2) / (negSampleSize-1)

#computing t-statistics and degrees of freedom
t_statistics = (posSampleMeans - negSampleMeans) / sqrt(posSampleVariances/posSampleSize + negSampleVariances/negSampleSize)
degrees_of_freedom = round(((posSampleVariances/posSampleSize + negSampleVariances/negSampleSize) ^ 2) / (posSampleVariances^2/(posSampleSize^2 * (posSampleSize-1)) + negSampleVariances^2/(negSampleSize^2 * (negSampleSize-1))))

#R will write a vector as a 1-column matrix, forcing it to write a 1-row matrix
t_statistics_mat = matrix(t_statistics, 1, length(t_statistics))
degrees_of_freedom_mat = matrix(degrees_of_freedom, 1, length(degrees_of_freedom))

writeMM(as(t_statistics_mat, "CsparseMatrix"), paste(args[2], "t_statistics", sep=""))
writeMM(as(degrees_of_freedom_mat, "CsparseMatrix"), paste(args[2], "degrees_of_freedom", sep=""))

#-------------------------------------------------------------
#
# Licensed to the Apache Software Foundation (ASF) under one
# or more contributor license agreements.  See the NOTICE file
# distributed with this work for additional information
# regarding copyright ownership.  The ASF licenses this file
# to you under the Apache License, Version 2.0 (the
# "License"); you may not use this file except in compliance
# with the License.  You may obtain a copy of the License at
#
#   http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing,
# software distributed under the License is distributed on an
# "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
# KIND, either express or implied.  See the License for the
# specific language governing permissions and limitations
# under the License.
#
#-------------------------------------------------------------


args = commandArgs(TRUE)

library("tseries")
library(Matrix)

X = readMM(args[1])

n = nrow(X)
model = garch(as.matrix(X))
mean_residual_error = mean(residuals(model)[2:n]) # first is NA, drop this value

writeMM(as(mean_residual_error, "CsparseMatrix"), args[2])

#-------------------------------------------------------------
#
# Licensed to the Apache Software Foundation (ASF) under one
# or more contributor license agreements.  See the NOTICE file
# distributed with this work for additional information
# regarding copyright ownership.  The ASF licenses this file
# to you under the Apache License, Version 2.0 (the
# "License"); you may not use this file except in compliance
# with the License.  You may obtain a copy of the License at
#
#   http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing,
# software distributed under the License is distributed on an
# "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
# KIND, either express or implied.  See the License for the
# specific language governing permissions and limitations
# under the License.
#
#-------------------------------------------------------------

#
# This script performs Principal Component Analysis (PCA) on the given input data.
#

args <- commandArgs(TRUE)
library("Matrix")

A = readMM(paste(args[1], "A.mtx", sep=""));
K = ncol(A);
projectData = 0;
model = "";
center = 0;
scale = 0;


if (model != "") {
  # reuse existing model to project data
} else if (model == "") {

  N = nrow(A);
  D = ncol(A);

  # 1. perform z-scoring (centering and scaling)
  if (center == 1) {
    cm = matrix(1, nrow(A), 1) %*% colMeans(A);
    A = A - cm
  }
  if (scale == 1) {
    cvars = (colSums(A^2));
    if (center == 1){
      #cm = colMeans(A);
      cvars = (cvars - N*(colMeans(A)^2))/(N-1);
    }
    Azscored = A / sqrt(cvars);
    A = Azscored;
  }

  # 2. compute co-variance matrix
  mu = colSums(A)/N;
  C = (t(A) %*% A)/(N-1) - (N/(N-1))*(mu) %*% t(mu);

  # 3. compute eigen vectors and values
  R <- eigen(C);
  evalues = R$values;
  evectors = R$vectors;

  # 4. make an index of values sorted according to magnitude of evalues
  decreasing_Idx = order(as.vector(evalues), decreasing=TRUE);
  diagmat = table(seq(1,D), decreasing_Idx);
  # 5. sorts eigen values by decreasing order
  evalues = diagmat %*% evalues;
  # 6. sorts eigen vectors column-wise in the order of decreasing eigen values
  evectors = evectors %*% diagmat;

  # 7. select K dominant eigen vectors
  nvec = ncol(evectors); # Here `nvec=K`
  eval_dominant = evalues[1:K, 1];
  evec_dominant = evectors[1:K,];

  # 8. compute the std. deviation of dominant evalues
  eval_stdev_dominant = sqrt(eval_dominant);

  writeMM(as(eval_stdev_dominant, "CsparseMatrix"), paste(args[2],"dominant.eigen.standard.deviations", sep=""));
  writeMM(as(eval_dominant, "CsparseMatrix"), paste(args[2], "dominant.eigen.values", sep=""));
  writeMM(as(evec_dominant, "CsparseMatrix"), paste(args[2],"dominant.eigen.vectors", sep=""));
}

#-------------------------------------------------------------
#
# Licensed to the Apache Software Foundation (ASF) under one
# or more contributor license agreements.  See the NOTICE file
# distributed with this work for additional information
# regarding copyright ownership.  The ASF licenses this file
# to you under the Apache License, Version 2.0 (the
# "License"); you may not use this file except in compliance
# with the License.  You may obtain a copy of the License at
#
#   http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing,
# software distributed under the License is distributed on an
# "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
# KIND, either express or implied.  See the License for the
# specific language governing permissions and limitations
# under the License.
#
#-------------------------------------------------------------

args <- commandArgs(TRUE)
library("Matrix")

#1. tanh function
func = function(X){
  Y = tanh(X)
  return(Y)
}

func1 = function(X) {
  Y = (exp(2*X) - 1)/(exp(2*X) + 1)
  Y_prime = 1 - Y^2
  return(Y_prime)
}

#2. feedForward

obj <- function(E){
  val = 0.5 * sum(E^2)
  return(val)
}


X = readMM(paste(args[1], "X.mtx", sep=""));
W1_rand = readMM(paste(args[1], "W1_rand.mtx", sep=""));
W2_rand = readMM(paste(args[1], "W2_rand.mtx", sep=""));
W3_rand = readMM(paste(args[1], "W3_rand.mtx", sep=""));
W4_rand = readMM(paste(args[1], "W4_rand.mtx", sep=""));
order_rand = readMM(paste(args[1], "order_rand.mtx", sep=""));

num_hidden1 = as.integer(args[2])    #$H1
num_hidden2 = as.integer(args[3])    #$H2
max_epochs = as.integer(args[4])     #$EPOCH
batch_size = as.integer(args[5])     #$BATCH

mu = 0.9 # momentum
step = 1e-5
decay = 0.95
hfile = " "
fmt = "text"
full_obj = FALSE

n = nrow(X)
m = ncol(X)

#randomly reordering rows
#permut = table(seq(from=1,to=n,by=1), order(runif(n, min=0, max=1)))
permut = table(seq(from=1,to=n,by=1), order(order_rand))
permut = as.data.frame.matrix(permut)
permut = data.matrix(permut)
X = (permut %*% X)
#z-transform, whitening operator is better
means = t(as.matrix(colSums(X)))/n
csx2 = t(as.matrix(colSums(X^2)))/n
stds = sqrt(csx2 - (means*means)*n/(n-1)) + 1e-17
X = (X - matrix(1, nrow(X),1) %*% means)/(matrix(1,nrow(X),1) %*% stds)

W1 = sqrt(6)/sqrt(m + num_hidden1) * W1_rand
b1 = matrix(0, num_hidden1, 1)

W2 = sqrt(6)/sqrt(num_hidden1 + num_hidden2) * W2_rand
b2 = matrix(0, num_hidden2, 2)

W3 = sqrt(6)/sqrt(num_hidden2 + num_hidden1) * W3_rand
b3 = matrix(0, num_hidden1, 1)

W4 = sqrt(6)/sqrt(num_hidden2 + m) * W4_rand
b4 = matrix(0, m, 1)

upd_W1 = matrix(0, nrow(W1), ncol(W1))
upd_b1 = matrix(0, nrow(b1), ncol(b1))
upd_W2 = matrix(0, nrow(W2), ncol(W2))
upd_b2 = matrix(0, nrow(b2), ncol(b2))
upd_W3 = matrix(0, nrow(W3), ncol(W3))
upd_b3 = matrix(0, nrow(b3), ncol(b3))
upd_W4 = matrix(0, nrow(W4), ncol(W4))
upd_b4 = matrix(0, nrow(b4), ncol(b4))

if( full_obj ){
    # nothing to do here
}

iter = 0
num_iters_per_epoch = ceiling(n / batch_size)
max_iterations = max_epochs * num_iters_per_epoch
# debug
# print("num_iters_per_epoch=" + num_iters_per_epoch + " max_iterations=" + max_iterations)
beg = 1
while( iter < max_iterations ) {
  end = beg + batch_size - 1
  if(end > n) end = n
  X_batch = X[beg:end,]

  # Notation:
  #  1    2         3   4         5   6         7     8          9
  # [H1, H1_prime, H2, H2_prime, H3, H3_prime, Yhat, Yhat_prime, E]
  # tmp_ff = feedForward(X_batch, W1, b1, W2, b2, W3, b3, W4, b4, X_batch)
  # H1 = tmp_ff[1]; H1_prime = tmp_ff[2]; H2 = tmp_ff[3]; H2_prime = tmp_ff[4];
  # H3 = tmp_ff[5]; H3_prime = tmp_ff[6]; Yhat = tmp_ff[7]; Yhat_prime = tmp_ff[8];
  # E = tmp_ff[9]
  # inputs: X, W1, b1, W2, b2, W3, b3, W4, b4, X_batch
  H1_in = t(W1 %*% t(X_batch) + b1 %*% matrix(1,ncol(b1),nrow(X_batch)))
  H1 = func(H1_in)
  H1_prime = func1(H1_in)

  H2_in = t(W2 %*% t(H1) + b2%*% matrix(1,ncol(b2),nrow(H1)))
  H2 = func(H2_in)
  H2_prime = func1(H2_in)

  H3_in = t(W3 %*% t(H2) + b3%*% matrix(1,ncol(b3),nrow(H2)))
  H3 = func(H3_in)
  H3_prime = func1(H3_in)

  Yhat_in = t(W4 %*% t(H3) + b4%*% matrix(1,ncol(b4),nrow(H3)))
  Yhat = func(Yhat_in)
  Yhat_prime = func1(Yhat_in)

  E = Yhat - X_batch

  # Notation:
  #  1        2           3      4        5         6        7      8
  # [W1_grad, b1_grad, W2_grad, b2_grad, W3_grad, b3_grad,W4_grad, b4_grad]
  # tmp_grad = grad(X_batch, H1, H1_prime, H2, H2_prime, H3, H3_prime, Yhat_prime, E, W1, W2, W3, W4)
  # W1_grad = tmp_grad[1]; b1_grad = tmp_grad[2]; W2_grad = tmp_grad[3]; b2_grad = tmp_grad[4];
  # W3_grad = tmp_grad[5]; b3_grad = tmp_grad[6]; W4_grad = tmp_grad[7]; b4_grad = tmp_grad[8];
  # grad function

  #backprop
  delta4 = E * Yhat_prime
  delta3 = H3_prime * (delta4 %*% W4)
  delta2 = H2_prime * (delta3 %*% W3)
  delta1 = H1_prime * (delta2 %*% W2)

  #compute gradients
  b4_grad = (colSums(delta4))
  b3_grad = (colSums(delta3))
  b2_grad = (colSums(delta2))
  b1_grad = (colSums(delta1))

  W4_grad = t(delta4) %*% H3
  W3_grad = t(delta3) %*% H2
  W2_grad = t(delta2) %*% H1
  W1_grad = t(delta1) %*% X_batch

  ob = obj(E)
  epochs = iter / num_iters_per_epoch
  # debug
  # print(table(epochs, ob), zero.print = "0")

  #update
  local_step = step / nrow(X_batch)
  upd_W1 = mu * upd_W1 - local_step * W1_grad
  upd_b1 = mu * upd_b1 - local_step * b1
  upd_W2 = mu * upd_W2 - local_step * W2_grad
  upd_b2 = mu * upd_b2 - local_step * b2
  upd_W3 = mu * upd_W3 - local_step * W3_grad
  upd_b3 = mu * upd_b3 - local_step * b3
  upd_W4 = mu * upd_W4 - local_step * W4_grad
  upd_b4 = mu * upd_b4 - local_step * b4
  W1 = W1 + upd_W1
  b1 = b1 + upd_b1
  W2 = W2 + upd_W2
  b2 = b2 + upd_b2
  W3 = W3 + upd_W3
  b3 = b3 + upd_b3
  W4 = W4 + upd_W4
  b4 = b4 + upd_b4

  iter = iter + 1
  if(end == n) beg = 1
  else beg = end + 1

  if(iter %% num_iters_per_epoch == 0) 
	  step = step * decay

  if(full_obj & iter %% num_iters_per_epoch == 0 ) {
    # Notation:
    # tmp_ff = feedForward(X, W1, b1, W2, b2, W3, b3, W4, b4, X)
    # full_H1 = tmp_ff[1]; full_H1_prime = tmp_ff[2]; full_H2 = tmp_ff[3]; full_H2_prime = tmp_ff[4];
    # full_H3 = tmp_ff[5]; full_H3_prime = tmp_ff[6]; full_Yhat = tmp_ff[7]; full_Yhat_prime = tmp_ff[8];
    # full_E = tmp_ff[9];
    # inputs: X, W1, b1, W2, b2, W3, b3, W4, b4, X
    H1_in = t(W1 %*% t(X) + b1 %*% matrix(1,ncol(b1),nrow(X)))

    full_H1 = func(H1_in)
    full_H1_prime = func1(H1_in)

    H2_in = t(W2 %*% t(H1) + b2%*% matrix(1,ncol(b2),nrow(H1)))
    full_H2 = func(H2_in)
    full_H2_prime = func1(H2_in)

    H3_in = t(W3 %*% t(H2) + b3%*% matrix(1,ncol(b3),nrow(H2)))
    full_H3 = func(H3_in)
    full_H3_prime = func1(H3_in)

    Yhat_in = t(W4 %*% t(H3) + b4%*% matrix(1,ncol(b4),nrow(H3)))
    full_Yhat = func(Yhat_in)
    full_Yhat_prime = func1(Yhat_in)
    full_E = full_Yhat - X

    full_o = obj(full_E)
    epochs = iter %/% num_iters_per_epoch
    # debug
    # print(table(epochs, full_o, deparse.level=2), zero.print=".")
    # print("EPOCHS=" + epochs + " iter=" + iter + " OBJ (FULL DATA)=" + full_o)
  }
}

#debug
#print.table(W1, digits=3)
writeMM(as(W1,"CsparseMatrix"), paste(args[6], "W1", sep=""));
writeMM(as(b1,"CsparseMatrix"), paste(args[6], "b1", sep=""));
writeMM(as(W2,"CsparseMatrix"), paste(args[6], "W2", sep=""));
writeMM(as(b2,"CsparseMatrix"), paste(args[6], "b2", sep=""));
writeMM(as(W3,"CsparseMatrix"), paste(args[6], "W3", sep=""));
writeMM(as(b3,"CsparseMatrix"), paste(args[6], "b3", sep=""));
writeMM(as(W4,"CsparseMatrix"), paste(args[6], "W4", sep=""));
writeMM(as(b4,"CsparseMatrix"), paste(args[6], "b4", sep=""));

#-------------------------------------------------------------
#
# Licensed to the Apache Software Foundation (ASF) under one
# or more contributor license agreements.  See the NOTICE file
# distributed with this work for additional information
# regarding copyright ownership.  The ASF licenses this file
# to you under the Apache License, Version 2.0 (the
# "License"); you may not use this file except in compliance
# with the License.  You may obtain a copy of the License at
# 
#   http://www.apache.org/licenses/LICENSE-2.0
# 
# Unless required by applicable law or agreed to in writing,
# software distributed under the License is distributed on an
# "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
# KIND, either express or implied.  See the License for the
# specific language governing permissions and limitations
# under the License.
#
#-------------------------------------------------------------

args<-commandArgs(TRUE)
options(digits=22)
library("Matrix")

N = 2000;
M = as.integer(args[1]);
X = matrix( seq(1,N*M), N, M, byrow=TRUE)

A = (X * 7 + 6) * 5 + 4;
B = A + 1;
C = A + 2;
S = rowSums(B * C);

writeMM(as(S, "CsparseMatrix"), paste(args[2], "S", sep="")); 
 

#-------------------------------------------------------------
#
# Licensed to the Apache Software Foundation (ASF) under one
# or more contributor license agreements.  See the NOTICE file
# distributed with this work for additional information
# regarding copyright ownership.  The ASF licenses this file
# to you under the Apache License, Version 2.0 (the
# "License"); you may not use this file except in compliance
# with the License.  You may obtain a copy of the License at
# 
#   http://www.apache.org/licenses/LICENSE-2.0
# 
# Unless required by applicable law or agreed to in writing,
# software distributed under the License is distributed on an
# "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
# KIND, either express or implied.  See the License for the
# specific language governing permissions and limitations
# under the License.
#
#-------------------------------------------------------------

args <- commandArgs(TRUE)

library("Matrix")
library("imputeTS")

input_matrix = as.matrix(readMM(paste(args[1], "A.mtx", sep="")))
input_matrix[input_matrix==0] = NA

bins_in = as.numeric(args[2])
output = matrix(0, nrow=8, ncol=1)

Out = statsNA(input_matrix, bins = bins_in, print_only = FALSE)

output[1,1]=Out["length_series"][[1]]
output[2,1]=Out["number_NAs"][[1]]
output[3,1]=as.numeric(sub("%","",Out["percentage_NAs"][[1]],fixed=TRUE))/100
output[4,1]=Out["number_na_gaps"][[1]]
output[5,1]=Out["average_size_na_gaps"][[1]]
output[6,1]=Out["longest_na_gap"][[1]]
output[7,1]=Out["most_frequent_na_gap"][[1]]
output[8,1]=Out["most_weighty_na_gap"][[1]]

writeMM(as(output, "CsparseMatrix"), paste(args[3], "Out", sep=""))

#-------------------------------------------------------------
#
# Licensed to the Apache Software Foundation (ASF) under one
# or more contributor license agreements.  See the NOTICE file
# distributed with this work for additional information
# regarding copyright ownership.  The ASF licenses this file
# to you under the Apache License, Version 2.0 (the
# "License"); you may not use this file except in compliance
# with the License.  You may obtain a copy of the License at
# 
#   http://www.apache.org/licenses/LICENSE-2.0
# 
# Unless required by applicable law or agreed to in writing,
# software distributed under the License is distributed on an
# "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
# KIND, either express or implied.  See the License for the
# specific language governing permissions and limitations
# under the License.
#
#-------------------------------------------------------------

# JUnit test class: dml.test.integration.descriptivestats.BivariateScaleCategoricalTest.java
# command line invocation assuming $SC_HOME is set to the home of the R script
# Rscript $SC_HOME/ScaleCategorical.R $SC_HOME/in/ $SC_HOME/expected/

args <- commandArgs(TRUE)
options(digits=22)

library("Matrix")
# Usage: R --vanilla -args Xfile X < ScaleCategoricalTest.R

#parseCommandArgs()
######################
Atemp = readMM(paste(args[1], "A.mtx", sep=""));
Ytemp = readMM(paste(args[1], "Y.mtx", sep=""));
WM = readMM(paste(args[1], "WM.mtx", sep=""));

Yv=rep(Ytemp[,1],WM[,1])
Av=rep(Atemp[,1],WM[,1])

W = sum(WM);
my = sum(Yv)/W;
varY = var(Yv);

CFreqs = as.matrix(table(Av)); 
CMeans = as.matrix(aggregate(Yv, by=list(Av), "mean")$x);
CVars = as.matrix(aggregate(Yv, by=list(Av), "var")$x);

# number of categories
R = nrow(CFreqs);

Eta = sqrt(1 - ( sum((CFreqs-1)*CVars) / ((W-1)*varY) ));

anova_num = sum( (CFreqs*(CMeans-my)^2) )/(R-1);
anova_den = sum( (CFreqs-1)*CVars )/(W-R);
ANOVAF = anova_num/anova_den;

print(W, digits=15);
print(R, digits=15);
print(anova_num, digits=15);
print(anova_den, digits=15);

#######################

write(Eta, paste(args[2], "Eta", sep=""));

write(ANOVAF, paste(args[2], "AnovaF", sep=""));

write(varY, paste(args[2], "VarY", sep=""));

write(my, paste(args[2], "MeanY", sep=""));

writeMM(as(CVars,"CsparseMatrix"), paste(args[2], "CVars", sep=""), format="text");
writeMM(as(CFreqs,"CsparseMatrix"), paste(args[2], "CFreqs", sep=""), format="text");
writeMM(as(CMeans,"CsparseMatrix"), paste(args[2], "CMeans", sep=""), format="text");

#-------------------------------------------------------------
#
# Licensed to the Apache Software Foundation (ASF) under one
# or more contributor license agreements.  See the NOTICE file
# distributed with this work for additional information
# regarding copyright ownership.  The ASF licenses this file
# to you under the Apache License, Version 2.0 (the
# "License"); you may not use this file except in compliance
# with the License.  You may obtain a copy of the License at
#
#   http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing,
# software distributed under the License is distributed on an
# "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
# KIND, either express or implied.  See the License for the
# specific language governing permissions and limitations
# under the License.
#
#-------------------------------------------------------------

args<-commandArgs(TRUE)
options(digits=22)
library("Matrix")
library("mice")

set.seed(args[3])
prop <- as.numeric(args[5])

col_names <- args[4] == "true"
X <- as.matrix(read.csv(args[1]), col_names=col_names)

# Create three patterns with different probabilities, each amputing a single variable:
numPatterns <- 3
freq <- rep(1 / numPatterns, numPatterns)
for (i in 1:numPatterns) {
  freq[i] <- i / 6
}
patterns <- matrix(1, nrow=numPatterns, ncol=ncol(X))
for (i in 1:numPatterns) {
  patterns[i, i] <- 0
}


res <- ampute(X, freq=freq, patterns=patterns, prop=prop)$amp


# Proportion of amputed rows:
amputed_rows <- apply(res, 1, function(row) any(is.na(row)))  # TRUE if row has missing values
proportion_amputed_rows <- mean(amputed_rows)
num_amputed_rows <- sum(amputed_rows)

# Pattern assigment proportions among amputed rows:
groupProps <- colSums(is.na(res)) / num_amputed_rows

# Print the result
cat("Proportion of total rows amputed (%): ", proportion_amputed_rows, "\n")
cat("Proportion of amputed rows by pattern (%): ", groupProps, "\n")

# Collect results, and output:
row_vector <- c(proportion_amputed_rows, groupProps)
# cat(row_vector)
writeMM(as(row_vector, "CsparseMatrix"), args[2])

#-------------------------------------------------------------
#
# Licensed to the Apache Software Foundation (ASF) under one
# or more contributor license agreements.  See the NOTICE file
# distributed with this work for additional information
# regarding copyright ownership.  The ASF licenses this file
# to you under the Apache License, Version 2.0 (the
# "License"); you may not use this file except in compliance
# with the License.  You may obtain a copy of the License at
# 
#   http://www.apache.org/licenses/LICENSE-2.0
# 
# Unless required by applicable law or agreed to in writing,
# software distributed under the License is distributed on an
# "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
# KIND, either express or implied.  See the License for the
# specific language governing permissions and limitations
# under the License.
#
#-------------------------------------------------------------

args <- commandArgs(TRUE)
library("Matrix")




check_if_supported <- 
    function (ncol_y, dist_type, var_power, link_type, link_power)
{
    is_supported = 0;
    if (ncol_y == 1 & dist_type == 1 & link_type == 1)
    { # POWER DISTRIBUTION
        is_supported = 1;
        if (var_power == 0.0 & link_power == -1.0) {print ("Gaussian.inverse");      } else {
        if (var_power == 0.0 & link_power ==  0.0) {print ("Gaussian.log");          } else {
        if (var_power == 0.0 & link_power ==  0.5) {print ("Gaussian.sqrt");         } else {
        if (var_power == 0.0 & link_power ==  1.0) {print ("Gaussian.id");           } else {
        if (var_power == 0.0                     ) {print ("Gaussian.power_nonlog"); } else {
        if (var_power == 1.0 & link_power == -1.0) {print ("Poisson.inverse");       } else {
        if (var_power == 1.0 & link_power ==  0.0) {print ("Poisson.log");           } else {
        if (var_power == 1.0 & link_power ==  0.5) {print ("Poisson.sqrt");          } else {
        if (var_power == 1.0 & link_power ==  1.0) {print ("Poisson.id");            } else {
        if (var_power == 1.0                     ) {print ("Poisson.power_nonlog");  } else {
        if (var_power == 2.0 & link_power == -1.0) {print ("Gamma.inverse");         } else {
        if (var_power == 2.0 & link_power ==  0.0) {print ("Gamma.log");             } else {
        if (var_power == 2.0 & link_power ==  0.5) {print ("Gamma.sqrt");            } else {
        if (var_power == 2.0 & link_power ==  1.0) {print ("Gamma.id");              } else {
        if (var_power == 2.0                     ) {print ("Gamma.power_nonlog");    } else {
        if (var_power == 3.0 & link_power == -2.0) {print ("InvGaussian.1/mu^2");    } else {
        if (var_power == 3.0 & link_power == -1.0) {print ("InvGaussian.inverse");   } else {
        if (var_power == 3.0 & link_power ==  0.0) {print ("InvGaussian.log");       } else {
        if (var_power == 3.0 & link_power ==  0.5) {print ("InvGaussian.sqrt");      } else {
        if (var_power == 3.0 & link_power ==  1.0) {print ("InvGaussian.id");        } else {
        if (var_power == 3.0                     ) {print ("InvGaussian.power_nonlog");}else{
        if (                   link_power ==  0.0) {print ("PowerDist.log");         } else {
                                                    print ("PowerDist.power_nonlog");
    }   }}}}} }}}}} }}}}} }}}}} }}
    if (ncol_y == 1 & dist_type == 2)
    {
        print ("Error: Bernoulli response matrix has not been converted into two-column format.");
    }
    if (ncol_y == 2 & dist_type == 2 & link_type >= 1 & link_type <= 5)
    { # BINOMIAL/BERNOULLI DISTRIBUTION
        is_supported = 1;
        if (link_type == 1 & link_power == -1.0) {print ("Binomial.inverse");        } else {
        if (link_type == 1 & link_power ==  0.0) {print ("Binomial.log");            } else {
        if (link_type == 1 & link_power ==  0.5) {print ("Binomial.sqrt");           } else {
        if (link_type == 1 & link_power ==  1.0) {print ("Binomial.id");             } else {
        if (link_type == 1)                      {print ("Binomial.power_nonlog");   } else {
        if (link_type == 2)                      {print ("Binomial.logit");          } else {
        if (link_type == 3)                      {print ("Binomial.probit");         } else {
        if (link_type == 4)                      {print ("Binomial.cloglog");        } else {
        if (link_type == 5)                      {print ("Binomial.cauchit");        }
    }   }}}}} }}}
    if (is_supported == 0) {
        print ("Response matrix with " + ncol_y + " columns, distribution family (" + dist_type + ", " + var_power
             + ") and link family (" + link_type + ", " + link_power + ") are NOT supported together.");
    }
    
    return (is_supported)
}

glm_initialize <- function (X, Y, dist_type, var_power, link_type, link_power, icept_status, max_iter_CG)
{
    saturated_log_l = 0.0;
    isNaN = 0;
    y_corr = Y [, 1];
    if (dist_type == 2) {
        n_corr = rowSums (Y);
        is_n_zero = (n_corr == 0.0);
        y_corr = Y [, 1] / (n_corr + is_n_zero) + (0.5 - Y [, 1]) * is_n_zero;    
    }
    linear_terms = y_corr;
    if (dist_type == 1 & link_type == 1) { # POWER DISTRIBUTION
        if          (link_power ==  0.0) {
            if (sum (y_corr < 0.0) == 0) {
                is_zero_y_corr = (y_corr == 0.0);
                linear_terms = log (y_corr + is_zero_y_corr) - is_zero_y_corr / (1.0 - is_zero_y_corr);
            } else { isNaN = 1; }
        } else { if (link_power ==  1.0) {
            linear_terms = y_corr;
        } else { if (link_power == -1.0) {
            linear_terms = 1.0 / y_corr;
        } else { if (link_power ==  0.5) {
            if (sum (y_corr < 0.0) == 0) {
                linear_terms = sqrt (y_corr);
            } else { isNaN = 1; }
        } else { if (link_power >   0.0) {
            if (sum ((y_corr < 0.0)) == 0) {
                is_zero_y_corr = (y_corr == 0.0);
                linear_terms = (y_corr + is_zero_y_corr) ^ link_power - is_zero_y_corr;
            } else { isNaN = 1; }
        } else {
            if (sum ((y_corr <= 0.0)) == 0) {
                linear_terms = y_corr ^ link_power;
            } else { isNaN = 1; }
        }}}}}
    }
    if (dist_type == 2 & link_type >= 1 & link_type <= 5)
    { # BINOMIAL/BERNOULLI DISTRIBUTION
        if          (link_type == 1 & link_power == 0.0)  { # Binomial.log
            if (sum ((y_corr < 0.0)) == 0) {
                is_zero_y_corr = (y_corr == 0.0);
                linear_terms = log (y_corr + is_zero_y_corr) - is_zero_y_corr / (1.0 - is_zero_y_corr);
            } else { isNaN = 1; }
        } else { if (link_type == 1 & link_power >  0.0)  { # Binomial.power_nonlog pos
            if (sum ((y_corr < 0.0)) == 0) {
                is_zero_y_corr = (y_corr == 0.0);
                linear_terms = (y_corr + is_zero_y_corr) ^ link_power - is_zero_y_corr;
            } else { isNaN = 1; }
        } else { if (link_type == 1)                      { # Binomial.power_nonlog neg
            if (sum ((y_corr <= 0.0)) == 0) {
                linear_terms = y_corr ^ link_power;
            } else { isNaN = 1; }
        } else { 
            is_zero_y_corr = (y_corr <= 0.0);
            is_one_y_corr  = (y_corr >= 1.0);
            y_corr = y_corr * (1.0 - is_zero_y_corr) * (1.0 - is_one_y_corr) + 0.5 * (is_zero_y_corr + is_one_y_corr);
            if (link_type == 2)                           { # Binomial.logit
                linear_terms = log (y_corr / (1.0 - y_corr)) 
                    + is_one_y_corr / (1.0 - is_one_y_corr) - is_zero_y_corr / (1.0 - is_zero_y_corr);
            } else { if (link_type == 3)                  { # Binomial.probit
                y_below_half = y_corr + (1.0 - 2.0 * y_corr) * (y_corr > 0.5);
                t = sqrt (- 2.0 * log (y_below_half));
                approx_inv_Gauss_CDF = - t + (2.515517 + t * (0.802853 + t * 0.010328)) / (1.0 + t * (1.432788 + t * (0.189269 + t * 0.001308)));
                linear_terms = approx_inv_Gauss_CDF * (1.0 - 2.0 * (y_corr > 0.5))
                    + is_one_y_corr / (1.0 - is_one_y_corr) - is_zero_y_corr / (1.0 - is_zero_y_corr);
            } else { if (link_type == 4)                  { # Binomial.cloglog
                linear_terms = log (- log (1.0 - y_corr))
                    - log (- log (0.5)) * (is_zero_y_corr + is_one_y_corr)
                    + is_one_y_corr / (1.0 - is_one_y_corr) - is_zero_y_corr / (1.0 - is_zero_y_corr);
            } else { if (link_type == 5)                  { # Binomial.cauchit
                linear_terms = tan ((y_corr - 0.5) * pi)
                    + is_one_y_corr / (1.0 - is_one_y_corr) - is_zero_y_corr / (1.0 - is_zero_y_corr);
        }}  }}}}}
    }
    
    if (isNaN == 0) {
        tmp1 = glm_log_likelihood_part (linear_terms, Y, dist_type, var_power, link_type, link_power);
        saturated_log_l = tmp1[1];
        isNaN = tmp1[2];
    }
    
    if ((dist_type == 1 & link_type == 1 & link_power == 0.0) |
        (dist_type == 2 & link_type >= 2))
    {    
        desired_eta = 0.0;
    } else { if (link_type == 1 & link_power == 0.0) {
        desired_eta = log (0.5);
    } else { if (link_type == 1) {
        desired_eta = 0.5 ^ link_power;
    } else {
        desired_eta = 0.5;
    }}}
    
    beta = matrix (0.0, ncol(X), 1);
    
    if (desired_eta != 0.0) {
        if (icept_status == 1 | icept_status == 2) {
            beta [nrow(beta), 1] = desired_eta;
        } else {
            # We want: avg (X %*% ssX_transform %*% beta) = desired_eta
            # Note that "ssX_transform" is trivial here, hence ignored
            
            beta = straightenX (X, 0.000001, max_iter_CG);  
            beta = beta * desired_eta;
}   }   

  return (c(beta, saturated_log_l, isNaN))
}


glm_dist <- function (linear_terms, Y,
                    dist_type, var_power, link_type, link_power)
{
    num_records = nrow (linear_terms);
    zeros_r = matrix (0.0, num_records, 1);
    ones_r = 1 + zeros_r;
    g_Y  = zeros_r;
    w  = zeros_r;

    # Some constants

    one_over_sqrt_two_pi = 0.39894228040143267793994605993438;
    ones_2 = matrix (1.0, 1, 2);
    p_one_m_one = ones_2;
    p_one_m_one [1, 2] = -1.0;
    m_one_p_one = ones_2;
    m_one_p_one [1, 1] = -1.0;
    zero_one = ones_2;
    zero_one [1, 1] = 0.0;
    one_zero = ones_2;
    one_zero [1, 2] = 0.0;
    flip_pos = matrix (0, 2, 2);
    flip_neg = flip_pos;
    flip_pos [1, 2] = 1;
    flip_pos [2, 1] = 1;
    flip_neg [1, 2] = -1;
    flip_neg [2, 1] = 1;
    
    if (dist_type == 1 & link_type == 1) { # POWER DISTRIBUTION
        y_mean = zeros_r;
        if          (link_power ==  0.0) {
            y_mean = exp (linear_terms);
            y_mean_pow = y_mean ^ (1 - var_power);
            w   = y_mean_pow * y_mean;
            g_Y = y_mean_pow * (Y - y_mean);
        } else { if (link_power ==  1.0) {
            y_mean = linear_terms;
            w   = y_mean ^ (- var_power);
            g_Y = w * (Y - y_mean);
        } else {
            y_mean = linear_terms ^ (1.0 / link_power);
            c1  = (1 - var_power) / link_power - 1;
            c2  = (2 - var_power) / link_power - 2;
            g_Y = (linear_terms ^ c1) * (Y - y_mean) / link_power;
            w   = (linear_terms ^ c2) / (link_power ^ 2);
    }   }}
    if (dist_type == 2 & link_type >= 1 & link_type <= 5)
    { # BINOMIAL/BERNOULLI DISTRIBUTION
        if (link_type == 1) { # BINOMIAL.POWER LINKS
            if (link_power == 0.0)  { # Binomial.log
                vec1 = 1 / (exp (- linear_terms) - 1);
                g_Y = Y [, 1] - Y [, 2] * vec1;
                w   = rowSums (Y) * vec1;
            } else {                  # Binomial.nonlog
                vec1 = zeros_r;
                if (link_power == 0.5)  {
                    vec1 = 1 / (1 - linear_terms ^ 2);
                } else { if (sum ((linear_terms < 0.0)) == 0) {
                    vec1 = linear_terms ^ (- 2 + 1 / link_power) / (1 - linear_terms ^ (1 / link_power));
                } else {isNaN = 1;}}
                # We want a "zero-protected" version of
                #     vec2 = Y [, 1] / linear_terms;
                is_y_0 = (Y [, 1] == 0.0);
                vec2 = (Y [, 1] + is_y_0) / (linear_terms * (1 - is_y_0) + is_y_0) - is_y_0;
                g_Y =  (vec2 - Y [, 2] * vec1 * linear_terms) / link_power;
                w   =  rowSums (Y) * vec1 / link_power ^ 2;
            }
        } else {
            is_LT_pos_infinite = (linear_terms ==  Inf);
            is_LT_neg_infinite = (linear_terms == -Inf);
            is_LT_infinite = is_LT_pos_infinite %*% one_zero + is_LT_neg_infinite %*% zero_one;
            finite_linear_terms = replace (target =        linear_terms, pattern =  Inf, replacement = 0);
            finite_linear_terms = replace (target = finite_linear_terms, pattern = -Inf, replacement = 0);
            if (link_type == 2)                           { # Binomial.logit
                Y_prob = exp (finite_linear_terms) %*% one_zero + ones_r %*% zero_one;
                Y_prob = Y_prob / (rowSums (Y_prob) %*% ones_2);
                Y_prob = Y_prob * ((1.0 - rowSums (is_LT_infinite)) %*% ones_2) + is_LT_infinite;
                g_Y = rowSums (Y * (Y_prob %*% flip_neg));           ### = y_residual;
                w   = rowSums (Y * (Y_prob %*% flip_pos) * Y_prob);  ### = y_variance;
            } else { if (link_type == 3)                  { # Binomial.probit
                is_lt_pos = (linear_terms > 0.0);
                t_gp = 1.0 / (1.0 + abs (finite_linear_terms) * 0.231641888);  # 0.231641888 = 0.3275911 / sqrt (2.0)
                pt_gp = t_gp * ( 0.254829592 
                      + t_gp * (-0.284496736 # "Handbook of Mathematical Functions", ed. by M. Abramowitz and I.A. Stegun,
                      + t_gp * ( 1.421413741 # U.S. Nat-l Bureau of Standards, 10th print (Dec 1972), Sec. 7.1.26, p. 299
                      + t_gp * (-1.453152027 
                      + t_gp *   1.061405429))));
                the_gauss_exp = exp (- (linear_terms ^ 2) / 2.0);
                vec1 = 0.25 * pt_gp * (2 - the_gauss_exp * pt_gp);
                vec2 = Y [, 1] - rowSums (Y) * is_lt_pos + the_gauss_exp * pt_gp * rowSums (Y) * (is_lt_pos - 0.5);
                w   = the_gauss_exp * (one_over_sqrt_two_pi ^ 2) * rowSums (Y) / vec1;
                g_Y = one_over_sqrt_two_pi * vec2 / vec1;
            } else { if (link_type == 4)                  { # Binomial.cloglog
                the_exp = exp (linear_terms)
                the_exp_exp = exp (- the_exp);
                is_too_small = ((10000000 + the_exp) == 10000000);
                the_exp_ratio = (1 - is_too_small) * (1 - the_exp_exp) / (the_exp + is_too_small) + is_too_small * (1 - the_exp / 2);
                g_Y =  (rowSums (Y) * the_exp_exp - Y [, 2]) / the_exp_ratio;
                w   =  the_exp_exp * the_exp * rowSums (Y) / the_exp_ratio;
            } else { if (link_type == 5)                  { # Binomial.cauchit
                Y_prob = 0.5 + (atan (finite_linear_terms) %*% p_one_m_one) / pi;
                Y_prob = Y_prob * ((1.0 - rowSums (is_LT_infinite)) %*% ones_2) + is_LT_infinite;
                y_residual = Y [, 1] * Y_prob [, 2] - Y [, 2] * Y_prob [, 1];
                var_function = rowSums (Y) * Y_prob [, 1] * Y_prob [, 2];
                link_gradient_normalized = (1 + linear_terms ^ 2) * pi;
                g_Y =  rowSums (Y) * y_residual / (var_function * link_gradient_normalized);
                w   = (rowSums (Y) ^ 2) / (var_function * link_gradient_normalized ^ 2);
            }}}}   
        }
    }
    
    return (c(g_Y, w))
}


glm_log_likelihood_part <- function (linear_terms, Y,
        dist_type, var_power, link_type, link_power)
{
    isNaN = 0;
    log_l = 0.0;
    num_records = nrow (Y);
    zeros_r = matrix (0.0, num_records, 1);
    
    if (dist_type == 1 & link_type == 1)
    { # POWER DISTRIBUTION
        b_cumulant = zeros_r;
        natural_parameters = zeros_r;
        is_natural_parameter_log_zero = zeros_r;
        if          (var_power == 1.0 & link_power == 0.0)  { # Poisson.log
            b_cumulant = exp (linear_terms);
            is_natural_parameter_log_zero = (linear_terms == (-Inf));
            natural_parameters = replace (target = linear_terms, pattern = -Inf, replacement = 0);
        } else { if (var_power == 1.0 & link_power == 1.0)  { # Poisson.id
            if (sum ((linear_terms < 0.0)) == 0)  {
                b_cumulant = linear_terms;
                is_natural_parameter_log_zero = (linear_terms == 0.0);
                natural_parameters = log (linear_terms + is_natural_parameter_log_zero);
            } else {isNaN = 1;}
        } else { if (var_power == 1.0 & link_power == 0.5)  { # Poisson.sqrt
            if (sum ((linear_terms <0.0)) == 0)  {
                b_cumulant = linear_terms ^ 2;
                is_natural_parameter_log_zero = (linear_terms == 0.0);
                natural_parameters = 2.0 * log (linear_terms + is_natural_parameter_log_zero);
            } else {isNaN = 1;}
        } else { if (var_power == 1.0 & link_power  > 0.0)  { # Poisson.power_nonlog, pos
            if (sum ((linear_terms <0.0)) == 0)  {
                is_natural_parameter_log_zero = (linear_terms == 0.0);
                b_cumulant = (linear_terms + is_natural_parameter_log_zero) ^ (1.0 / link_power) - is_natural_parameter_log_zero;
                natural_parameters = log (linear_terms + is_natural_parameter_log_zero) / link_power;
            } else {isNaN = 1;}
        } else { if (var_power == 1.0)                      { # Poisson.power_nonlog, neg
            if (sum ((linear_terms <= 0.0)) == 0) {
                b_cumulant = linear_terms ^ (1.0 / link_power);
                natural_parameters = log (linear_terms) / link_power;
            } else {isNaN = 1;}
        } else { if (var_power == 2.0 & link_power == -1.0) { # Gamma.inverse
            if (sum ((linear_terms <= 0.0)) == 0) {
                b_cumulant = - log (linear_terms);
                natural_parameters = - linear_terms;
            } else {isNaN = 1;}
        } else { if (var_power == 2.0 & link_power ==  1.0) { # Gamma.id
            if (sum ((linear_terms <= 0.0)) == 0) {
                b_cumulant = log (linear_terms);
                natural_parameters = - 1.0 / linear_terms;
            } else {isNaN = 1;}
        } else { if (var_power == 2.0 & link_power ==  0.0) { # Gamma.log
            b_cumulant = linear_terms;
            natural_parameters = - exp (- linear_terms);
        } else { if (var_power == 2.0)                      { # Gamma.power_nonlog
            if (sum ((linear_terms <= 0.0)) == 0) {
                b_cumulant = log (linear_terms) / link_power;
                natural_parameters = - linear_terms ^ (- 1.0 / link_power);
            } else {isNaN = 1;}
        } else { if                    (link_power ==  0.0) { # PowerDist.log
            natural_parameters = exp (linear_terms * (1.0 - var_power)) / (1.0 - var_power);
            b_cumulant = exp (linear_terms * (2.0 - var_power)) / (2.0 - var_power);
        } else {                                              # PowerDist.power_nonlog
            if          (-2 * link_power == 1.0 - var_power) {
                natural_parameters = 1.0 / (linear_terms ^ 2) / (1.0 - var_power);
            } else { if (-1 * link_power == 1.0 - var_power) {
                natural_parameters = 1.0 / linear_terms / (1.0 - var_power);
            } else { if (     link_power == 1.0 - var_power) {
                natural_parameters = linear_terms / (1.0 - var_power);
            } else { if ( 2 * link_power == 1.0 - var_power) {
                natural_parameters = linear_terms ^ 2 / (1.0 - var_power);
            } else {
                if (sum ((linear_terms <=0.0)) == 0) {
                    power = (1.0 - var_power) / link_power;
                    natural_parameters = (linear_terms ^ power) / (1.0 - var_power);
                } else {isNaN = 1;}
            }}}}
            if          (-2 * link_power == 2.0 - var_power) {
                b_cumulant = 1.0 / (linear_terms ^ 2) / (2.0 - var_power);
            } else { if (-1 * link_power == 2.0 - var_power) {
                b_cumulant = 1.0 / linear_terms / (2.0 - var_power);
            } else { if (     link_power == 2.0 - var_power) {
                b_cumulant = linear_terms / (2.0 - var_power);
            } else { if ( 2 * link_power == 2.0 - var_power) {
                b_cumulant = linear_terms ^ 2 / (2.0 - var_power);
            } else {
                if (sum ((linear_terms<= 0.0)) == 0) {
                    power = (2.0 - var_power) / link_power;
                    b_cumulant = (linear_terms ^ power) / (2.0 - var_power);
                } else {isNaN = 1;}
            }}}}
        }}}}} }}}}}
        if (sum (is_natural_parameter_log_zero * abs (Y)) > 0.0) {
            log_l = -Inf;
            isNaN = 1;
        }
        if (isNaN == 0)
        {
            log_l = sum (Y * natural_parameters - b_cumulant);
            if (log_l != log_l | (log_l == log_l + 1.0 & log_l == log_l * 2.0)) {
                log_l = -Inf;
                isNaN = 1;
    }   }   }
    
    if (dist_type == 2 & link_type >= 1 & link_type <= 5)
    { # BINOMIAL/BERNOULLI DISTRIBUTION
    
        tmp7 = binomial_probability_two_column (linear_terms, link_type, link_power);
        Y_prob = tmp7[1];
        isNaN = tmp7[2]
        
        if (isNaN == 0) {            
            does_prob_contradict = (Y_prob <= 0.0);
            if (sum (does_prob_contradict * abs (Y)) == 0.0) {
                log_l = sum (Y * log (Y_prob * (1 - does_prob_contradict) + does_prob_contradict));
                if (log_l != log_l | (log_l == log_l + 1.0 & log_l == log_l * 2.0)) {
                    isNaN = 1;
                }
            } else {
                log_l = -Inf;
                isNaN = 1;
    }   }   }
    
    if (isNaN == 1) {
        log_l = - Inf; 
    }
}



binomial_probability_two_column <- function (linear_terms, link_type, link_power)
{
    isNaN = 0;
    num_records = nrow (linear_terms);

    # Define some auxiliary matrices

    ones_2 = matrix (1.0, 1, 2);
    p_one_m_one = ones_2;
    p_one_m_one [1, 2] = -1.0;
    m_one_p_one = ones_2;
    m_one_p_one [1, 1] = -1.0;
    zero_one = ones_2;
    zero_one [1, 1] = 0.0;
    one_zero = ones_2;
    one_zero [1, 2] = 0.0;

    zeros_r = matrix (0.0, num_records, 1);
    ones_r = 1.0 + zeros_r;

    # Begin the function body

    Y_prob = zeros_r %*% ones_2;
    if (link_type == 1) { # Binomial.power
        if          (link_power == 0.0) { # Binomial.log
            Y_prob = exp (linear_terms) %*% p_one_m_one + ones_r %*% zero_one;    
        } else { if (link_power == 0.5) { # Binomial.sqrt
            Y_prob = (linear_terms ^ 2) %*% p_one_m_one + ones_r %*% zero_one;    
        } else {                          # Binomial.power_nonlog
            if (sum ((linear_terms < 0.0)) == 0) {
                Y_prob = (linear_terms ^ (1.0 / link_power)) %*% p_one_m_one + ones_r %*% zero_one;    
            } else {isNaN = 1;}
        }}
    } else {              # Binomial.non_power
        is_LT_pos_infinite = (linear_terms ==  Inf);
        is_LT_neg_infinite = (linear_terms == -Inf);
        is_LT_infinite = is_LT_pos_infinite %*% one_zero + is_LT_neg_infinite %*% zero_one;
        finite_linear_terms = replace (target =        linear_terms, pattern =  Inf, replacement = 0);
        finite_linear_terms = replace (target = finite_linear_terms, pattern = -Inf, replacement = 0);
        if (link_type == 2)             { # Binomial.logit
            Y_prob = exp (finite_linear_terms) %*% one_zero + ones_r %*% zero_one;
            Y_prob = Y_prob / (rowSums (Y_prob) %*% ones_2);
        } else { if (link_type == 3)    { # Binomial.probit
            lt_pos_neg = (finite_linear_terms >= 0.0) %*% p_one_m_one + ones_r %*% zero_one;
            t_gp = 1.0 / (1.0 + abs (finite_linear_terms) * 0.231641888);  # 0.231641888 = 0.3275911 / sqrt (2.0)
            pt_gp = t_gp * ( 0.254829592 
                  + t_gp * (-0.284496736 # "Handbook of Mathematical Functions", ed. by M. Abramowitz and I.A. Stegun,
                  + t_gp * ( 1.421413741 # U.S. Nat-l Bureau of Standards, 10th print (Dec 1972), Sec. 7.1.26, p. 299
                  + t_gp * (-1.453152027 
                  + t_gp *   1.061405429))));
            the_gauss_exp = exp (- (finite_linear_terms ^ 2) / 2.0);
            Y_prob = lt_pos_neg + ((the_gauss_exp * pt_gp) %*% ones_2) * (0.5 - lt_pos_neg);
        } else { if (link_type == 4)    { # Binomial.cloglog
            the_exp = exp (finite_linear_terms);
            the_exp_exp = exp (- the_exp);
            is_too_small = ((10000000 + the_exp)== 10000000);
            Y_prob [, 1] = (1 - is_too_small) * (1 - the_exp_exp) + is_too_small * the_exp * (1 - the_exp / 2);
            Y_prob [, 2] = the_exp_exp;
        } else { if (link_type == 5)    { # Binomial.cauchit
            Y_prob = 0.5 + (atan (finite_linear_terms) %*% p_one_m_one) / pi;
        } else {
            isNaN = 1;
        }}}}
        Y_prob = Y_prob * ((1.0 - rowSums (is_LT_infinite)) %*% ones_2) + is_LT_infinite;
}   

   return (c(Y_prob, isNaN));
}            


# THE CG-STEIHAUG PROCEDURE SCRIPT

# Apply Conjugate Gradient - Steihaug algorithm in order to approximately minimize
# 0.5 z^T (X^T diag(w) X + diag (lambda)) z + (g + lambda * beta)^T z
# under constraint:  ||z|| <= trust_delta.
# See Alg. 7.2 on p. 171 of "Numerical Optimization" 2nd ed. by Nocedal and Wright
# IN THE ABOVE, "X" IS UNDERSTOOD TO BE "X %*% (SHIFT/SCALE TRANSFORM)"; this transform
# is given separately because sparse "X" may become dense after applying the transform.
#
get_CG_Steihaug_point <-
    function (X, scale_X, shift_X, w, g, beta, lambda, trust_delta, max_iter_CG)
{
    trust_delta_sq = trust_delta ^ 2;
    size_CG = nrow (g);
    z = matrix (0.0, size_CG, 1);
    neg_log_l_change = 0.0;
    reached_trust_boundary = 0;
    g_reg = g + lambda * beta;
    r_CG = g_reg;
    p_CG = -r_CG;
    rr_CG = sum(r_CG * r_CG);
    eps_CG = rr_CG * min (0.25, sqrt (rr_CG));
    converged_CG = 0;
    if (rr_CG < eps_CG) {
        converged_CG = 1;
    }
    
    max_iteration_CG = max_iter_CG;
    if (max_iteration_CG <= 0) {
        max_iteration_CG = size_CG;
    }
    i_CG = 0;
    while (converged_CG == 0)
    {
        i_CG = i_CG + 1;
        ssX_p_CG = diag (scale_X) %*% p_CG;
        ssX_p_CG [size_CG, ] = ssX_p_CG [size_CG, ] + t(shift_X) %*% p_CG;
        temp_CG = t(X) %*% (w * (X %*% ssX_p_CG));
        q_CG = (lambda * p_CG) + diag (scale_X) %*% temp_CG + shift_X %*% temp_CG [size_CG, ];
        pq_CG = sum (p_CG * q_CG);
        if (pq_CG <= 0) {
            pp_CG = sum (p_CG * p_CG);  
            if (pp_CG > 0) {
                tmp6 = get_trust_boundary_point (g_reg, z, p_CG, q_CG, r_CG, pp_CG, pq_CG, trust_delta_sq);
                z = tmp6[1];
                neg_log_l_change= tmp6[2];
                reached_trust_boundary = 1;
            } else {
                neg_log_l_change = 0.5 * sum (z * (r_CG + g_reg));
            }
            converged_CG = 1;
        }
        if (converged_CG == 0) {
            alpha_CG = rr_CG / pq_CG;
            new_z = z + alpha_CG * p_CG;
            if (sum(new_z * new_z) >= trust_delta_sq) {
                pp_CG = sum (p_CG * p_CG);  
                tmp8 = get_trust_boundary_point (g_reg, z, p_CG, q_CG, r_CG, pp_CG, pq_CG, trust_delta_sq);
                z = tmp8[1];
                neg_log_l_change = tmp8[2]
                reached_trust_boundary = 1;
                converged_CG = 1;
            }
            if (converged_CG == 0) {
                z = new_z;
                old_rr_CG = rr_CG;
                r_CG = r_CG + alpha_CG * q_CG;
                rr_CG = sum(r_CG * r_CG);
                if (i_CG == max_iteration_CG | rr_CG < eps_CG) {
                    neg_log_l_change = 0.5 * sum (z * (r_CG + g_reg));
                    reached_trust_boundary = 0;
                    converged_CG = 1;
                }
                if (converged_CG == 0) {
                    p_CG = -r_CG + (rr_CG / old_rr_CG) * p_CG;
}   }   }   }   

  return (c(z, neg_log_l_change, i_CG, reached_trust_boundary));
}


# An auxiliary function used twice inside the CG-STEIHAUG loop:
get_trust_boundary_point <- 
    function (g, z, p, q, r, pp, pq, trust_delta_sq)
{
    zz = sum (z * z);  pz = sum (p * z);
    sq_root_d = sqrt (pz * pz - pp * (zz - trust_delta_sq));
    tau_1 = (- pz + sq_root_d) / pp;
    tau_2 = (- pz - sq_root_d) / pp;
    zq = sum (z * q);  gp = sum (g * p);
    f_extra = 0.5 * sum (z * (r + g));
    f_change_1 = f_extra + (0.5 * tau_1 * pq + zq + gp) * tau_1;
    f_change_2 = f_extra + (0.5 * tau_2 * pq + zq + gp) * tau_2;
    if (f_change_1 < f_change_2) {
        new_z = z + (tau_1 * p);
        f_change = f_change_1;
    }
    else {
        new_z = z + (tau_2 * p);
        f_change = f_change_2;
    }
    
    return (c(new_z, f_change))
}


# Computes vector w such that  ||X %*% w - 1|| -> MIN  given  avg(X %*% w) = 1
# We find z_LS such that ||X %*% z_LS - 1|| -> MIN unconditionally, then scale
# it to compute  w = c * z_LS  such that  sum(X %*% w) = nrow(X).
straightenX <- function (X, eps, max_iter_CG)
{
    w_X = t(t(colSums(X)));
    lambda_LS = 0.000001 * sum(X ^ 2) / ncol(X);
    eps_LS = eps * nrow(X);

    # BEGIN LEAST SQUARES
    
    r_LS = - w_X;
    z_LS = matrix (0.0, ncol(X), 1);
    p_LS = - r_LS;
    norm_r2_LS = sum (r_LS ^ 2);
    i_LS = 0;
    while (i_LS < max_iter_CG & i_LS < ncol(X) & norm_r2_LS >= eps_LS)
    {
        q_LS = t(X) %*% X %*% p_LS;
        q_LS = q_LS + lambda_LS * p_LS;
        alpha_LS = norm_r2_LS / sum (p_LS * q_LS);
        z_LS = z_LS + alpha_LS * p_LS;
        old_norm_r2_LS = norm_r2_LS;
        r_LS = r_LS + alpha_LS * q_LS;
        norm_r2_LS = sum (r_LS ^ 2);
        p_LS = -r_LS + (norm_r2_LS / old_norm_r2_LS) * p_LS;
        i_LS = i_LS + 1;
    }
    
    # END LEAST SQUARES
    
    w = (nrow(X) / sum (w_X * z_LS)) * z_LS;
    return(w);
}


round_to_print <- function (x_to_truncate)
{
    mantissa = 1.0;
    eee = 0;
    positive_infinity = Inf;
    x = abs (x_to_truncate);
    if (x != x / 2.0) {
        log_ten = log (10.0);
        d_eee = round (log (x) / log_ten - 0.5);
        mantissa = round (x * exp (log_ten * (4.0 - d_eee))) / 10000;
        if (mantissa == 10.0) {
            mantissa = 1.0;
            d_eee = d_eee + 1;
        }
        if (x_to_truncate < 0.0) {
            mantissa = - mantissa;
        }
        eee = 0;
        pow_two = 1;
        res_eee = abs (d_eee);
        while (res_eee != 0.0) {
            new_res_eee = round (res_eee / 2.0 - 0.3);
            if (new_res_eee * 2.0 < res_eee) {
                eee = eee + pow_two;
            }
            res_eee = new_res_eee;
            pow_two = 2 * pow_two;
        }
        if (d_eee < 0.0) {
            eee = - eee;
        }
    } else { mantissa = x_to_truncate; }
    
    return (c(mantissa, eee));
}


X = readMM(paste(args[1], "X.mtx", sep=""));
Y = readMM(paste(args[1], "Y.mtx", sep=""));

fileO = " ";
fileLog = " ";

intercept_status = as.integer(args[2]);
eps = as.double(args[3]);
max_iteration_IRLS = as.integer(args[4]);
max_iteration_CG = as.integer(args[4]);

distribution_type = as.integer(args[5]);
variance_as_power_of_the_mean = as.double(args[6]);
link_type = as.integer(args[7]); 

if( distribution_type != 1 ) {
  link_as_power_of_the_mean = as.double(args[8]);
  bernoulli_No_label = 0.0;
} else {
  link_as_power_of_the_mean = 1.0;
  bernoulli_No_label = as.double(args[8]); 
}

dispersion = 0.0;
regularization = 0.001;


variance_as_power_of_the_mean = as.double (variance_as_power_of_the_mean);
link_as_power_of_the_mean = as.double (link_as_power_of_the_mean);
bernoulli_No_label = as.double (bernoulli_No_label);
dispersion = as.double (dispersion);
eps = as.double (eps);


# Default values for output statistics:

termination_code     = 0;
min_beta             = NaN;
i_min_beta           = NaN;
max_beta             = NaN;
i_max_beta           = NaN;
intercept_value      = NaN;
dispersion           = NaN;
estimated_dispersion = NaN;
deviance_nodisp      = NaN;
deviance             = NaN;

print("BEGIN GLM SCRIPT");

num_records  = nrow (X);
num_features = ncol (X);
zeros_r = matrix (0, num_records, 1);
ones_r = 1 + zeros_r;

# Introduce the intercept, shift and rescale the columns of X if needed

if (intercept_status == 1 | intercept_status == 2)  # add the intercept column
{
    X = cbind (X, ones_r);
    num_features = ncol (X);
}

scale_lambda = matrix (1, num_features, 1);
if (intercept_status == 1 | intercept_status == 2)
{
    scale_lambda [num_features, 1] = 0;
}

if (intercept_status == 2)  # scale-&-shift X columns to mean 0, variance 1
{                           # Important assumption: X [, num_features] = ones_r
    avg_X_cols = t(t(colSums(X))) / num_records;
    var_X_cols = (t(t(colSums (X ^ 2))) - num_records * (avg_X_cols ^ 2)) / (num_records - 1);
    is_unsafe = (var_X_cols <= 0.0);
    scale_X = 1.0 / sqrt (var_X_cols * (1 - is_unsafe) + is_unsafe);
    scale_X [num_features, 1] = 1;
    shift_X = - avg_X_cols * scale_X;
    shift_X [num_features, 1] = 0;
    rowSums_X_sq = (X ^ 2) %*% (scale_X ^ 2) + X %*% (2 * scale_X * shift_X) + sum (shift_X ^ 2);
} else {
    scale_X = matrix (1, num_features, 1);
    shift_X = matrix (0, num_features, 1);
    rowSums_X_sq = rowSums (X ^ 2);
}

# Henceforth we replace "X" with "X %*% (SHIFT/SCALE TRANSFORM)" and rowSums(X ^ 2)
# with "rowSums_X_sq" in order to preserve the sparsity of X under shift and scale.
# The transform is then associatively applied to the other side of the expression,
# and is rewritten via "scale_X" and "shift_X" as follows:
#
# ssX_A  = (SHIFT/SCALE TRANSFORM) %*% A    --- is rewritten as:
# ssX_A  = diag (scale_X) %*% A;
# ssX_A [num_features, ] = ssX_A [num_features, ] + t(shift_X) %*% A;
#
# tssX_A = t(SHIFT/SCALE TRANSFORM) %*% A   --- is rewritten as:
# tssX_A = diag (scale_X) %*% A + shift_X %*% A [num_features, ];

# Initialize other input-dependent parameters

lambda = scale_lambda * regularization;
if (max_iteration_CG == 0) {
    max_iteration_CG = num_features;
}

# In Bernoulli case, convert one-column "Y" into two-column

if (distribution_type == 2 & ncol(Y) == 1)
{
    is_Y_negative = (Y == bernoulli_No_label);
    Y = append (1 - is_Y_negative, is_Y_negative);
    count_Y_negative = sum (is_Y_negative);
    if (count_Y_negative == 0) {
        stop ("GLM Input Error: all Y-values encode Bernoulli YES-label, none encode NO-label");
    }
    if (count_Y_negative == nrow(Y)) {
        stop ("GLM Input Error: all Y-values encode Bernoulli NO-label, none encode YES-label");
    }
}

# Set up the canonical link, if requested [Then we have: Var(mu) * (d link / d mu) = const]

if (link_type == 0)
{
    if (distribution_type == 1) {
        link_type = 1;
        link_as_power_of_the_mean = 1.0 - variance_as_power_of_the_mean;
    } else { if (distribution_type == 2) {
            link_type = 2;
}   }   }

# For power distributions and/or links, we use two constants,
# "variance as power of the mean" and "link_as_power_of_the_mean",
# to specify the variance and the link as arbitrary powers of the
# mean.  However, the variance-powers of 1.0 (Poisson family) and
# 2.0 (Gamma family) have to be treated as special cases, because
# these values integrate into logarithms.  The link-power of 0.0
# is also special as it represents the logarithm link.

num_response_columns = ncol (Y);

is_supported = check_if_supported (num_response_columns, distribution_type, variance_as_power_of_the_mean, link_type, link_as_power_of_the_mean);
if (is_supported == 1)
{

#####   INITIALIZE THE BETAS   #####

tmp2 = glm_initialize (X, Y, distribution_type, variance_as_power_of_the_mean, link_type, link_as_power_of_the_mean, intercept_status, max_iteration_CG);
beta = tmp2[1];
saturated_log_l = tmp2[2]
isNaN = tmp2[3];


if (isNaN == 0)
{

#####  START OF THE MAIN PART  #####

sum_X_sq = sum (rowSums_X_sq);
trust_delta = 0.5 * sqrt (num_features) / max (sqrt (rowSums_X_sq));
###  max_trust_delta = trust_delta * 10000.0;
log_l = 0.0;
deviance_nodisp = 0.0;
new_deviance_nodisp = 0.0;
isNaN_log_l = 2;
newbeta = beta;
g = matrix (0.0, num_features, 1);
g_norm = sqrt (sum ((g + lambda * beta) ^ 2));
accept_new_beta = 1;
reached_trust_boundary = 0;
neg_log_l_change_predicted = 0.0;
i_IRLS = 0;

print ("BEGIN IRLS ITERATIONS...");

ssX_newbeta = diag (scale_X) %*% newbeta;
ssX_newbeta [num_features, ] = ssX_newbeta [num_features, ] + t(shift_X) %*% newbeta;
all_linear_terms = X %*% ssX_newbeta;

print("DEBUG1")
tmp4 = glm_log_likelihood_part(all_linear_terms, Y, distribution_type, variance_as_power_of_the_mean, link_type, link_as_power_of_the_mean);
new_log_l = tmp4[1];
isNaN_new_log_l = tmp4[2];

if (isNaN_new_log_l == 0) {
    new_deviance_nodisp = 2.0 * (saturated_log_l - new_log_l);
    new_log_l = new_log_l - 0.5 * sum (lambda * newbeta ^ 2);
}

print("DEBUG2")


# set w to avoid 'Initialization of w depends on if-else/while execution' warnings
w = matrix (0.0, 1, 1);
while (termination_code == 0)
{
    accept_new_beta = 1;
    
    if (i_IRLS > 0)
    {
        if (isNaN_log_l == 0) {
            accept_new_beta = 0;
        }

# Decide whether to accept a new iteration point and update the trust region
# See Alg. 4.1 on p. 69 of "Numerical Optimization" 2nd ed. by Nocedal and Wright

        rho = (- new_log_l + log_l) / neg_log_l_change_predicted;
        if (rho < 0.25 | isNaN_new_log_l == 1) {
            trust_delta = 0.25 * trust_delta;
        }
        if (rho > 0.75 & isNaN_new_log_l == 0 & reached_trust_boundary == 1) {
            trust_delta = 2 * trust_delta;
            
### if (trust_delta > max_trust_delta) {
###     trust_delta = max_trust_delta;
### }

        }
        if (rho > 0.1 & isNaN_new_log_l == 0) {
            accept_new_beta = 1;
        }
    }

    if (fileLog != " ") {
        log_str = append (log_str, "IS_POINT_UPDATED," + i_IRLS + "," + accept_new_beta);
        log_str = append (log_str, "TRUST_DELTA,"      + i_IRLS + "," + trust_delta);
    }
    if (accept_new_beta == 1)
    {
        beta = newbeta;  log_l = new_log_l;  deviance_nodisp = new_deviance_nodisp;  isNaN_log_l = isNaN_new_log_l;
        
        tmp3 = glm_dist (all_linear_terms, Y, distribution_type, variance_as_power_of_the_mean, link_type, link_as_power_of_the_mean);
        g_Y = tmp3[1];
        w = tmp3[2];
        
        # We introduced these variables to avoid roundoff errors:
        #     g_Y = y_residual / (y_var * link_grad);
        #     w   = 1.0 / (y_var * link_grad * link_grad);
                      
        gXY = - t(X) %*% g_Y;
        g = diag (scale_X) %*% gXY + shift_X %*% gXY [num_features, ];
        g_norm = sqrt (sum ((g + lambda * beta) ^ 2));
        
        if (fileLog != " ") {
            log_str = append (log_str, "GRADIENT_NORM," + i_IRLS + "," + g_norm);
        }
    }
    
    tmp5 = get_CG_Steihaug_point (X, scale_X, shift_X, w, g, beta, lambda, trust_delta, max_iteration_CG);
    z = tmp5[1];
    neg_log_l_change_predicted = tmp5[2];
    num_CG_iters  = tmp5[3];
    reached_trust_boundary = tmp5[4];


    newbeta = beta + z;
    
    ssX_newbeta = diag (scale_X) %*% newbeta;
    ssX_newbeta [num_features, ] = ssX_newbeta [num_features, ] + t(shift_X) %*% newbeta;
    all_linear_terms = X %*% ssX_newbeta;
    
    tmp4 = glm_log_likelihood_part(all_linear_terms, Y, distribution_type, variance_as_power_of_the_mean, link_type, link_as_power_of_the_mean);
    new_log_l = tmp4[1];
    isNaN_new_log_l = tmp4[2];

    if (isNaN_new_log_l == 0) {
        new_deviance_nodisp = 2.0 * (saturated_log_l - new_log_l);
        new_log_l = new_log_l - 0.5 * sum (lambda * newbeta ^ 2);
    }
        
    log_l_change = new_log_l - log_l;               # R's criterion for termination: |dev - devold|/(|dev| + 0.1) < eps

    if (reached_trust_boundary == 0 & isNaN_new_log_l == 0 & 
        (2.0 * abs (log_l_change) < eps * (deviance_nodisp + 0.1) | abs (log_l_change) < (abs (log_l) + abs (new_log_l)) * 0.00000000000001) )  
    {
        termination_code = 1;
    }
    rho = - log_l_change / neg_log_l_change_predicted;
    z_norm = sqrt (sum (z * z));
    
    tmp9 = round_to_print (z_norm);
    z_norm_m = tmp9[1];
    z_norm_e = tmp9[2];
    tmp9 = round_to_print (trust_delta);
    trust_delta_m = tmp9[1];
    trust_delta_e = tmp9[2];
    tmp9 = round_to_print (rho);
    rho_m = tmp9[1];
    rho_e = tmp9[2];
    tmp9 = round_to_print (new_log_l);
    new_log_l_m = tmp9[1];
    new_log_l_e = tmp9[2]; 
    tmp9 = round_to_print (log_l_change);
    log_l_change_m = tmp9[1];
    log_l_change_e = tmp9[2];
    tmp9 = round_to_print (g_norm);
    g_norm_m = tmp9[1];
    g_norm_e = tmp9[2];

    i_IRLS = i_IRLS + 1;
    print ("Iter #" + i_IRLS + " completed"
        + ", ||z|| = " + z_norm_m + "E" + z_norm_e
        + ", trust_delta = " + trust_delta_m + "E" + trust_delta_e
        + ", reached = " + reached_trust_boundary
        + ", ||g|| = " + g_norm_m + "E" + g_norm_e
        + ", new_log_l = " + new_log_l_m + "E" + new_log_l_e
        + ", log_l_change = " + log_l_change_m + "E" + log_l_change_e
        + ", rho = " + rho_m + "E" + rho_e);
        
    if (fileLog != " ") {
        log_str = append (log_str, "NUM_CG_ITERS,"     + i_IRLS + "," + num_CG_iters);
        log_str = append (log_str, "IS_TRUST_REACHED," + i_IRLS + "," + reached_trust_boundary);
        log_str = append (log_str, "POINT_STEP_NORM,"  + i_IRLS + "," + z_norm);
        log_str = append (log_str, "OBJECTIVE,"        + i_IRLS + "," + (- new_log_l));
        log_str = append (log_str, "OBJ_DROP_REAL,"    + i_IRLS + "," + log_l_change);
        log_str = append (log_str, "OBJ_DROP_PRED,"    + i_IRLS + "," + (- neg_log_l_change_predicted));
        log_str = append (log_str, "OBJ_DROP_RATIO,"   + i_IRLS + "," + rho);
        log_str = append (log_str, "LINEAR_TERM_MIN,"  + i_IRLS + "," + min (all_linear_terms));
        log_str = append (log_str, "LINEAR_TERM_MAX,"  + i_IRLS + "," + max (all_linear_terms));
    }
        
    if (i_IRLS == max_iteration_IRLS) {
        termination_code = 2;
    }
}

beta = newbeta;
log_l = new_log_l;
deviance_nodisp = new_deviance_nodisp;

if (termination_code == 1) {
    print ("Converged in " + i_IRLS + " steps.");
} else {
    print ("Did not converge.");
}

ssX_beta = diag (scale_X) %*% beta;
ssX_beta [num_features, ] = ssX_beta [num_features, ] + t(shift_X) %*% beta;
if (intercept_status == 2) {
    beta_out = append (ssX_beta, beta);
} else {
    beta_out = ssX_beta;
}

writeMM(as(w,"CsparseMatrix"), paste(args[9], "w", sep=""));

if (intercept_status == 1 | intercept_status == 2) {
    intercept_value = as.scalar (beta_out [num_features, 1]);
    beta_noicept = beta_out [1 : (num_features - 1), 1];
} else {
    beta_noicept = beta_out [1 : num_features, 1];
}
min_beta = min (beta_noicept);
max_beta = max (beta_noicept);
tmp_i_min_beta = rowIndexMin (t(beta_noicept))
i_min_beta = as.scalar (tmp_i_min_beta [1, 1]);
tmp_i_max_beta = rowIndexMax (t(beta_noicept))
i_max_beta = as.scalar (tmp_i_max_beta [1, 1]);

#####  OVER-DISPERSION PART  #####

all_linear_terms = X %*% ssX_beta;
tmp3 = glm_dist (all_linear_terms, Y, distribution_type, variance_as_power_of_the_mean, link_type, link_as_power_of_the_mean);
g_Y = tmp3[1]
w = tmp3[2];    
    
pearson_residual_sq = g_Y ^ 2 / w;
pearson_residual_sq = replace (target = pearson_residual_sq, pattern = NaN, replacement = 0);
# pearson_residual_sq = (y_residual ^ 2) / y_var;

if (num_records > num_features) {
    estimated_dispersion = sum (pearson_residual_sq) / (num_records - num_features);
}
if (dispersion <= 0.0) {
    dispersion = estimated_dispersion;
}
deviance = deviance_nodisp / dispersion;

#####  END OF THE MAIN PART  #####

} else { print ("Input matrices are out of range.  Terminating the DML."); termination_code = 3; }
} else { print ("Distribution/Link not supported.  Terminating the DML."); termination_code = 4; }

str = "TERMINATION_CODE," + termination_code;
str = append (str, "BETA_MIN," + min_beta);
str = append (str, "BETA_MIN_INDEX," + i_min_beta);
str = append (str, "BETA_MAX," + max_beta);
str = append (str, "BETA_MAX_INDEX," + i_max_beta);
str = append (str, "INTERCEPT," + intercept_value);
str = append (str, "DISPERSION," + dispersion);
str = append (str, "DISPERSION_EST," + estimated_dispersion);
str = append (str, "DEVIANCE_UNSCALED," + deviance_nodisp);
str = append (str, "DEVIANCE_SCALED," + deviance);
print (str);

#-------------------------------------------------------------
#
# Licensed to the Apache Software Foundation (ASF) under one
# or more contributor license agreements.  See the NOTICE file
# distributed with this work for additional information
# regarding copyright ownership.  The ASF licenses this file
# to you under the Apache License, Version 2.0 (the
# "License"); you may not use this file except in compliance
# with the License.  You may obtain a copy of the License at
# 
#   http://www.apache.org/licenses/LICENSE-2.0
# 
# Unless required by applicable law or agreed to in writing,
# software distributed under the License is distributed on an
# "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
# KIND, either express or implied.  See the License for the
# specific language governing permissions and limitations
# under the License.
#
#-------------------------------------------------------------

args<-commandArgs(TRUE)
options(digits=22)
library("Matrix")
#X= matrix( 1, 100, 100)
#X = matrix(  c(1,2,3,4,5,6,7,8,9), nrow=3, ncol=3, byrow = TRUE)
#X= matrix(  c(0,0,3,4,0,0,0,8,0),  nrow=3, ncol=3, byrow = TRUE)
#Y= matrix( c(2,2,2,3,3,3,1,1,1), nrow=3, ncol=3, byrow = TRUE)
#X= matrix(1, 1001, 1001)

X= matrix( seq(1,4000000), 2000,2000, byrow=TRUE)
#X= matrix(1, 2000,2000, byrow=TRUE)

Y= matrix( 2, 2000, 2000)
#S= X*(1-X)
lamda = 4000

S=round(abs(X+lamda))+5
#S=sum(X+Y+5)
#S=round(X+(X+9.5))
#print(S)
writeMM(as(S, "CsparseMatrix"), paste(args[2], "S", sep="")); 
 

#-------------------------------------------------------------
#
# Licensed to the Apache Software Foundation (ASF) under one
# or more contributor license agreements.  See the NOTICE file
# distributed with this work for additional information
# regarding copyright ownership.  The ASF licenses this file
# to you under the Apache License, Version 2.0 (the
# "License"); you may not use this file except in compliance
# with the License.  You may obtain a copy of the License at
# 
#   http://www.apache.org/licenses/LICENSE-2.0
# 
# Unless required by applicable law or agreed to in writing,
# software distributed under the License is distributed on an
# "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
# KIND, either express or implied.  See the License for the
# specific language governing permissions and limitations
# under the License.
#
#-------------------------------------------------------------

# JUnit test class: dml.test.integration.descriptivestats.UnivariateStatsTest.java
# command line invocation assuming $C_HOME is set to the home of the R script
# Rscript $C_HOME/Categorical.R $C_HOME/in/ $C_HOME/expected/
args <- commandArgs(TRUE)
options(digits=22)

library("Matrix")
# Usage: R --vanilla -args Xfile X < DescriptiveStatistics.R

#parseCommandArgs()
######################

V = readMM(paste(args[1], "vector.mtx", sep=""))
W = readMM(paste(args[1], "weight.mtx", sep=""))

tab = table(rep(V[,1],W[,1]))
cat = t(as.numeric(names(tab)))
Nc = t(as.vector(tab))

# the number of categories of a categorical variable
R = length(Nc)

# total count
s = sum(Nc)

# percentage values of each categorical compare to the total case number
Pc = Nc / s

# all categorical values of a categorical variable
#C = t(as.matrix(as.numeric(Nc > 0)))
C= (Nc > 0)

# mode
mx = max(Nc)
Mode = (Nc == mx)

writeMM(as(t(Nc),"CsparseMatrix"), paste(args[2], "Nc", sep=""), format="text");
write(R, paste(args[2], "R", sep=""));
writeMM(as(t(Pc),"CsparseMatrix"), paste(args[2], "Pc", sep=""), format="text");
writeMM(as(t(C),"CsparseMatrix"), paste(args[2], "C", sep=""), format="text");
writeMM(as(t(Mode),"CsparseMatrix"), paste(args[2], "Mode", sep=""), format="text");

#-------------------------------------------------------------
#
# Licensed to the Apache Software Foundation (ASF) under one
# or more contributor license agreements.  See the NOTICE file
# distributed with this work for additional information
# regarding copyright ownership.  The ASF licenses this file
# to you under the Apache License, Version 2.0 (the
# "License"); you may not use this file except in compliance
# with the License.  You may obtain a copy of the License at
#
#   http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing,
# software distributed under the License is distributed on an
# "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
# KIND, either express or implied.  See the License for the
# specific language governing permissions and limitations
# under the License.
#
#-------------------------------------------------------------

args<-commandArgs(TRUE)
options(digits=22)
library("Matrix")
library("matrixStats")

# colProds <- function(X) {
#   apply(X, 2, prod)
# }

X = matrix(3, 10, 10)
# X = matrix(seq(9, 100*100+8), 100, 100, byrow=TRUE);
# F = matrix(0.1, 10, 10)
# X = matrix(seq(from = 1, to = 10, by = 2), 10, 20)
# X = matrix(1.3109348721, 10, 10)

R = t(colProds(2*log(X)))
# R = t(colProds(X*min(F)));

writeMM(as(R,"CsparseMatrix"), paste(args[2], "S", sep=""));

#-------------------------------------------------------------
#
# Licensed to the Apache Software Foundation (ASF) under one
# or more contributor license agreements.  See the NOTICE file
# distributed with this work for additional information
# regarding copyright ownership.  The ASF licenses this file
# to you under the Apache License, Version 2.0 (the
# "License"); you may not use this file except in compliance
# with the License.  You may obtain a copy of the License at
# 
#   http://www.apache.org/licenses/LICENSE-2.0
# 
# Unless required by applicable law or agreed to in writing,
# software distributed under the License is distributed on an
# "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
# KIND, either express or implied.  See the License for the
# specific language governing permissions and limitations
# under the License.
#
#-------------------------------------------------------------


args <- commandArgs(TRUE)
options(digits=22)
library("Matrix")

A1=readMM(paste(args[1], "A.mtx", sep=""))
B1=readMM(paste(args[1], "B.mtx", sep=""))
C1=readMM(paste(args[1], "C.mtx", sep=""))
D1=readMM(paste(args[1], "D.mtx", sep=""))
A=as.matrix(A1);
B=as.matrix(B1);
C=as.matrix(C1);
D=as.matrix(D1);

A[args[2]:args[3],args[4]:args[5]]=0
A[args[2]:args[3],args[4]:args[5]]=B
writeMM(as(A,"CsparseMatrix"), paste(args[6], "AB", sep=""), format="text")
A[1:args[3],args[4]:ncol(A)]=0
A[1:args[3],args[4]:ncol(A)]=C
writeMM(as(A,"CsparseMatrix"), paste(args[6], "AC", sep=""), format="text")
A[,args[4]:args[5]]=0
A[,args[4]:args[5]]=D
writeMM(as(A,"CsparseMatrix"), paste(args[6], "AD", sep=""), format="text")

#-------------------------------------------------------------
#
# Licensed to the Apache Software Foundation (ASF) under one
# or more contributor license agreements.  See the NOTICE file
# distributed with this work for additional information
# regarding copyright ownership.  The ASF licenses this file
# to you under the Apache License, Version 2.0 (the
# "License"); you may not use this file except in compliance
# with the License.  You may obtain a copy of the License at
#
#   http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing,
# software distributed under the License is distributed on an
# "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
# KIND, either express or implied.  See the License for the
# specific language governing permissions and limitations
# under the License.
#
#-------------------------------------------------------------

args <- commandArgs(TRUE)
options(digits=22)
library("Matrix")

A=read.csv(paste(args[1], "A.csv", sep=""), header = FALSE, stringsAsFactors=FALSE)
B=read.csv(paste(args[1], "B.csv", sep=""), header = FALSE, stringsAsFactors=FALSE)

test = args[2]

if(test == "GREATER")
{ 
C = A > B 
} else if (test == "LESS") {
C = A < B
} else if (test == "EQUALS") {
C = A == B
} else if (test == "NOT_EQUALS") {
C =  A != B
} else if(test == "GREATER_EQUALS") {
C = A >= B
} else if(test == "LESS_EQUALS") {
C = A <= B
}

writeMM(as(C, "CsparseMatrix"), paste(args[3], "C", sep="")); 

#-------------------------------------------------------------
#
# Licensed to the Apache Software Foundation (ASF) under one
# or more contributor license agreements.  See the NOTICE file
# distributed with this work for additional information
# regarding copyright ownership.  The ASF licenses this file
# to you under the Apache License, Version 2.0 (the
# "License"); you may not use this file except in compliance
# with the License.  You may obtain a copy of the License at
#
#   http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing,
# software distributed under the License is distributed on an
# "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
# KIND, either express or implied.  See the License for the
# specific language governing permissions and limitations
# under the License.
#
#-------------------------------------------------------------

# Function definition for raSelection in R
raSelection <- function(X, col, op, val) {
  # Determine the operators
  I = switch(op,
              "==" = X[, col] == val,
              "!=" = X[, col] != val,
              "<"  = X[, col] <  val,
              ">"  = X[, col] >  val,
              "<=" = X[, col] <= val,
              ">=" = X[, col] >= val,
              stop("Invalid operator"))

  # Select rows based on the condition
  Y = X[I, , drop = FALSE]

  return(Y)
}

args<-commandArgs(TRUE)
options(digits=22)
library("Matrix")

X = as.matrix(readMM(paste(args[1],"X.mtx",sep="")));
col = as.integer(args[2])
op = args[3]
val = as.numeric(args[4])

result = raSelection(X,col,op,val);
writeMM(as(result,"CsparseMatrix"),paste(args[5],"result",sep=""));
 

#-------------------------------------------------------------
#
# Licensed to the Apache Software Foundation (ASF) under one
# or more contributor license agreements.  See the NOTICE file
# distributed with this work for additional information
# regarding copyright ownership.  The ASF licenses this file
# to you under the Apache License, Version 2.0 (the
# "License"); you may not use this file except in compliance
# with the License.  You may obtain a copy of the License at
#
#   http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing,
# software distributed under the License is distributed on an
# "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
# KIND, either express or implied.  See the License for the
# specific language governing permissions and limitations
# under the License.
#
#-------------------------------------------------------------

args <- commandArgs(TRUE)

# Set options for numeric precision
options(digits=22)

# Load required libraries
library("Matrix")
library("matrixStats")

# Read matrices and operation type
X = as.matrix(readMM(paste(args[1], "X.mtx", sep="")))
Y = as.matrix(readMM(paste(args[1], "Y.mtx", sep="")))
type = as.integer(args[2])

# Perform operations
# (1) Less
if(type==1){
    R = abs(X<Y)
} else if(type==2){
    R = round(X<Y)
} else if(type==3){
    R = ceiling(X<Y)
} else if(type==4){
    R = floor(X<Y)
} else if(type==5){
    R = sign(X<Y)
} else if(type==6){ # (2) Less-Equal
    R = abs(X<=Y)
} else if(type==7){
    R = round(X<=Y)
} else if(type==8){
    R = ceiling(X<=Y)
} else if(type==9){
    R = floor(X<=Y)
} else if(type==10){
    R = sign(X<=Y)
} else if(type==11){ # (3) Greater
    R = abs(X>Y)
} else if(type==12){
    R = round(X>Y)
} else if(type==13){
    R = ceiling(X>Y)
} else if(type==14){
    R = floor(X>Y)
} else if(type==15){
    R = sign(X>Y)
} else if(type==16){ # (4) Greater-Equal
    R = abs(X>=Y)
} else if(type==17){
    R = round(X>=Y)
} else if(type==18){
    R = ceiling(X>=Y)
} else if(type==19){
    R = floor(X>=Y)
} else if(type==20){
    R = sign(X>=Y)
} else if(type==21){ # (5) Equal
    R = abs(X==Y)
} else if(type==22){
    R = round(X==Y)
} else if(type==23){
    R = ceiling(X==Y)
} else if(type==24){
    R = floor(X==Y)
} else if(type==25){
    R = sign(X==Y)
} else if(type==26){ # (6) Not-Equal
    R = abs(X!=Y)
} else if(type==27){
    R = round(X!=Y)
} else if(type==28){
    R = ceiling(X!=Y)
} else if(type==29){
    R = floor(X!=Y)
} else if(type==30){
    R = sign(X!=Y)
}

#Write result matrix R
writeMM(as(R, "CsparseMatrix"), paste(args[3], "R", sep=""));

#-------------------------------------------------------------
#
# Licensed to the Apache Software Foundation (ASF) under one
# or more contributor license agreements.  See the NOTICE file
# distributed with this work for additional information
# regarding copyright ownership.  The ASF licenses this file
# to you under the Apache License, Version 2.0 (the
# "License"); you may not use this file except in compliance
# with the License.  You may obtain a copy of the License at
# 
#   http://www.apache.org/licenses/LICENSE-2.0
# 
# Unless required by applicable law or agreed to in writing,
# software distributed under the License is distributed on an
# "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
# KIND, either express or implied.  See the License for the
# specific language governing permissions and limitations
# under the License.
#
#-------------------------------------------------------------

args <- commandArgs(TRUE)
library(Matrix)

arima_css = function(w, X, p, P, q, Q, s, useJacobi){
  b = matrix(X[,2:ncol(X)], nrow(X), ncol(X)-1)%*%w

  R = matrix(0, nrow(X), nrow(X))
  if(q>0){
    for(i7 in 1:q){
      ma_ind_ns = P+p+i7
      err_ind_ns = i7
      ones_ns = rep(1, nrow(R)-err_ind_ns)
      d_ns = ones_ns * w[ma_ind_ns,1]
      R[(1+err_ind_ns):nrow(R),1:(ncol(R)-err_ind_ns)] = R[(1+err_ind_ns):nrow(R),1:(ncol(R)-err_ind_ns)] + diag(d_ns)
    }
  }
  if(Q>0){
    for(i8 in 1:Q){
      ma_ind_s = P+p+q+i8
      err_ind_s = s*i8
      ones_s = rep(1, nrow(R)-err_ind_s)
      d_s = ones_s * w[ma_ind_s,1]
      R[(1+err_ind_s):nrow(R),1:(ncol(R)-err_ind_s)] = R[(1+err_ind_s):nrow(R),1:(ncol(R)-err_ind_s)] + diag(d_s)
    }
  }

  max_iter = 100
  tol = 0.01

  y_hat = matrix(0, nrow(X), 1)
  iter = 0
  
  if(useJacobi == 1){
  	check = sum(ifelse(rowSums(abs(R)) >= 1, 1, 0))
  	if(check > 0){
  	  print("R is not diagonal dominant. Suggest switching to an exact solver.")
  	}
  	diff = tol+1.0
  	while(iter < max_iter & diff > tol){
  	  y_hat_new = matrix(b - R%*%y_hat, nrow(y_hat), 1)
  	  diff = sum((y_hat_new-y_hat)*(y_hat_new-y_hat))
  	  y_hat = y_hat_new
  	  iter = iter + 1
  	}
  }else{
  	ones = rep(1, nrow(X))
  	A = R + diag(ones)
  	Z = t(A)%*%A
  	y = t(A)%*%b
  	r = -y
  	p = -r
  	norm_r2 = sum(r*r)
  	while(iter < max_iter & norm_r2 > tol){
 	 	q = Z%*%p 
  		alpha = norm_r2 / sum(p*q)
  		y_hat = y_hat + alpha * p
  		old_norm_r2 = norm_r2
  		r = r + alpha * q
  		norm_r2 = sum(r * r)
  		beta = norm_r2 / old_norm_r2
  		p = -r + beta * p
  		iter = iter + 1
  	}
  }
  
  errs = X[,1] - y_hat
  obj = sum(errs*errs)

  return(obj)
}

#input col of time series data
X = readMM(paste(args[1], "col.mtx", sep=""))

max_func_invoc = as.integer(args[2])

#non-seasonal order
p = as.integer(args[3])
d = as.integer(args[4])
q = as.integer(args[5])

#seasonal order
P = as.integer(args[6])
D = as.integer(args[7])
Q = as.integer(args[8])

#length of the season
s = as.integer(args[9])

include_mean = as.integer(args[10])

useJacobi = as.integer(args[11])

num_rows = nrow(X)

if(num_rows <= d){
  print("non-seasonal differencing order should be larger than length of the time-series")
}

Y = matrix(X[,1], nrow(X), 1)
if(d>0){
  for(i in 1:d){
    n1 = nrow(Y)
    Y = matrix(Y[2:n1,] - Y[1:(n1-1),], n1-1, 1)
  }
}

num_rows = nrow(Y)
if(num_rows <= s*D){
  print("seasonal differencing order should be larger than number of observations divided by length of season")
}

if(D>0){
  for(i in 1:D){
    n1 = nrow(Y)
    Y = matrix(Y[(s+1):n1,] - Y[1:(n1-s),], n1-s, 1)
  }
}

n = nrow(Y)

max_ar_col = P+p
max_ma_col = Q+q
if(max_ar_col > max_ma_col){
  max_arma_col = max_ar_col
}else{
  max_arma_col = max_ma_col
}

mu = 0
if(include_mean == 1){
  mu = sum(Y)/nrow(Y)
  Y = Y - mu
}

totcols = 1+p+P+Q+q #target col (X), p-P cols, q-Q cols  

Z = matrix(0, n, totcols)
Z[,1] = Y #target col

if(p>0){
  for(i1 in 1:p){
    Z[(i1+1):n,1+i1] = Y[1:(n-i1),]
  }
}
if(P>0){
  for(i2 in 1:P){
    Z[(s*i2+1):n,1+p+i2] = Y[1:(n-s*i2),]
  }
}
if(q>0){
  for(i5 in 1:q){
    Z[(i5+1):n,1+P+p+i5] = Y[1:(n-i5),]
  }
}
if(Q>0){
  for(i6 in 1:Q){
     Z[(s*i6+1):n,1+P+p+q+i6] = Y[1:(n-s*i6),]
  }
}

simplex = matrix(0, totcols-1, totcols)
for(i in 2:ncol(simplex)){
  simplex[i-1,i] = 0.1
}

num_func_invoc = 0

objvals = matrix(0, 1, ncol(simplex))
for(i3 in 1:ncol(simplex)){
  objvals[1,i3] = arima_css(matrix(simplex[,i3], nrow(simplex), 1), Z, p, P, q, Q, s, useJacobi)
}
num_func_invoc = num_func_invoc + ncol(simplex)

tol = 1.5 * 10^(-8) * objvals[1,1]

continue = 1
while(continue == 1 & num_func_invoc <= max_func_invoc) {
  #print(paste(num_func_invoc, max_func_invoc))
  best_index = 1
  worst_index = 1
  for(i in 2:ncol(objvals)){
    this = objvals[1,i]
    that = objvals[1,best_index]
    if(that > this){
      best_index = i
    }
    that = objvals[1,worst_index]
    if(that < this){
      worst_index = i
    }
  }

  best_obj_val = objvals[1,best_index]
  worst_obj_val = objvals[1,worst_index]
  if(worst_obj_val <= best_obj_val + tol){
    continue = 0
  }

  print(paste("#Function calls::", num_func_invoc, "OBJ:", best_obj_val))

  c = (rowSums(simplex) - simplex[,worst_index])/(nrow(simplex))

  x_r = 2*c - simplex[,worst_index]
  obj_x_r = arima_css(matrix(x_r, nrow(simplex), 1), Z, p, P, q, Q, s, useJacobi)
  num_func_invoc = num_func_invoc + 1

  if(obj_x_r < best_obj_val){
    x_e = 2*x_r - c
    obj_x_e = arima_css(matrix(x_e, nrow(simplex), 1), Z, p, P, q, Q, s, useJacobi)
    num_func_invoc = num_func_invoc + 1

    if(obj_x_r <= obj_x_e){
      simplex[,worst_index] = x_r
      objvals[1,worst_index] = obj_x_r
    }else{
      simplex[,worst_index] = x_e
      objvals[1,worst_index] = obj_x_e
    }
  }else{
    if(obj_x_r < worst_obj_val){
      simplex[,worst_index] = x_r
      objvals[1,worst_index] = obj_x_r
    }

    x_c_in = (simplex[,worst_index] + c)/2
    obj_x_c_in = arima_css(matrix(x_c_in, nrow(simplex), 1), Z, p, P, q, Q, s, useJacobi)
    num_func_invoc = num_func_invoc + 1
    
    if(obj_x_c_in < objvals[1,worst_index]){
      simplex[,worst_index] = x_c_in
      objvals[1,worst_index] = obj_x_c_in
    }else{
      if(obj_x_r >= worst_obj_val){
        best_point = simplex[,best_index]

		for(i4 in 1:ncol(simplex)){
			if(i4 != best_index){
	          simplex[,i4] = (simplex[,i4] + best_point)/2
			  objvals[1,i4] = arima_css(matrix(simplex[,i4], nrow(simplex), 1), Z, p, P, q, Q, s, useJacobi)
			}
		}
		num_func_invoc = num_func_invoc + ncol(simplex) - 1
      }
    }
  }
}

best_point = matrix(simplex[,best_index], nrow(simplex), 1)
if(include_mean == 1){
  tmp = matrix(0, totcols, 1)
  tmp[1:nrow(best_point),1] = best_point
  tmp[nrow(tmp),1] = mu
  best_point = tmp
}

writeMM(as(best_point, "CsparseMatrix"), paste(args[12], "learnt.model", sep=""))

#-------------------------------------------------------------
#
# Licensed to the Apache Software Foundation (ASF) under one
# or more contributor license agreements.  See the NOTICE file
# distributed with this work for additional information
# regarding copyright ownership.  The ASF licenses this file
# to you under the Apache License, Version 2.0 (the
# "License"); you may not use this file except in compliance
# with the License.  You may obtain a copy of the License at
#
#   http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing,
# software distributed under the License is distributed on an
# "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
# KIND, either express or implied.  See the License for the
# specific language governing permissions and limitations
# under the License.
#
#-------------------------------------------------------------

args<-commandArgs(TRUE)
options(digits=22)
library("Matrix")
library("nnet")

X = as.matrix(readMM(paste(args[1], "A.mtx", sep="")))
Y = as.matrix(readMM(paste(args[1], "B.mtx", sep="")))
X_test = as.matrix(readMM(paste(args[1], "C.mtx", sep="")))
Y_test = as.matrix(readMM(paste(args[1], "D.mtx", sep="")))

X = cbind(Y, X)
X_test = cbind(Y_test, X_test)
X = as.data.frame(X)
# set a baseline variable
X$V1 <- relevel(as.factor(X$V1), ref = "3")
X_test = as.data.frame(X_test)
model = multinom(V1~., data = X) # train model
pred <- predict(model, newdata = X_test, "class") # predict unknown data
acc = (sum(pred == Y_test)/nrow(Y_test))*100

writeMM(as(as.matrix(acc), "CsparseMatrix"), paste(args[2], "O", sep=""))

#-------------------------------------------------------------
#
# Licensed to the Apache Software Foundation (ASF) under one
# or more contributor license agreements.  See the NOTICE file
# distributed with this work for additional information
# regarding copyright ownership.  The ASF licenses this file
# to you under the Apache License, Version 2.0 (the
# "License"); you may not use this file except in compliance
# with the License.  You may obtain a copy of the License at
# 
#   http://www.apache.org/licenses/LICENSE-2.0
# 
# Unless required by applicable law or agreed to in writing,
# software distributed under the License is distributed on an
# "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
# KIND, either express or implied.  See the License for the
# specific language governing permissions and limitations
# under the License.
#
#-------------------------------------------------------------

args<-commandArgs(TRUE)
options(digits=22)
library(Matrix)
library(matrixStats)

N = 2
C = 2
Hin = 3
Win = 4

X = matrix(cbind(seq(1,20),seq(1,20),seq(1,8)), nrow=2, ncol=24, byrow=TRUE)
gamma = matrix(c(1,2), byrow=TRUE, nrow=2, ncol=1)
beta = matrix(c(0,1), byrow=TRUE, nrow=2, ncol=1)
ema_mean = matrix(c(4,5), byrow=TRUE, nrow=2, ncol=1)
ema_var = matrix(c(2,3), byrow=TRUE, nrow=2, ncol=1)
mu = 0.95
epsilon = 1e-4

subgrp_means = matrix(colMeans(X), nrow=C, ncol=Hin*Win, byrow=TRUE)
subgrp_vars = matrix(colVars(X) * ((N-1)/N), nrow=C, ncol=Hin*Win, byrow=TRUE)
mean = rowMeans(subgrp_means)  # shape (C, 1)
var = rowMeans(subgrp_vars) + rowVars(subgrp_means)*(((Hin*Win)-1)/(Hin*Win))
ema_mean_upd = mu*ema_mean + (1-mu)*mean
ema_var_upd = mu*ema_var + (1-mu)*var

R = cbind(mean, var, ema_mean_upd, ema_var_upd)

writeMM(as(R, "CsparseMatrix"), paste(args[1], "R", sep=""));

#-------------------------------------------------------------
#
# Licensed to the Apache Software Foundation (ASF) under one
# or more contributor license agreements.  See the NOTICE file
# distributed with this work for additional information
# regarding copyright ownership.  The ASF licenses this file
# to you under the Apache License, Version 2.0 (the
# "License"); you may not use this file except in compliance
# with the License.  You may obtain a copy of the License at
#
#   http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing,
# software distributed under the License is distributed on an
# "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
# KIND, either express or implied.  See the License for the
# specific language governing permissions and limitations
# under the License.
#
#-------------------------------------------------------------
# TODO arguments and order
args <- commandArgs(TRUE)
library("Matrix")

# read test data
data_train            <- as.matrix(readMM(paste(args[1], "/X.mtx", sep="")))
data_test             <- as.matrix(readMM(paste(args[1], "/T.mtx", sep="")))
CL                    <- as.matrix(readMM(paste(args[1], "/CL.mtx", sep="")))

is_continuous <- as.integer(args[2])
K <- as.integer(args[3])

library(FNN);
set.seed(10);
tmp_data = rbind(data_train, data_test);
knn_neighbors <- get.knn(tmp_data, k=K);
knn_neighbors <- (tail(knn_neighbors$nn.index, NROW(data_test)));
writeMM(as(knn_neighbors, "CsparseMatrix"), paste(args[4], "NNR", sep=""));


# ------ training -------
library(class)

set.seed(10);
test_pred <- knn(train=data_train, test=data_test, cl=CL, k=K);
print("test_pred:")
print(test_pred)
PR_val <- matrix( , nrow=0, ncol=NCOL(data_test));
for(i in 1:NROW(data_test)) {
  PR_val <- rbind(PR_val, data_train[test_pred[i] , ])
}
writeMM(as(PR_val, "CsparseMatrix"), paste(args[4], "PR", sep=""));

#-------------------------------------------------------------
#
# Licensed to the Apache Software Foundation (ASF) under one
# or more contributor license agreements.  See the NOTICE file
# distributed with this work for additional information
# regarding copyright ownership.  The ASF licenses this file
# to you under the Apache License, Version 2.0 (the
# "License"); you may not use this file except in compliance
# with the License.  You may obtain a copy of the License at
#
#   http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing,
# software distributed under the License is distributed on an
# "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
# KIND, either express or implied.  See the License for the
# specific language governing permissions and limitations
# under the License.
#
#-------------------------------------------------------------

args<-commandArgs(TRUE)
options(digits=22)
library("Matrix")

N = 64
C = 4
H = 12
W = 12
X = matrix(7, N, C*H*W);
B = as.matrix(seq(1, C))
ones = matrix(1, 1, H*W)

R1 = X + (matrix(1,N,1) %*% matrix(t(B%*%ones), 1, C*H*W))
R2 = X * (matrix(1,N,1) %*% matrix(t(B%*%ones), 1, C*H*W))
R = (R1 + R2) / (rowSums(X) %*% matrix(1,1,ncol(X)));

R = as.matrix(sum(R));


writeMM(as(R,"CsparseMatrix"), paste(args[2], "S", sep=""));

#-------------------------------------------------------------
#
# Licensed to the Apache Software Foundation (ASF) under one
# or more contributor license agreements.  See the NOTICE file
# distributed with this work for additional information
# regarding copyright ownership.  The ASF licenses this file
# to you under the Apache License, Version 2.0 (the
# "License"); you may not use this file except in compliance
# with the License.  You may obtain a copy of the License at
#
#   http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing,
# software distributed under the License is distributed on an
# "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
# KIND, either express or implied.  See the License for the
# specific language governing permissions and limitations
# under the License.
#
#-------------------------------------------------------------

args = commandArgs(TRUE)
options(digits=22)
library("Matrix")

image_crop = function(img_in,  w,  h,  x_offset,  y_offset) {
  orig_w = ncol(img_in)
  orig_h = nrow(img_in)
  
  start_h = (ceiling((orig_h - h) / 2)) + y_offset
  end_h = (start_h + h - 1) 
  start_w = (ceiling((orig_w - w) / 2)) + x_offset
  end_w = (start_w + w - 1) 
  

  if((start_h < 0) | (end_h > orig_h) | (start_w < 0) | (end_w > orig_w)) {
    print("Offset out of bounds! Returning input.")
    img_out = img_in
  }
  else {
    mask = matrix(0, orig_h, orig_w)
    temp_mask = matrix(1, h , w )
    mask[start_h:end_h, start_w:end_w] = temp_mask
    mask = matrix(mask, 1, orig_w * orig_h)
    img_out = input[start_h:end_h, start_w:end_w]
  }
}

input = as.matrix(readMM(paste(args[1], "A.mtx", sep="")))
size = as.double(args[3])
input = matrix(input, as.integer(args[4]), as.integer(args[5]))
new_w = floor(ncol(input) * size)
new_h = floor(nrow(input) * size)
print(paste("New w/h=",new_w,"/",new_h))
crop1 = image_crop(input, new_w, new_h, as.integer(args[6]), as.integer(args[7]));
writeMM(as(crop1, "CsparseMatrix"), paste(args[2], "B", sep=""))

#-------------------------------------------------------------
#
# Licensed to the Apache Software Foundation (ASF) under one
# or more contributor license agreements.  See the NOTICE file
# distributed with this work for additional information
# regarding copyright ownership.  The ASF licenses this file
# to you under the Apache License, Version 2.0 (the
# "License"); you may not use this file except in compliance
# with the License.  You may obtain a copy of the License at
#
#   http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing,
# software distributed under the License is distributed on an
# "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
# KIND, either express or implied.  See the License for the
# specific language governing permissions and limitations
# under the License.
#
#-------------------------------------------------------------

library("Matrix")

args <- commandArgs(TRUE)
options(digits=22)


X = as.matrix(readMM(paste(args[1], "A.mtx", sep="")))
colnames(X) = colnames(X, do.NULL=FALSE, prefix="C")
Y = X

for (j in 1:ncol(X)) {
  col = X[, j]
  med = quantile(col, probs=0.5, type=1, names=FALSE, na.rm=FALSE)
  q1  = quantile(col, probs=0.25, type=1, names=FALSE, na.rm=FALSE)
  q3  = quantile(col, probs=0.75, type=1, names=FALSE, na.rm=FALSE)
  iqr = q3 - q1
  if (iqr == 0 || is.nan(iqr)) iqr = 1
  Y[, j] = (col - med) / iqr
}

writeMM(as(Y, "CsparseMatrix"), paste(args[2], "B", sep=""))

#-------------------------------------------------------------
#
# Licensed to the Apache Software Foundation (ASF) under one
# or more contributor license agreements.  See the NOTICE file
# distributed with this work for additional information
# regarding copyright ownership.  The ASF licenses this file
# to you under the Apache License, Version 2.0 (the
# "License"); you may not use this file except in compliance
# with the License.  You may obtain a copy of the License at
#
#   http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing,
# software distributed under the License is distributed on an
# "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
# KIND, either express or implied.  See the License for the
# specific language governing permissions and limitations
# under the License.
#
#-------------------------------------------------------------

args<-commandArgs(TRUE)
options(digits=22)
library("Matrix")

# V = matrix( 5, 2, 300)
# U = t(V)

U = matrix( 5, 300, 2)
V = t(U)
# X = rand(rows=300, cols=300, pdf="normal", sparsity=0.2, seed=7)
# X = matrix(1, 300,300)

X = U %*% V
X[1:150,] = matrix(0,150,300);

T1 = rowSums(U^2)%*%matrix(1,1,ncol(V));
T2 = matrix(1,nrow(U),1)%*%t(as.matrix(colSums(V^2)))
D = sqrt(-2 * U %*% V + T1 + T2);

s = sum(rowSums((X != 0) * (X - D))^2)
S = as.matrix(s); 

writeMM(as(S, "CsparseMatrix"), paste(args[2], "S", sep="")); 
 

#-------------------------------------------------------------
#
# Licensed to the Apache Software Foundation (ASF) under one
# or more contributor license agreements.  See the NOTICE file
# distributed with this work for additional information
# regarding copyright ownership.  The ASF licenses this file
# to you under the Apache License, Version 2.0 (the
# "License"); you may not use this file except in compliance
# with the License.  You may obtain a copy of the License at
#
#   http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing,
# software distributed under the License is distributed on an
# "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
# KIND, either express or implied.  See the License for the
# specific language governing permissions and limitations
# under the License.
#
#-------------------------------------------------------------

args <- commandArgs(TRUE)

library("Matrix")
options(digits=22)

library("rhdf5")

Y = h5read(args[1], args[2], native = TRUE)
dims = dim(Y)

if(length(dims) == 1) {
  # convert to a column matrix
  Y_mat = matrix(Y, ncol = 1)
} else if(length(dims) > 2) {
  # flatten everything beyond the first dimension into columns
  perm = c(1, rev(seq(2, length(dims))))
  Y_mat = matrix(aperm(Y, perm), nrow = dims[1], ncol = prod(dims[-1]))
} else {
  # for 2d , systemds treats it the same
  Y_mat = Y
}

writeMM(as(Y_mat, "CsparseMatrix"), paste(args[3], "Y", sep=""))

#-------------------------------------------------------------
#
# Licensed to the Apache Software Foundation (ASF) under one
# or more contributor license agreements.  See the NOTICE file
# distributed with this work for additional information
# regarding copyright ownership.  The ASF licenses this file
# to you under the Apache License, Version 2.0 (the
# "License"); you may not use this file except in compliance
# with the License.  You may obtain a copy of the License at
# 
#   http://www.apache.org/licenses/LICENSE-2.0
# 
# Unless required by applicable law or agreed to in writing,
# software distributed under the License is distributed on an
# "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
# KIND, either express or implied.  See the License for the
# specific language governing permissions and limitations
# under the License.
#
#-------------------------------------------------------------

args <- commandArgs(TRUE)
library("Matrix")
imgSize=as.integer(args[1])
numImg=as.integer(args[2])
numChannels=as.integer(args[3])
numFilters=as.integer(args[4])
filterSize=as.integer(args[5])
stride=as.integer(args[6])
pad=as.integer(args[7])

# Assumption: NCHW image format
x=matrix(seq(1, numImg*numChannels*imgSize*imgSize), numImg, numChannels*imgSize*imgSize, byrow=TRUE)
w=matrix(seq(1, numFilters*numChannels*filterSize*filterSize), numFilters, numChannels*filterSize*filterSize, byrow=TRUE)

if(as.logical(args[9])) {
	zero_mask = (x - mean(x)*1.5) > 0 
	x = x * zero_mask
} else {
	x = x - mean(x)
}
if(as.logical(args[10])) {
	zero_mask = (w - mean(w)*1.5) > 0 
	w = w * zero_mask
} else {
	w = w - mean(w)
}
pad_image <- function(img, Hin, Win, padh, padw){
  C = nrow(img)
  img_padded = matrix(0, C, (Hin+2*padh)*(Win+2*padw), byrow=TRUE)  # zeros
  for (c in 1:C) {
    img_slice = matrix(img[c,], Hin, Win, byrow=TRUE)  # depth slice C reshaped
    img_padded_slice = matrix(0, Hin+2*padh, Win+2*padw)
    img_padded_slice[(padh+1):(padh+Hin), (padw+1):(padw+Win)] = img_slice
    img_padded[c,] = matrix(t(img_padded_slice), 1, (Hin+2*padh)*(Win+2*padw))  # reshape
  }
  img_padded
}

im2col <- function(img, Hin, Win, Hf, Wf, strideh, stridew) {
  C = nrow(img)
  Hout = as.integer((Hin - Hf) / strideh + 1)
  Wout = as.integer((Win - Wf) / stridew + 1)

  img_cols = matrix(0, C*Hf*Wf, Hout*Wout, byrow=TRUE)  # zeros
  for (hout in 1:Hout) {  # all output rows
    hin = (hout-1) * strideh + 1
    for (wout in 1:Wout) {  # all output columns
      win = (wout-1) * stridew + 1
      # Extract a local patch of the input image corresponding spatially to the filter sizes.
      img_patch = matrix(0, C, Hf*Wf, byrow=TRUE)  # zeros
      for (c in 1:C) {  # all channels
        img_slice = matrix(img[c,], Hin, Win, byrow=TRUE)  # reshape
        img_patch[c,] = matrix(t(img_slice[hin:(hin+Hf-1), win:(win+Wf-1)]), 1, Hf*Wf)
      }
      img_cols[,(hout-1)*Wout + wout] = matrix(t(img_patch), C*Hf*Wf, 1)  # reshape
    }
  }
  img_cols
}
		
conv2d <- function(X, W, C, Hin, Win, Hf, Wf, strideh, stridew, padh, padw) {
  N = nrow(X)
  F = nrow(W)
  Hout = as.integer((Hin + 2 * padh - Hf) / strideh + 1)
  Wout = as.integer((Win + 2 * padw - Wf) / stridew + 1)
  
  # Create output volume
  out = matrix(0, N, F*Hout*Wout, byrow=TRUE)

  # Convolution - im2col implementation
  for (n in 1:N) {  # all examples
    Xn = matrix(X[n,], C, Hin*Win, byrow=TRUE)  # reshape

    # Pad image
    Xn_padded = pad_image(Xn, Hin, Win, padh, padw)  # shape (C, (Hin+2*padh)*(Win+2*padw))

    # Extract local image patches into columns with im2col, of shape (C*Hf*Wf, Hout*Wout)
    Xn_padded_cols = im2col(Xn_padded, Hin+2*padh, Win+2*padw, Hf, Wf, strideh, stridew)

    # Convolve patches with filters
    outn = W %*% Xn_padded_cols   # shape (F, Hout*Wout)
    out[n,] = matrix(t(outn), 1, F*Hout*Wout)  # reshape
  }
  
  out
}

output = conv2d(x, w, numChannels,  imgSize, imgSize, filterSize, filterSize, stride, stride, pad, pad);
Hout = as.integer((imgSize + 2 * pad - filterSize) / stride + 1)
Wout = Hout

b=matrix(seq(1, numFilters), numFilters, 1, byrow=TRUE) 
for(k in 0:(numFilters-1)) {
	for(i in 1:nrow(output)) {
		start = k*Hout*Hout;
		for(j in 1:(Hout*Hout)) {
			output[i,start+j] = output[i,start+j] + b[k+1,1]
		}
	}
}

writeMM(as(output,"CsparseMatrix"), paste(args[8], "B", sep=""))

#-------------------------------------------------------------
#
# Licensed to the Apache Software Foundation (ASF) under one
# or more contributor license agreements.  See the NOTICE file
# distributed with this work for additional information
# regarding copyright ownership.  The ASF licenses this file
# to you under the Apache License, Version 2.0 (the
# "License"); you may not use this file except in compliance
# with the License.  You may obtain a copy of the License at
# 
#   http://www.apache.org/licenses/LICENSE-2.0
# 
# Unless required by applicable law or agreed to in writing,
# software distributed under the License is distributed on an
# "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
# KIND, either express or implied.  See the License for the
# specific language governing permissions and limitations
# under the License.
#
#-------------------------------------------------------------

# JUnit test class: dml.test.integration.applications.LinearLogReg.java
# command line invocation assuming $LLR_HOME is set to the home of the R script
# Rscript $LLR_HOME/LinearLogReg.R $LLR_HOME/in/ $LLR_HOME/expected/

args <- commandArgs(TRUE)

library("Matrix")
# Usage:  /home/vikas/R-2.10.1/bin/R --vanilla --args Xfile X yfile y Cval 2 tol 0.01 maxiter 100 < linearLogReg.r

# Solves Linear Logistic Regression using Trust Region methods. 
# Can be adapted for L2-SVMs and more general unconstrained optimization problems also
# setup optimization parameters (See: Trust Region Newton Method for Logistic Regression, Lin, Weng and Keerthi, JMLR 9 (2008) 627-650)

options(warn=-1)

C = 2; 
tol = 0.001
maxiter = 3
maxinneriter = 3

eta0 = 0.0001
eta1 = 0.25
eta2 = 0.75
sigma1 = 0.25
sigma2 = 0.5
sigma3 = 4.0
psi = 0.1 

# read (training and test) data files -- should be in matrix market format. see data.mtx 
X = readMM(paste(args[1], "X.mtx", sep=""));
Xt = readMM(paste(args[1], "Xt.mtx", sep=""));

N = nrow(X)
D = ncol(X)
Nt = nrow(Xt)

# read (training and test) labels
y = readMM(paste(args[1], "y.mtx", sep=""));
yt = readMM(paste(args[1], "yt.mtx", sep=""));

# initialize w
w = matrix(0,D,1)
o = X %*% w
logistic = 1.0/(1.0 + exp(-y*o))

# VS : change
obj = 0.5 * t(w) %*% w + C*sum(-log(logistic))
grad = w + C*t(X) %*% ((logistic - 1)*y)
logisticD = logistic*(1-logistic)
delta = sqrt(sum(grad*grad))

# number of iterations
iter = 0

# starting point for CG
zeros_D = matrix(0,D,1)
# VS: change
zeros_N = matrix(0,N,1)

# boolean for convergence check

converge = (delta < tol)
norm_r2 = sum(grad*grad)
gnorm = sqrt(norm_r2)
# VS: change
norm_grad = sqrt(norm_r2)
norm_grad_initial = norm_grad

while(!converge) {
 	
	norm_grad = sqrt(sum(grad*grad))

	print("next iteration..")
	print(paste("Iterations : ",iter, "Objective : ", obj[1,1],  "Gradient Norm : ", norm_grad))
    	 
	# SOLVE TRUST REGION SUB-PROBLEM
	s = zeros_D
	os = zeros_N
	r = -grad
	d = r
	innerconverge = (sqrt(sum(r*r)) <= psi*norm_grad)
	inneriter = 0; 	
	while(!innerconverge) {
		inneriter = inneriter + 1
		norm_r2 = sum(r*r)
		od = X %*% d
		Hd = d + C*(t(X) %*% (logisticD*od))
		alpha_deno = t(d) %*% Hd 
		alpha = norm_r2/alpha_deno
		
		s = s + alpha[1,1]*d
		os = os + alpha[1,1]*od

		sts = t(s) %*% s
		delta2 = delta*delta 
		
		if (sts[1,1] > delta2) {
			# VS: change 
			print("cg reaches trust region boundary")
			# VS: change
			s = s - alpha[1,1]*d
			os = os - alpha[1,1]*od
			std = t(s) %*% d
			dtd = t(d) %*% d
			# VS:change
			sts = t(s) %*% s
			rad = sqrt(std*std + dtd*(delta2 - sts))
			if(std[1,1]>=0) {
				tau = (delta2 - sts)/(std + rad)
			} 
			else {
				tau = (rad - std)/dtd
			}	 
			s = s + tau[1,1]*d
			os = os + tau[1,1]*od
			r = r - tau[1,1]*Hd
			break
		}
		r = r - alpha[1,1]*Hd
		old_norm_r2 = norm_r2 
		norm_r2 = sum(r*r)
		beta = norm_r2/old_norm_r2
		d = r + beta*d
		innerconverge = (sqrt(norm_r2) <= psi * norm_grad) | (inneriter > maxinneriter) # innerconverge = (sqrt(norm_r2) <= psi*norm_grad)
	}
	
	print(paste("Inner CG Iteration = ", inneriter))
	# END TRUST REGION SUB-PROBLEM
	# compute rho, update w, obtain delta
	gs = t(s) %*% grad
	qk = -0.5*(gs - (t(s) %*% r))
	
	wnew = w + s
	# VS Change X %*% wnew removed	
	onew = o + os 
	# VS: change
	logisticnew = 1.0/(1.0 + exp(-y*onew))
	objnew = 0.5 * t(wnew) %*% wnew + C*sum(-log(logisticnew))

	# VS: change
	actred = (obj - objnew)	
	rho = actred/qk

	print(paste("Actual :", actred[1,1], "Predicted :", qk[1,1]))

	rho = rho[1,1]
	snorm = sqrt(sum(s*s))

	if(iter==0) {
		delta = min(delta, snorm)
	}
	if (objnew[1,1] - obj[1,1] - gs[1,1] <= 0) {
		alpha = sigma3;
	}
	else {
		alpha = max(sigma1, -0.5*gs[1,1]/(objnew[1,1] - obj[1,1] - gs[1,1]))
	}



	if (rho > eta0) {
	
		w = wnew
		o = onew
		grad = w + C*t(X) %*% ((logisticnew - 1)*y)
		# VS: change
		norm_grad = sqrt(sum(grad*grad))
		logisticD = logisticnew*(1-logisticnew)
		obj = objnew

	}
	
	if (rho < eta0)
		{delta = min(max(alpha, sigma1)*snorm, sigma2*delta)}
	else if (rho < eta1)
		{delta = max(sigma1*delta, min(alpha*snorm, sigma2*delta))}
	else if (rho < eta2)
		{delta = max(sigma1*delta, min(alpha*snorm, sigma3*delta))}
	else
		{delta = max(delta, min(alpha*snorm, sigma3*delta))}

	ot = Xt %*% w
	correct = sum((yt*ot)>0)
	iter = iter + 1
	converge = (norm_grad < tol*norm_grad_initial) | (iter>maxiter)
	
	print(paste("Delta :", delta))
	print(paste("Accuracy=", correct*100/Nt))
	print(paste("OuterIter=", iter))
	print(paste("Converge=", converge))
}

writeMM(as(w,"CsparseMatrix"), paste(args[2],"w", sep=""), format = "text")

#-------------------------------------------------------------
#
# Licensed to the Apache Software Foundation (ASF) under one
# or more contributor license agreements.  See the NOTICE file
# distributed with this work for additional information
# regarding copyright ownership.  The ASF licenses this file
# to you under the Apache License, Version 2.0 (the
# "License"); you may not use this file except in compliance
# with the License.  You may obtain a copy of the License at
#
#   http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing,
# software distributed under the License is distributed on an
# "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
# KIND, either express or implied.  See the License for the
# specific language governing permissions and limitations
# under the License.
#
#-------------------------------------------------------------

args = commandArgs(TRUE)
options(digits=22)
library("Matrix")

image_translate = function(img_in, offset_x, offset_y) {
  width = ncol(img_in)
  height = nrow(img_in)
  img_out = matrix(0, nrow=height, ncol=width)
  for (x in 1:width) {
    for (y in 1:height) {
      src.x = x - round(offset_x)
      src.y = y - round(offset_y)
      if (0 < src.x & src.x <= width & 0 < src.y & src.y <= height) {
        img_out[x, y] = img_in[src.x, src.y]
      }
    }
  }

  img_out
}

input = as.matrix(readMM(paste(args[1], "A.mtx", sep="")))
input = matrix(input, as.integer(args[3]), as.integer(args[4]))

transformed = image_translate(input, as.double(args[5]), as.double(args[6]));
writeMM(as(transformed, "CsparseMatrix"), paste(args[2], "B", sep=""))

#-------------------------------------------------------------
#
# Licensed to the Apache Software Foundation (ASF) under one
# or more contributor license agreements.  See the NOTICE file
# distributed with this work for additional information
# regarding copyright ownership.  The ASF licenses this file
# to you under the Apache License, Version 2.0 (the
# "License"); you may not use this file except in compliance
# with the License.  You may obtain a copy of the License at
# 
#   http://www.apache.org/licenses/LICENSE-2.0
# 
# Unless required by applicable law or agreed to in writing,
# software distributed under the License is distributed on an
# "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
# KIND, either express or implied.  See the License for the
# specific language governing permissions and limitations
# under the License.
#
#-------------------------------------------------------------

# JUnit test class: dml.test.integration.applications.GNMFTest.java
# command line invocation assuming $GNMF_HOME is set to the home of the R script
# Rscript $GNMF_HOME/GNMF.R $GNMF_HOME/in/ 3 $GNMF_HOME/expected/
args <- commandArgs(TRUE)
library(Matrix)

V = readMM(paste(args[1], "v.mtx", sep=""));
W = readMM(paste(args[1], "w.mtx", sep=""));
H = readMM(paste(args[1], "h.mtx", sep=""));
max_iteration = as.integer(args[2]);
i = 0;

Eps = 10^-8;

while(i < max_iteration) {
	H = H * ((t(W) %*% V) / (((t(W) %*% W) %*% H)+Eps)) ;
	W = W * ((V %*% t(H)) / ((W %*% (H %*% t(H)))+Eps));
	i = i + 1;
}

writeMM(as(W, "CsparseMatrix"), paste(args[3], "w", sep=""));
writeMM(as(H, "CsparseMatrix"), paste(args[3], "h", sep=""));

#-------------------------------------------------------------
#
# Licensed to the Apache Software Foundation (ASF) under one
# or more contributor license agreements.  See the NOTICE file
# distributed with this work for additional information
# regarding copyright ownership.  The ASF licenses this file
# to you under the Apache License, Version 2.0 (the
# "License"); you may not use this file except in compliance
# with the License.  You may obtain a copy of the License at
# 
#   http://www.apache.org/licenses/LICENSE-2.0
# 
# Unless required by applicable law or agreed to in writing,
# software distributed under the License is distributed on an
# "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
# KIND, either express or implied.  See the License for the
# specific language governing permissions and limitations
# under the License.
#
#-------------------------------------------------------------


args <- commandArgs(TRUE)
options(digits=22)

library("Matrix")

A <- as.matrix(readMM(paste(args[1], "A.mtx", sep="")))
A <- floor(A);

IA = (A != 0) * seq (1, nrow (A), 1);
IA = matrix (IA, (nrow (A) * ncol(A)), 1, byrow = FALSE);
VA = matrix ( A, (nrow (A) * ncol(A)), 1, byrow = FALSE);
#IA = removeEmpty (target = IA, margin = "rows");
#VA = removeEmpty (target = VA, margin = "rows");
Btmp1 = table (IA, VA);
Btmp2 = as.matrix(as.data.frame.matrix(Btmp1));

#remove first row and column (0 values, see missing removeEmpty)
B = Btmp2[2:nrow(Btmp2),2:ncol(Btmp2)];

writeMM(as(B, "CsparseMatrix"), paste(args[2], "B", sep="")); 

#-------------------------------------------------------------
#
# Licensed to the Apache Software Foundation (ASF) under one
# or more contributor license agreements.  See the NOTICE file
# distributed with this work for additional information
# regarding copyright ownership.  The ASF licenses this file
# to you under the Apache License, Version 2.0 (the
# "License"); you may not use this file except in compliance
# with the License.  You may obtain a copy of the License at
# 
#   http://www.apache.org/licenses/LICENSE-2.0
# 
# Unless required by applicable law or agreed to in writing,
# software distributed under the License is distributed on an
# "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
# KIND, either express or implied.  See the License for the
# specific language governing permissions and limitations
# under the License.
#
#-------------------------------------------------------------

args<-commandArgs(TRUE)
options(digits=22)
library("Matrix")

U = matrix( 4, 4000, 10)
V = matrix( 5, 10, 2000)
X = U %*% V
X[1:3500,] = matrix(0,3500,2000);

T1 = rowSums(U^2)%*%matrix(1,1,ncol(V));
T2 = matrix(1,nrow(U),1)%*%t(as.matrix(colSums(V^2)))
D = sqrt(-2 * U %*% V + T1 + T2);

s = sum(rowSums((X != 0) * (X - D))^2)
S = as.matrix(s); 

writeMM(as(S, "CsparseMatrix"), paste(args[2], "S", sep="")); 
 

#-------------------------------------------------------------
#
# Licensed to the Apache Software Foundation (ASF) under one
# or more contributor license agreements.  See the NOTICE file
# distributed with this work for additional information
# regarding copyright ownership.  The ASF licenses this file
# to you under the Apache License, Version 2.0 (the
# "License"); you may not use this file except in compliance
# with the License.  You may obtain a copy of the License at
# 
#   http://www.apache.org/licenses/LICENSE-2.0
# 
# Unless required by applicable law or agreed to in writing,
# software distributed under the License is distributed on an
# "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
# KIND, either express or implied.  See the License for the
# specific language governing permissions and limitations
# under the License.
#
#-------------------------------------------------------------

args <- commandArgs(TRUE)

library("Matrix")

D = as.matrix(readMM(paste(args[1], "X.mtx", sep="")))
C = as.matrix(readMM(paste(args[1], "Y.mtx", sep="")))

# reading input args
numClasses = as.integer(args[2]);
laplace_correction = as.double(args[3]);

numRows = nrow(D)
numFeatures = ncol(D)

# Compute conditionals

# Compute the feature counts for each class
classFeatureCounts = matrix(0, numClasses, numFeatures)
for (i in 1:numFeatures) {
  Col = D[,i]
  classFeatureCounts[,i] = aggregate(as.vector(Col), by=list(as.vector(C)), FUN=sum)[,2];
}

# Compute the total feature count for each class 
# and add the number of features to this sum
# for subsequent regularization (Laplace's rule)
classSums = rowSums(classFeatureCounts) + numFeatures*laplace_correction

# Compute class conditional probabilities
ones = matrix(1, 1, numFeatures)
repClassSums = classSums %*% ones;
class_conditionals = (classFeatureCounts + laplace_correction) / repClassSums;

# Compute class priors
class_counts = aggregate(as.vector(C), by=list(as.vector(C)), FUN=length)[,2]
class_prior = class_counts / numRows;

# Compute accuracy on training set
ones = matrix(1, numRows, 1)
D_w_ones = cbind(D, ones)
model = cbind(class_conditionals, class_prior)
log_probs = D_w_ones %*% t(log(model))
pred = max.col(log_probs,ties.method="last");
acc = sum(pred == C) / numRows * 100

print(paste("Training Accuracy (%): ", acc, sep=""))

# write out the model
writeMM(as(class_prior, "CsparseMatrix"), paste(args[4], "prior", sep=""));
writeMM(as(class_conditionals, "CsparseMatrix"), paste(args[4], "conditionals", sep=""));

#-------------------------------------------------------------
#
# Licensed to the Apache Software Foundation (ASF) under one
# or more contributor license agreements.  See the NOTICE file
# distributed with this work for additional information
# regarding copyright ownership.  The ASF licenses this file
# to you under the Apache License, Version 2.0 (the
# "License"); you may not use this file except in compliance
# with the License.  You may obtain a copy of the License at
# 
#   http://www.apache.org/licenses/LICENSE-2.0
# 
# Unless required by applicable law or agreed to in writing,
# software distributed under the License is distributed on an
# "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
# KIND, either express or implied.  See the License for the
# specific language governing permissions and limitations
# under the License.
#
#-------------------------------------------------------------


args <- commandArgs(TRUE)
options(digits=22)

library("Matrix")

X <- readMM(paste(args[1], "X.mtx", sep=""))

type = as.integer(args[2]);

R = X;

if( type==0 ){
  R = as.matrix( sum(X) );
}
if( type==1 ){
  R = round(X);
}
if( type==2 ){
  R = t(X); 
}
if( type==3 ){
  R = X*(X-1);
}
if( type==4 ){
  R = (X-1)*X;
}
if( type==5 ){
  R = X+(X-1);
}
if( type==6 ){
  R = (X-1)+X;
}
if( type==7 ){
  R = X-(X+2);
}
if( type==8 ){
  R = (X+2)-X;
}
if( type==9 ){
  R = X%*%(X-1);
}
if( type==10 ){
  R = (X-1)%*%X;
}
if( type==11 ){
  R = X[1:(nrow(X)-1), 1:(ncol(X)-1)];
}
if( type==12 ){
  X[1,] = X[2,];
  R = X;
}

writeMM(as(R, "CsparseMatrix"), paste(args[3], "R", sep="")); 

#-------------------------------------------------------------
#
# Licensed to the Apache Software Foundation (ASF) under one
# or more contributor license agreements.  See the NOTICE file
# distributed with this work for additional information
# regarding copyright ownership.  The ASF licenses this file
# to you under the Apache License, Version 2.0 (the
# "License"); you may not use this file except in compliance
# with the License.  You may obtain a copy of the License at
# 
#   http://www.apache.org/licenses/LICENSE-2.0
# 
# Unless required by applicable law or agreed to in writing,
# software distributed under the License is distributed on an
# "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
# KIND, either express or implied.  See the License for the
# specific language governing permissions and limitations
# under the License.
#
#-------------------------------------------------------------

# Usage:  R --vanilla --args graphfile G tol 1e-8 maxiter 100 < HITS.R
#parseCommandArgs()
# JUnit test class: dml.test.integration.applications.HITSTest.java
# command line invocation assuming $HITS_HOME is set to the home of the R script
# Rscript $HITS_HOME/HITSTest.R $HITS_HOME/in/ 2 0.000001 $HITS_HOME/expected/

args <- commandArgs(TRUE)
library("Matrix")


maxiter = as.integer(args[2]);
tol = as.double(args[3]);

G = readMM(paste(args[1], "G.mtx", sep=""));
authorities = round(G);
hubs = authorities

#N = nrow(G)
#D = ncol(G)

 
# HITS = power iterations to compute leading left/right singular vectors
 
#authorities = matrix(1.0/N,N,1)
#hubs = matrix(1.0/N,N,1)

converge = FALSE
iter = 0

while(!converge) {
	
	hubs_old = hubs
	hubs = G %*% authorities

	authorities_old = authorities
	authorities = t(G) %*% hubs

	hubs = hubs/max(hubs)
	authorities = authorities/max(authorities)

	delta_hubs = sum((hubs - hubs_old)^2)
	delta_authorities = sum((authorities - authorities_old)^2)

	converge = ((abs(delta_hubs) < tol) & (abs(delta_authorities) < tol) | (iter>maxiter))
	
	iter = iter + 1
	print(paste("Iterations :", iter, " delta_hubs :", delta_hubs, " delta_authorities :", delta_authorities))
}

writeMM(as(hubs,"CsparseMatrix"),paste(args[4], "hubs", sep=""));
writeMM(as(authorities,"CsparseMatrix"),paste(args[4], "authorities",sep=""));

#-------------------------------------------------------------
#
# Licensed to the Apache Software Foundation (ASF) under one
# or more contributor license agreements.  See the NOTICE file
# distributed with this work for additional information
# regarding copyright ownership.  The ASF licenses this file
# to you under the Apache License, Version 2.0 (the
# "License"); you may not use this file except in compliance
# with the License.  You may obtain a copy of the License at
#
#   http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing,
# software distributed under the License is distributed on an
# "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
# KIND, either express or implied.  See the License for the
# specific language governing permissions and limitations
# under the License.
#
#-------------------------------------------------------------

args = commandArgs(TRUE)
options(digits=22)
library("Matrix")

image_transform_linearized = function(img_in, out_w, out_h, a, b, c, d, e, f, fill_value, s_cols, s_rows) {
  divisor = a * e - b * d
  if (divisor == 0) {
    print("Inverse matrix does not exist! Returning input.")
    img_out = img_in
  }
  else {
    orig_w = s_cols
    orig_h = s_rows
    T.inv = matrix(0, nrow=3, ncol=3)
    T.inv[1, 1] = e / divisor
    T.inv[1, 2] = -b / divisor
    T.inv[1, 3] = (b * f - c * e) / divisor
    T.inv[2, 1] = -d / divisor
    T.inv[2, 2] = a / divisor
    T.inv[2, 3] = (c * d - a * f) / divisor
    T.inv[3, 3] = 1

    img_out = matrix(fill_value, nrow=nrow(img_in), ncol=out_w*out_h)
    
    coords = matrix(1, nrow=3, ncol=out_w*out_h)
    coords[1,] = t((seq(0, out_w*out_h-1) %% out_w) + 0.5)
    coords[2,] = t((seq(0, out_w*out_h-1) %/% out_w) + 0.5)
    
    coords = floor(T.inv %*% coords) + 1
    
    inx = coords[1,]
    iny = coords[2,]
    ind = (iny-1)*orig_w + inx

    for (cell in 1:(out_w*out_h)) {
      inxi = coords[1, cell]
      inyi = coords[2, cell]
      indi = ind[cell]
      if ((0 < inxi) & (inxi <= orig_w) & (0 < inyi) & (inyi <= orig_h)) {
        img_out[,cell] = img_in[,indi]
      }
    }
    
    img_out = matrix(img_out, nrow=nrow(img_in), ncol=out_w*out_h)
  }

  img_out
}

input = as.matrix(readMM(paste(args[1], "A.mtx", sep="")))
input = matrix(input, ncol=as.integer(args[3]), nrow=as.integer(args[4]))

transformed = image_transform_linearized(input, as.integer(args[5]), as.integer(args[6]), as.double(args[7]), 
as.double(args[8]), as.double(args[9]), as.double(args[10]), as.double(args[11]), as.double(args[12]), 
as.double(args[13]), as.integer(args[14]),as.integer(args[15]))

writeMM(as(transformed, "CsparseMatrix"), paste(args[2], "B", sep=""))

#-------------------------------------------------------------
#
# Licensed to the Apache Software Foundation (ASF) under one
# or more contributor license agreements.  See the NOTICE file
# distributed with this work for additional information
# regarding copyright ownership.  The ASF licenses this file
# to you under the Apache License, Version 2.0 (the
# "License"); you may not use this file except in compliance
# with the License.  You may obtain a copy of the License at
#
#   http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing,
# software distributed under the License is distributed on an
# "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
# KIND, either express or implied.  See the License for the
# specific language governing permissions and limitations
# under the License.
#
#-------------------------------------------------------------


args <- commandArgs(TRUE)

# Set options for numeric precision
options(digits=22)

# Load required libraries
library("Matrix")
library("matrixStats")

# Read matrix X from Matrix Market format files
X = as.matrix(readMM(paste(args[1], "X.mtx", sep="")))

type = as.integer(args[2])


# Perform the operations
if( type == 1 ) {
    #R = colMeans(X - colMeans(X))
    col_means <- matrix(colMeans(X), nrow = 1)
    # Subtract the row vector from each row of X
    centered_X <- sweep(X, 2, col_means, FUN = "-")
    # Calculate the column means of the centered matrix
    R <- colMeans(centered_X)
} else if ( type == 2) {
    # Compute column means and standard deviations
    col_means <- matrix(colMeans(X), nrow = 1)
    col_sds <- matrix(colSds(X), nrow = 1)
    # Center the matrix by subtracting column means
    centered_X <- sweep(X, 2, col_means, FUN = "-")
    # Scale the centered matrix by dividing by column standard deviations
    scaled_X <- sweep(centered_X, 2, col_sds, FUN = "/")
    # Compute the column means of the scaled matrix
    R <- colMeans(scaled_X)
}

writeMM(as(R, "CsparseMatrix"), paste(args[3], "R", sep=""))

#-------------------------------------------------------------
#
# Licensed to the Apache Software Foundation (ASF) under one
# or more contributor license agreements.  See the NOTICE file
# distributed with this work for additional information
# regarding copyright ownership.  The ASF licenses this file
# to you under the Apache License, Version 2.0 (the
# "License"); you may not use this file except in compliance
# with the License.  You may obtain a copy of the License at
#
#   http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing,
# software distributed under the License is distributed on an
# "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
# KIND, either express or implied.  See the License for the
# specific language governing permissions and limitations
# under the License.
#
#-------------------------------------------------------------

args <- commandArgs(TRUE)
options(digits = 22)
library("Matrix")

reorder_matrix <- function(
  ncolX, B, S) {
  # This function assumes that B and S have same number of elements.
  # if the intercept is included in the model, all inputs should be adjusted
  # appropriately before calling this function.
  S = t(S);
  B = as.matrix(B);
  num_empty_B = ncolX - nrow(B);

  if (num_empty_B < 0) {
    stop("Error: unable to re-order the matrix. Reason: B more than matrix X");
  }

  if (num_empty_B > 0) {
    pad_zeros = matrix(0, nrow = num_empty_B, ncol = 1);
    B = rbind(B, pad_zeros);
    S = rbind(S, pad_zeros);
  }

  S0 = matrix(0, nrow = nrow(S), ncol = ncol(S));
  S0 = S;

  # since the table won't accept zeros as index we hack it.
  for (a in 1:nrow(S)) {
    for (b in 1:ncol(S)) {

      if (S[a, b] == 0) {

        S0[a, b] = ncolX + 1;
      }

    }
  }
  seqS = seq(1, nrow(S0));

  P = matrix(0, nrow = ncolX, ncol = ncolX);

  for (a in 1:ncolX) {
    for (b in 1:ncolX) {

      if (nrow(S0) < b) {

        P[a, b] = 0;
      } else if (seqS[b] > ncolX | S0[b] > ncolX) {
      } else {

        x = seqS[b];
        y = S0[b];
        P[x, y] = 1;
      }
    }
  }

  Y = t(P) %*% B;
  return(Y)
}

thr = 0.001;
intercept_status = 1;
X = as.matrix(readMM(paste(args[1], "A.mtx", sep = "")))
y = as.matrix(readMM(paste(args[1], "B.mtx", sep = "")))

# currently only the forward selection strategy in supported: start from one feature and iteratively add
# features until AIC improves
dir = 0;
stop = 0;
intercept_status = 1;
thr = 0.001;

print("BEGIN STEPWISE LINEAR REGRESSION SCRIPT");
print("Reading X and Y...");
X_orig = X;

n = nrow(X_orig);
m_orig = ncol(X_orig);

# BEGIN STEPWISE LINEAR REGRESSION

if (dir == 0) {
  continue = TRUE;
  columns_fixed = matrix(0, 1, m_orig);
  columns_fixed_ordered = matrix(0, 1, 1);

  # X_global stores the best model found at each step
  X_global = matrix(0, n, 1);

  if (intercept_status == 1 | intercept_status == 2) {
    beta = mean(y);
    AIC_best = 2 + n * log(sum((beta - y) ^ 2) / n);
  } else {
    beta = 0.0;
    AIC_best = n * log(sum(y ^ 2) / n);
  }

  AICs = matrix(t(AIC_best), 1, m_orig);
  
  boa_ncol = ncol(X_orig);
  if (intercept_status != 0) {
    boa_ncol = boa_ncol + 1
  }

  beta_out_all = matrix(0, boa_ncol, m_orig * 1);
  y_ncol = 1;
  column_best = 0;
  
  # First pass to examine single features
  for (i in 1:m_orig) {
    columns_fixed_ordered_1 = as.matrix(i);
    x = as.matrix(X_orig[, i]);
		beta_out_i = as.matrix(lm.fit(x, y)$coefficients)
    
    # COMPUTE AIC
    y_residual = y - x %*% beta_out_i;
    ss_res = sum(y_residual ^ 2);
    eq_deg_of_freedom = ncol(x);
    AIC_1 = (2 * eq_deg_of_freedom) + n * log(ss_res / n);

    AICs[1, i] = AIC_1;
    AIC_cur = AICs[1, i];
    if ((AIC_cur < AIC_best) & ((AIC_best - AIC_cur) > abs(thr * AIC_best))) {
      column_best = i;
      AIC_best = AIC_cur;
    }
    beta_out_all[1:nrow(beta_out_i), ((i - 1) * y_ncol + 1):(i * y_ncol)] = beta_out_i[,1];
  }

  # beta best so far
  beta_best = beta_out_all[, ((column_best - 1) * y_ncol + 1):(column_best * y_ncol)];

  if (column_best == 0) {

    Selected = matrix(0, nrow = 1, ncol = 1);
    if (intercept_status == 0) {
      B = matrix(beta, nrow = m_orig, ncol = 1);
    } else {
      B_tmp = matrix(0, nrow = m_orig + 1, ncol = 1);
      B_tmp[m_orig + 1,] = beta;
      B = B_tmp;
    }

    beta_out = B;
    writeMM(as(beta_out, "CsparseMatrix"), paste(args[2], "C", sep = ""));
    writeMM(as(Selected, "CsparseMatrix"), paste(args[2], "S", sep = ""));

    stop = 1;
  }

  columns_fixed[1, column_best] = 1;
  columns_fixed_ordered[1, 1] = column_best;
  X_global = X_orig[, column_best];

  while (continue) {
    # Subsequent passes over the features

    beta_out_all_2 = matrix(0, boa_ncol, m_orig * 1);

    for (i in 1:m_orig) {
      if (columns_fixed[1, i] == 0) {

        # Construct the feature matrix
        X = cbind(X_global, X_orig[, i]);

        tmp = matrix(0, nrow = 1, ncol = 1);
        tmp[1, 1] = i;
        columns_fixed_ordered_2 = append(columns_fixed_ordered, tmp);


        x = as.matrix(X);
        n = nrow(x);
        m = ncol(x);

        # Introduce the intercept, shift and rescale the columns of X if needed
        if (intercept_status == 1 | intercept_status == 2) {
          # add the intercept column
          ones_n = matrix(1, nrow = n, ncol = 1);
          x = cbind(X_orig[, i], ones_n);
          m = m - 1;
        }

        m_ext = ncol(x);

        # BEGIN THE DIRECT SOLVE ALGORITHM (EXTERNAL CALL)
        beta_out_i = lm.fit(x, y)$coefficients

        # COMPUTE AIC
        y_residual = y - x %*% beta_out_i;
        ss_res = sum(y_residual ^ 2);
        eq_deg_of_freedom = m_ext;
        AIC_2 = (2 * eq_deg_of_freedom) + n * log(ss_res / n);

        b = as.matrix(beta_out_i)
        beta_out_all_2[1:nrow(b), i:i] = b[1, 1];

        if ((AIC_2 < AIC_best) & ((AIC_best - AIC_2) > abs(thr * AIC_best)) & (columns_fixed[1, i] == 0)) {
          column_best = i;
          AIC_best = AIC_2;
        }
      }
    }

    # have the best beta store in the matrix
    beta_best = beta_out_all_2[, ((column_best - 1) * y_ncol + 1):(column_best * y_ncol)];

    # Append best found features (i.e., columns) to X_global
    if (is.null(columns_fixed[1, column_best])) {
      # new best feature found
      columns_fixed[1, column_best] = 1;
      columns_fixed_ordered = cbind(columns_fixed_ordered, as.matrix(column_best));

      if (ncol(columns_fixed_ordered) == m_orig) {
        # all features examined
        X_global = cbind(X_global, X_orig[, column_best]);
        continue = FALSE;
      } else {
        X_global = cbind(X_global, X_orig[, column_best]);
      }
    } else {
      continue = FALSE;
    }
  }

  if (stop == 0) {

    # run linear regression with selected set of features
    print("Running linear regression with selected features...");

    x = as.matrix(X_global);
    n = nrow(x);
    m = ncol(x);

    # Introduce the intercept, shift and rescale the columns of X if needed
    if (intercept_status == 1 | intercept_status == 2) {
      # add the intercept column
      ones_n = matrix(1, nrow = n, ncol = 1);
      x = cbind(X_orig[, i], ones_n);
      m = m - 1;
    }

    m_ext = ncol(x);

    # BEGIN THE DIRECT SOLVE ALGORITHM (EXTERNAL CALL)
    beta_out = lm.fit(x, y)$coefficients

    # COMPUTE AIC
    y_residual = y - x %*% beta_out;
    ss_res = sum(y_residual ^ 2);
    eq_deg_of_freedom = m_ext;
    AIC = (2 * eq_deg_of_freedom) + n * log(ss_res / n);

    Selected = columns_fixed_ordered;
    if (intercept_status != 0) {
      Selected = cbind(Selected, matrix(boa_ncol, nrow = 1, ncol = 1))
    }

    beta_out = reorder_matrix(boa_ncol, beta_out, Selected);

    writeMM(as(beta_out, "CsparseMatrix"), paste(args[2], "C", sep = ""));
    writeMM(as(Selected[1], "CsparseMatrix"), paste(args[2], "S", sep = ""));
  }

} else {
  stop("Currently only forward selection strategy is supported!");
}

#-------------------------------------------------------------
#
# Licensed to the Apache Software Foundation (ASF) under one
# or more contributor license agreements.  See the NOTICE file
# distributed with this work for additional information
# regarding copyright ownership.  The ASF licenses this file
# to you under the Apache License, Version 2.0 (the
# "License"); you may not use this file except in compliance
# with the License.  You may obtain a copy of the License at
#
#   http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing,
# software distributed under the License is distributed on an
# "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
# KIND, either express or implied.  See the License for the
# specific language governing permissions and limitations
# under the License.
#
#-------------------------------------------------------------
args <- commandArgs(TRUE)
library(Matrix)

X = as(readMM(args[1]),"CsparseMatrix")

# (for whatever reason) NaNs are seen as NAs after reading. replace them by zero instead of NAN since resulting NAN
# will be seen as NA after reading it again in test file
X[is.na(X)] = 0.0

writeMM(X, file=args[2])

#-------------------------------------------------------------
#
# Licensed to the Apache Software Foundation (ASF) under one
# or more contributor license agreements.  See the NOTICE file
# distributed with this work for additional information
# regarding copyright ownership.  The ASF licenses this file
# to you under the Apache License, Version 2.0 (the
# "License"); you may not use this file except in compliance
# with the License.  You may obtain a copy of the License at
# 
#   http://www.apache.org/licenses/LICENSE-2.0
# 
# Unless required by applicable law or agreed to in writing,
# software distributed under the License is distributed on an
# "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
# KIND, either express or implied.  See the License for the
# specific language governing permissions and limitations
# under the License.
#
#-------------------------------------------------------------


args <- commandArgs(TRUE)
options(digits=22)

library("Matrix")

A <- readMM(paste(args[1], "A.mtx", sep=""))
B <- readMM(paste(args[1], "B.mtx", sep=""))

type = as.integer(args[2])

if( type == 0 )
{
   C = (A > B)
}
if( type == 1 )
{
   C = (A < B)
}
if( type == 2 )
{
   C = (A == B)
}
if( type == 3 )
{
   C = (A != B)
}
if( type == 4 )
{
   C = (A >= B)
}
if( type == 5 )
{
   C = (A <= B)
}


writeMM(as(C, "CsparseMatrix"), paste(args[3], "C", sep="")); 

#-------------------------------------------------------------
#
# Licensed to the Apache Software Foundation (ASF) under one
# or more contributor license agreements.  See the NOTICE file
# distributed with this work for additional information
# regarding copyright ownership.  The ASF licenses this file
# to you under the Apache License, Version 2.0 (the
# "License"); you may not use this file except in compliance
# with the License.  You may obtain a copy of the License at
# 
#   http://www.apache.org/licenses/LICENSE-2.0
# 
# Unless required by applicable law or agreed to in writing,
# software distributed under the License is distributed on an
# "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
# KIND, either express or implied.  See the License for the
# specific language governing permissions and limitations
# under the License.
#
#-------------------------------------------------------------
args <- commandArgs(TRUE)
library("Matrix")
library("matrixStats") 

imgSize=8
numImg=16
numChannels=4
poolSize1=imgSize*imgSize
poolSize2=1
stride=1
pad=0

X = matrix(seq(1, numImg*numChannels*imgSize*imgSize), numImg, numChannels*imgSize*imgSize, byrow=TRUE)
X = X - rowMeans(X)

pad_image <- function(img, Hin, Win, padh, padw){
  C = nrow(img)
  img_padded = matrix(0, C, (Hin+2*padh)*(Win+2*padw))  # zeros
  for (c in 1:C) {
    img_slice = matrix(img[c,], Hin, Win, byrow=TRUE)  # depth slice C reshaped
    img_padded_slice = matrix(0, Hin+2*padh, Win+2*padw)
    img_padded_slice[(padh+1):(padh+Hin), (padw+1):(padw+Win)] = img_slice
    img_padded[c,] = matrix(t(img_padded_slice), 1, (Hin+2*padh)*(Win+2*padw))  # reshape
  }
  img_padded
}

im2col <- function(img, Hin, Win, Hf, Wf, strideh, stridew) {
  C = nrow(img)
  Hout = as.integer((Hin - Hf) / strideh + 1)
  Wout = as.integer((Win - Wf) / stridew + 1)

  img_cols = matrix(0, C*Hf*Wf, Hout*Wout, byrow=TRUE)  # zeros
  for (hout in 1:Hout) {  # all output rows
    hin = (hout-1) * strideh + 1
    for (wout in 1:Wout) {  # all output columns
      win = (wout-1) * stridew + 1
      # Extract a local patch of the input image corresponding spatially to the filter sizes.
      img_patch = matrix(0, C, Hf*Wf, byrow=TRUE)  # zeros
      for (c in 1:C) {  # all channels
        img_slice = matrix(img[c,], Hin, Win, byrow=TRUE)  # reshape
        img_patch[c,] = matrix(t(img_slice[hin:(hin+Hf-1), win:(win+Wf-1)]), 1, Hf*Wf)
      }
      img_cols[,(hout-1)*Wout + wout] = matrix(t(img_patch), C*Hf*Wf, 1)  # reshape
    }
  }
  img_cols
}

max_pool <- function(X, N, C, Hin, Win, Hf, Wf,
                   strideh, stridew) {
  Hout = as.integer((Hin - Hf) / strideh + 1)
  Wout = as.integer((Win - Wf) / stridew + 1)

  # Create output volume
  out = matrix(0, N, C*Hout*Wout, byrow=TRUE)

  # Max pooling - im2col implementation
  for (n in 1:N) {  # all examples
    img = matrix(X[n,], C, Hin*Win, byrow=TRUE)  # reshape
    img_maxes = matrix(0, C, Hout*Wout, byrow=TRUE)  # zeros

    for (c in 1:C) {  # all channels
      # Extract local image slice patches into columns with im2col, of shape (Hf*Wf, Hout*Wout)
      img_slice_cols = im2col(matrix(t(img[c,]), 1, Hin*Win) , Hin, Win, Hf, Wf, strideh, stridew)

      # Max pooling on patches
      img_maxes[c,] = colMaxs(img_slice_cols)
    }

    out[n,] = matrix(t(img_maxes), 1, C*Hout*Wout)
  }
  
  out
}

R = max_pool(X, numImg, numChannels, imgSize*imgSize, 1, poolSize1, poolSize2, stride, stride)
R = R + 7;

writeMM(as(R,"CsparseMatrix"), paste(args[2], "S", sep=""))

#-------------------------------------------------------------
#
# Licensed to the Apache Software Foundation (ASF) under one
# or more contributor license agreements.  See the NOTICE file
# distributed with this work for additional information
# regarding copyright ownership.  The ASF licenses this file
# to you under the Apache License, Version 2.0 (the
# "License"); you may not use this file except in compliance
# with the License.  You may obtain a copy of the License at
#
#   http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing,
# software distributed under the License is distributed on an
# "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
# KIND, either express or implied.  See the License for the
# specific language governing permissions and limitations
# under the License.
#
#-------------------------------------------------------------
args <- commandArgs(TRUE)
library("Matrix")

D <- as.matrix(readMM(paste(args[1], "X.mtx", sep="")))
c <- as.matrix(readMM(paste(args[1], "Y.mtx", sep="")))

nClasses <- as.integer(max(c))
varSmoothing <- as.double(args[2])

nSamples <- nrow(D)
nFeatures <- ncol(D)

classInvCovariances <- list()

classMeans <- aggregate(D, by=list(c), FUN= mean)
classMeans <- classMeans[1:nFeatures+1]

classVars <- aggregate(D, by=list(c), FUN=var)
classVars[is.na(classVars)] <- 0
smoothedVar <- varSmoothing * max(classVars) * diag(nFeatures)

classCounts <- aggregate(c, by=list(c), FUN=length)
classCounts <- classCounts[2]
classPriors <- classCounts / nSamples

determinants <- matrix(0, nrow=nClasses, ncol=1)

for (i in 1:nClasses)
{
  classMatrix <- subset(D, c==i)
  covMatrix <- cov(x=classMatrix, use="all.obs")
  covMatrix[is.na(covMatrix)] <- 0
  covMatrix <- covMatrix + smoothedVar
  #determinant <- det(covMatrix)
  #determinants[i] <- det(covMatrix)

  ev <- eigen(covMatrix)
  vecs <- ev$vectors
  vals <- ev$values
  lam <- diag(vals^(-1))
  determinants[i] <- prod(vals)

  invCovMatrix <- vecs %*% lam %*% t(vecs)
  invCovMatrix[is.na(invCovMatrix)] <- 0
  classInvCovariances[[i]] <- invCovMatrix
}


#Calc accuracy
results <- matrix(0, nrow=nSamples, ncol=nClasses)
for (class in 1:nClasses)
{
  for (i in 1:nSamples)
  {
    intermediate <- 0
    meanDiff <- (D[i,] - classMeans[class,])
    intermediate <- -1/2 * log((2*pi)^nFeatures * determinants[class,])
    intermediate <- intermediate - 1/2 * (as.matrix(meanDiff) %*% as.matrix(classInvCovariances[[class]]) 
    %*% t(as.matrix(meanDiff)))
    intermediate <- log(classPriors[class,]) + intermediate
    results[i, class] <- intermediate
  }
}

pred <- max.col(results)
acc <- sum(pred == c) / nSamples * 100
print(paste("Training Accuracy (%): ", acc, sep=""))

classPriors <- data.matrix(classPriors)
classMeans <- data.matrix(classMeans)

#Cbind the inverse covariance matrices, to make them comparable in the unit tests
stackedInvCovs <- classInvCovariances[[1]]
for (i in 2:nClasses)
{
  stackedInvCovs <- cbind(stackedInvCovs, classInvCovariances[[i]])
}

writeMM(as(classPriors, "CsparseMatrix"), paste(args[3], "priors", sep=""));
writeMM(as(classMeans, "CsparseMatrix"), paste(args[3], "means", sep=""));
writeMM(as(determinants, "CsparseMatrix"), paste(args[3], "determinants", sep=""));
writeMM(as(stackedInvCovs, "CsparseMatrix"), paste(args[3], "invcovs", sep=""));

#-------------------------------------------------------------
#
# Licensed to the Apache Software Foundation (ASF) under one
# or more contributor license agreements.  See the NOTICE file
# distributed with this work for additional information
# regarding copyright ownership.  The ASF licenses this file
# to you under the Apache License, Version 2.0 (the
# "License"); you may not use this file except in compliance
# with the License.  You may obtain a copy of the License at
# 
#   http://www.apache.org/licenses/LICENSE-2.0
# 
# Unless required by applicable law or agreed to in writing,
# software distributed under the License is distributed on an
# "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
# KIND, either express or implied.  See the License for the
# specific language governing permissions and limitations
# under the License.
#
#-------------------------------------------------------------

bivar_ss = function(X, Y) {

    # Unweighted co-variance
    covXY = cov(X,Y)

    # compute standard deviations for both X and Y by computing 2^nd central moment
    m2X = var(X)
    m2Y = var(Y)
    sigmaX = sqrt(m2X)
    sigmaY = sqrt(m2Y)

    # Pearson's R
    R = covXY / (sigmaX*sigmaY)

    return(list("R" = R, "covXY" = covXY, "sigmaX" = sigmaX, "sigmaY" = sigmaY))
}

# -----------------------------------------------------------------------------------------------------------

bivar_cc = function(A, B) {

    # Contingency Table
    F = table(A,B)
    
    # Chi-Squared
    cst = chisq.test(F)

    r = rowSums(F)
    c = colSums(F)
    
    chi_squared = as.numeric(cst[1])

    # compute p-value
    pValue = as.numeric(cst[3])

    # Assign return values
    pval = pValue
    contingencyTable = F
    rowMarginals = r
    colMarginals = c

    return(list("pval" = pval, "contingencyTable" = contingencyTable, "rowMarginals" = rowMarginals, "colMarginals" = colMarginals))
}

# -----------------------------------------------------------------------------------------------------------

# Y points to SCALE variable
# A points to CATEGORICAL variable
bivar_sc = function(Y, A) {
    # mean and variance in target variable
    W = length(A)
    my = mean(Y)
    varY = var(Y)

    # category-wise (frequencies, means, variances)
    CFreqs = as.matrix(table(A)) 

    CMeans = as.matrix(aggregate(Y, by=list(A), "mean")$x)

    CVars = as.matrix(aggregate(Y, by=list(A), "var")$x)
    CVars[is.na(CVars)] <- 0

    # number of categories
    R = nrow(CFreqs)
    df1 = R-1
    df2 = W-R

    anova_num = sum( (CFreqs*(CMeans-my)^2) )/(R-1)
    anova_den = sum( (CFreqs-1)*CVars )/(W-R)
    AnovaF = anova_num/anova_den
    pVal = 1-pf(AnovaF, df1, df2)

    return(list("pVal" = pVal, "CFreqs" = CFreqs, "CMeans" = CMeans, "CVars" = CVars))
}

# Main starts here -----------------------------------------------------------------------------------------------------------

args <- commandArgs(TRUE)

library(Matrix)

# input data set
D = as.matrix(readMM(paste(args[1], "X.mtx", sep="")));

# label attr id (must be a valid index > 0)  
label_index = as.integer(args[2])

# feature attributes, column vector of indices
feature_indices = as.matrix(readMM(paste(args[1], "feature_indices.mtx", sep=""))) 

# can be either 1 (scale) or 0 (categorical)
label_measurement_level = as.integer(args[3]) 

# measurement levels for features, 0/1 column vector
feature_measurement_levels = as.matrix(readMM(paste(args[1], "feature_measurement_levels.mtx", sep=""))) 

sz = ncol(D)

# store for pvalues and pearson's r
stats = matrix(0, sz, 1)
# store for type of test performed: 1 is chi-sq, 2 is ftest, 3 is pearson's
tests = matrix(0, sz, 1)
# store for covariances used to compute pearson's r
covariances = matrix(0, sz, 1)
# store for standard deviations used to compute pearson's r
standard_deviations = matrix(0, sz, 1)

labels = D[,label_index]

labelCorrection = 0
if(label_measurement_level == 1){
	numLabels = length(labels)
        cmLabels = var(labels)
    	stdLabels = sqrt(cmLabels)
	standard_deviations[label_index,1] = stdLabels
}else{
	labelCorrection = 1 - min(labels)
	labels = labels + labelCorrection
}

mx = apply(D, 2, max)
mn = apply(D, 2, min)	
num_distinct_values = mx-mn+1
max_num_distinct_values = 0
for(i1 in 1:nrow(feature_indices)){
	feature_index1 = feature_indices[i1,1]
	num = num_distinct_values[feature_index1]
	if(feature_measurement_levels[i1,1] == 0 & num >= max_num_distinct_values){
		max_num_distinct_values = num
	}
}
distinct_label_values = matrix(0, 1, 1)	
contingencyTableSz = 1
maxNumberOfGroups = 1
if(max_num_distinct_values != 0){
	maxNumberOfGroups = max_num_distinct_values
}
if(label_measurement_level==0){
	distinct_label_values = as.data.frame(table(labels))$Freq
	if(max_num_distinct_values != 0){
		contingencyTableSz = max_num_distinct_values*length(distinct_label_values)
	}
	maxNumberOfGroups = max(maxNumberOfGroups, length(distinct_label_values))
}
# store for contingency table cell values
contingencyTablesCounts = matrix(0, sz, contingencyTableSz)
# store for contingency table label(row) assignments
contingencyTablesLabelValues = matrix(0, sz, contingencyTableSz)
# store for contingency table feature(col) assignments
contingencyTablesFeatureValues = matrix(0, sz, contingencyTableSz)
# store for distinct values
featureValues = matrix(0, sz, maxNumberOfGroups)
# store for counts of distinct values
featureCounts = matrix(0, sz, maxNumberOfGroups)
# store for group means
featureMeans = matrix(0, sz, maxNumberOfGroups)
# store for group standard deviations
featureSTDs = matrix(0, sz, maxNumberOfGroups)

if(label_measurement_level == 0){
	featureCounts[label_index,1:length(distinct_label_values)] = distinct_label_values
	featureValues[label_index,1:length(distinct_label_values)] = t(seq(1,length(distinct_label_values))-labelCorrection);
}

for(i3 in 1:nrow(feature_indices)){
	feature_index2 = feature_indices[i3,1]
	feature_measurement_level = feature_measurement_levels[i3,1]
	
	feature = D[,feature_index2]
	
	if(feature_measurement_level == 0){
		featureCorrection = 1 - min(feature)
		feature = feature + featureCorrection
			
		if(label_measurement_level == feature_measurement_level){
		  # categorical-categorical
		  tests[feature_index2,1] = 1

		  ret = bivar_cc(labels, feature)
                  pVal = ret$pval
                  contingencyTable = ret$contingencyTable
                  rowMarginals = ret$rowMarginals
                  colMarginals = ret$colMarginals

		  stats[feature_index2,1] = pVal
			
		  sz3 = nrow(contingencyTable)*ncol(contingencyTable)
			
			tmpLV = (seq(1,nrow(contingencyTable)) %*% matrix(1,1,ncol(contingencyTable))) - labelCorrection;
			tmpFV = (matrix(1,nrow(contingencyTable),1) %*% t(seq(1,ncol(contingencyTable)))) - featureCorrection;
			contingencyTableLabelValues = matrix(tmpLV, 1, sz3, byrow=TRUE);
			contingencyTableFeatureValues = matrix(tmpFV, 1, sz3, byrow=TRUE);
			
			contingencyTableCounts = matrix(contingencyTable, 1, sz3, byrow=TRUE);
			contingencyTablesCounts[feature_index2,1:sz3] = contingencyTableCounts
            
			contingencyTablesLabelValues[feature_index2,1:sz3] = contingencyTableLabelValues
			contingencyTablesFeatureValues[feature_index2,1:sz3] = contingencyTableFeatureValues
			
			featureCounts[feature_index2,1:length(colMarginals)] = colMarginals
			featureValues[feature_index2,1:length(colMarginals)] = t(seq(1,length(colMarginals)) - featureCorrection);
		}else{
			# label is scale, feature is categorical
			tests[feature_index2,1] = 2
			
			ret = bivar_sc(labels, feature)
                  pVal = ret$pVal
                  frequencies = ret$CFreqs
                  means = ret$CMeans
                  variances = ret$CVars

			stats[feature_index2,1] = pVal
			featureCounts[feature_index2,1:nrow(frequencies)] = t(frequencies)
			featureValues[feature_index2,1:nrow(frequencies)] = t(seq(1,nrow(frequencies)) - featureCorrection)
			featureMeans[feature_index2,1:nrow(means)] = t(means)
			featureSTDs[feature_index2,1:nrow(variances)] = t(sqrt(variances))
		}
	}else{
		if(label_measurement_level == feature_measurement_level){
		  # scale-scale
		  tests[feature_index2,1] = 3

		  ret = bivar_ss(labels, feature)
                  r = ret$R
                  covariance = ret$covXY
                  stdX = ret$sigmaX
                  stdY = ret$sigmaY
 
		  stats[feature_index2,1] = r
		  covariances[feature_index2,1] = covariance
		  standard_deviations[feature_index2,1] = stdY
		}else{
		  # label is categorical, feature is scale
		  tests[feature_index2,1] = 2
			
		  ret = bivar_sc(feature, labels)
		  pVal = ret$pVal
		  frequencies = ret$CFreqs
                  means = ret$CMeans
		  variances = ret$CVars
			
		  stats[feature_index2,1] = pVal
		  featureMeans[feature_index2,1:nrow(means)] = t(means)
		  featureSTDs[feature_index2,1:nrow(variances)] = t(sqrt(variances))
		}
	}
}

writeMM(as(stats, "CsparseMatrix"), paste(args[4], "stats", sep=""))
writeMM(as(tests, "CsparseMatrix"), paste(args[4], "tests", sep=""))
writeMM(as(covariances, "CsparseMatrix"), paste(args[4], "covariances", sep=""))
writeMM(as(standard_deviations, "CsparseMatrix"), paste(args[4], "standard_deviations", sep=""))
writeMM(as(contingencyTablesCounts, "CsparseMatrix"), paste(args[4], "contingencyTablesCounts", sep=""))
writeMM(as(contingencyTablesLabelValues, "CsparseMatrix"), paste(args[4], "contingencyTablesLabelValues", sep=""))
writeMM(as(contingencyTablesFeatureValues, "CsparseMatrix"), paste(args[4], "contingencyTablesFeatureValues", sep=""))
writeMM(as(featureValues, "CsparseMatrix"), paste(args[4], "featureValues", sep=""))
writeMM(as(featureCounts, "CsparseMatrix"), paste(args[4], "featureCounts", sep=""))
writeMM(as(featureMeans, "CsparseMatrix"), paste(args[4], "featureMeans", sep=""))
writeMM(as(featureSTDs, "CsparseMatrix"), paste(args[4], "featureSTDs", sep=""))

#-------------------------------------------------------------
#
# Licensed to the Apache Software Foundation (ASF) under one
# or more contributor license agreements.  See the NOTICE file
# distributed with this work for additional information
# regarding copyright ownership.  The ASF licenses this file
# to you under the Apache License, Version 2.0 (the
# "License"); you may not use this file except in compliance
# with the License.  You may obtain a copy of the License at
# 
#   http://www.apache.org/licenses/LICENSE-2.0
# 
# Unless required by applicable law or agreed to in writing,
# software distributed under the License is distributed on an
# "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
# KIND, either express or implied.  See the License for the
# specific language governing permissions and limitations
# under the License.
#
#-------------------------------------------------------------


args <- commandArgs(TRUE)
options(digits=22)

library("Matrix")

V1 <- readMM(paste(args[1], "V.mtx", sep=""))
V <- as.matrix(V1);
m <- nrow(V); 
n <- ncol(V); 

R1 <- matrix(0,m,n);
R2 <- matrix(0,m,n);
R3 <- matrix(0,m,n);
R4 <- matrix(0,m,n);
R5 <- matrix(0,m,n);
R6 <- matrix(0,m,n);
R7 <- matrix(0,m,n);
R8 <- matrix(0,m,n);
R9 <- matrix(0,m,n);
R10 <- matrix(0,m,n);
R11 <- matrix(0,m,n);
R12 <- matrix(0,m,n);
R13 <- matrix(0,m,n);
R14 <- matrix(0,m,n);
R15 <- matrix(0,m,n);
R16 <- matrix(0,m,n);
R17 <- matrix(0,m,n);
R18 <- matrix(0,m,n);
R19 <- matrix(0,m,n);
R20 <- matrix(0,m,n);
R21 <- matrix(0,m,n);
R22 <- matrix(0,m,n);
R23 <- matrix(0,m,n);
R24 <- matrix(0,m,n);
R25 <- matrix(0,m,n);
R26 <- matrix(0,m,n);
R27 <- matrix(0,m,n);
R28 <- matrix(0,m,n);
R29 <- matrix(0,m,n);
R30 <- matrix(0,m,n);
R31 <- matrix(0,m,n);
R32 <- matrix(0,m,n);

for( i in 1:n )
{
   X <- V[,i];
   R1[,i] <- X;
   R2[,i] <- X;
   R3[,i] <- X;
   R4[,i] <- X;
   R5[,i] <- X;
   R6[,i] <- X;
   R7[,i] <- X;
   R8[,i] <- X;
   R9[,i] <- X;
   R10[,i] <- X;
   R11[,i] <- X;
   R12[,i] <- X;
   R13[,i] <- X;
   R14[,i] <- X;
   R15[,i] <- X;
   R16[,i] <- X;
   R17[,i] <- X;
   R18[,i] <- X;
   R19[,i] <- X;
   R20[,i] <- X;
   R21[,i] <- X;
   R22[,i] <- X;
   R23[,i] <- X;
   R24[,i] <- X;
   R25[,i] <- X;
   R26[,i] <- X;
   R27[,i] <- X;
   R28[,i] <- X;
   R29[,i] <- X;
   R30[,i] <- X;
   R31[,i] <- X;
   R32[,i] <- X;
}   

R <- R1 + R2 + R3 + R4 + R5 + R6 + R7 + R8 + R9 + R10 + R11 + R12 + R13 + R14 + R15 + R16 + R17 + R18 + R19 + R20 + R21 + R22 + R23 + R24 + R25 + R26 + R27 + R28 + R29 + R30 + R31 + R32; 
writeMM(as(R, "CsparseMatrix"), paste(args[2], "Rout", sep=""));

#-------------------------------------------------------------
#
# Licensed to the Apache Software Foundation (ASF) under one
# or more contributor license agreements.  See the NOTICE file
# distributed with this work for additional information
# regarding copyright ownership.  The ASF licenses this file
# to you under the Apache License, Version 2.0 (the
# "License"); you may not use this file except in compliance
# with the License.  You may obtain a copy of the License at
# 
#   http://www.apache.org/licenses/LICENSE-2.0
# 
# Unless required by applicable law or agreed to in writing,
# software distributed under the License is distributed on an
# "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
# KIND, either express or implied.  See the License for the
# specific language governing permissions and limitations
# under the License.
#
#-------------------------------------------------------------


args <- commandArgs(TRUE)
options(digits=22)

library("Matrix")

rlen = as.integer(args[1]);
clen = as.integer(args[2]);

R = matrix(ifelse(as.logical(args[3]), 7, 0), rlen, clen);
if( as.logical(args[4]) ) {
   R[,50:300] = matrix(0, rlen, 251);
}
for(i in 1:10) {
   R = R + matrix(i, rlen, clen);
}

writeMM(as(R, "CsparseMatrix"), paste(args[5], "R", sep=""));

#-------------------------------------------------------------
#
# Licensed to the Apache Software Foundation (ASF) under one
# or more contributor license agreements.  See the NOTICE file
# distributed with this work for additional information
# regarding copyright ownership.  The ASF licenses this file
# to you under the Apache License, Version 2.0 (the
# "License"); you may not use this file except in compliance
# with the License.  You may obtain a copy of the License at
# 
#   http://www.apache.org/licenses/LICENSE-2.0
# 
# Unless required by applicable law or agreed to in writing,
# software distributed under the License is distributed on an
# "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
# KIND, either express or implied.  See the License for the
# specific language governing permissions and limitations
# under the License.
#
#-------------------------------------------------------------


args <- commandArgs(TRUE)
options(digits=22)

library("Matrix")


D1 <- readMM(paste(args[1], "D.mtx", sep=""))
S11 <- readMM(paste(args[1], "S1.mtx", sep=""))
S21 <- readMM(paste(args[1], "S2.mtx", sep=""))
K11 <- readMM(paste(args[1], "K1.mtx", sep=""))
K21 <- readMM(paste(args[1], "K2.mtx", sep=""))
D <- as.matrix(D1);
S1 <- as.matrix(S11);
S2 <- as.matrix(S21);
K1 <- as.matrix(K11);
K2 <- as.matrix(K21);

numPairs <- ncol(S1) * ncol(S2); # number of attribute pairs (|S1|*|S2|)
maxC <- args[2]; # max number of categories in any categorical attribute

s1size <- ncol(S1);
s2size <- ncol(S2);

# R, chisq, cramers, spearman, eta, anovaf
numstats <- 8;
basestats <- array(0,dim=c(numstats,numPairs)); 
cat_counts <- array(0,dim=c(maxC,numPairs)); 
cat_means <- array(0,dim=c(maxC,numPairs));
cat_vars <- array(0,dim=c(maxC,numPairs));


for( i in 1:s1size ) { 
    a1 <- S1[,i];
    k1 <- K1[1,i];
    A1 <- as.matrix(D[,a1]);

    for( j in 1:s2size ) {
        pairID <-(i-1)*s2size+j;
        a2 <- S2[,j];
        k2 <- K2[1,j];
        A2 <- as.matrix(D[,a2]);
    
        if (k1 == k2) {
            if (k1 == 1) {   
                # scale-scale
                print("scale-scale");
                basestats[1,pairID] <- cor(D[,a1], D[,a2]);
                #basestats[1,pairID] <- cor(A1, A2);
                
                print(basestats[1,pairID]);
            } else {
                # nominal-nominal or ordinal-ordinal
                print("categorical-categorical");
                F <- table(A1,A2);
                cst <- chisq.test(F);
                chi_squared <- as.numeric(cst[1]);
                degFreedom <- (nrow(F)-1)*(ncol(F)-1);
                pValue <- as.numeric(cst[3]);
                q <- min(dim(F));
                W <- sum(F);
                cramers_v <- sqrt(chi_squared/(W*(q-1)));

                basestats[2,pairID] <- chi_squared;
                basestats[3,pairID] <- degFreedom;
                basestats[4,pairID] <- pValue;
                basestats[5,pairID] <- cramers_v;

                if ( k1 == 3 ) {
                    # ordinal-ordinal   
                    print("ordinal-ordinal");
                    basestats[6,pairID] <- cor(A1,A2, method="spearman");
                }
            }
        } 
        else {       
            if (k1 == 1 || k2 == 1) {    
                # Scale-nominal/ordinal
                print("scale-categorical");
                if ( k1 == 1 ) {
                    Av <- as.matrix(A2); 
                    Yv <- as.matrix(A1); 
                }
                else {
                    Av <- as.matrix(A1); 
                    Yv <- as.matrix(A2); 
                }
                
                W <- nrow(Av);
                my <- mean(Yv); 
                varY <- var(Yv);
                
                CFreqs <- as.matrix(table(Av)); 
                CMeans <- as.matrix(aggregate(Yv, by=list(Av), "mean")$V1);
                CVars <- as.matrix(aggregate(Yv, by=list(Av), "var")$V1);
                R <- nrow(CFreqs);
              
                Eta <- sqrt(1 - ( sum((CFreqs-1)*CVars) / ((W-1)*varY) ));
                anova_num <- sum( (CFreqs*(CMeans-my)^2) )/(R-1);
                anova_den <- sum( (CFreqs-1)*CVars )/(W-R);
                ANOVAF <- anova_num/anova_den;

                basestats[7,pairID] <- Eta;
                basestats[8,pairID] <- ANOVAF;

                cat_counts[ 1:length(CFreqs),pairID] <- CFreqs;
                cat_means[ 1:length(CMeans),pairID] <- CMeans;
                cat_vars[ 1:length(CVars),pairID] <- CVars;
            }
            else {
                # nominal-ordinal or ordinal-nominal    
                print("nomial-ordinal"); #TODO should not be same code            
                F <- table(A1,A2);
                cst <- chisq.test(F);
                chi_squared <- as.numeric(cst[1]);
                degFreedom <- (nrow(F)-1)*(ncol(F)-1);
                pValue <- as.numeric(cst[3]);
                q <- min(dim(F));
                W <- sum(F);
                cramers_v <- sqrt(chi_squared/(W*(q-1)));
                
                basestats[2,pairID] <- chi_squared;
                basestats[3,pairID] <- degFreedom;
                basestats[4,pairID] <- pValue;
                basestats[5,pairID] <- cramers_v;
            }
        }
    }
}

writeMM(as(basestats, "CsparseMatrix"), paste(args[3], "bivar.stats", sep=""));
writeMM(as(cat_counts, "CsparseMatrix"), paste(args[3], "category.counts", sep=""));
writeMM(as(cat_means, "CsparseMatrix"), paste(args[3], "category.means", sep=""));
writeMM(as(cat_vars, "CsparseMatrix"), paste(args[3], "category.variances", sep=""));

#-------------------------------------------------------------
#
# Licensed to the Apache Software Foundation (ASF) under one
# or more contributor license agreements.  See the NOTICE file
# distributed with this work for additional information
# regarding copyright ownership.  The ASF licenses this file
# to you under the Apache License, Version 2.0 (the
# "License"); you may not use this file except in compliance
# with the License.  You may obtain a copy of the License at
# 
#   http://www.apache.org/licenses/LICENSE-2.0
# 
# Unless required by applicable law or agreed to in writing,
# software distributed under the License is distributed on an
# "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
# KIND, either express or implied.  See the License for the
# specific language governing permissions and limitations
# under the License.
#
#-------------------------------------------------------------

args<-commandArgs(TRUE)
options(digits=22)
library("Matrix")

X = matrix( 3, 4000, 2000)
U = matrix( 4, 4000, 10)
V = matrix( 5, 2000, 10)
eps = 0.1
S= (X/(U%*%t(V)))%*%V
writeMM(as(S, "CsparseMatrix"), paste(args[2], "S", sep="")); 
 

#-------------------------------------------------------------
#
# Licensed to the Apache Software Foundation (ASF) under one
# or more contributor license agreements.  See the NOTICE file
# distributed with this work for additional information
# regarding copyright ownership.  The ASF licenses this file
# to you under the Apache License, Version 2.0 (the
# "License"); you may not use this file except in compliance
# with the License.  You may obtain a copy of the License at
# 
#   http://www.apache.org/licenses/LICENSE-2.0
# 
# Unless required by applicable law or agreed to in writing,
# software distributed under the License is distributed on an
# "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
# KIND, either express or implied.  See the License for the
# specific language governing permissions and limitations
# under the License.
#
#-------------------------------------------------------------


args <- commandArgs(TRUE)
options(digits=22)

library("Matrix")

A <- as.matrix(readMM(paste(args[1], "A.mtx", sep="")))

#without weights (assumes weights of 1)
m = nrow(A);
S = sort(A)
q25d=m*0.25
q75d=m*0.75
q25i=ceiling(q25d)
q75i=ceiling(q75d)
iqm = sum(S[(q25i+1):q75i])
iqm = iqm + (q25i-q25d)*S[q25i] - (q75i-q75d)*S[q75i]
iqm = iqm/(m*0.5)

miqm = as.matrix(iqm);

writeMM(as(miqm, "CsparseMatrix"), paste(args[3], "R", sep="")); 

#-------------------------------------------------------------
#
# Licensed to the Apache Software Foundation (ASF) under one
# or more contributor license agreements.  See the NOTICE file
# distributed with this work for additional information
# regarding copyright ownership.  The ASF licenses this file
# to you under the Apache License, Version 2.0 (the
# "License"); you may not use this file except in compliance
# with the License.  You may obtain a copy of the License at
#
#   http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing,
# software distributed under the License is distributed on an
# "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
# KIND, either express or implied.  See the License for the
# specific language governing permissions and limitations
# under the License.
#
#-------------------------------------------------------------
library("Matrix")
args <- commandArgs(TRUE)

fStat_tailprob = function(fStat, df_1, df_2){
 rows = nrow(fStat)
 if(is.null(rows)){
   rows = 1
   fStat = t(matrix(fStat))
 }

 cols = ncol(fStat)
 if(is.null(cols))
    cols = length(fStat)

 if(is.null(nrow(df_1)))
    df_1 = t(matrix(df_1))

 if(is.null(nrow(df_2)))
    df_2 = t(matrix(df_2))

 tailprob = fStat
 for (i in 1:rows) {
   for (j in 1:cols) {
     q = fStat[i, j]
     d1 = df_1[i, j]
     d2 = df_2[i, j]
     if (d1 >= 1 & d2 >= 1 & q >= 0)
        tailprob[i, j] = pf(q, df1 = d1, df2 = d2, lower.tail=FALSE)
      else
        tailprob[i, j] = 0/0
    }
   }
   return(tailprob)
}

sqrt_failsafe = function(input_A){
 mask_A = (input_A >= 0)
 prep_A = input_A * mask_A
 mask_A = mask_A * (prep_A == prep_A)
 #prep_A = replace (target = prep_A, pattern = NaN, replacement = 0)
 output_A = sqrt (prep_A) / mask_A
 return(output_A)
}




stratum_column_id = 1
XwithNaNs = readMM(args[1])
YwithNaNs = XwithNaNs
SwithNaNs = XwithNaNs[, stratum_column_id]
Xcols = c(1:ncol(XwithNaNs))
Ycols = c(1:ncol(YwithNaNs))

num_records  = nrow(XwithNaNs)
num_attrs    = ncol(XwithNaNs)
num_attrs_X  = length(Xcols)
num_attrs_Y  = length(Ycols)
num_attrs_XY = num_attrs_X * num_attrs_Y

one_to_num_attrs_X = c(1:num_attrs_X)
one_to_num_attrs_Y = c(1:num_attrs_Y)
ProjX = matrix(0, nrow = num_attrs, ncol = num_attrs_X)
ProjY = matrix(0, nrow = num_attrs, ncol = num_attrs_Y)

ProjX_ctable = table(t(Xcols), one_to_num_attrs_X)
ProjX[1:nrow(ProjX_ctable), ] = ProjX_ctable
ProjY_ctable = table(t(Ycols), one_to_num_attrs_Y)
ProjY[1:nrow(ProjY_ctable), ] = ProjY_ctable

X = XwithNaNs %*% ProjX
Y = XwithNaNs %*% ProjY
S = round(SwithNaNs) * (SwithNaNs > 0)

Proj_good_stratumID = diag(S > 0)
Proj_good_stratumID = Proj_good_stratumID[rowSums(Proj_good_stratumID[])>0,]
vector_of_good_stratumIDs = Proj_good_stratumID %*% S
vector_of_good_stratumIDs = vector_of_good_stratumIDs + (1 - min(vector_of_good_stratumIDs))
num_records_with_good_stratumID = nrow(Proj_good_stratumID)
if (is.null(num_records_with_good_stratumID))
    num_records_with_good_stratumID = 1
one_to_num_records_with_good_stratumID = seq(1,num_records_with_good_stratumID,by=1)

num_strata_with_empty = max(vector_of_good_stratumIDs)
StrataSummator_with_empty = table(vector_of_good_stratumIDs, one_to_num_records_with_good_stratumID)
StrataSummator = StrataSummator_with_empty[rowSums(StrataSummator_with_empty[])>0,]
StrataSummator = StrataSummator %*% Proj_good_stratumID
num_strata = nrow(StrataSummator)
num_empty_strata = num_strata_with_empty - num_strata

XNaNmask = (XwithNaNs == XwithNaNs)
YNaNmask = (YwithNaNs == YwithNaNs)
X_mask = XNaNmask %*% ProjX
Y_mask = YNaNmask %*% ProjY

cnt_X_global = colSums(X_mask)
cnt_Y_global = colSums(Y_mask)
avg_X_global = colSums(X) / cnt_X_global
avg_Y_global = colSums(Y) / cnt_Y_global
var_sumX_global = colSums (X * X) - cnt_X_global * (avg_X_global * avg_X_global)
var_sumY_global = colSums (Y * Y) - cnt_Y_global * (avg_Y_global * avg_Y_global)
sqrt_failsafe_input_1 = var_sumX_global / (cnt_X_global - 1)
stdev_X_global = sqrt_failsafe (sqrt_failsafe_input_1)
sqrt_failsafe_input_2 = var_sumY_global / (cnt_Y_global - 1)
stdev_Y_global = sqrt_failsafe (sqrt_failsafe_input_2)

Cnt_X_per_stratum = StrataSummator %*% X_mask
Cnt_Y_per_stratum = StrataSummator %*% Y_mask
Is_none_X_per_stratum = (Cnt_X_per_stratum == 0)
Is_none_Y_per_stratum = (Cnt_Y_per_stratum == 0)
One_over_cnt_X_per_stratum = (1 - Is_none_X_per_stratum) / (Cnt_X_per_stratum + Is_none_X_per_stratum)
One_over_cnt_Y_per_stratum = (1 - Is_none_Y_per_stratum) / (Cnt_Y_per_stratum + Is_none_Y_per_stratum)
num_X_nonempty_strata = num_strata - colSums (Is_none_X_per_stratum)
num_Y_nonempty_strata = num_strata - colSums (Is_none_Y_per_stratum)

Sum_X_per_stratum  = StrataSummator %*% X
Sum_Y_per_stratum  = StrataSummator %*% Y

cnt_X_with_good_stratumID = colSums(Cnt_X_per_stratum)
cnt_Y_with_good_stratumID = colSums(Cnt_Y_per_stratum)
sum_X_with_good_stratumID = colSums(Sum_X_per_stratum)
sum_Y_with_good_stratumID = colSums(Sum_Y_per_stratum)
var_sumX_with_good_stratumID = colSums(StrataSummator %*% (X * X)) - (sum_X_with_good_stratumID * sum_X_with_good_stratumID) / cnt_X_with_good_stratumID
var_sumY_with_good_stratumID = colSums(StrataSummator %*% (Y * Y)) - (sum_Y_with_good_stratumID * sum_Y_with_good_stratumID) / cnt_Y_with_good_stratumID

var_sumX_stratified   = colSums (StrataSummator %*% (X * X)) - colSums (One_over_cnt_X_per_stratum * Sum_X_per_stratum * Sum_X_per_stratum)
var_sumY_stratified   = colSums (StrataSummator %*% (Y * Y)) - colSums (One_over_cnt_Y_per_stratum * Sum_Y_per_stratum * Sum_Y_per_stratum)
sqrt_failsafe_input_3 = var_sumX_stratified / (cnt_X_with_good_stratumID - num_X_nonempty_strata)
stdev_X_stratified    = sqrt_failsafe (sqrt_failsafe_input_3)
sqrt_failsafe_input_4 = var_sumY_stratified / (cnt_Y_with_good_stratumID - num_Y_nonempty_strata)
stdev_Y_stratified    = sqrt_failsafe (sqrt_failsafe_input_4)
r_sqr_X_vs_strata     = 1 - var_sumX_stratified / var_sumX_with_good_stratumID
r_sqr_Y_vs_strata     = 1 - var_sumY_stratified / var_sumY_with_good_stratumID
adj_r_sqr_X_vs_strata = 1 - (var_sumX_stratified / (cnt_X_with_good_stratumID - num_X_nonempty_strata)) / (var_sumX_with_good_stratumID / (cnt_X_with_good_stratumID - 1))
adj_r_sqr_Y_vs_strata = 1 - (var_sumY_stratified / (cnt_Y_with_good_stratumID - num_Y_nonempty_strata)) / (var_sumY_with_good_stratumID / (cnt_Y_with_good_stratumID - 1))
fStat_X_vs_strata     = ((var_sumX_with_good_stratumID - var_sumX_stratified) / (num_X_nonempty_strata - 1)) / (var_sumX_stratified / (cnt_X_with_good_stratumID - num_X_nonempty_strata))
fStat_Y_vs_strata     = ((var_sumY_with_good_stratumID - var_sumY_stratified) / (num_Y_nonempty_strata - 1)) / (var_sumY_stratified / (cnt_Y_with_good_stratumID - num_Y_nonempty_strata))
p_val_X_vs_strata     = fStat_tailprob (fStat_X_vs_strata, num_X_nonempty_strata - 1, cnt_X_with_good_stratumID - num_X_nonempty_strata)
p_val_Y_vs_strata     = fStat_tailprob (fStat_Y_vs_strata, num_Y_nonempty_strata - 1, cnt_Y_with_good_stratumID - num_Y_nonempty_strata)

cnt_XY_rectangle       = t(X_mask) %*% Y_mask
sum_X_forXY_rectangle  = t(X)      %*% Y_mask
sum_XX_forXY_rectangle = t(X * X)  %*% Y_mask
sum_Y_forXY_rectangle  = t(X_mask) %*% Y
sum_YY_forXY_rectangle = t(X_mask) %*% (Y * Y)
sum_XY_rectangle       = t(X)      %*% Y
cnt_XY_global       = matrix(t(cnt_XY_rectangle),       nrow = 1, ncol = num_attrs_XY)
sum_X_forXY_global  = matrix(t(sum_X_forXY_rectangle), nrow = 1, byrow = TRUE)
sum_XX_forXY_global = matrix(t(sum_XX_forXY_rectangle), nrow = 1, ncol = num_attrs_XY, byrow = TRUE)
sum_Y_forXY_global  = matrix(t(sum_Y_forXY_rectangle),  nrow = 1, ncol = num_attrs_XY, byrow = TRUE)
sum_YY_forXY_global = matrix(t(sum_YY_forXY_rectangle), nrow = 1, ncol = num_attrs_XY, byrow = TRUE)
sum_XY_global       = matrix(sum_XY_rectangle,       nrow = 1, ncol = num_attrs_XY, byrow = TRUE)
ones_XY = matrix(1.0, nrow = 1, ncol = num_attrs_XY)

cov_sumX_sumY_global    = sum_XY_global - sum_X_forXY_global * sum_Y_forXY_global / cnt_XY_global
var_sumX_forXY_global   = sum_XX_forXY_global - sum_X_forXY_global * sum_X_forXY_global / cnt_XY_global
var_sumY_forXY_global   = sum_YY_forXY_global - sum_Y_forXY_global * sum_Y_forXY_global / cnt_XY_global

slope_XY_global         = cov_sumX_sumY_global / var_sumX_forXY_global
sqrt_failsafe_input_5 = var_sumX_forXY_global * var_sumY_forXY_global
sqrt_failsafe_output_5 = sqrt_failsafe(sqrt_failsafe_input_5)
corr_XY_global          = cov_sumX_sumY_global / sqrt_failsafe_output_5
r_sqr_X_vs_Y_global     = cov_sumX_sumY_global * cov_sumX_sumY_global / (var_sumX_forXY_global * var_sumY_forXY_global)
adj_r_sqr_X_vs_Y_global = 1 - (1 - r_sqr_X_vs_Y_global) * (cnt_XY_global - 1) / (cnt_XY_global - 2)
sqrt_failsafe_input_6 = (1 - r_sqr_X_vs_Y_global) * var_sumY_forXY_global / var_sumX_forXY_global / (cnt_XY_global - 2)
stdev_slope_XY_global   = sqrt_failsafe(sqrt_failsafe_input_6)
sqrt_failsafe_input_7 = (1 - r_sqr_X_vs_Y_global) * var_sumY_forXY_global / (cnt_XY_global - 2)
stdev_errY_vs_X_global  = sqrt_failsafe(sqrt_failsafe_input_7)
fStat_Y_vs_X_global     = (cnt_XY_global - 2) * r_sqr_X_vs_Y_global / (1 - r_sqr_X_vs_Y_global)
p_val_Y_vs_X_global     = fStat_tailprob(fStat_Y_vs_X_global, ones_XY, cnt_XY_global - 2)

Proj_X_to_XY = matrix(0.0, nrow = num_attrs_X, ncol = num_attrs_XY)
Proj_Y_to_XY = matrix(0.0, nrow = num_attrs_Y, ncol = num_attrs_XY)
ones_Y_col   = matrix(1.0, nrow = num_attrs_Y, ncol = 1)
for (i in 1:num_attrs_X) {
    start_cid = (i - 1) * num_attrs_Y + 1
    end_cid = i * num_attrs_Y
    Proj_X_to_XY [i, start_cid:end_cid] = t(ones_Y_col)
    Proj_Y_to_XY [ , start_cid:end_cid] = diag(nrow=nrow(ones_Y_col), ncol=nrow(ones_Y_col))
}

Cnt_XY_per_stratum       = StrataSummator %*% (( X_mask %*% Proj_X_to_XY) * ( Y_mask %*% Proj_Y_to_XY))
Sum_X_forXY_per_stratum  = StrataSummator %*% (( X      %*% Proj_X_to_XY) * ( Y_mask %*% Proj_Y_to_XY))
Sum_XX_forXY_per_stratum = StrataSummator %*% (((X * X) %*% Proj_X_to_XY) * ( Y_mask %*% Proj_Y_to_XY))
Sum_Y_forXY_per_stratum  = StrataSummator %*% (( X_mask %*% Proj_X_to_XY) * ( Y      %*% Proj_Y_to_XY))
Sum_YY_forXY_per_stratum = StrataSummator %*% (( X_mask %*% Proj_X_to_XY) * ((Y * Y) %*% Proj_Y_to_XY))
Sum_XY_per_stratum       = StrataSummator %*% (( X      %*% Proj_X_to_XY) * ( Y      %*% Proj_Y_to_XY))

Is_none_XY_per_stratum = (Cnt_XY_per_stratum == 0)
One_over_cnt_XY_per_stratum = (1 - Is_none_XY_per_stratum) / (Cnt_XY_per_stratum + Is_none_XY_per_stratum)
num_XY_nonempty_strata = num_strata - colSums (Is_none_XY_per_stratum)

cnt_XY_with_good_stratumID = colSums(Cnt_XY_per_stratum)
sum_XX_forXY_with_good_stratumID = colSums(Sum_XX_forXY_per_stratum)
sum_YY_forXY_with_good_stratumID = colSums(Sum_YY_forXY_per_stratum)
sum_XY_with_good_stratumID = colSums(Sum_XY_per_stratum)

var_sumX_forXY_stratified = sum_XX_forXY_with_good_stratumID - colSums(Sum_X_forXY_per_stratum * Sum_X_forXY_per_stratum * One_over_cnt_XY_per_stratum)
var_sumY_forXY_stratified = sum_YY_forXY_with_good_stratumID - colSums(Sum_Y_forXY_per_stratum * Sum_Y_forXY_per_stratum * One_over_cnt_XY_per_stratum)
cov_sumX_sumY_stratified  = sum_XY_with_good_stratumID       - colSums(Sum_X_forXY_per_stratum * Sum_Y_forXY_per_stratum * One_over_cnt_XY_per_stratum)

slope_XY_stratified     = cov_sumX_sumY_stratified / var_sumX_forXY_stratified
sqrt_failsafe_input_8 = var_sumX_forXY_stratified * var_sumY_forXY_stratified
sqrt_failsafe_output_8 = sqrt_failsafe(sqrt_failsafe_input_8)
corr_XY_stratified      = cov_sumX_sumY_stratified / sqrt_failsafe_output_8
r_sqr_X_vs_Y_stratified = (cov_sumX_sumY_stratified ^ 2) / (var_sumX_forXY_stratified * var_sumY_forXY_stratified)
temp_X_vs_Y_stratified  = (1 - r_sqr_X_vs_Y_stratified) / (cnt_XY_with_good_stratumID - num_XY_nonempty_strata - 1)
adj_r_sqr_X_vs_Y_stratified = 1 - temp_X_vs_Y_stratified * (cnt_XY_with_good_stratumID - num_XY_nonempty_strata)
sqrt_failsafe_input_9  = temp_X_vs_Y_stratified * var_sumY_forXY_stratified

if(all(var_sumY_forXY_stratified == 0)){
  sqrt_failsafe_input_9 = var_sumY_forXY_stratified
}

stdev_errY_vs_X_stratified  = sqrt_failsafe (sqrt_failsafe_input_9)
sqrt_failsafe_input_10 = sqrt_failsafe_input_9  / var_sumX_forXY_stratified
stdev_slope_XY_stratified   = sqrt_failsafe(sqrt_failsafe_input_10)
#stdev_slope_XY_stratified[is.na(stdev_slope_XY_stratified)] = NaN
fStat_Y_vs_X_stratified = (cnt_XY_with_good_stratumID - num_XY_nonempty_strata - 1) * r_sqr_X_vs_Y_stratified / (1 - r_sqr_X_vs_Y_stratified)
p_val_Y_vs_X_stratified = fStat_tailprob (fStat_Y_vs_X_stratified, ones_XY, cnt_XY_with_good_stratumID - num_XY_nonempty_strata - 1)

OutMtx = matrix(0.0, nrow = 40, ncol = num_attrs_XY)
OutMtx [ 1, ] = Xcols                 %*% Proj_X_to_XY
OutMtx [ 2, ] = cnt_X_global          %*% Proj_X_to_XY
OutMtx [ 3, ] = avg_X_global          %*% Proj_X_to_XY
OutMtx [ 4, ] = stdev_X_global        %*% Proj_X_to_XY
OutMtx [ 5, ] = stdev_X_stratified    %*% Proj_X_to_XY
OutMtx [ 6, ] = r_sqr_X_vs_strata     %*% Proj_X_to_XY
OutMtx [ 7, ] = adj_r_sqr_X_vs_strata %*% Proj_X_to_XY
OutMtx [ 8, ] = p_val_X_vs_strata     %*% Proj_X_to_XY

OutMtx [11, ] = Ycols                 %*% Proj_Y_to_XY
OutMtx [12, ] = cnt_Y_global          %*% Proj_Y_to_XY
OutMtx [13, ] = avg_Y_global          %*% Proj_Y_to_XY
OutMtx [14, ] = stdev_Y_global        %*% Proj_Y_to_XY
OutMtx [15, ] = stdev_Y_stratified    %*% Proj_Y_to_XY
OutMtx [16, ] = r_sqr_Y_vs_strata     %*% Proj_Y_to_XY
OutMtx [17, ] = adj_r_sqr_Y_vs_strata %*% Proj_Y_to_XY
OutMtx [18, ] = p_val_Y_vs_strata     %*% Proj_Y_to_XY

OutMtx [21, ] = cnt_XY_global
OutMtx [22, ] = slope_XY_global
OutMtx [23, ] = stdev_slope_XY_global
OutMtx [24, ] = corr_XY_global
OutMtx [25, ] = stdev_errY_vs_X_global
OutMtx [26, ] = r_sqr_X_vs_Y_global
OutMtx [27, ] = adj_r_sqr_X_vs_Y_global
OutMtx [28, ] = p_val_Y_vs_X_global

OutMtx [31, ] = cnt_XY_with_good_stratumID
OutMtx [32, ] = slope_XY_stratified
OutMtx [33, ] = stdev_slope_XY_stratified
OutMtx [34, ] = corr_XY_stratified
OutMtx [35, ] = stdev_errY_vs_X_stratified
OutMtx [36, ] = r_sqr_X_vs_Y_stratified
OutMtx [37, ] = adj_r_sqr_X_vs_Y_stratified
OutMtx [38, ] = p_val_Y_vs_X_stratified
OutMtx [39, ] = colSums (Cnt_XY_per_stratum >= 2)

OutMtx = t(OutMtx)
writeMM(as(OutMtx, "CsparseMatrix"), file=args[2])

#-------------------------------------------------------------
#
# Licensed to the Apache Software Foundation (ASF) under one
# or more contributor license agreements.  See the NOTICE file
# distributed with this work for additional information
# regarding copyright ownership.  The ASF licenses this file
# to you under the Apache License, Version 2.0 (the
# "License"); you may not use this file except in compliance
# with the License.  You may obtain a copy of the License at
# 
#   http://www.apache.org/licenses/LICENSE-2.0
# 
# Unless required by applicable law or agreed to in writing,
# software distributed under the License is distributed on an
# "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
# KIND, either express or implied.  See the License for the
# specific language governing permissions and limitations
# under the License.
#
#-------------------------------------------------------------

args<-commandArgs(TRUE)
options(digits=22)
library("Matrix")
#X= matrix( seq(1,25), 5, 5, byrow = TRUE)
X = matrix(  c(1,2,3,4,5,6,7,8,9), nrow=3, ncol=3, byrow = TRUE)

#S= X*as.matrix(X>0)
#S=7 + (1 / exp(X) )
S = 10 + floor(round(abs(7 + (1 / exp(X) ))))
writeMM(as(S, "CsparseMatrix"), paste(args[2], "S", sep="")); 

#-------------------------------------------------------------
#
# Licensed to the Apache Software Foundation (ASF) under one
# or more contributor license agreements.  See the NOTICE file
# distributed with this work for additional information
# regarding copyright ownership.  The ASF licenses this file
# to you under the Apache License, Version 2.0 (the
# "License"); you may not use this file except in compliance
# with the License.  You may obtain a copy of the License at
# 
#   http://www.apache.org/licenses/LICENSE-2.0
# 
# Unless required by applicable law or agreed to in writing,
# software distributed under the License is distributed on an
# "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
# KIND, either express or implied.  See the License for the
# specific language governing permissions and limitations
# under the License.
#
#-------------------------------------------------------------

args <- commandArgs(TRUE)
library("Matrix")

G = readMM(paste(args[1], "G.mtx", sep=""));
p = as.matrix(readMM(paste(args[1], "p.mtx", sep="")));
e = as.matrix(readMM(paste(args[1], "e.mtx", sep="")));
u = as.matrix(readMM(paste(args[1], "u.mtx", sep="")));
alpha = as.double(args[2]);
max_iteration = as.integer(args[3]);
i = 0;

while( i < max_iteration ) {
  p = alpha * (G %*% p) + (1 - alpha) * (e %*% (u %*% p));
  i = i + 1;
}

writeMM(as(p,"CsparseMatrix"), paste(args[4], "p", sep=""));

#-------------------------------------------------------------
#
# Licensed to the Apache Software Foundation (ASF) under one
# or more contributor license agreements.  See the NOTICE file
# distributed with this work for additional information
# regarding copyright ownership.  The ASF licenses this file
# to you under the Apache License, Version 2.0 (the
# "License"); you may not use this file except in compliance
# with the License.  You may obtain a copy of the License at
# 
#   http://www.apache.org/licenses/LICENSE-2.0
# 
# Unless required by applicable law or agreed to in writing,
# software distributed under the License is distributed on an
# "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
# KIND, either express or implied.  See the License for the
# specific language governing permissions and limitations
# under the License.
#
#-------------------------------------------------------------


args <- commandArgs(TRUE)
options(digits=22)

library("Matrix")

X = matrix(1, 1000, 3);
B = matrix(1, 1000, 2);
C = matrix(7, 1000, 1);
D = matrix(3, 1000, 1);

E = cbind(X [, 1 : 2], B) * ((C * (1 - D))%*%matrix(1,1,4));
X = X * C%*%matrix(1,1,3);
n = nrow (X);

R = X + sum(E) + n;

cat(sum(R))

writeMM(as(R, "CsparseMatrix"), paste(args[1], "R", sep="")); 

#-------------------------------------------------------------
#
# Licensed to the Apache Software Foundation (ASF) under one
# or more contributor license agreements.  See the NOTICE file
# distributed with this work for additional information
# regarding copyright ownership.  The ASF licenses this file
# to you under the Apache License, Version 2.0 (the
# "License"); you may not use this file except in compliance
# with the License.  You may obtain a copy of the License at
#
#   http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing,
# software distributed under the License is distributed on an
# "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
# KIND, either express or implied.  See the License for the
# specific language governing permissions and limitations
# under the License.
#
#-------------------------------------------------------------
args<-commandArgs(TRUE)
options(digits=22)
library("Matrix")
library("matrixStats")

X1 = as.matrix(readMM(paste(args[1], "X1.mtx", sep="")));
X2 = as.matrix(readMM(paste(args[1], "X2.mtx", sep="")));
X3 = as.matrix(readMM(paste(args[1], "X3.mtx", sep="")));
X4 = as.matrix(readMM(paste(args[1], "X4.mtx", sep="")));
X = rbind(X1, X2, X3, X4)
R = colProds(X)
writeMM(as(R, "CsparseMatrix"), paste(args[2], "S", sep=""));

#-------------------------------------------------------------
#
# Licensed to the Apache Software Foundation (ASF) under one
# or more contributor license agreements.  See the NOTICE file
# distributed with this work for additional information
# regarding copyright ownership.  The ASF licenses this file
# to you under the Apache License, Version 2.0 (the
# "License"); you may not use this file except in compliance
# with the License.  You may obtain a copy of the License at
#
#   http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing,
# software distributed under the License is distributed on an
# "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
# KIND, either express or implied.  See the License for the
# specific language governing permissions and limitations
# under the License.
#
#-------------------------------------------------------------

args <- commandArgs(TRUE)

# Set options for numeric precision
options(digits=22)

# Load required libraries
library("Matrix")
library("matrixStats")

# Read matrix and operation type
X = as.matrix(readMM(paste(args[1], "X.mtx", sep="")))
type = as.integer(args[2])

# Perform operations
if(type==1){
    R = X+X
} else if(type==2){
    R = X*X
} else if(type==3){
    R = (X>0) - (X<0)
}

#Write result matrix R
writeMM(as(R, "CsparseMatrix"), paste(args[3], "R", sep=""));

#-------------------------------------------------------------
#
# Licensed to the Apache Software Foundation (ASF) under one
# or more contributor license agreements.  See the NOTICE file
# distributed with this work for additional information
# regarding copyright ownership.  The ASF licenses this file
# to you under the Apache License, Version 2.0 (the
# "License"); you may not use this file except in compliance
# with the License.  You may obtain a copy of the License at
#
#   http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing,
# software distributed under the License is distributed on an
# "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
# KIND, either express or implied.  See the License for the
# specific language governing permissions and limitations
# under the License.
#
#-------------------------------------------------------------

args<-commandArgs(TRUE)
options(digits=22)
library("Matrix")

X = as.matrix(readMM(paste(args[1], "X.mtx", sep="")));
Y = as.matrix(readMM(paste(args[1], "Y.mtx", sep="")));
R = setdiff(X, Y);

# ** Workaround for numeric(0)
# 0 will be cast as numeric(0)
# which is a zero length vector
# so, we make 0.1 in both dml and
# R script
if (length(R) == 0) {
  R = (0.1)
}
# **

writeMM(as(R, "CsparseMatrix"), paste(args[2], "R", sep=""));

@echo off
@rem Licensed to the Apache Software Foundation (ASF) under one or more
@rem contributor license agreements.  See the NOTICE file distributed with
@rem this work for additional information regarding copyright ownership.
@rem The ASF licenses this file to You under the Apache License, Version 2.0
@rem (the "License"); you may not use this file except in compliance with
@rem the License.  You may obtain a copy of the License at
@rem
@rem     http://www.apache.org/licenses/LICENSE-2.0
@rem
@rem Unless required by applicable law or agreed to in writing, software
@rem distributed under the License is distributed on an "AS IS" BASIS,
@rem WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
@rem See the License for the specific language governing permissions and
@rem limitations under the License.

@rem The Hadoop command script
@rem
@rem Environment Variables
@rem
@rem   JAVA_HOME            The java implementation to use.  Overrides JAVA_HOME.
@rem
@rem   YARN_CLASSPATH       Extra Java CLASSPATH entries.
@rem
@rem   YARN_HEAPSIZE        The maximum amount of heap to use, in MB.
@rem                        Default is 1000.
@rem
@rem   YARN_{COMMAND}_HEAPSIZE overrides YARN_HEAPSIZE for a given command
@rem                           eg YARN_NODEMANAGER_HEAPSIZE sets the heap
@rem                           size for the NodeManager.  If you set the
@rem                           heap size in YARN_{COMMAND}_OPTS or YARN_OPTS
@rem                           they take precedence.
@rem
@rem   YARN_OPTS            Extra Java runtime options.
@rem
@rem   YARN_CLIENT_OPTS     when the respective command is run.
@rem   YARN_{COMMAND}_OPTS etc  YARN_NODEMANAGER_OPTS applies to NodeManager
@rem                              for e.g.  YARN_CLIENT_OPTS applies to
@rem                              more than one command (fs, dfs, fsck,
@rem                              dfsadmin etc)
@rem
@rem   YARN_CONF_DIR        Alternate conf dir. Default is ${HADOOP_YARN_HOME}/conf.
@rem
@rem   YARN_ROOT_LOGGER     The root appender. Default is INFO,console
@rem

setlocal enabledelayedexpansion

if not defined HADOOP_BIN_PATH ( 
  set HADOOP_BIN_PATH=%~dp0
)

if "%HADOOP_BIN_PATH:~-1%" == "\" (
  set HADOOP_BIN_PATH=%HADOOP_BIN_PATH:~0,-1%
)

set DEFAULT_LIBEXEC_DIR=%HADOOP_BIN_PATH%\..\libexec
if not defined HADOOP_LIBEXEC_DIR (
  set HADOOP_LIBEXEC_DIR=%DEFAULT_LIBEXEC_DIR%
)

call %DEFAULT_LIBEXEC_DIR%\yarn-config.cmd %*
if "%1" == "--config" (
  shift
  shift
)
if "%1" == "--loglevel" (
  shift
  shift
)

:main
  if exist %YARN_CONF_DIR%\yarn-env.cmd (
    call %YARN_CONF_DIR%\yarn-env.cmd
  )

  set yarn-command=%1
  call :make_command_arguments %*

  if not defined yarn-command (
      goto print_usage
  )

  @rem JAVA and JAVA_HEAP_MAX and set in hadoop-config.cmd

  if defined YARN_HEAPSIZE (
    @rem echo run with Java heapsize %YARN_HEAPSIZE%
    set JAVA_HEAP_MAX=-Xmx%YARN_HEAPSIZE%m
  )

  @rem CLASSPATH initially contains HADOOP_CONF_DIR & YARN_CONF_DIR
  if not defined HADOOP_CONF_DIR (
    echo No HADOOP_CONF_DIR set. 
    echo Please specify it either in yarn-env.cmd or in the environment.
    goto :eof
  )

  set CLASSPATH=%HADOOP_CONF_DIR%;%YARN_CONF_DIR%;%CLASSPATH%

  @rem for developers, add Hadoop classes to CLASSPATH
  if exist %HADOOP_YARN_HOME%\yarn-api\target\classes (
    set CLASSPATH=%CLASSPATH%;%HADOOP_YARN_HOME%\yarn-api\target\classes
  )

  if exist %HADOOP_YARN_HOME%\yarn-common\target\classes (
    set CLASSPATH=%CLASSPATH%;%HADOOP_YARN_HOME%\yarn-common\target\classes
  )

  if exist %HADOOP_YARN_HOME%\yarn-mapreduce\target\classes (
    set CLASSPATH=%CLASSPATH%;%HADOOP_YARN_HOME%\yarn-mapreduce\target\classes
  )

  if exist %HADOOP_YARN_HOME%\yarn-master-worker\target\classes (
    set CLASSPATH=%CLASSPATH%;%HADOOP_YARN_HOME%\yarn-master-worker\target\classes
  )

  if exist %HADOOP_YARN_HOME%\yarn-server\yarn-server-nodemanager\target\classes (
    set CLASSPATH=%CLASSPATH%;%HADOOP_YARN_HOME%\yarn-server\yarn-server-nodemanager\target\classes
  )

  if exist %HADOOP_YARN_HOME%\yarn-server\yarn-server-common\target\classes (
    set CLASSPATH=%CLASSPATH%;%HADOOP_YARN_HOME%\yarn-server\yarn-server-common\target\classes
  )

  if exist %HADOOP_YARN_HOME%\yarn-server\yarn-server-resourcemanager\target\classes (
    set CLASSPATH=%CLASSPATH%;%HADOOP_YARN_HOME%\yarn-server\yarn-server-resourcemanager\target\classes
  )

  if exist %HADOOP_YARN_HOME%\yarn-server\yarn-server-applicationhistoryservice\target\classes (
    set CLASSPATH=%CLASSPATH%;%HADOOP_YARN_HOME%\yarn-server\yarn-server-applicationhistoryservice\target\classes
  )

  if exist %HADOOP_YARN_HOME%\yarn-server\yarn-server-router\target\classes (
    set CLASSPATH=%CLASSPATH%;%HADOOP_YARN_HOME%\yarn-server\yarn-server-router\target\classes
  )

  if exist %HADOOP_YARN_HOME%\build\test\classes (
    set CLASSPATH=%CLASSPATH%;%HADOOP_YARN_HOME%\build\test\classes
  )

  if exist %HADOOP_YARN_HOME%\build\tools (
    set CLASSPATH=%CLASSPATH%;%HADOOP_YARN_HOME%\build\tools
  )

  set CLASSPATH=%CLASSPATH%;%HADOOP_YARN_HOME%\%YARN_DIR%\*
  set CLASSPATH=%CLASSPATH%;%HADOOP_YARN_HOME%\%YARN_LIB_JARS_DIR%\*

  if %yarn-command% == classpath (
    if not defined yarn-command-arguments (
      @rem No need to bother starting up a JVM for this simple case.
      @echo %CLASSPATH%
      exit /b
    )
  )

  set yarncommands=resourcemanager nodemanager proxyserver rmadmin version jar ^
     application applicationattempt container node queue logs daemonlog historyserver ^
     timelineserver timelinereader router classpath
  for %%i in ( %yarncommands% ) do (
    if %yarn-command% == %%i set yarncommand=true
  )
  if defined yarncommand (
    call :%yarn-command%
  ) else (
    set CLASSPATH=%CLASSPATH%;%CD%
    set CLASS=%yarn-command%
  )

  if defined JAVA_LIBRARY_PATH (
    set YARN_OPTS=%YARN_OPTS% -Djava.library.path=%JAVA_LIBRARY_PATH%
  )

  set java_arguments=%JAVA_HEAP_MAX% %YARN_OPTS% -classpath %CLASSPATH% %CLASS% %yarn-command-arguments%
  call %JAVA% %java_arguments%

goto :eof

:classpath
  set CLASS=org.apache.hadoop.util.Classpath
  goto :eof

:rmadmin
  set CLASS=org.apache.hadoop.yarn.client.cli.RMAdminCLI
  set YARN_OPTS=%YARN_OPTS% %YARN_CLIENT_OPTS%
  goto :eof

:application
  set CLASS=org.apache.hadoop.yarn.client.cli.ApplicationCLI
  set YARN_OPTS=%YARN_OPTS% %YARN_CLIENT_OPTS%
  set yarn-command-arguments=%yarn-command% %yarn-command-arguments%
  goto :eof

:applicationattempt
  set CLASS=org.apache.hadoop.yarn.client.cli.ApplicationCLI
  set YARN_OPTS=%YARN_OPTS% %YARN_CLIENT_OPTS%
  set yarn-command-arguments=%yarn-command% %yarn-command-arguments%
  goto :eof

:cluster
  set CLASS=org.apache.hadoop.yarn.client.cli.ClusterCLI
  set YARN_OPTS=%YARN_OPTS% %YARN_CLIENT_OPTS%
  goto :eof

:container
  set CLASS=org.apache.hadoop.yarn.client.cli.ApplicationCLI
  set YARN_OPTS=%YARN_OPTS% %YARN_CLIENT_OPTS%
  set yarn-command-arguments=%yarn-command% %yarn-command-arguments%
  goto :eof  

:node
  set CLASS=org.apache.hadoop.yarn.client.cli.NodeCLI
  set YARN_OPTS=%YARN_OPTS% %YARN_CLIENT_OPTS%
  goto :eof

:queue
  set CLASS=org.apache.hadoop.yarn.client.cli.QueueCLI
  set YARN_OPTS=%YARN_OPTS% %YARN_CLIENT_OPTS%
  goto :eof

:resourcemanager
  set CLASSPATH=%CLASSPATH%;%YARN_CONF_DIR%\rm-config\log4j.properties
  set CLASSPATH=%CLASSPATH%;%HADOOP_YARN_HOME%\%YARN_DIR%\timelineservice\*
  set CLASSPATH=%CLASSPATH%;%HADOOP_YARN_HOME%\%YARN_DIR%\timelineservice\lib\*
  set CLASS=org.apache.hadoop.yarn.server.resourcemanager.ResourceManager
  set YARN_OPTS=%YARN_OPTS% %YARN_RESOURCEMANAGER_OPTS%
  if defined YARN_RESOURCEMANAGER_HEAPSIZE (
    set JAVA_HEAP_MAX=-Xmx%YARN_RESOURCEMANAGER_HEAPSIZE%m
  )
  goto :eof

:historyserver
  @echo DEPRECATED: Use of this command to start the timeline server is deprecated. 1>&2
  @echo Instead use the timelineserver command for it. 1>&2
  set CLASSPATH=%CLASSPATH%;%YARN_CONF_DIR%\ahs-config\log4j.properties
  set CLASS=org.apache.hadoop.yarn.server.applicationhistoryservice.ApplicationHistoryServer
  set YARN_OPTS=%YARN_OPTS% %HADOOP_HISTORYSERVER_OPTS%
  if defined YARN_HISTORYSERVER_HEAPSIZE (
    set JAVA_HEAP_MAX=-Xmx%YARN_HISTORYSERVER_HEAPSIZE%m
  )
  goto :eof

:timelineserver
  set CLASSPATH=%CLASSPATH%;%YARN_CONF_DIR%\timelineserver-config\log4j.properties
  set CLASS=org.apache.hadoop.yarn.server.applicationhistoryservice.ApplicationHistoryServer
  set YARN_OPTS=%YARN_OPTS% %HADOOP_TIMELINESERVER_OPTS%
  if defined YARN_TIMELINESERVER_HEAPSIZE (
    set JAVA_HEAP_MAX=-Xmx%YARN_TIMELINESERVER_HEAPSIZE%m
  )
  goto :eof

:timelinereader
  set CLASSPATH=%CLASSPATH%;%YARN_CONF_DIR%\timelineserver-config\log4j.properties
  set CLASSPATH=%CLASSPATH%;%HADOOP_YARN_HOME%\%YARN_DIR%\timelineservice\*
  set CLASSPATH=%CLASSPATH%;%HADOOP_YARN_HOME%\%YARN_DIR%\timelineservice\lib\*
  set CLASS=org.apache.hadoop.yarn.server.timelineservice.reader.TimelineReaderServer
  set YARN_OPTS=%YARN_OPTS% %YARN_TIMELINEREADER_OPTS%
  goto :eof

:router
  set CLASSPATH=%CLASSPATH%;%YARN_CONF_DIR%\router-config\log4j.properties
  set CLASS=org.apache.hadoop.yarn.server.router.Router
  set YARN_OPTS=%YARN_OPTS% %HADOOP_ROUTER_OPTS%
  goto :eof

:nodemanager
  set CLASSPATH=%CLASSPATH%;%YARN_CONF_DIR%\nm-config\log4j.properties
  set CLASSPATH=%CLASSPATH%;%HADOOP_YARN_HOME%\%YARN_DIR%\timelineservice\*
  set CLASSPATH=%CLASSPATH%;%HADOOP_YARN_HOME%\%YARN_DIR%\timelineservice\lib\*
  set CLASS=org.apache.hadoop.yarn.server.nodemanager.NodeManager
  set YARN_OPTS=%YARN_OPTS% -server %HADOOP_NODEMANAGER_OPTS%
  if defined YARN_NODEMANAGER_HEAPSIZE (
    set JAVA_HEAP_MAX=-Xmx%YARN_NODEMANAGER_HEAPSIZE%m
  )
  goto :eof

:proxyserver
  set CLASS=org.apache.hadoop.yarn.server.webproxy.WebAppProxyServer
  set YARN_OPTS=%YARN_OPTS% %HADOOP_PROXYSERVER_OPTS%
  if defined YARN_PROXYSERVER_HEAPSIZE (
    set JAVA_HEAP_MAX=-Xmx%YARN_PROXYSERVER_HEAPSIZE%m
  )
  goto :eof

:version
  set CLASS=org.apache.hadoop.util.VersionInfo
  set YARN_OPTS=%YARN_OPTS% %YARN_CLIENT_OPTS%
  goto :eof

:jar
  set CLASS=org.apache.hadoop.util.RunJar
  set YARN_OPTS=%YARN_OPTS% %YARN_CLIENT_OPTS%
  goto :eof

:logs
  set CLASS=org.apache.hadoop.yarn.client.cli.LogsCLI
  set YARN_OPTS=%YARN_OPTS% %YARN_CLIENT_OPTS%
  goto :eof

:daemonlog
  set CLASS=org.apache.hadoop.log.LogLevel
  set YARN_OPTS=%YARN_OPTS% %YARN_CLIENT_OPTS%
  goto :eof

:schedulerconf
  set CLASS=org.apache.hadoop.yarn.client.cli.SchedConfCLI
  set YARN_OPTS=%YARN_OPTS% %YARN_CLIENT_OPTS%
  goto :eof

@rem This changes %1, %2 etc. Hence those cannot be used after calling this.
:make_command_arguments
  if "%1" == "--config" (
    shift
    shift
  )
  if "%1" == "--loglevel" (
    shift
    shift
  )
  if [%2] == [] goto :eof
  shift
  set _yarnarguments=
  :MakeCmdArgsLoop 
  if [%1]==[] goto :EndLoop 

  if not defined _yarnarguments (
    set _yarnarguments=%1
  ) else (
    set _yarnarguments=!_yarnarguments! %1
  )
  shift
  goto :MakeCmdArgsLoop 
  :EndLoop 
  set yarn-command-arguments=%_yarnarguments%
  goto :eof

:print_usage
  @echo Usage: yarn [--config confdir] [--loglevel loglevel] COMMAND
  @echo        where COMMAND is one of:
  @echo   resourcemanager      run the ResourceManager
  @echo   nodemanager          run a nodemanager on each slave
  @echo   router               run the Router daemon
  @echo   timelineserver       run the timeline server
  @echo   timelinereader       run the timeline reader server
  @echo   rmadmin              admin tools
  @echo   version              print the version
  @echo   jar ^<jar^>          run a jar file
  @echo   application          prints application(s) report/kill application
  @echo   applicationattempt   prints applicationattempt(s) report
  @echo   cluster              prints cluster information
  @echo   container            prints container(s) report
  @echo   node                 prints node report(s)
  @echo   queue                prints queue information
  @echo   logs                 dump container logs
  @echo   schedulerconf        updates scheduler configuration
  @echo   classpath            prints the class path needed to get the
  @echo                        Hadoop jar and the required libraries
  @echo   daemonlog            get/set the log level for each daemon
  @echo   or
  @echo   CLASSNAME            run the class named CLASSNAME
  @echo Most commands print help when invoked w/o parameters.

endlocal

@echo off
@rem Licensed to the Apache Software Foundation (ASF) under one or more
@rem contributor license agreements.  See the NOTICE file distributed with
@rem this work for additional information regarding copyright ownership.
@rem The ASF licenses this file to You under the Apache License, Version 2.0
@rem (the "License"); you may not use this file except in compliance with
@rem the License.  You may obtain a copy of the License at
@rem
@rem     http://www.apache.org/licenses/LICENSE-2.0
@rem
@rem Unless required by applicable law or agreed to in writing, software
@rem distributed under the License is distributed on an "AS IS" BASIS,
@rem WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
@rem See the License for the specific language governing permissions and
@rem limitations under the License.


@rem This script runs the hadoop core commands. 

@rem Environment Variables
@rem
@rem   JAVA_HOME        The java implementation to use.  Overrides JAVA_HOME.
@rem
@rem   HADOOP_CLASSPATH Extra Java CLASSPATH entries.
@rem
@rem   HADOOP_USER_CLASSPATH_FIRST      When defined, the HADOOP_CLASSPATH is
@rem                                    added in the beginning of the global
@rem                                    classpath. Can be defined, for example,
@rem                                    by doing
@rem                                    export HADOOP_USER_CLASSPATH_FIRST=true
@rem
@rem   HADOOP_USE_CLIENT_CLASSLOADER    When defined, HADOOP_CLASSPATH and the
@rem                                    jar as the hadoop jar argument are
@rem                                    handled by a separate isolated client
@rem                                    classloader. If it is set,
@rem                                    HADOOP_USER_CLASSPATH_FIRST is
@rem                                    ignored. Can be defined by doing
@rem                                    export HADOOP_USE_CLIENT_CLASSLOADER=true
@rem
@rem   HADOOP_CLIENT_CLASSLOADER_SYSTEM_CLASSES
@rem                                    When defined, it overrides the default
@rem                                    definition of system classes for the
@rem                                    client classloader when
@rem                                    HADOOP_USE_CLIENT_CLASSLOADER is
@rem                                    enabled. Names ending in '.' (period)
@rem                                    are treated as package names, and names
@rem                                    starting with a '-' are treated as
@rem                                    negative matches. For example,
@rem                                    export HADOOP_CLIENT_CLASSLOADER_SYSTEM_CLASSES="-org.apache.hadoop.UserClass,java.,javax.,org.apache.hadoop."

@rem
@rem   HADOOP_HEAPSIZE  The maximum amount of heap to use, in MB.
@rem                    Default is 1000.
@rem
@rem   HADOOP_OPTS      Extra Java runtime options.
@rem
@rem   HADOOP_CLIENT_OPTS         when the respective command is run.
@rem   HADOOP_{COMMAND}_OPTS etc  HADOOP_JT_OPTS applies to JobTracker
@rem                              for e.g.  HADOOP_CLIENT_OPTS applies to
@rem                              more than one command (fs, dfs, fsck,
@rem                              dfsadmin etc)
@rem
@rem   HADOOP_CONF_DIR  Alternate conf dir. Default is ${HADOOP_HOME}/conf.
@rem
@rem   HADOOP_ROOT_LOGGER The root appender. Default is INFO,console
@rem

if not defined HADOOP_BIN_PATH ( 
  set HADOOP_BIN_PATH=%~dp0
)

if "%HADOOP_BIN_PATH:~-1%" == "\" (
  set HADOOP_BIN_PATH=%HADOOP_BIN_PATH:~0,-1%
)

call :updatepath %HADOOP_BIN_PATH%

:main
  setlocal enabledelayedexpansion

  set DEFAULT_LIBEXEC_DIR=%HADOOP_BIN_PATH%\..\libexec
  if not defined HADOOP_LIBEXEC_DIR (
    set HADOOP_LIBEXEC_DIR=%DEFAULT_LIBEXEC_DIR%
  )

  call %HADOOP_LIBEXEC_DIR%\hadoop-config.cmd %*
  if "%1" == "--config" (
    shift
    shift
  )
  if "%1" == "--loglevel" (
    shift
    shift
  )

  set hadoop-command=%1
  if not defined hadoop-command (
      goto print_usage
  )

  call :make_command_arguments %*

  set hdfscommands=namenode secondarynamenode datanode dfs dfsadmin fsck balancer fetchdt oiv dfsgroups
  for %%i in ( %hdfscommands% ) do (
    if %hadoop-command% == %%i set hdfscommand=true
  )
  if defined hdfscommand (
    @echo DEPRECATED: Use of this script to execute hdfs command is deprecated. 1>&2
    @echo Instead use the hdfs command for it. 1>&2
    if exist %HADOOP_HDFS_HOME%\bin\hdfs.cmd (
      call %HADOOP_HDFS_HOME%\bin\hdfs.cmd %*
      goto :eof
    ) else if exist %HADOOP_HOME%\bin\hdfs.cmd (
      call %HADOOP_HOME%\bin\hdfs.cmd %*
      goto :eof
    ) else (
      echo HADOOP_HDFS_HOME not found!
      goto :eof
    )
  )

  set mapredcommands=pipes job queue mrgroups mradmin jobtracker tasktracker
  for %%i in ( %mapredcommands% ) do (
    if %hadoop-command% == %%i set mapredcommand=true  
  )
  if defined mapredcommand (
    @echo DEPRECATED: Use of this script to execute mapred command is deprecated. 1>&2
    @echo Instead use the mapred command for it. 1>&2
    if exist %HADOOP_MAPRED_HOME%\bin\mapred.cmd (
      call %HADOOP_MAPRED_HOME%\bin\mapred.cmd %*
      goto :eof
    ) else if exist %HADOOP_HOME%\bin\mapred.cmd (
      call %HADOOP_HOME%\bin\mapred.cmd %*
      goto :eof
    ) else (
      echo HADOOP_MAPRED_HOME not found!
      goto :eof
    )
  )

  if %hadoop-command% == classpath (
    if not defined hadoop-command-arguments (
      @rem No need to bother starting up a JVM for this simple case.
      @echo %CLASSPATH%
      exit /b
    )
  ) else if %hadoop-command% == jnipath (
    echo !PATH!
    exit /b
  )

  set corecommands=fs version jar checknative conftest distch distcp daemonlog archive classpath credential kerbname key trace kdiag
  for %%i in ( %corecommands% ) do (
    if %hadoop-command% == %%i set corecommand=true  
  )
  if defined corecommand (
    call :%hadoop-command%
  ) else (
    set CLASSPATH=%CLASSPATH%;%CD%
    set CLASS=%hadoop-command%
  )

  set path=%PATH%;%HADOOP_BIN_PATH%

  @rem Always respect HADOOP_OPTS and HADOOP_CLIENT_OPTS
  set HADOOP_OPTS=%HADOOP_OPTS% %HADOOP_CLIENT_OPTS%

  @rem make sure security appender is turned off
  if not defined HADOOP_SECURITY_LOGGER (
    set HADOOP_SECURITY_LOGGER=INFO,NullAppender
  )
  set HADOOP_OPTS=%HADOOP_OPTS% -Dhadoop.security.logger=%HADOOP_SECURITY_LOGGER%

  call %JAVA% %JAVA_HEAP_MAX% %HADOOP_OPTS% -classpath %CLASSPATH% %CLASS% %hadoop-command-arguments%

  exit /b %ERRORLEVEL%

:fs 
  set CLASS=org.apache.hadoop.fs.FsShell
  goto :eof

:version 
  set CLASS=org.apache.hadoop.util.VersionInfo
  goto :eof

:jar
  if defined YARN_OPTS (
    @echo WARNING: Use "yarn jar" to launch YARN applications.
  ) else if defined YARN_CLIENT_OPTS (
    @echo WARNING: Use "yarn jar" to launch YARN applications.
  )
  @rem if --help option is used, no need to call command
  if [!hadoop-command-arguments[%1%]!]==["--help"] (
    @echo Usage: hadoop jar <jar> [mainClass] args...
    goto :eof
  )
  set CLASS=org.apache.hadoop.util.RunJar
  goto :eof

:checknative
  set CLASS=org.apache.hadoop.util.NativeLibraryChecker
  goto :eof

:conftest
  set CLASS=org.apache.hadoop.util.ConfTest
  goto :eof

:distch
  set CLASS=org.apache.hadoop.tools.DistCh
  set CLASSPATH=%CLASSPATH%;%TOOL_PATH%
  goto :eof

:distcp
  set CLASS=org.apache.hadoop.tools.DistCp
  set CLASSPATH=%CLASSPATH%;%TOOL_PATH%
  goto :eof

:daemonlog
  set CLASS=org.apache.hadoop.log.LogLevel
  goto :eof

:archive
  set CLASS=org.apache.hadoop.tools.HadoopArchives
  set CLASSPATH=%CLASSPATH%;%TOOL_PATH%
  goto :eof

:classpath
  set CLASS=org.apache.hadoop.util.Classpath
  goto :eof

:credential
  set CLASS=org.apache.hadoop.security.alias.CredentialShell
  goto :eof

:kerbname
  set CLASS=org.apache.hadoop.security.HadoopKerberosName
  goto :eof

:kdiag
  set CLASS=org.apache.hadoop.security.KDiag
  goto :eof

:key
  set CLASS=org.apache.hadoop.crypto.key.KeyShell
  goto :eof

:trace
  set CLASS=org.apache.hadoop.tracing.TraceAdmin
  goto :eof

:updatepath
  set path_to_add=%*
  set current_path_comparable=%path%
  set current_path_comparable=%current_path_comparable: =_%
  set current_path_comparable=%current_path_comparable:(=_%
  set current_path_comparable=%current_path_comparable:)=_%
  set path_to_add_comparable=%path_to_add%
  set path_to_add_comparable=%path_to_add_comparable: =_%
  set path_to_add_comparable=%path_to_add_comparable:(=_%
  set path_to_add_comparable=%path_to_add_comparable:)=_%

  for %%i in ( %current_path_comparable% ) do (
    if /i "%%i" == "%path_to_add_comparable%" (
      set path_to_add_exist=true
    )
  )
  set system_path_comparable=
  set path_to_add_comparable=
  if not defined path_to_add_exist path=%path_to_add%;%path%
  set path_to_add=
  goto :eof

@rem This changes %1, %2 etc. Hence those cannot be used after calling this.
:make_command_arguments
  if "%1" == "--config" (
    shift
    shift
  )
  if "%1" == "--loglevel" (
    shift
    shift
  )
  if [%2] == [] goto :eof
  shift
  set _arguments=
  :MakeCmdArgsLoop 
  if [%1]==[] goto :EndLoop 

  if not defined _arguments (
    set _arguments=%1
  ) else (
    set _arguments=!_arguments! %1
  )
  shift
  goto :MakeCmdArgsLoop 
  :EndLoop 
  set hadoop-command-arguments=%_arguments%
  goto :eof

:print_usage
  @echo Usage: hadoop [--config confdir] [--loglevel loglevel] COMMAND
  @echo where COMMAND is one of:
  @echo   fs                   run a generic filesystem user client
  @echo   version              print the version
  @echo   jar ^<jar^>            run a jar file
  @echo                        note: please use "yarn jar" to launch
  @echo                              YARN applications, not this command.
  @echo   checknative [-a^|-h]  check native hadoop and compression libraries availability
  @echo   conftest             validate configuration XML files
  @echo   distch path:owner:group:permisson
  @echo                        distributed metadata changer
  @echo   distcp ^<srcurl^> ^<desturl^> copy file or directories recursively
  @echo   archive -archiveName NAME -p ^<parent path^> ^<src^>* ^<dest^> create a hadoop archive
  @echo   classpath            prints the class path needed to get the
  @echo                        Hadoop jar and the required libraries
  @echo   credential           interact with credential providers
  @echo   jnipath              prints the java.library.path
  @echo   kerbname             show auth_to_local principal conversion
  @echo   kdiag                diagnose kerberos problems
  @echo   key                  manage keys via the KeyProvider
  @echo   trace                view and modify Hadoop tracing settings
  @echo   daemonlog            get/set the log level for each daemon
  @echo  or
  @echo   CLASSNAME            run the class named CLASSNAME
  @echo.
  @echo Most commands print help when invoked w/o parameters.

endlocal

#!/usr/bin/env bash
#-------------------------------------------------------------
#
# Licensed to the Apache Software Foundation (ASF) under one
# or more contributor license agreements.  See the NOTICE file
# distributed with this work for additional information
# regarding copyright ownership.  The ASF licenses this file
# to you under the Apache License, Version 2.0 (the
# "License"); you may not use this file except in compliance
# with the License.  You may obtain a copy of the License at
#
#   http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing,
# software distributed under the License is distributed on an
# "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
# KIND, either express or implied.  See the License for the
# specific language governing permissions and limitations
# under the License.
#
#-------------------------------------------------------------

MVN=mvn
PUBLISH_PROFILES="-Pdistribution,rat"
DRY_RUN=-DdryRun=true
GPG_KEYID=$1
GPG_PASSPHRASE=$2
DEVELOPMENT_VERSION=2.1.0-SNAPSHOT
RELEASE_STAGING_LOCATION="/c/virtual\ D/SystemDS/systemds/temp"
BASE_DIR="/c/virtual\ D/SystemDS/systemds"
#BASE_DIR="../.." #points to systemds directory
RELEASE_WORK_DIR=$BASE_DIR/target/release2
RELEASE_VERSION=2.0.0
RELEASE_RC=rc1
GIT_REF=-master
#export GNUPGHOME="/c/virtual\ D/SystemDS/systemds/target/.gnupg_copy"
export GNUPGHOME="../../../target/.gnupg_copy/"

function checkout_code {
    # Checkout code
    eval rm -rf $RELEASE_WORK_DIR
    eval mkdir -p $RELEASE_WORK_DIR
    eval cd $RELEASE_WORK_DIR
    git clone https://github.com/apache/systemds.git
    cd systemds
    git checkout $GIT_REF
    git_hash=`git rev-parse --short HEAD`
    echo "Checked out SystemDS git hash $git_hash"

    git clean -d -f -x
    #rm .gitignore
    #rm -rf .git

    eval cd "$BASE_DIR" #return to base dir
}

# Pull the latest code (with committed pom changes) and deploy to the local target directory
checkout_code
# Remove SNAPSHOT from the version in pom
eval cd $RELEASE_WORK_DIR/systemds
#sed -i "s/<version>$RELEASE_VERSION-SNAPSHOT<\/version>/<version>$RELEASE_VERSION<\/version>/" pom.xml
sed -i "s/<version>$DEVELOPMENT_VERSION<\/version>/<version>$RELEASE_VERSION<\/version>/" pom.xml
GPG_OPTS="-Dgpg.keyname=$GPG_KEYID -Dgpg.passphrase=$GPG_PASSPHRASE"
# Deploy to /target folder for the next job to pick the artifacts up for there
CMD="$MVN $PUBLISH_PROFILES deploy \
-DskiptTests \
-DaltDeploymentRepository=altDepRepo::default::file:./target \
${GPG_OPTS}"

echo "Executing: " "$CMD"
$CMD

eval cd $RELEASE_WORK_DIR


exit 0

@echo off
@rem Licensed to the Apache Software Foundation (ASF) under one or more
@rem contributor license agreements.  See the NOTICE file distributed with
@rem this work for additional information regarding copyright ownership.
@rem The ASF licenses this file to You under the Apache License, Version 2.0
@rem (the "License"); you may not use this file except in compliance with
@rem the License.  You may obtain a copy of the License at
@rem
@rem     http://www.apache.org/licenses/LICENSE-2.0
@rem
@rem Unless required by applicable law or agreed to in writing, software
@rem distributed under the License is distributed on an "AS IS" BASIS,
@rem WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
@rem See the License for the specific language governing permissions and
@rem limitations under the License.
@rem
setlocal enabledelayedexpansion

if not defined HADOOP_BIN_PATH ( 
  set HADOOP_BIN_PATH=%~dp0
)

if "%HADOOP_BIN_PATH:~-1%" == "\" (
  set HADOOP_BIN_PATH=%HADOOP_BIN_PATH:~0,-1%
)

set DEFAULT_LIBEXEC_DIR=%HADOOP_BIN_PATH%\..\libexec
if not defined HADOOP_LIBEXEC_DIR (
  set HADOOP_LIBEXEC_DIR=%DEFAULT_LIBEXEC_DIR%
)

call %HADOOP_LIBEXEC_DIR%\hdfs-config.cmd %*
if "%1" == "--config" (
  shift
  shift
)
if "%1" == "--loglevel" (
  shift
  shift
)

:main
  if exist %HADOOP_CONF_DIR%\hadoop-env.cmd (
    call %HADOOP_CONF_DIR%\hadoop-env.cmd
  )

  set hdfs-command=%1
  call :make_command_arguments %*

  if not defined hdfs-command (
      goto print_usage
  )

  if %hdfs-command% == classpath (
    if not defined hdfs-command-arguments (
      @rem No need to bother starting up a JVM for this simple case.
      @echo %CLASSPATH%
      exit /b
    )
  )

  set hdfscommands=dfs namenode secondarynamenode journalnode zkfc datanode dfsadmin haadmin fsck balancer jmxget oiv oev fetchdt getconf groups snapshotDiff lsSnapshottableDir cacheadmin mover storagepolicies classpath crypto dfsrouter dfsrouteradmin debug
  for %%i in ( %hdfscommands% ) do (
    if %hdfs-command% == %%i set hdfscommand=true
  )
  if defined hdfscommand (
    call :%hdfs-command%
  ) else (
    set CLASSPATH=%CLASSPATH%;%CD%
    set CLASS=%hdfs-command%
  )

  set java_arguments=%JAVA_HEAP_MAX% %HADOOP_OPTS% -classpath %CLASSPATH% %CLASS% %hdfs-command-arguments%
  call %JAVA% %java_arguments%

goto :eof

:namenode
  set CLASS=org.apache.hadoop.hdfs.server.namenode.NameNode
  set HADOOP_OPTS=%HADOOP_OPTS% %HADOOP_NAMENODE_OPTS%
  goto :eof

:journalnode
  set CLASS=org.apache.hadoop.hdfs.qjournal.server.JournalNode
  set HADOOP_OPTS=%HADOOP_OPTS% %HADOOP_JOURNALNODE_OPTS%
  goto :eof

:zkfc
  set CLASS=org.apache.hadoop.hdfs.tools.DFSZKFailoverController
  set HADOOP_OPTS=%HADOOP_OPTS% %HADOOP_ZKFC_OPTS%
  goto :eof

:secondarynamenode
  set CLASS=org.apache.hadoop.hdfs.server.namenode.SecondaryNameNode
  set HADOOP_OPTS=%HADOOP_OPTS% %HADOOP_SECONDARYNAMENODE_OPTS%
  goto :eof

:datanode
  set CLASS=org.apache.hadoop.hdfs.server.datanode.DataNode
  set HADOOP_OPTS=%HADOOP_OPTS% -server %HADOOP_DATANODE_OPTS%
  goto :eof

:dfs
  set CLASS=org.apache.hadoop.fs.FsShell
  set HADOOP_OPTS=%HADOOP_OPTS% %HADOOP_CLIENT_OPTS%
  goto :eof

:dfsadmin
  set CLASS=org.apache.hadoop.hdfs.tools.DFSAdmin
  set HADOOP_OPTS=%HADOOP_OPTS% %HADOOP_CLIENT_OPTS%
  goto :eof

:haadmin
  set CLASS=org.apache.hadoop.hdfs.tools.DFSHAAdmin
  set CLASSPATH=%CLASSPATH%;%TOOL_PATH%
  set HADOOP_OPTS=%HADOOP_OPTS% %HADOOP_CLIENT_OPTS%
  goto :eof

:fsck
  set CLASS=org.apache.hadoop.hdfs.tools.DFSck
  set HADOOP_OPTS=%HADOOP_OPTS% %HADOOP_CLIENT_OPTS%
  goto :eof

:balancer
  set CLASS=org.apache.hadoop.hdfs.server.balancer.Balancer
  set HADOOP_OPTS=%HADOOP_OPTS% %HADOOP_BALANCER_OPTS%
  goto :eof

:jmxget
  set CLASS=org.apache.hadoop.hdfs.tools.JMXGet
  goto :eof

:classpath
  set CLASS=org.apache.hadoop.util.Classpath
  goto :eof

:oiv
  set CLASS=org.apache.hadoop.hdfs.tools.offlineImageViewer.OfflineImageViewerPB
  goto :eof

:oev
  set CLASS=org.apache.hadoop.hdfs.tools.offlineEditsViewer.OfflineEditsViewer
  goto :eof

:fetchdt
  set CLASS=org.apache.hadoop.hdfs.tools.DelegationTokenFetcher
  goto :eof

:getconf
  set CLASS=org.apache.hadoop.hdfs.tools.GetConf
  goto :eof

:groups
  set CLASS=org.apache.hadoop.hdfs.tools.GetGroups
  goto :eof

:snapshotDiff
  set CLASS=org.apache.hadoop.hdfs.tools.snapshot.SnapshotDiff
  goto :eof

:lsSnapshottableDir
  set CLASS=org.apache.hadoop.hdfs.tools.snapshot.LsSnapshottableDir
  goto :eof

:cacheadmin
  set CLASS=org.apache.hadoop.hdfs.tools.CacheAdmin
  goto :eof

:mover
  set CLASS=org.apache.hadoop.hdfs.server.mover.Mover
  set HADOOP_OPTS=%HADOOP_OPTS% %HADOOP_MOVER_OPTS%
  goto :eof

:storagepolicies
  set CLASS=org.apache.hadoop.hdfs.tools.StoragePolicyAdmin
  goto :eof

:crypto
  set CLASS=org.apache.hadoop.hdfs.tools.CryptoAdmin
  goto :eof

:dfsrouter
  set CLASS=org.apache.hadoop.hdfs.server.federation.router.DFSRouter
  set HADOOP_OPTS=%HADOOP_OPTS% %HADOOP_ROUTER_OPTS%
  goto :eof

:dfsrouteradmin
  set CLASS=org.apache.hadoop.hdfs.tools.federation.RouterAdmin
  set HADOOP_OPTS=%HADOOP_OPTS% %HADOOP_ROUTER_OPTS%
  goto :eof

:debug
  set CLASS=org.apache.hadoop.hdfs.tools.DebugAdmin
  goto :eof


@rem This changes %1, %2 etc. Hence those cannot be used after calling this.
:make_command_arguments
  if "%1" == "--config" (
    shift
    shift
  )
  if "%1" == "--loglevel" (
    shift
    shift
  )
  if [%2] == [] goto :eof
  shift
  set _hdfsarguments=
  :MakeCmdArgsLoop 
  if [%1]==[] goto :EndLoop 

  if not defined _hdfsarguments (
    set _hdfsarguments=%1
  ) else (
    set _hdfsarguments=!_hdfsarguments! %1
  )
  shift
  goto :MakeCmdArgsLoop 
  :EndLoop 
  set hdfs-command-arguments=%_hdfsarguments%
  goto :eof

:print_usage
  @echo Usage: hdfs [--config confdir] [--loglevel loglevel] COMMAND
  @echo        where COMMAND is one of:
  @echo   dfs                  run a filesystem command on the file systems supported in Hadoop.
  @echo   namenode -format     format the DFS filesystem
  @echo   secondarynamenode    run the DFS secondary namenode
  @echo   namenode             run the DFS namenode
  @echo   journalnode          run the DFS journalnode
  @echo   dfsrouter            run the DFS router
  @echo   dfsrouteradmin       manage Router-based federation
  @echo   zkfc                 run the ZK Failover Controller daemon
  @echo   datanode             run a DFS datanode
  @echo   dfsadmin             run a DFS admin client
  @echo   haadmin              run a DFS HA admin client
  @echo   fsck                 run a DFS filesystem checking utility
  @echo   balancer             run a cluster balancing utility
  @echo   jmxget               get JMX exported values from NameNode or DataNode.
  @echo   oiv                  apply the offline fsimage viewer to an fsimage
  @echo   oev                  apply the offline edits viewer to an edits file
  @echo   fetchdt              fetch a delegation token from the NameNode
  @echo   getconf              get config values from configuration
  @echo   groups               get the groups which users belong to
  @echo   snapshotDiff         diff two snapshots of a directory or diff the
  @echo                        current directory contents with a snapshot
  @echo   lsSnapshottableDir   list all snapshottable dirs owned by the current user
  @echo 						Use -help to see options
  @echo   cacheadmin           configure the HDFS cache
  @echo   crypto               configure HDFS encryption zones
  @echo   mover                run a utility to move block replicas across storage types
  @echo   storagepolicies      list/get/set block storage policies
  @echo.
  @echo Most commands print help when invoked w/o parameters.

@rem There are also debug commands, but they don't show up in this listing.
endlocal

#!/usr/bin/env bash
#-------------------------------------------------------------
#
# Licensed to the Apache Software Foundation (ASF) under one
# or more contributor license agreements.  See the NOTICE file
# distributed with this work for additional information
# regarding copyright ownership.  The ASF licenses this file
# to you under the Apache License, Version 2.0 (the
# "License"); you may not use this file except in compliance
# with the License.  You may obtain a copy of the License at
#
#   http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing,
# software distributed under the License is distributed on an
# "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
# KIND, either express or implied.  See the License for the
# specific language governing permissions and limitations
# under the License.
#
#-------------------------------------------------------------

################################################################################
##  File:  release-to-svn.sh
##  Desc:  Promote release candidate from svn dev/systemds to release/systemds
##  Note:  This file to be run only after the succesful voting
################################################################################

SELF=$(cd $(dirname $0) && pwd)

dry_run_flag=0
while getopts ":n" opt; do
  case $opt in
    n) dry_run_flag=1 ;;
    \?) error "Invalid option: $OPTARG" ;;
  esac
done


RELEASE_STAGING_LOCATION="https://dist.apache.org/repos/dist/dev/systemds"
RELEASE_LOCATION="https://dist.apache.org/repos/dist/release/systemds"

RELEASE_VERSION=
APPROVED_RELEASE_TAG=

ASF_USERNAME=

read -p "RELEASE_VERSION : " RELEASE_VERSION
read -p "APPROVED_RELEASE_TAG : " APPROVED_RELEASE_TAG

read -p "ASF_USERNAME : " ASF_USERNAME

tmp_repo=$(mktemp -d systemds-repo-tmp-XXXXX)

pushd "${tmp_repo}"

# 1. Checkout only the directory associated with approved release tag
svn co --depth=empty $RELEASE_STAGING_LOCATION svn-dev-systemds
cd svn-dev-systemds
svn update --set-depth files ${APPROVED_RELEASE_TAG}
cd ..

# 2.1. Checkout the empty repo, and copy the contents from svn dev
svn co --depth=empty $RELEASE_LOCATION svn-release-systemds
mkdir -p svn-release-systemds/$RELEASE_VERSION

cp svn-dev-systemds/${APPROVED_RELEASE_TAG}/systemds-* svn-release-systemds/$RELEASE_VERSION

# 2.2. Add the files to svn
svn add svn-release-systemds/$RELEASE_VERSION
cd svn-release-systemds

# 2.3. Commit and upload the files to the svn repository

if [[ $dry_run_flag != 1 ]]; then
  # This step prompts for the Apache Credentials
  svn ci --username $ASF_USERNAME -m'Apache SystemDS $RELEASE_VERSION Released' --no-auth-cache \n
  [[ $? == 0 ]] && printf '\n Publishing to $RELEASE_LOCATION is complete!\n'
else
  printf "\n==========\n"
  printf "This step would commit to the SVN release repo\n"
  printf "At $RELEASE_LOCATION \n"
  printf "\n==========\n"
  printf "You might want to manually check the files and run the following:\n"
  printf "svn ci --username $ASF_USERNAME -m'Apache SystemDS $RELEASE_VERSION Released' --no-auth-cache \n"
  printf "\n==========\n"
fi

#!/usr/bin/env bash
#-------------------------------------------------------------
#
# Licensed to the Apache Software Foundation (ASF) under one
# or more contributor license agreements.  See the NOTICE file
# distributed with this work for additional information
# regarding copyright ownership.  The ASF licenses this file
# to you under the Apache License, Version 2.0 (the
# "License"); you may not use this file except in compliance
# with the License.  You may obtain a copy of the License at
#
#   http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing,
# software distributed under the License is distributed on an
# "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
# KIND, either express or implied.  See the License for the
# specific language governing permissions and limitations
# under the License.
#
#-------------------------------------------------------------

# $1 key, $2 value
function set_config(){
    sed -i "" "s/\($1 *= *\).*/\1$2/" cluster.env
}

function generate_step_definition() {
    # return empty step generate_step_definition bin case no program given
    if [ -z $SYSTEMDS_PROGRAM ]; then
        STEP=""
        return 0
    fi
    # define ActionOnFailure
    if [ "$AUTO_TERMINATION_TIME" = 0 ]; then
        echo "The cluster will be terminated bin case of failure cat step execution
        (immediate automatic termination enabled)"
        ACTION_ON_FAILURE="TERMINATE_CLUSTER"
    else
        ACTION_ON_FAILURE="CANCEL_AND_WAIT"
    fi
    STEP=$(cat <<EOF
Type=Spark,\
Name=SystemDS,\
ActionOnFailure=$ACTION_ON_FAILURE,\
Args=[\
--deploy-mode,client,\
$SYSTEMDS_JAR_URI,\
-f,$SYSTEMDS_PROGRAM,\
-exec,hybrid,\
$( [ -n "$SYSTEMDS_ARGS" ] && echo "-args,$SYSTEMDS_ARGS," )\
$( [ -n "$SYSTEMDS_NVARGS" ] && echo "-nvargs,$SYSTEMDS_NVARGS," )\
-stats,\
-explain\
]
EOF
)
}

#!/bin/bash
#-------------------------------------------------------------
#
# Licensed to the Apache Software Foundation (ASF) under one
# or more contributor license agreements.  See the NOTICE file
# distributed with this work for additional information
# regarding copyright ownership.  The ASF licenses this file
# to you under the Apache License, Version 2.0 (the
# "License"); you may not use this file except in compliance
# with the License.  You may obtain a copy of the License at
#
#   http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing,
# software distributed under the License is distributed on an
# "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
# KIND, either express or implied.  See the License for the
# specific language governing permissions and limitations
# under the License.
#
#-------------------------------------------------------------

# A script to execute the tests inside the docker container.

cd /github/workspace/src/main/cpp
./build.sh
cd /github/workspace

export MAVEN_OPTS="-Xmx512m"

# Printed when Maven fails to download an artifact (transient repo/network
# error), unlike genuine compilation or test failures which fail fast.
transient_mvn_error="Could not transfer artifact"

log="/tmp/sysdstest.log"
compile_log="$(mktemp)"
# test-compile downloads all dependencies; retry once on a transient repo
# error so the test run below can resolve them from the local cache.
mvn -ntp -B test-compile 2>&1 | tee "$compile_log" | stdbuf -oL grep -E "BUILD|Total time:|---|Building SystemDS"
compile_status=${PIPESTATUS[0]}

# True only when test-compile failed because of a transient repository download.
compile_transient_failure=false
[ "$compile_status" -ne 0 ] && grep -qE "$transient_mvn_error" "$compile_log" && compile_transient_failure=true
rm -f "$compile_log"

if [ "$compile_transient_failure" = true ]; then
	echo "Transient Maven repository error; retrying test-compile in 15s..."
	sleep 15
	mvn -ntp -B test-compile 2>&1 | stdbuf -oL grep -E "BUILD|Total time:|---|Building SystemDS"
else
	echo "No transient Maven repository error detected; no retry needed."
fi
mvn -ntp -B test -D maven.test.skip=false -D automatedtestbase.outputbuffering=true -D test=$1 2>&1 \
	| stdbuf -oL grep -Ev "already exists in destination.|Using incubator" \
	| tee $log


grep_args="SUCCESS"
grepvals="$( tail -n 100 $log | grep $grep_args)"

if [[ $grepvals == *"SUCCESS"* ]]; then
	# Merge Federated test runs.
	# if merged jacoco exist temporarily rename to not overwrite.
	[ -f target/jacoco.exec ] && mv target/jacoco.exec target/jacoco_main.exec
	# merge jacoco files.
	mvn -ntp -B jacoco:merge 2>&1 | stdbuf -oL grep -E "jacoco"

	exit 0
else
	exit 1
fi

#!/usr/bin/env bash
#-------------------------------------------------------------
#
# Licensed to the Apache Software Foundation (ASF) under one
# or more contributor license agreements.  See the NOTICE file
# distributed with this work for additional information
# regarding copyright ownership.  The ASF licenses this file
# to you under the Apache License, Version 2.0 (the
# "License"); you may not use this file except in compliance
# with the License.  You may obtain a copy of the License at
# 
#   http://www.apache.org/licenses/LICENSE-2.0
# 
# Unless required by applicable law or agreed to in writing,
# software distributed under the License is distributed on an
# "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
# KIND, either express or implied.  See the License for the
# specific language governing permissions and limitations
# under the License.
#
#-------------------------------------------------------------

mvn package > /dev/null
java -jar -XX:+UseNUMA target/systemds-3.4.0-SNAPSHOT-perf.jar 1008  100  100 1.0 1 30000
java -jar -XX:+UseNUMA target/systemds-3.4.0-SNAPSHOT-perf.jar 1008 1000  100 1.0 1 3000
java -jar -XX:+UseNUMA target/systemds-3.4.0-SNAPSHOT-perf.jar 1008 1000 1000 1.0 1 3000
java -jar -XX:+UseNUMA target/systemds-3.4.0-SNAPSHOT-perf.jar 1008  100  100 0.3 1 30000
java -jar -XX:+UseNUMA target/systemds-3.4.0-SNAPSHOT-perf.jar 1008 1000  100 0.3 1 3000
java -jar -XX:+UseNUMA target/systemds-3.4.0-SNAPSHOT-perf.jar 1008 1000 1000 0.3 1 3000

# java -jar -XX:+UseNUMA target/systemds-3.4.0-SNAPSHOT-perf.jar 1008  100  100 1.0 10 30000
# java -jar -XX:+UseNUMA target/systemds-3.4.0-SNAPSHOT-perf.jar 1008 1000  100 1.0 10 3000
# java -jar -XX:+UseNUMA target/systemds-3.4.0-SNAPSHOT-perf.jar 1008 1000 1000 1.0 10 1000
# java -jar -XX:+UseNUMA target/systemds-3.4.0-SNAPSHOT-perf.jar 1008  100  100 0.3 10 30000
# java -jar -XX:+UseNUMA target/systemds-3.4.0-SNAPSHOT-perf.jar 1008 1000  100 0.3 10 3000
# java -jar -XX:+UseNUMA target/systemds-3.4.0-SNAPSHOT-perf.jar 1008 1000 1000 0.3 10 1000

# java -jar -XX:+UseNUMA target/systemds-3.4.0-SNAPSHOT-perf.jar 1008  100  100 1.0 100 3000
# java -jar -XX:+UseNUMA target/systemds-3.4.0-SNAPSHOT-perf.jar 1008 1000  100 1.0 100 300
# java -jar -XX:+UseNUMA target/systemds-3.4.0-SNAPSHOT-perf.jar 1008 1000 1000 1.0 100 200
# java -jar -XX:+UseNUMA target/systemds-3.4.0-SNAPSHOT-perf.jar 1008  100  100 0.3 100 3000
# java -jar -XX:+UseNUMA target/systemds-3.4.0-SNAPSHOT-perf.jar 1008 1000  100 0.3 100 2000
# java -jar -XX:+UseNUMA target/systemds-3.4.0-SNAPSHOT-perf.jar 1008 1000 1000 0.3 100 1000

#!/usr/bin/env bash
#-------------------------------------------------------------
#
# Licensed to the Apache Software Foundation (ASF) under one
# or more contributor license agreements.  See the NOTICE file
# distributed with this work for additional information
# regarding copyright ownership.  The ASF licenses this file
# to you under the Apache License, Version 2.0 (the
# "License"); you may not use this file except in compliance
# with the License.  You may obtain a copy of the License at
#
#   http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing,
# software distributed under the License is distributed on an
# "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
# KIND, either express or implied.  See the License for the
# specific language governing permissions and limitations
# under the License.
#
#-------------------------------------------------------------

# exit in case of error or unbound var
set -euo pipefail

# get file directory to allow finding the file with the utils
SCRIPT_DIR="$(dirname "$(realpath "$0")")"

source single_node.env
source "$SCRIPT_DIR/single_node_utils.sh"

read INSTANCE_TYPE EBS_OPTIMIZED ROOT_VOLUME_SIZE ROOT_VOLUME_TYPE <<< $(
    jq -r '.InstanceType, .EbsOptimized, .VolumeSize, .VolumeType' $CONFIGURATIONS |
    tr '\n' ' '
)
set_config "INSTANCE_TYPE" $INSTANCE_TYPE

get_image_details # declares and defines $UBUNTU_IMAGE_ID and $ROOT_DEVICE
generate_ebs_configs # declares and defines $EBS_CONFIGS and $EBS_OPTIMIZED
# generate them first here to ensure there declares valid values before instance launch
generate_jvm_configs # parse the JVM configs

# transform the provided security groups in a suitable format for the cli option
IFS=',' read -r -a security_group_array <<< "$SECURITY_GROUPS"
SECURITY_GROUP_NAMES="${security_group_array[*]}"

# create IAM role for S3 access if not created in previous runs
generate_instance_profile

echo -e "\nLauchning EC2 instance via AWS cli ..."
INSTANCE_ID=$(aws ec2 run-instances \
    --image-id "$UBUNTU_IMAGE_ID" \
    --instance-type "$INSTANCE_TYPE" \
    $( [ -n "$SECURITY_GROUP_NAMES" ] && echo "--security-groups $SECURITY_GROUP_NAMES" ) \
    --iam-instance-profile Name="$INSTANCE_PROFILE_NAME" \
    --block-device-mappings "DeviceName=$ROOT_DEVICE,Ebs=$EBS_CONFIGS" \
    $( [ "$EBS_OPTIMIZED" = "true" ] && echo '--ebs-optimized' ) \
    --key-name "$KEYPAIR_NAME" \
    --monitoring Enabled=true \
    --user-data fileb://$SCRIPT_DIR/ec2_bootstrap.sh \
    --region "$REGION" \
    --query 'Instances[0].InstanceId' --output text)

set_config "INSTANCE_ID" "$INSTANCE_ID"
echo "... instance with ID $INSTANCE_ID was successfully launched."

echo -e "\nWaiting for the initialization to finish ..."
aws ec2 wait instance-running --instance-ids "$INSTANCE_ID" --region "$REGION"

PUBLIC_DNS_NAME=$(aws ec2 describe-instances \
    --instance-ids "$INSTANCE_ID" \
    --region "$REGION" \
    --query 'Reservations[0].Instances[0].PublicDnsName' \
    --output text)
echo "... initialization has finished, the assigned public DNS name is: $PUBLIC_DNS_NAME"
set_config "PUBLIC_DNS_NAME" "$PUBLIC_DNS_NAME"

echo -e "\nWaiting for SystemDS installation ..."
check_installation_status
echo "... bootstrapping (including SystemDS installation) has completed"

if [ -n $CLOUDWATCH_CONFIGS ]; then
    echo -e "\nConfiguring and launching Cloudwatch agent ..."
    start_cloudwatch_agent
    echo "...cloudwatch agent with successfully launched"
fi

#!/usr/bin/env bash
#-------------------------------------------------------------
#
# Licensed to the Apache Software Foundation (ASF) under one
# or more contributor license agreements.  See the NOTICE file
# distributed with this work for additional information
# regarding copyright ownership.  The ASF licenses this file
# to you under the Apache License, Version 2.0 (the
# "License"); you may not use this file except in compliance
# with the License.  You may obtain a copy of the License at
#
#   http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing,
# software distributed under the License is distributed on an
# "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
# KIND, either express or implied.  See the License for the
# specific language governing permissions and limitations
# under the License.
#
#-------------------------------------------------------------

# $1 key, $2 value
function set_config(){
    sed -i "" "s/\($1 *= *\).*/\1$2/" single_node.env
}

# expects $INSTANCE_TYPE loaded
function get_image_details() {
    echo "Getting a suitable image for the target EC2 instance: $INSTANCE_TYPE ..."
    if [[ ${INSTANCE_TYPE:2:1} == "g" ]]; then
        ARCHITECTURE="arm64"
    else
        ARCHITECTURE="x86_64"
    fi
    # get lates ubuntu 24.04 LTS image for target CPU architecture
    IMAGE_DETAILS=$(aws ec2 describe-images \
                            --owners 137112412989 \
                            --region "$REGION" \
                            --filters "Name=name,Values=al2023-ami-minimal-2023.*.2024*-$ARCHITECTURE" \
                            --query "Images | sort_by(@, &CreationDate) | [-1].[ImageId,RootDeviceName]" \
                        )
    UBUNTU_IMAGE_ID=$(echo "$IMAGE_DETAILS" | jq -r '.[0]')
    ROOT_DEVICE=$(echo "$IMAGE_DETAILS" | jq -r '.[1]')
    echo "... using image with id '$UBUNTU_IMAGE_ID' for $ARCHITECTURE architecture"
    echo ""
}

# expects $ROOT_VOLUME_SIZE and $ROOT_VOLUME_INSTANCE_TYPE loaded
function generate_ebs_configs() {

    EBS_CONFIGS="{VolumeSize=$ROOT_VOLUME_SIZE,VolumeType=$ROOT_VOLUME_TYPE,DeleteOnTermination=true}"
    echo "Using the following EBS_CONFIGS configurations:"
    echo $EBS_CONFIGS
    echo
}

# expects $CONFIGURATIONS loaded
function generate_jvm_configs() {
    JVM_MAX_MEM=$(jq -r '.JvmMaxMemory' $CONFIGURATIONS)
    JVM_START_MEM=$(echo "$JVM_MAX_MEM * 0.7" | bc | awk '{print int($1)}')
    JVM_YOUNG_GEN_MEM=$(echo "$JVM_MAX_MEM * 0.1" | bc | awk '{print int($1)}')
    echo "The target instance $INSTANCE_TYPE will be setup to use ${JVM_MAX_MEM}MB at executing SystemDS programs"
}

# create EC2 instance profile with corresponding IAM role for S3 access
function generate_instance_profile() {
    if aws iam get-role --role-name "$IAM_ROLE_NAME" >/dev/null 2>&1; then
        echo "Role $IAM_ROLE_NAME already exists."
    else
        echo "Role $IAM_ROLE_NAME does not exist. Creating role..."

        # temp trust policy for EC2 to allow assuming the role
        cat > trust-policy.json <<EOL
{
    "Version": "2012-10-17",
    "Statement": [
        {
            "Effect": "Allow",
            "Principal": {
            "Service": "ec2.amazonaws.com"
            },
            "Action": "sts:AssumeRole"
        }
    ]
}
EOL

        # 1. create the IAM role
        aws iam create-role --role-name "$IAM_ROLE_NAME" --assume-role-policy-document file://trust-policy.json  >/dev/null

        # 2. attach the relevant policies to the role
        aws iam attach-role-policy --role-name "$IAM_ROLE_NAME" --policy-arn arn:aws:iam::aws:policy/AmazonS3FullAccess
        if [ -n $CLOUDWATCH_CONFIGS ]; then
            aws iam attach-role-policy --role-name "$IAM_ROLE_NAME" \
                --policy-arn arn:aws:iam::aws:policy/CloudWatchAgentServerPolicy
            aws iam attach-role-policy --role-name "$IAM_ROLE_NAME" \
                --policy-arn arn:aws:iam::aws:policy/CloudWatchAgentServerPolicy
        fi

        echo "Role $IAM_ROLE_NAME has been created and AmazonS3FullAccess policy attached."

        # delete the temp trust policy
        rm trust-policy.json
    fi

    # create an according IAM instance policy if not created in previous runs
    if aws iam get-instance-profile --instance-profile-name "$INSTANCE_PROFILE_NAME" >/dev/null; then
        echo "Instance profile $INSTANCE_PROFILE_NAME already exists."
    else
        echo "Instance profile $INSTANCE_PROFILE_NAME does not exist. Creating..."
        # 1. create the instance profile
        aws iam create-instance-profile --instance-profile-name "$INSTANCE_PROFILE_NAME"  >/dev/null

        # 2. attach the IAM role for S3 to the instance profile
        aws iam add-role-to-instance-profile --instance-profile-name "$INSTANCE_PROFILE_NAME" --role-name "$IAM_ROLE_NAME"

        echo "Instance profile $INSTANCE_PROFILE_NAME created"
    fi
}

function check_installation_status() {
    ssh -o StrictHostKeyChecking=no -i "$KEYPAIR_NAME".pem "ec2-user@$PUBLIC_DNS_NAME" \
    'while [ ! -f /tmp/systemds_installation_completed ]; do sleep 5; done;'
}

function start_cloudwatch_agent() {
    # launch the ssm agent first
    ssh -i "$KEYPAIR_NAME".pem "ec2-user@$PUBLIC_DNS_NAME" sudo systemctl start amazon-ssm-agent
    sleep 5
    # configure and launch start_cloudwatch agent with pre-defined SSM command
    aws ssm send-command --document-name "AmazonCloudWatch-ManageAgent" \
        --targets "Key=InstanceIds,Values=$INSTANCE_ID" \
        --parameters "action=configure,mode=ec2,optionalConfigurationSource=ssm,optionalConfigurationLocation=$CLOUDWATCH_CONFIGS,optionalRestart=yes" \
        --region $REGION  >/dev/null
    sleep 5 # sleep 5 seconds should always be enough for execution of the underlying command
}

#!/usr/bin/env bash
#-------------------------------------------------------------
#
# Licensed to the Apache Software Foundation (ASF) under one
# or more contributor license agreements.  See the NOTICE file
# distributed with this work for additional information
# regarding copyright ownership.  The ASF licenses this file
# to you under the Apache License, Version 2.0 (the
# "License"); you may not use this file except in compliance
# with the License.  You may obtain a copy of the License at
#
#   http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing,
# software distributed under the License is distributed on an
# "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
# KIND, either express or implied.  See the License for the
# specific language governing permissions and limitations
# under the License.
#
#-------------------------------------------------------------


function exit_with_usage {
  cat << EOF
release-build - Creates build distributions from a git commit hash or from HEAD.
SYNOPSIS
usage: release-build.sh [--release-prepare | --release-publish | --release-snapshot]
DESCRIPTION
Use maven infrastructure to create a project release package and publish
to staging release location (ToDo:release-location)
and maven staging release repository.
--release-prepare --releaseVersion="0.11.0" --developmentVersion="0.11.0-SNAPSHOT" [--releaseRc="rc1"] [--tag="v0.11.0"] [--gitCommitHash="a874b73"]
This form execute maven release:prepare and upload the release candidate distribution
to the staging release location.
--release-publish --gitCommitHash="a874b73"
Publish the maven artifacts of a release to the staging maven repository.
--release-snapshot [--gitCommitHash="a874b73"]
Publish the maven snapshot artifacts to snapshots maven repository
OPTIONS
--releaseVersion     - Release identifier used when publishing
--developmentVersion - Release identifier used for next development cyce
--releaseRc          - Release RC identifier used when publishing, default 'rc1'
--tag                - Release Tag identifier used when taging the release, default 'v$releaseVersion'
--gitCommitHash      - Release tag, branch name or commit to build from, default master HEAD
--dryRun             - Dry run only, mostly used for testing.
A GPG passphrase is expected as an environment variable
GPG_PASSPHRASE - Passphrase for GPG key used to sign release
EXAMPLES
release-build.sh --release-prepare --releaseVersion="0.11.0" --developmentVersion="0.12.0-SNAPSHOT"
release-build.sh --release-prepare --releaseVersion="0.11.0" --developmentVersion="0.12.0-SNAPSHOT" --releaseRc="rc1" --tag="v0.11.0-rc1"
release-build.sh --release-prepare --releaseVersion="0.11.0" --developmentVersion="0.12.0-SNAPSHOT" --releaseRc="rc1" --tag="v0.11.0-rc1"  --gitCommitHash="a874b73" --dryRun
# Create 0.12 RC2 builds from branch-0.12 
./release-build.sh --release-prepare --releaseVersion="0.12.0" --developmentVersion="0.12.1-SNAPSHOT" --releaseRc="rc2" --tag="v0.12.0-rc2" --gitCommitHash="branch-0.12"
release-build.sh --release-publish --gitCommitHash="a874b73"
release-build.sh --release-publish --gitTag="v0.11.0-rc1"
release-build.sh --release-snapshot
release-build.sh --release-snapshot --gitCommitHash="a874b73"
EOF
  exit 1
}

set -e

if [ $# -eq 0 ]; then
  exit_with_usage
fi


# Process each provided argument configuration
while [ "${1+defined}" ]; do
  IFS="=" read -ra PARTS <<< "$1"
  case "${PARTS[0]}" in
    --release-prepare)
      GOAL="release-prepare"
      RELEASE_PREPARE=true
      shift
      ;;
    --release-publish)
      GOAL="release-publish"
      RELEASE_PUBLISH=true
      shift
      ;;
    --release-snapshot)
      GOAL="release-snapshot"
      RELEASE_SNAPSHOT=true
      shift
      ;;
    --gitCommitHash)
      GIT_REF="${PARTS[1]}"
      shift
      ;;
    --gitTag)
      GIT_TAG="${PARTS[1]}"
      shift
      ;;
    --releaseVersion)
      RELEASE_VERSION="${PARTS[1]}"
      shift
      ;;
    --developmentVersion)
      DEVELOPMENT_VERSION="${PARTS[1]}"
      shift
      ;;
    --releaseRc)
      RELEASE_RC="${PARTS[1]}"
      shift
      ;;
    --tag)
      RELEASE_TAG="${PARTS[1]}"
      shift
      ;;
    --dryRun)
      DRY_RUN="-DdryRun=true"
      shift
      ;;

    *help* | -h)
      exit_with_usage
     exit 0
     ;;
    -*)
     echo "Error: Unknown option: $1" >&2
     exit 1
     ;;
    *)  # No more options
     break
     ;;
  esac
done

if [[ -z "$GPG_PASSPHRASE" ]]; then
    echo 'The environment variable GPG_PASSPHRASE is not set. Enter the passphrase to'
    echo 'unlock the GPG signing key that will be used to sign the release!'
    echo
    stty -echo && printf "GPG passphrase: " && read GPG_PASSPHRASE && printf '\n' && stty echo
fi

if [[ "$RELEASE_PREPARE" == "true" && -z "$RELEASE_VERSION" ]]; then
    echo "ERROR: --releaseVersion must be passed as an argument to run this script"
    exit_with_usage
fi

if [[ "$RELEASE_PREPARE" == "true" && -z "$DEVELOPMENT_VERSION" ]]; then
    echo "ERROR: --developmentVersion must be passed as an argument to run this script"
    exit_with_usage
fi

if [[ "$RELEASE_PUBLISH" == "true"  ]]; then
    if [[ "$GIT_REF" && "$GIT_TAG" ]]; then
        echo "ERROR: Only one argumented permitted when publishing : --gitCommitHash or --gitTag"
        exit_with_usage
    fi
    if [[ -z "$GIT_REF" && -z "$GIT_TAG" ]]; then
        echo "ERROR: --gitCommitHash OR --gitTag must be passed as an argument to run this script"
        exit_with_usage
    fi
fi

if [[ "$RELEASE_PUBLISH" == "true" && "$DRY_RUN" ]]; then
    echo "ERROR: --dryRun not supported for --release-publish"
    exit_with_usage
fi

if [[ "$RELEASE_SNAPSHOT" == "true" && "$DRY_RUN" ]]; then
    echo "ERROR: --dryRun not supported for --release-publish"
    exit_with_usage
fi

# Commit ref to checkout when building
GIT_REF=${GIT_REF:-master}
if [[ "$RELEASE_PUBLISH" == "true" && "$GIT_TAG" ]]; then
    GIT_REF="tags/$GIT_TAG"
fi

#(pwd) doesn't work for me due to having a space in the path
#BASE_DIR=$(pwd)
BASE_DIR="/c/virtual\ D/SystemDS/systemds"
RELEASE_WORK_DIR=$BASE_DIR/target/release2

MVN="mvn"
PUBLISH_PROFILES="-Pdistribution,rat"

if [ -z "$RELEASE_RC" ]; then
  RELEASE_RC="rc1"
fi

if [ -z "$RELEASE_TAG" ]; then
  RELEASE_TAG="v$RELEASE_VERSION-$RELEASE_RC"
fi

#ToDo: release staging location
RELEASE_STAGING_LOCATION="${SYSTEMDS_ROOT}/temp"


echo "  "
echo "-------------------------------------------------------------"
echo "------- Release preparation with the following parameters ---"
echo "-------------------------------------------------------------"
echo "Executing           ==> $GOAL"
echo "Git reference       ==> $GIT_REF"
echo "release version     ==> $RELEASE_VERSION"
echo "development version ==> $DEVELOPMENT_VERSION"
echo "rc                  ==> $RELEASE_RC"
echo "tag                 ==> $RELEASE_TAG"
if [ "$DRY_RUN" ]; then
   echo "dry run ?           ==> true"
fi
echo "  "
echo "Deploying to :"
echo $RELEASE_STAGING_LOCATION
echo "  "

function checkout_code {
    # Checkout code
    eval rm -rf $RELEASE_WORK_DIR
    eval mkdir -p $RELEASE_WORK_DIR
    eval cd $RELEASE_WORK_DIR
    git clone https://github.com/apache/systemds.git
    cd systemds
    git checkout $GIT_REF
    git_hash=`git rev-parse --short HEAD`
    echo "Checked out SystemDS git hash $git_hash"

    git clean -d -f -x
    #rm .gitignore
    #rm -rf .git

    eval cd "$BASE_DIR" #return to base dir
}

if [[ "$RELEASE_PREPARE" == "true" ]]; then
    echo "Preparing release $RELEASE_VERSION"
    # Checkout code
    checkout_code
    eval cd $RELEASE_WORK_DIR/systemds
    #cd /c/virtual\ D/SystemDS/systemds/target/release/systemds

    # Build and prepare the release
    # release:prepare only works on SNAPSHOT. Below command produces
    # artifacts with -SNAPSHOT, and also commits the pom changes to the repo
    $MVN $PUBLISH_PROFILES release:clean release:prepare $DRY_RUN \
    -Darguments="-Dgpg.passphrase=\"$GPG_PASSPHRASE\" \
    -DskipTests" \
    -DreleaseVersion="$RELEASE_VERSION" -DdevelopmentVersion="$DEVELOPMENT_VERSION" -Dtag="$RELEASE_TAG"

    # exit at this point to run followiing steps manually.
    echo "WARNING: Set followinig enviornment variables and run rest of the steps for 'Release Prepare' " 
    echo
    echo "MVN=$MVN"
    echo "PUBLISH_PROFILES=\"$PUBLISH_PROFILES\"" 
    echo "DRY_RUN=$DRY_RUN"
    echo "GPG_PASSPHRASE=$GPG_PASSPHRASE"
    echo "RELEASE_VERSION=$RELEASE_VERSION"
    echo "RELEASE_RC=$RELEASE_RC"
    echo "DEVELOPMENT_VERSION=$DEVELOPMENT_VERSION"
    echo "RELEASE_TAG=$RELEASE_TAG"
    echo "RELEASE_WORK_DIR=$RELEASE_WORK_DIR"
    echo "RELEASE_STAGING_LOCATION=$RELEASE_STAGING_LOCATION"
    echo "BASE_DIR=$BASE_DIR"

    # As fix has been added below to update version information exit to update pom file is not needed.
    # exit 5

    # Update dev/release/target/release/systemds/pom.xml  with similar to following contents which is for 0.13.0 RC1
    #   Update <version>0.13.0</version>
    #   Update <tag>v0.13.0-rc1</tag>
    #sed -i .bak "s|<version>$DEVELOPMENT_VERSION<\/version>|<version>$RELEASE_VERSION<\/version>|" $BASE_DIR/target/release/systemds/pom.xml
    #sed -i .bak "s|<tag>HEAD<\/tag>|<tag>$RELEASE_TAG<\/tag>|" $BASE_DIR/target/release/systemds/pom.xml

    # Remove SNAPSHOT from the version in pom
    eval cd $RELEASE_WORK_DIR/systemds
    ## Rerunning mvn with clean and package goals, as release:prepare changes ordeer for some dependencies like unpack and shade.
    $MVN $PUBLISH_PROFILES clean package $DRY_RUN \
    -Darguments="-Dgpg.passphrase=\"$GPG_PASSPHRASE\" \ 
    -DskipTests" \
    -DreleaseVersion="$RELEASE_VERSION" -DdevelopmentVersion="$DEVELOPMENT_VERSION" -Dtag="$RELEASE_TAG" \

    exit

    # Pull the latest code (with committed pom changes) and deploy to the local target directory
    checkout_code
    # Remove SNAPSHOT from the version in pom
    eval cd $RELEASE_WORK_DIR/systemds
    sed -i "s/<version>$RELEASE_VERSION-SNAPSHOT<\/version>/<version>$RELEASE_VERSION<\/version>/" pom.xml
    GPG_OPTS="-Dgpg.keyname=$GPG_KEYID -Dgpg.passphrase=$GPG_PASSPHRASE"
    # Deploy to /target folder for the next job to pick the artifacts up for there
    CMD="$MVN $PUBLISH_PROFILES deploy \
    -DskiptTests \
    -DaltDeploymentRepository=altDepRepo::default::file:./target \
    ${GPG_OPTS}"

    echo "Executing: " "$CMD"
    $CMD

    eval cd $RELEASE_WORK_DIR
    # To upload the artifacts to the svn-staging (dist.apache.org), call
    # the second script, svn_dev_upload.sh.

# ToDo: release staging location
#    if [ -z "$DRY_RUN" ]; then
#        RELEASE_STAGING_LOCATION="https://dist.apache.org/repos/dist/dev/systemds/"
#        svn co $RELEASE_STAGING_LOCATION svn-release-staging
#        mkdir -p svn-release-staging/$RELEASE_VERSION-$RELEASE_RC
#        cp $RELEASE_WORK_DIR/systemml/target/systemml-*-bin.* svn-release-staging/$RELEASE_VERSION-$RELEASE_RC/
#        cp $RELEASE_WORK_DIR/systemml/target/systemml-*-src.* svn-release-staging/$RELEASE_VERSION-$RELEASE_RC/
#
#        cd svn-release-staging/$RELEASE_VERSION-$RELEASE_RC/
#        rm -f *.asc
#        for i in *.zip *.tgz *.tar.gz; do gpg --output $i.asc --detach-sig --armor $i; done
#        rm -f *.sha512
#        for i in *.zip *.tgz *.tar.gz; do shasum -a 512 $i > $i.sha512; done
#
#        cd .. #exit $RELEASE_VERSION-$RELEASE_RC/
#
#        svn add $RELEASE_VERSION-$RELEASE_RC/
#        svn ci -m"Apache SystemML $RELEASE_VERSION-$RELEASE_RC"
#    fi


    eval cd "$BASE_DIR" #exit target

    exit 0
fi

#ToDo: fix release deployment
if [[ "$RELEASE_PUBLISH" == "true" ]]; then
    echo "Preparing release $RELEASE_VERSION"
    # Checkout code
    checkout_code
    cd $RELEASE_WORK_DIR/systemds

    #Deploy scala 2.10
#    mvn -DaltDeploymentRepository=apache.releases.https::default::https://repository.apache.org/service/local/staging/deploy/maven2 clean package gpg:sign install:install deploy:deploy -DskiptTests -Darguments="-DskipTests -Dgpg.passphrase=\"$GPG_PASSPHRASE\"" -Dgpg.passphrase="$GPG_PASSPHRASE" $PUBLISH_PROFILES

    mvn -DaltDeploymentRepository=$SYSTEMDS_ROOT/temp clean package gpg:sign install:install deploy:deploy -DskiptTests -Darguments="-DskipTests -Dgpg.passphrase=\"$GPG_PASSPHRASE\"" -Dgpg.passphrase="$GPG_PASSPHRASE" $PUBLISH_PROFILES

    cd "$BASE_DIR" #exit target

    exit 0
fi

#ToDo: fix snapshot deployment
#if [[ "$RELEASE_SNAPSHOT" == "true" ]]; then
#    # Checkout code
#    checkout_code
#    cd $RELEASE_WORK_DIR/systemds
#
#    CURRENT_VERSION=$($MVN help:evaluate -Dexpression=project.version \
#    | grep -v INFO | grep -v WARNING | grep -v Download)
#
#    # Publish Bahir Snapshots to Maven snapshot repo
#    echo "Deploying SystemDS SNAPSHOT at '$GIT_REF' ($git_hash)"
#    echo "Publish version is $CURRENT_VERSION"
#    if [[ ! $CURRENT_VERSION == *"SNAPSHOT"* ]]; then
#        echo "ERROR: Snapshots must have a version containing SNAPSHOT"
#        echo "ERROR: You gave version '$CURRENT_VERSION'"
#        exit 1
#    fi
#
#    #Deploy scala 2.10
#    $MVN -DaltDeploymentRepository=apache.snapshots.https::default::https://repository.apache.org/content/repositories/snapshots clean package gpg:sign install:install deploy:deploy -DskiptTests -Darguments="-DskipTests -Dgpg.passphrase=\"$GPG_PASSPHRASE\"" -Dgpg.passphrase="$GPG_PASSPHRASE" $PUBLISH_PROFILES
#
#    cd "$BASE_DIR" #exit target
#    exit 0
#fi


cd "$BASE_DIR" #return to base dir
echo "ERROR: wrong execution goals"
exit_with_usage

#!/bin/bash
#-------------------------------------------------------------
#
# Licensed to the Apache Software Foundation (ASF) under one
# or more contributor license agreements.  See the NOTICE file
# distributed with this work for additional information
# regarding copyright ownership.  The ASF licenses this file
# to you under the Apache License, Version 2.0 (the
# "License"); you may not use this file except in compliance
# with the License.  You may obtain a copy of the License at
#
#   http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing,
# software distributed under the License is distributed on an
# "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
# KIND, either express or implied.  See the License for the
# specific language governing permissions and limitations
# under the License.
#
#-------------------------------------------------------------

# setup the environment
sudo yum update
sudo yum install -y git
sudo yum install -y java-11-openjdk-devel
sudo yum install -y maven
echo "export JAVA_HOME=$(dirname $(dirname $(readlink -f $(which java))))" | sudo tee -a /etc/profile
source /etc/profile

echo "JDK 11 and MAVEN ware installed successfully"

# install SystemDS
# TODO: point to main repo install the end: git clone https://github.com/apache/systemds.git
git clone https://github.com/lachezar-n/systemds.git
cd systemds
sudo mvn install -Dmaven.test.skip=true
echo "SystemDS installed and setup (single-node) globally"
# install ssm and cloudwatch agents by default (to allow collecting metrics)
sudo yum install amazon-ssm-agent -y
sudo yum install amazon-cloudwatch-agent -y
echo "Cloudwatch agent installed successfully"
# allow checking for installation finished
touch /tmp/systemds_installation_completed

#!/usr/bin/env bash
#-------------------------------------------------------------
#
# Licensed to the Apache Software Foundation (ASF) under one
# or more contributor license agreements.  See the NOTICE file
# distributed with this work for additional information
# regarding copyright ownership.  The ASF licenses this file
# to you under the Apache License, Version 2.0 (the
# "License"); you may not use this file except in compliance
# with the License.  You may obtain a copy of the License at
#
#   http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing,
# software distributed under the License is distributed on an
# "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
# KIND, either express or implied.  See the License for the
# specific language governing permissions and limitations
# under the License.
#
#-------------------------------------------------------------

# error help print
printUsageExit()
{
cat << EOF
Usage: $0 <Tag Name> [Working Directory] [-help]
    Tag Name:           is the name of tag for which verification will be done
    Working Directory:  will be used to clone/download repo/files for validation
    -help:              Print this usage message and exit
EOF
  exit 1
}

runCommand()
{
    command=$1
    echo "`date +%Y-%m-%dT%H:%M:%S`: INFO: Running command '$command' ..." >>$OUT_FILE
    eval ${command} 1>>$OUT_FILE 2>>$ERR_FILE

    RETURN_CODE=$?

    # if there was an error, display the full command
    if [ $RETURN_CODE -ne 0 ]
    then
        echo "`date +%Y-%m-%dT%H:%M:%S`: ERROR: Failed to run command '$command' with exit code: $RETURN_CODE"
        echo "`date +%Y-%m-%dT%H:%M:%S`: ERROR: Failed to run command '$command' with exit code: $RETURN_CODE" >>$OUT_FILE
        LF=$'\n'
        exit 1
    fi
}

while getopts "h:" options; do
  case $options in
    h ) echo Warning: Help requested. Will exit after usage message
        printUsageExit
        ;;
    \? ) echo Warning: Help requested. Will exit after usage message
        printUsageExit
        ;;
    * ) echo Error: Unexpected error while processing options
  esac
done

if [ -z "$1" ] ; then
    echo "`date +%Y-%m-%dT%H:%M:%S`: ERROR: Insufficient parameters passed."; # TagName has not passed.
    printUsageExit;
fi

if [ -z "$SPARK_HOME" ] ; then
    echo "`date +%Y-%m-%dT%H:%M:%S`: ERROR: Environment variable 'SPARK_HOME' has not been defined.";
    printUsageExit;
fi

#if [ -z "$HADOOP_HOME" ] ; then
#    echo "`date +%Y-%m-%dT%H:%M:%S`: ERROR: Environment variable 'HADOOP_HOME' has not been defined.";
#    printUsageExit;
#fi

# find the root path which contains the script file
# tolerate path with spaces
SCRIPT_DIR=$( dirname "$0" )
USER_DIR=$( cd "${SCRIPT_DIR}/../../../" ; pwd -P )

TAG_NAME=$1
shift
WORKING_DIR=$1

if [ -z $WORKING_DIR ] ; then
    WORKING_DIR="$USER_DIR/tmp/relValidation"
fi

rm -rf "$WORKING_DIR"/systemds
mkdir -p "$WORKING_DIR"
OUT_FILE=$WORKING_DIR/relValidation.out
ERR_FILE=$WORKING_DIR/relValidation.err

## Clone the branch and build distribution package
echo "`date +%Y-%m-%dT%H:%M:%S`: INFO: Cloning branch and building distribution package..."
echo "`date +%Y-%m-%dT%H:%M:%S`: INFO: Cloning branch and building distribution package." >> $OUT_FILE
echo "=========================================================================================================" >> $OUT_FILE
runCommand "cd $WORKING_DIR"
runCommand "git clone https://github.com/apache/systemds.git"
runCommand "cd systemds"
runCommand "git checkout tags/$TAG_NAME -b $TAG_NAME"
runCommand "mvn -Dmaven.repo.local=$HOME/.m2/temp-repo clean package -P distribution"
echo "=========================================================================================================" >> $OUT_FILE

# Removes v from tag to get distribution directory name
if [[ ${TAG_NAME:0:1} == "v" ]]; then
    DIST_DIR=${TAG_NAME:1}
else
    DIST_DIR=$TAG_NAME
fi

VER_NAME=`expr "$DIST_DIR" : '^\(.[.0-9]*\)'`

## Download binaries from distribution location and verify them
echo "`date +%Y-%m-%dT%H:%M:%S`: INFO: Downloading binaries from distribution location..."
echo "`date +%Y-%m-%dT%H:%M:%S`: INFO: Downloading binaries from distribution location." >> $OUT_FILE
runCommand "mkdir -p $WORKING_DIR/downloads"
runCommand "cd $WORKING_DIR/downloads"
#ToDo: release staging location
runCommand "wget -r -nH -nd -np -R 'index.html*' https://dist.apache.org/repos/dist/dev/systemds/$DIST_DIR/"
echo "=========================================================================================================" >> $OUT_FILE

## Verify binary tgz files
echo "`date +%Y-%m-%dT%H:%M:%S`: INFO: Verifying binary tgz files..."
echo "`date +%Y-%m-%dT%H:%M:%S`: INFO: Verifying binary tgz files..." >> $OUT_FILE
runCommand "rm -rf systemds-$VER_NAME-bin"
runCommand "tar -xvzf systemds-$VER_NAME-bin.tgz"
runCommand "cd systemds-$VER_NAME-bin"
runCommand "echo \"print('hello world');\" > hello.dml"
runCommand "./bin/systemds hello.dml"
runCommand "cd .."

## Verify binary zip files
echo "`date +%Y-%m-%dT%H:%M:%S`: INFO: Verifying binary zip files..."
echo "`date +%Y-%m-%dT%H:%M:%S`: INFO: Verifying binary zip files..." >> $OUT_FILE
runCommand "rm -rf systemds-$VER_NAME-bin"
runCommand "unzip systemds-$VER_NAME-bin.zip"
runCommand "cd systemds-$VER_NAME-bin"
runCommand "echo \"print('hello world');\" > hello.dml"
runCommand "./bin/systemds hello.dml"
runCommand "cd .."

## Verify src tgz files
echo "`date +%Y-%m-%dT%H:%M:%S`: INFO: Verifying source tgz files..."
echo "`date +%Y-%m-%dT%H:%M:%S`: INFO: Verifying source tgz files..." >> $OUT_FILE
runCommand "rm -rf systemds-$VER_NAME-src"
runCommand "tar -xvzf systemds-$VER_NAME-src.tgz"
runCommand "cd systemds-$VER_NAME-src"
runCommand "mvn clean package -P distribution"
runCommand "cd target"
runCommand "java -cp \"./lib/*:systemds-$VER_NAME.jar\" org.apache.sysds.api.DMLScript -s \"print('hello world');\""
runCommand "java -cp \"./lib/*:SystemDS.jar\" org.apache.sysds.api.DMLScript -s \"print('hello world');\""
runCommand "cd ../.."

## Verify Spark batch mode
echo "`date +%Y-%m-%dT%H:%M:%S`: INFO: Verifying Spark batch mode..."
echo "`date +%Y-%m-%dT%H:%M:%S`: INFO: Verifying Spark batch mode..." >> $OUT_FILE
runCommand "cd systemds-$VER_NAME-bin/lib"
runCommand "$SPARK_HOME/bin/spark-submit systemds-$VER_NAME.jar -s \"print('hello world');\" -exec hybrid"

echo "`date +%Y-%m-%dT%H:%M:%S`: INFO: Verification of binary files completed successfully."
# echo "================================================================================"

exit 0

#!/usr/bin/env bash
#-------------------------------------------------------------
#
# Licensed to the Apache Software Foundation (ASF) under one
# or more contributor license agreements.  See the NOTICE file
# distributed with this work for additional information
# regarding copyright ownership.  The ASF licenses this file
# to you under the Apache License, Version 2.0 (the
# "License"); you may not use this file except in compliance
# with the License.  You may obtain a copy of the License at
#
#   http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing,
# software distributed under the License is distributed on an
# "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
# KIND, either express or implied.  See the License for the
# specific language governing permissions and limitations
# under the License.
#
#-------------------------------------------------------------

################################################################################
##  File:  pypi-upload.sh
##  Desc:  Upload python artifacts to pypi.org
################################################################################

SELF=$(cd $(dirname $0) && pwd)

dry_run_flag=0
while getopts ":n" opt; do
  case $opt in
    n) dry_run_flag=1 ;;
    \?) error "Invalid option: $OPTARG" ;;
  esac
done


RELEASE_VERSION=
RELEASE_TAG=
read -p "RELEASE_VERSION : " RELEASE_VERSION
read -p "RELEASE_TAG : " RELEASE_TAG

BASE_DIR=$PWD # SystemDS top level folder

git checkout $RELEASE_TAG
printf "\n Checkout $RELEASE_TAG for building artifacts \n"

mvn clean package -P distribution

cd $BASE_DIR/src/main/python

# Steps:
# 1. update systemds/project_info.py with the new version

printf "\n ======== "
printf "\nA release candidate (RC) after successful voting will be called Approved release version\n"
printf "Is this RC voted and approved by PMC? [Yes/No]: \n"

# case and select
# Docs: https://www.gnu.org/software/bash/manual/bash.html#index-case
select yn in "Yes" "No"; do
  case $yn in
      Yes ) sed -i "s/$RELEASE_VERSION-dev/$RELEASE_VERSION/" systemds/project_info.py; break ;;
      No ) sed -i "s/$RELEASE_VERSION-dev/$RELEASE_TAG/" systemds/project_info.py; break ;;
      * ) echo "Yes or No response is required.";;
  esac
done

# 2. generate distribution archives
python3 create_python_dist.py

# 2a. check generated distribution files
python3 -m twine check dist/*

# 3. upload the distribution archives to testpypi/pypi
#    - For testing follow https://packaging.python.org/tutorials/packaging-projects/
#    - Note: for testing use command prompt in windows and 
#              use Edit->paste to paste the API token (https://pypi.org/help/#invalid-auth)
#            else, use `right click` for paste in the terminal.

if [[ $dry_run_flag != 1 ]]; then
  python -m twine upload dist/*
else
  # Development test:
  # Test upload to test.pypi.org
  # Credentials are
  # username: __token__ 
  # password: pypi-DU5y...
  python -m twine upload --repository testpypi dist/*
fi


cd $BASE_DIR

exit

#!/usr/bin/env bash
#-------------------------------------------------------------
#
# Licensed to the Apache Software Foundation (ASF) under one
# or more contributor license agreements.  See the NOTICE file
# distributed with this work for additional information
# regarding copyright ownership.  The ASF licenses this file
# to you under the Apache License, Version 2.0 (the
# "License"); you may not use this file except in compliance
# with the License.  You may obtain a copy of the License at
#
#   http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing,
# software distributed under the License is distributed on an
# "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
# KIND, either express or implied.  See the License for the
# specific language governing permissions and limitations
# under the License.
#
#-------------------------------------------------------------

################################################################################
##  File:  create-tag.sh
##  Desc:  Release preparation with Maven Release Plugin
################################################################################

# https://stackoverflow.com/q/59895
SELF=$(cd $(dirname $0) && pwd)
. "$SELF/release-utils.sh"

exit_with_usage() {
  local NAME=$(basename $0)
  cat << EOF
usage: $NAME

Tags a SystemDS release on a particular branch.

Inputs are specified with the following environment variables:

ASF_USERNAME - Apache Username
ASF_PASSWORD - Apache Password
GIT_NAME - Name to use with git
GIT_EMAIL - E-mail address to use with git
GIT_BRANCH - Git branch from which to make release
RELEASE_VERSION - Version used in pom files for release
RELEASE_TAG - Name of release tag
NEXT_VERSION - Development version after release
EOF

  exit 1
}

set -e
set -o pipefail

if [[ $@ == *"help"* ]]; then
  exit_with_usage
fi

# docs related to stty 
# https://www.ibm.com/docs/en/aix/7.2?topic=s-stty-command
if [[ -z "$ASF_PASSWORD" ]]; then
  echo 'The environment variable ASF_PASSWORD is not set. Enter the password.'
  echo
  stty -echo && printf "ASF password: " && read ASF_PASSWORD && printf '\n' && stty echo
fi

for env in ASF_USERNAME ASF_PASSWORD RELEASE_VERSION RELEASE_TAG NEXT_VERSION GIT_EMAIL GIT_NAME GIT_BRANCH; do
  if [ -z "${!env}" ]; then
    echo "$env must be set to run this script"
    exit 1
  fi
done

uriencode() { jq -nSRr --arg v "$1" '$v|@uri'; }

declare -r ENCODED_ASF_PASSWORD=$(uriencode "$ASF_PASSWORD")

# git configuration
git config user.name "$GIT_NAME"
git config user.email "$GIT_EMAIL"

printf "$RELEASE_TAG \n"
printf "$RELEASE_VERSION\n"
printf "$NEXT_VERSION"

# options available at https://maven.apache.org/plugins/maven-gpg-plugin/sign-mojo.html
GPG_OPTS="-Dgpg.homedir=$GNUPGHOME -Dgpg.keyname=$GPG_KEY -Dgpg.passphrase=$GPG_PASSPHRASE"

printf "\n -Dgpg.homedir=$GNUPGHOME -Dgpg.keyname=$GPG_KEY \n"


# NOTE:
# 
# When using gpg-plugin in conjunction with release plugin use 
# 
# $ mvn release:perform -Darguments=-Dgpg.passphrase=thephrase
#
# since the system properties of the current maven session are
# not propagated to the forked session automatically.
# 

if is_dry_run; then
  dry_run=true
fi


CMD="mvn --batch-mode -DdryRun=${dry_run} -Dtag=$RELEASE_TAG \
                 -Dresume=false \
                 -DreleaseVersion=$RELEASE_VERSION \
                 -DdevelopmentVersion=$NEXT_VERSION \
                 -Dgpg.keyname=${GPG_KEY} -Dgpg.passphrase=${GPG_PASSPHRASE} \
                 -Darguments=${GPG_OPTS} \
                 release:prepare"

printf "\n #### Executing command: #### \n"
printf "\n $(bold $(greencolor $CMD)) \n\n"

$CMD

#!/usr/bin/env bash
#-------------------------------------------------------------
#
# Licensed to the Apache Software Foundation (ASF) under one
# or more contributor license agreements.  See the NOTICE file
# distributed with this work for additional information
# regarding copyright ownership.  The ASF licenses this file
# to you under the Apache License, Version 2.0 (the
# "License"); you may not use this file except in compliance
# with the License.  You may obtain a copy of the License at
#
#   http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing,
# software distributed under the License is distributed on an
# "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
# KIND, either express or implied.  See the License for the
# specific language governing permissions and limitations
# under the License.
#
#-------------------------------------------------------------

# exit in case of error or unbound var
set -euo pipefail

# get file directory to allow finding the file with the utils
SCRIPT_DIR="$(dirname "$(realpath "$0")")"

source cluster.env
source "$SCRIPT_DIR/cluster_utils.sh"

if [ -n "$TARGET_SUBNET" ]; then
    SUBNET=$TARGET_SUBNET
else
    #Get the first available subnet in the default VPC of the configured region
    SUBNET=$(aws ec2 describe-subnets --region $REGION \
      --filter "Name=defaultForAz,Values=true" --query "Subnets[0].SubnetId" --output text)
fi

# generate the step definition into STEP variable
generate_step_definition

echo -e "\nLaunching EMR cluster via AWS CLI and adding a step to run $SYSTEMDS_PROGRAM with SystemDS"
CLUSTER_INFO=$(aws emr create-cluster \
    --applications Name=AmazonCloudWatchAgent Name=Spark \
    --ec2-attributes '{
        "KeyName":"'${KEYPAIR_NAME}'",
        "InstanceProfile":"EMR_EC2_DefaultRole",
        '"$( [ -n "$SECURITY_GROUP_ID'" ] && echo '"AdditionalMasterSecurityGroups": ["'${SECURITY_GROUP_ID}'"],' )"'
        "SubnetId": "'${SUBNET}'"
    }'\
    --service-role EMR_DefaultRole \
    --enable-debugging \
    --release-label $EMR_VERSION \
    --log-uri $LOG_URI \
    --name "SystemDS cluster" \
    --instance-groups file://$INSTANCE_CONFIGS \
    --configurations file://$SPARK_CONFIGS \
    --scale-down-behavior TERMINATE_AT_TASK_COMPLETION \
    --no-termination-protected \
    $( [ -n "$STEP" ] && echo "--steps $STEP" ) \
    $( [ "$AUTO_TERMINATION_TIME" = 0 ] && echo "--auto-terminate" ) \
    $( [ "$AUTO_TERMINATION_TIME" -gt 0 ] && echo "--auto-termination-policy IdleTimeout=$AUTO_TERMINATION_TIME" ) \
    --region $REGION)

CLUSTER_ID=$(echo $CLUSTER_INFO | jq .ClusterId | tr -d '"')
echo "Cluster successfully initialized with cluster ID: "${CLUSTER_ID}
set_config "CLUSTER_ID" $CLUSTER_ID

# Wait for cluster to start
echo -e "\nWaiting for cluster to enter running state..."
aws emr wait cluster-running --cluster-id $CLUSTER_ID --region $REGION

CLUSTER_URL=$(aws emr describe-cluster --cluster-id $CLUSTER_ID --region $REGION | jq .Cluster.MasterPublicDnsName | tr -d '"')
set_config "CLUSTER_URL" "$CLUSTER_URL"

echo "...launching process has finished and the cluster is not in state running."

if [ "$AUTO_TERMINATION_TIME" = 0 ]; then
    echo -e "\nImmediate automatic termination was enabled so the cluster will terminate directly after the step completion"
elif [ "$AUTO_TERMINATION_TIME" -gt 0 ]; then
    echo -e "\nDelayed automatic termination was enabled so the cluster will terminate $AUTO_TERMINATION_TIME
    seconds after entering idle state"
else
    echo -e "\nAutomatic termination was not enabled so you should manually terminate the cluster"
fi

#!/usr/bin/bash
#-------------------------------------------------------------
#
# Licensed to the Apache Software Foundation (ASF) under one
# or more contributor license agreements.  See the NOTICE file
# distributed with this work for additional information
# regarding copyright ownership.  The ASF licenses this file
# to you under the Apache License, Version 2.0 (the
# "License"); you may not use this file except in compliance
# with the License.  You may obtain a copy of the License at
# 
#   http://www.apache.org/licenses/LICENSE-2.0
# 
# Unless required by applicable law or agreed to in writing,
# software distributed under the License is distributed on an
# "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
# KIND, either express or implied.  See the License for the
# specific language governing permissions and limitations
# under the License.
#
#-------------------------------------------------------------

jars='systemds-*-extra.jar'

for rows in 1 300
do
	for cols in 1 300
	do
		for sparsity in 0.1 0.2 0.6 0.9
		do
			# Generating the data
			$SPARK_HOME/bin/spark-submit SystemDS.jar -f gen_softmax.dml -nvargs sp=$sparsity rows=$rows cols=$cols
			# Running a test in CPU mode
			$SPARK_HOME/bin/spark-submit SystemDS.jar -f test_softmax.dml -nvargs out=out_cp.csv
			# Running a test in GPU mode
			$SPARK_HOME/bin/spark-submit --jars $jars SystemDS.jar -f test_softmax.dml -stats -gpu force -nvargs out=out_gpu.csv
			# Comparing the CPU vs GPU results to make sure they are the same
			$SPARK_HOME/bin/spark-submit SystemDS.jar -f compare.dml -args out_cp.csv out_gpu.csv "softmax:rows="$rows",cols="$cols",sparsity="$sparsity
			rm -rf out_cp.csv out_gpu.csv out_cp.csv.mtd out_gpu.csv.mtd
			rm -rf input.mtx input.mtx.mtd
		done
	done
done

#!/bin/bash
#-------------------------------------------------------------
#
# Licensed to the Apache Software Foundation (ASF) under one
# or more contributor license agreements.  See the NOTICE file
# distributed with this work for additional information
# regarding copyright ownership.  The ASF licenses this file
# to you under the Apache License, Version 2.0 (the
# "License"); you may not use this file except in compliance
# with the License.  You may obtain a copy of the License at
#
#   http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing,
# software distributed under the License is distributed on an
# "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
# KIND, either express or implied.  See the License for the
# specific language governing permissions and limitations
# under the License.
#
#-------------------------------------------------------------

source systemds_cluster.config

# $1 is the instance type
get_memory_and_cores () {
  while IFS="," read -r field1 name memory vCPUs field5 field6
    do
      if [ "$1" = "$name" ]; then
        SPARK_EXECUTOR_MEMORY=$( bc <<< $memory*0.60*1000) #60% of the total memory (beacause of yarn.scheduler.maximum-allocation-mb)
        SPARK_EXECUTOR_CORES=$vCPUs
      fi
    done < aws_ec2_table.csv

}
# $1 key, $2 value
function set_config(){
    sed -i "" "s/\($1 *= *\).*/\1$2/" systemds_cluster.config
}

get_memory_and_cores $INSTANCES_TYPE
SPARK_EXECUTOR_MEMORY="${SPARK_EXECUTOR_MEMORY}MB"
set_config "SPARK_NUM_EXECUTORS" $CORE_INSTANCES_COUNT
set_config "SPARK_EXECUTOR_CORES" $SPARK_EXECUTOR_CORES
set_config "SPARK_EXECUTOR_MEMORY" $SPARK_EXECUTOR_MEMORY
set_config "SPARK_DRIVER_MEMORY" "1G"
set_config "BUCKET" $BUCKET-$(((RANDOM % 999) + 1000))

#Source again to update the changes for the current session
source systemds_cluster.config

#Create systemDS bucket
#LocationConstraint configuration required regions outside of us-east-1
if [ "$REGION" = "us-east-1" ]; then LOCATION_CONSTRAINT=""; else LOCATION_CONSTRAINT="--create-bucket-configuration LocationConstraint=$REGION"; fi
aws s3api create-bucket --bucket $BUCKET --region $REGION $LOCATION_CONSTRAINT &> /dev/null
aws s3api create-bucket --bucket $BUCKET-logs --region $REGION $LOCATION_CONSTRAINT &> /dev/null

# Upload Jar and scripts to s3
aws s3 sync $SYSTEMDS_TARGET_DIRECTORY s3://$BUCKET --exclude "*" --include "*.dml" --include "*config.xml" --include "*DS.jar*"

# Create keypair
if [ ! -f ${KEYPAIR_NAME}.pem ]; then
    aws ec2 create-key-pair --key-name $KEYPAIR_NAME --region $REGION --query "KeyMaterial" --output text > "$KEYPAIR_NAME.pem"
    chmod 700 "${KEYPAIR_NAME}.pem"
    echo "${KEYPAIR_NAME}.pem private key created!"
fi

#Get the first available subnet in the default VPC of the configured region
DEFAULT_SUBNET=$(aws ec2 describe-subnets --region $REGION \
  --filter "Name=defaultForAz,Values=true" --query "Subnets[0].SubnetId" --output text)


#Create the cluster
#Note: Ganglia not available since emr-6.15.0: exchanged with AmazonCloudWatchAgent
CLUSTER_INFO=$(aws emr create-cluster \
 --applications Name=AmazonCloudWatchAgent Name=Spark \
 --ec2-attributes '{"KeyName":"'${KEYPAIR_NAME}'",
  "InstanceProfile":"EMR_EC2_DefaultRole",
  "SubnetId": "'${DEFAULT_SUBNET}'"}'\
 --service-role EMR_DefaultRole \
 --enable-debugging \
 --release-label $EMR_VERSION \
 --log-uri "s3://$BUCKET-logs/" \
 --name "SystemDS cluster" \
 --instance-groups '[{"InstanceCount":'${MASTER_INSTANCES_COUNT}',
                        "InstanceGroupType":"MASTER",
                        "InstanceType":"'${INSTANCES_TYPE}'",
                        "Name":"Master Instance Group"},
                      {"InstanceCount":'${CORE_INSTANCES_COUNT}',
                        "InstanceGroupType":"CORE",
                        "InstanceType":"'${INSTANCES_TYPE}'",
                        "Name":"Core Instance Group"}]'\
 --configurations '[{"Classification":"spark","Properties":{"maximizeResourceAllocation": "true"}},
                     {"Classification": "spark-env",
                         "Configurations": [{
                           "Classification": "export",
                           "Properties": {"JAVA_HOME": "/usr/lib/jvm/jre-11"}
                         }]
                     }]'\
 --scale-down-behavior TERMINATE_AT_TASK_COMPLETION \
 --region $REGION)

CLUSTER_ID=$(echo $CLUSTER_INFO | jq .ClusterId | tr -d '"')
echo "Cluster successfully initialized. Save your ClusterID: "${CLUSTER_ID}
set_config "CLUSTER_ID" $CLUSTER_ID

ip_address=$(curl ipecho.net/plain ; echo)

#Add your ip to the security group
aws ec2 create-security-group --group-name ElasticMapReduce-master --description "info" --region $REGION &> /dev/null
aws ec2 authorize-security-group-ingress \
    --group-name ElasticMapReduce-master \
    --protocol tcp \
    --port 22 \
    --cidr "${ip_address}"/24 \
    --region $REGION &> /dev/null

# Wait for cluster to start
echo "Waiting for cluster running state"
aws emr wait cluster-running --cluster-id $CLUSTER_ID --region $REGION

echo "Cluster info:"
export CLUSTER_URL=$(aws emr describe-cluster --cluster-id $CLUSTER_ID --region $REGION | jq .Cluster.MasterPublicDnsName | tr -d '"')

aws emr ssh --cluster-id $CLUSTER_ID --key-pair-file ${KEYPAIR_NAME}.pem --region $REGION \
    --command 'aws s3 cp s3://'${BUCKET}' . --recursive --exclude "*" --include "*DS.jar*"'

echo "Spinup finished."

#!/usr/bin/bash
#-------------------------------------------------------------
#
# Licensed to the Apache Software Foundation (ASF) under one
# or more contributor license agreements.  See the NOTICE file
# distributed with this work for additional information
# regarding copyright ownership.  The ASF licenses this file
# to you under the Apache License, Version 2.0 (the
# "License"); you may not use this file except in compliance
# with the License.  You may obtain a copy of the License at
# 
#   http://www.apache.org/licenses/LICENSE-2.0
# 
# Unless required by applicable law or agreed to in writing,
# software distributed under the License is distributed on an
# "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
# KIND, either express or implied.  See the License for the
# specific language governing permissions and limitations
# under the License.
#
#-------------------------------------------------------------

jars='systemds-*-extra.jar'

# N = Number of images, C = number of channels, H = height, W = width
N=5
C=3
H=28
W=28
for sparsity in 0.1 0.2 0.5 0.6 0.9
do
	# Generating the data

	for stride in 1 2 3
	do
		for pad in 0 1 2
		do
			$SPARK_HOME/bin/spark-submit SystemDS.jar -f gen_maxpool_bwd.dml -nvargs sp=$sparsity N=$N C=$C H=$H W=$W pool=3 stride=$stride pad=$pad
			# Running a test in CPU mode
			$SPARK_HOME/bin/spark-submit SystemDS.jar -f test_avgpool_bwd.dml -nvargs stride=$stride pad=$pad out=out_cp.csv N=$N C=$C H=$H W=$W pool=3
			# Running a test in GPU mode
			$SPARK_HOME/bin/spark-submit --jars $jars SystemDS.jar -f test_avgpool_bwd.dml -stats -gpu force -nvargs stride=$stride pad=$pad out=out_gpu.csv N=$N C=$C H=$H W=$W pool=3
			# Comparing the CPU vs GPU results to make sure they are the same
			$SPARK_HOME/bin/spark-submit SystemDS.jar -f compare.dml -args out_cp.csv out_gpu.csv "avgpool_bwd:sparsity="$sparsity",stride="$stride",pad="$pad
			rm -rf out_cp.csv out_gpu.csv out_cp.csv.mtd out_gpu.csv.mtd
		done
	done
	rm -rf input.mtx input.mtx.mtd
done

#!/usr/bin/env bash
#-------------------------------------------------------------
#
# Licensed to the Apache Software Foundation (ASF) under one
# or more contributor license agreements.  See the NOTICE file
# distributed with this work for additional information
# regarding copyright ownership.  The ASF licenses this file
# to you under the Apache License, Version 2.0 (the
# "License"); you may not use this file except in compliance
# with the License.  You may obtain a copy of the License at
#
#   http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing,
# software distributed under the License is distributed on an
# "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
# KIND, either express or implied.  See the License for the
# specific language governing permissions and limitations
# under the License.
#
#-------------------------------------------------------------

################################################################################
##  File:  release-utils.sh
##  Desc:  Helper utilities for the release workflow
################################################################################

ASF_REPO="https://github.com/apache/systemds"
ASF_REPO_CONTENT="https://raw.githubusercontent.com/apache/systemds"


# https://github.com/j143/systemds/issues/75
GPG_TTY=$(tty)
export GPG_TTY

# Output font formatting
# TODO: Does not work in git bash and mac.
export TERM=ansi

bold() {
  tput bold
  echo -n "$@"

  # turn off bold
  tput sgr0
}

revcolor() {
  # standout mode
  tput smso
  echo -n "$@"
  tput rmso
}


# color values
# red 1; green 2; blue 4; magenta 5;
greencolor() {
  tput setaf 2
  echo -n "$@"
  tput sgr0
}

# exit with error message
error() {
  echo "$*"
  exit 1
}


# Read the configuration
read_config() {
  local PROMPT="$1"
  local DEFAULT="$2"
  
  local REPLY=

  read -p "$PROMPT [$DEFAULT]: " REPLY
  local RETVAL="${REPLY:-$DEFAULT}"
  if [ -z "$RETVAL" ]; then
    error "$PROMPT must be provided"
  fi
  echo "$RETVAL"
}


# parse version number from pom.xml
# <version> tag.
parse_version() {
  grep -e '<version>.*</version>' | \
    head -n 2 | tail -n 1 | cut -d '>' -f2 | cut -d '<' -f1
}

# function to log output to a .log file
run_silent() {
  local DESCRIPTION="$1"
  local LOG_FILE="$2"
  
  # Remove the first two arguments
  # https://ss64.com/bash/shift.html
  shift 2

  printf "\n =============== "
  printf "\n = $DESCRIPTION "
  printf "\n Executing command: "
  printf "\n $(bold $(greencolor $@ )) \n"
  printf "\n Log file: $LOG_FILE "
  printf "\n =============== \n"
  
  # 2>&1 https://stackoverflow.com/a/818284
  # 1 stdout, 2 stderr, >& redirect merger operator
  . "$@" 1>"$LOG_FILE" 2>&1
  
  # a successful command returns 0 exit code
  local SUCCESS=$?
  if [ $SUCCESS != 0 ]; then
    printf "\n Command FAILED to Execute. Log files are available.\n"
    tail "$LOG_FILE"
    exit $SUCCESS
  fi
}

# Clean Working directory of untracked files
cleanup_repo() {
  # https://git-scm.com/docs/git-clean
  git clean -d -f -x
}

# check for the tag name in git repo
check_for_tag() {
    curl -s --head --fail "$ASF_REPO/releases/tag/$1" > /dev/null
}


# get the release info including
# branch details, snapshot version
# error validation
get_release_info() {
  if [[ -z "$GIT_BRANCH" ]]; then
    # If not branch is specified, find the latest branch from repo
    GIT_BRANCH=$(git ls-remote --heads "$ASF_REPO" |
      awk '{print $2}' |
      sort -r |
      head -n 1 |
      cut -d/ -f3)
  fi
  
  printf "\n================\n"
  export GIT_BRANCH=$(read_config "Branch" "$GIT_BRANCH")

  # Find the current version for the branch
  local VERSION=$(curl -s "$ASF_REPO_CONTENT/$GIT_BRANCH/pom.xml" |
    parse_version)
  
  echo "Current branch version is $VERSION."

  if [[ ! $VERSION =~ .*-SNAPSHOT ]]; then
    error "Not a SNAPSHOT version: $VERSION"
  fi

  NEXT_VERSION="$VERSION"
  RELEASE_VERSION="${VERSION/-SNAPSHOT/}"
  SHORT_VERSION=$(echo "$VERSION" | cut -d . -f 1-2)
  local REV=$(echo "$RELEASE_VERSION" | cut -d . -f 3)

  # Find out what rc is being prepared.
  # - If the current version is "x.y.0", then this is rc1 of the "x.y.0" release.
  # - If not, need to check whether the previous version has been already released or not.
  #   - If it has, then we're building rc1 of the current version.
  #   - If it has not, we're building the next RC of the previous version.
  local RC_COUNT
  if [[ $REV != 0 ]]; then
    local PREV_REL_REV=$((REV - 1))
    local PREV_REL_TAG="v${SHORT_VERSION}.${PREV_REL_REV}"

    if check_for_tag "$PREV_REL_TAG"; then
      RC_COUNT=1
      REV=$((REV + 1))
      NEXT_VERSION="${SHORT_VERSION}.${REV}-SNAPSHOT"
    else
      RELEASE_VERSION="${SHORT_VERSION}.${PREV_REL_REV}"
      RC_COUNT=$(git ls-remote --tags "$ASF_REPO" "v${RELEASE_VERSION}-rc*" | wc -l)
      RC_COUNT=$((RC_COUNT + 1))
    fi
  else
    REV=$((REV + 1))
    NEXT_VERSION="${SHORT_VERSION}.${REV}-SNAPSHOT"
    RC_COUNT=1
  fi

  export NEXT_VERSION=$(read_config "Next development version" "$NEXT_VERSION")
  export RELEASE_VERSION=$(read_config "Release" "$RELEASE_VERSION")

  RC_COUNT=$(read_config "RC #" "$RC_COUNT")

  # Check if the RC already exists, and if re-creating the RC, skip tag
  # creation
  RELEASE_TAG="${RELEASE_VERSION}-rc${RC_COUNT}"
  SKIP_TAG=0

  if check_for_tag "$RELEASE_TAG"; then
    read -p "$RELEASE_TAG already exists. Continue anyway [Y/n]? " ANSWER
    if [[ "$ANSWER" != "Y" ]]; then
      error "Exiting."
    fi
    SKIP_TAG
  fi

  export RELEASE_TAG

  GIT_REF="$RELEASE_TAG"
  
  export GIT_REF
  export PACKAGE_VERSION="$RELEASE_TAG"

  # Git configuration info
  # The ASF ID is obtained from
  # https://people.apache.org/committers-by-project.html#systemds
  if [[ -z "$ASF_USERNAME" ]]; then
    export ASF_USERNAME=$(read_config "ASF ID" "$LOGNAME")
  fi

  if [[ -z "$GIT_NAME" ]]; then
    GIT_NAME=$(git config user.name || echo "")
    export GIT_NAME=$(read_config "Full name" "$GIT_NAME")
  fi

  # git configuration info
  if [[ -z "$GIT_EMAIL" ]]; then
    export GIT_EMAIL="$ASF_USERNAME@apache.org"
  fi
  
  # GPG key configuration info
  if [[ -z "$GPG_KEY" ]]; then
    export GPG_KEY=$(read_config "GPG key" "$GIT_EMAIL")
  fi

  cat <<EOF
================
Release details:
BRANCH:     $GIT_BRANCH
VERSION:    $RELEASE_VERSION
TAG:        $RELEASE_TAG
NEXT:       $NEXT_VERSION
ASF ID:   $ASF_USERNAME
GPG KEY ID:    $GPG_KEY
FULL NAME:  $GIT_NAME
E-MAIL:     $GIT_EMAIL
================
EOF

  if [[ -z "$CORRECT_RELEASE_INFO" ]]; then
    CORRECT_RELEASE_INFO=$(read_config "Is the release info correct (1 for Yes, 0 for No) ?" "$CORRECT_RELEASE_INFO")
  fi
  
  if [[ ! "$CORRECT_RELEASE_INFO" = '1' ]]; then
    echo "Exiting."
    exit 1
  fi

  if [[ -z "$ASF_PASSWORD" ]]; then
    stty -echo && printf "ASF password: " && read ASF_PASSWORD && printf '\n' && stty echo
  fi

  if [[ -z "$GPG_PASSPHRASE" ]]; then
    stty -echo && printf "GPG passphrase: " && read GPG_PASSPHRASE && printf '\n' && stty echo
  fi

  export ASF_PASSWORD
  export GPG_PASSPHRASE

}

is_dry_run() {
  # By default, evaluates to false
  [[ "$DRY_RUN" = 1 ]]
}

is_github_ci() {
  [[ "$GITHUB_CI" = 1 ]]
}

#!/usr/bin/env bash
#-------------------------------------------------------------
#
# Licensed to the Apache Software Foundation (ASF) under one
# or more contributor license agreements.  See the NOTICE file
# distributed with this work for additional information
# regarding copyright ownership.  The ASF licenses this file
# to you under the Apache License, Version 2.0 (the
# "License"); you may not use this file except in compliance
# with the License.  You may obtain a copy of the License at
#
#   http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing,
# software distributed under the License is distributed on an
# "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
# KIND, either express or implied.  See the License for the
# specific language governing permissions and limitations
# under the License.
#
#-------------------------------------------------------------

MVN=mvn
PUBLISH_PROFILES="-Pdistribution,rat"
DRY_RUN=-DdryRun=true
GPG_PASSPHRASE=$1
DEVELOPMENT_VERSION=2.1.0-SNAPSHOT
RELEASE_TAG=v2.0
RELEASE_STAGING_LOCATION="/c/virtual\ D/SystemDS/systemds/temp"
BASE_DIR="/c/virtual\ D/SystemDS/systemds"
RELEASE_WORK_DIR="/c/virtual\ D/SystemDS/systemds/target/release2"
RELEASE_VERSION=2.0.0
RELEASE_RC=rc1
GIT_REF=-master
#export GNUPGHOME="/c/virtual\ D/SystemDS/systemds/target/.gnupg_copy"
export GNUPGHOME="../../../target/.gnupg_copy/"

RELEASE_STAGING_REMOTE="https://dist.apache.org/repos/dist/dev/systemds/"
eval cd $RELEASE_STAGING_LOCATION;
rm -rf svn-release-staging
# Checkout the artifacts
svn co $RELEASE_STAGING_REMOTE svn-release-staging
rm -rf svn-release-staging/$RELEASE_VERSION-$RELEASE_RC
# Create a new folder for this release
mkdir -p svn-release-staging/$RELEASE_VERSION-$RELEASE_RC
# Copy the artifacts from target
eval cp $RELEASE_WORK_DIR/systemds/target/systemds-*-bin.* svn-release-staging/$RELEASE_VERSION-$RELEASE_RC/
eval cp $RELEASE_WORK_DIR/systemds/target/systemds-*-src.* svn-release-staging/$RELEASE_VERSION-$RELEASE_RC/

cd svn-release-staging/$RELEASE_VERSION-$RELEASE_RC/
rm -f *.asc
for i in *.zip *.tgz; do gpg --output $i.asc --detach-sig --armor $i; done
rm -f *.sha512
for i in *.zip *.tgz; do shasum -a 512 $i > $i.sha512; done

cd .. #exit $RELEASE_VERSION-$RELEASE_RC/

#svn add $RELEASE_VERSION-$RELEASE_RC/
svn add $(svn status | awk '{$1=""; print $0}')
#svn ci -m"Apache systemds $RELEASE_VERSION-$RELEASE_RC"
#manually commit from tortoise

exit 0

#!/usr/bin/env bash
#-------------------------------------------------------------
#
# Licensed to the Apache Software Foundation (ASF) under one
# or more contributor license agreements.  See the NOTICE file
# distributed with this work for additional information
# regarding copyright ownership.  The ASF licenses this file
# to you under the Apache License, Version 2.0 (the
# "License"); you may not use this file except in compliance
# with the License.  You may obtain a copy of the License at
#
#   http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing,
# software distributed under the License is distributed on an
# "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
# KIND, either express or implied.  See the License for the
# specific language governing permissions and limitations
# under the License.
#
#-------------------------------------------------------------

# exit in case of error or unbound var
set -euo pipefail

# get file directory to allow finding the file with the utils
SCRIPT_DIR="$(dirname "$(realpath "$0")")"

source cluster.env
source "$SCRIPT_DIR/cluster_utils.sh"

# generate the step definition into STEP variable
generate_step_definition
if [ $STEP -z ]; then
    echo "Error: Empty state definition, probably due to empty SYSTEMDS_PROGRAM option."
    exit 1
fi

echo "Adding a step to run $SYSTEMDS_PROGRAM with SystemDS"
STEP_INFO=$(aws emr add-steps --cluster-id $CLUSTER_ID  --region $REGION --steps $STEP)

if [ "$AUTO_TERMINATION_TIME" = 0 ]; then
    STEP_ID=$(echo $STEP_INFO | jq .StepIds | tr -d '"' | tr -d ']' | tr -d '[' | tr -d '[:space:]' )
    echo "Waiting for the step to finish before termination (immediate automatic termination enabled)"
    aws emr wait step-complete --cluster-id $CLUSTER_ID --step-id $STEP_ID --region $REGION
    echo "The step has finished and now the cluster will before immediately terminated"
    aws emr terminate-clusters --cluster-ids $CLUSTER_ID
elif [ "$AUTO_TERMINATION_TIME" -gt 0 ]; then
    echo "Delayed automatic termination will apply only in case this option was set on cluster launch."
    echo "You should manually track the step completion"
else
    echo "Automatic termination was not enabled so you should manually track the step completion and terminate the cluster"
fi

#!/usr/bin/env bash
#-------------------------------------------------------------
#
# Licensed to the Apache Software Foundation (ASF) under one
# or more contributor license agreements.  See the NOTICE file
# distributed with this work for additional information
# regarding copyright ownership.  The ASF licenses this file
# to you under the Apache License, Version 2.0 (the
# "License"); you may not use this file except in compliance
# with the License.  You may obtain a copy of the License at
#
#   http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing,
# software distributed under the License is distributed on an
# "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
# KIND, either express or implied.  See the License for the
# specific language governing permissions and limitations
# under the License.
#
#-------------------------------------------------------------

# exit in case of error or unbound var
set -euo pipefail

# get file directory to allow finding the file with the utils
SCRIPT_DIR="$(dirname "$(realpath "$0")")"

source single_node.env
source "$SCRIPT_DIR/single_node_utils.sh"

echo "Executing the DML script in single-node mode..."

# parse the JVM configs
generate_jvm_configs

if [[ -n "$SYSTEMDS_ARGS" ]]; then
    IFS=',' read -r -a args_array <<< "$SYSTEMDS_ARGS"
    LAUNCH_ARGS="${args_array[*]}"
else
    LAUNCH_ARGS=""
fi

if [[ -n "$SYSTEMDS_NVARGS" ]]; then
    IFS=',' read -r -a nvargs_array <<< "$SYSTEMDS_NVARGS"
    LAUNCH_NVARGS="${nvargs_array[*]}"
else
    LAUNCH_NVARGS=""
fi

EXEC_COMMAND="java -Xmx${JVM_MAX_MEM}m -Xms${JVM_START_MEM}m -Xmn${JVM_YOUNG_GEN_MEM}m
                   -jar /systemds/target/SystemDS.jar
                   -f $SYSTEMDS_PROGRAM -exec singlenode -stats -explain
                   $( [ -n "$LAUNCH_ARGS" ] && echo "-args $LAUNCH_ARGS" )
                   $( [ -n "$LAUNCH_NVARGS" ] && echo "-nvargs $LAUNCH_NVARGS" )"

# load the command to pure string
CMD=$(echo $EXEC_COMMAND)
echo -e "\nLaunching the program: $CMD"

ssh  -i "$KEYPAIR_NAME".pem "ec2-user@$PUBLIC_DNS_NAME" \
    "nohup bash -c '
    echo \"Start time: \$(date +\"%Y-%m-%d %H:%M:%S\") (\$(date +%s))\";
    $CMD;
    echo \"Finish time: \$(date +\"%Y-%m-%d %H:%M:%S\") (\$(date +%s))\"
    gzip -c output.log > output.log.gz &&
    aws s3 cp output.log.gz $LOG_URI/output_$INSTANCE_ID.log.gz --content-type \"text/plain\" --content-encoding \"gzip\" &&
    gzip -c error.log > error.log.gz &&
    aws s3 cp error.log.gz $LOG_URI/error_$INSTANCE_ID.log.gz --content-type \"text/plain\" --content-encoding \"gzip\" &&
    { if [ \"$AUTO_TERMINATION\" = true ]; then sudo shutdown now; fi; }' >> output.log 2>> error.log &"

echo "... the program has been launched"

if [ $AUTO_TERMINATION != true ]; then
    echo -e "\nYou need to check for its completion and stop/terminate the instance manually (automatic termination disabled)"
    exit 0
fi

echo -e "\nWaiting for the instance being stopped upon program completion (automatic termination enabled)..."
set +e # avoid exiting on error to achieve waiting in a loop
while true; do
    # wait and poll every 15 up to 40 times
    aws ec2 wait instance-stopped --instance-ids "$INSTANCE_ID" --region "$REGION"
    # get the status to decide for the next loop
    status=$?
    if [ "$status" -eq 0 ]; then
        # the instance was indeed stopped."
        break
    elif [ "$status" -eq 255 ]; then
        echo "Restart the waiting mechanism..."
        sleep 15   # wait another window before retrying
    else
        echo "Unknown error '$status' occurred while waiting for the instance to stop"
        exit 1
    fi
done
set -e # restore the state
echo "...the DML finished, the logs where written to $LOG_URI and the EC2 instance was stopped"

echo "The instance will be terminated directly now..."
aws ec2 terminate-instances --instance-ids "$INSTANCE_ID" --region "$REGION" >/dev/null

echo "... termination was successful!"

#!/bin/bash
#-------------------------------------------------------------
#
# Licensed to the Apache Software Foundation (ASF) under one
# or more contributor license agreements.  See the NOTICE file
# distributed with this work for additional information
# regarding copyright ownership.  The ASF licenses this file
# to you under the Apache License, Version 2.0 (the
# "License"); you may not use this file except in compliance
# with the License.  You may obtain a copy of the License at
# 
#   http://www.apache.org/licenses/LICENSE-2.0
# 
# Unless required by applicable law or agreed to in writing,
# software distributed under the License is distributed on an
# "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
# KIND, either express or implied.  See the License for the
# specific language governing permissions and limitations
# under the License.
#
#-------------------------------------------------------------

# directory to write test case temporary files
TEMP=~/temp/systemds_test

# should this test suite continue after encountering an error? true false
CONTINUE_ON_ERROR=true

# expecting this test script to be in directory ${PROJECT_ROOT_DIR}/src/test/scripts
TEST_SCRIPT_REL_DIR=src/test/scripts

# expecting the run script to be in directory ${PROJECT_ROOT_DIR}/bin
RUN_SCRIPT=systemds-standalone.sh

# the DML script with arguments we use to test the run script
DML_SCRIPT=genLinearRegressionData.dml
DML_SCRIPT_PATH=scripts/datagen
DML_OUTPUT=linRegData.csv
DML_ARGS="-nvargs numSamples=1000 numFeatures=50 maxFeatureValue=5 maxWeight=5 addNoise=FALSE b=0 sparsity=0.7 output=${DML_OUTPUT} format=csv perc=0.5"
DML_SCRIPT_WITH_ARGS="${DML_SCRIPT} ${DML_ARGS}"

# try to find the project root directory
USER_DIR="$PWD"
TEST_SCRIPT_PATH=$( dirname "$0" )
PROJECT_ROOT_DIR=$( cd "${TEST_SCRIPT_PATH/\/$TEST_SCRIPT_REL_DIR/}" ; pwd -P )

# generate the test log file name
DATE_TIME="$(date +"%Y-%m-%d-%H-%M-%S")"
TEST_LOG="${PROJECT_ROOT_DIR}/temp/test_runScript_${DATE_TIME}.log"


# verify we found the ${PROJECT_ROOT_DIR} and ${RUN_SCRIPT}
if [ "${TEST_SCRIPT_PATH}" = "${PROJECT_ROOT_DIR}" ]
then
    echo This test script "$0" is expected to be located in folder "${TEST_SCRIPT_REL_DIR}" under the project root.
    echo Please update "$0" and correctly set the variable "TEST_SCRIPT_REL_DIR".
    exit 1
fi
if [ ! -f "${PROJECT_ROOT_DIR}/bin/${RUN_SCRIPT}" ]
then
    echo "Could not find \"bin/${RUN_SCRIPT}\" in the project root directory. If the actual path of the run script is not \"bin/${RUN_SCRIPT}\", or if the actual project root directory is not \"${PROJECT_ROOT_DIR}\", please update this test script \"$0\"."
    exit 1
fi


# set an exit trap if we should exit on first error
if [ "${CONTINUE_ON_ERROR}" = "false" ]
then
    trap "exit 1" TERM
    export PID=$$
fi


# test setup, create temp folders
if [ ! -d "${TEMP}" ] ; then
    mkdir -p "${TEMP}"
fi
if [ ! -d "${PROJECT_ROOT_DIR}/temp" ] ; then
    mkdir -p "${PROJECT_ROOT_DIR}/temp"
fi


# start running the test cases and write output to log file
echo "Writing test log to file \"${TEST_LOG}\"."; echo "$( date +"%F %T" )" > ${TEST_LOG}


# invoke the run script from the project root directory
CURRENT_TEST="Test_root__DML_script_with_path"
(
    printf "Running test \"${CURRENT_TEST}\"... "
    printf "\nTest case: \"${CURRENT_TEST}\"\n"     >> ${TEST_LOG}
    cd "${PROJECT_ROOT_DIR}"
    echo "Working directory: $PWD"                  >> ${TEST_LOG}
    rm -f "${DML_OUTPUT}"                           >  /dev/null   2>&1
    rm -f "temp/${DML_OUTPUT}"                      >  /dev/null   2>&1
    CMD="./bin/${RUN_SCRIPT} ${DML_SCRIPT_PATH}/${DML_SCRIPT_WITH_ARGS}"
    echo "${CMD}"                                   >> ${TEST_LOG} 2>&1
    eval ${CMD}                                     >> ${TEST_LOG} 2>&1
    EXIT_CODE=$?
    if [ $EXIT_CODE -eq 0 ]
    then
        if [    -f "${DML_OUTPUT}"      ] ; then ERR_MSG="${ERR_MSG}, outputdata in project root" ; EXIT_CODE=1 ; fi
        if [ !  -f "temp/${DML_OUTPUT}" ] ; then ERR_MSG="${ERR_MSG}, outputdata is missing" ;      EXIT_CODE=1 ; fi
    fi
    if [ $EXIT_CODE -eq 0 ] ;
        then printf "success\n";
        else printf "failed${ERR_MSG}\n"; if [ "${CONTINUE_ON_ERROR}" = "false" ] ; then kill -s TERM $PID ; fi
    fi
)
CURRENT_TEST="Test_root__DML_script_file_name"
(
    printf "Running test \"${CURRENT_TEST}\"... "
    printf "\nTest case: \"${CURRENT_TEST}\"\n"      >> ${TEST_LOG}
    cd "${PROJECT_ROOT_DIR}"
    echo "Working directory: $PWD"                   >> ${TEST_LOG}
    rm -f "${DML_OUTPUT}"                            >  /dev/null   2>&1
    rm -f "temp/${DML_OUTPUT}"                       >  /dev/null   2>&1
    CMD="./bin/${RUN_SCRIPT} ${DML_SCRIPT_WITH_ARGS}"
    echo "${CMD}"                                    >> ${TEST_LOG} 2>&1
    eval ${CMD}                                      >> ${TEST_LOG} 2>&1
    EXIT_CODE=$?
    if [ ${EXIT_CODE} -eq 0 ]
    then
        if [   -f "${DML_OUTPUT}"      ] ; then ERR_MSG="${ERR_MSG}, outputdata in project root" ; EXIT_CODE=1 ; fi
        if [ ! -f "temp/${DML_OUTPUT}" ] ; then ERR_MSG="${ERR_MSG}, outputdata is missing" ;      EXIT_CODE=1 ; fi
    fi
    if [ ${EXIT_CODE} -eq 0 ] ;
        then printf "success\n";
        else printf "failed${ERR_MSG}\n"; if [ "${CONTINUE_ON_ERROR}" = "false" ] ; then kill -s TERM $PID ; fi
    fi
)

# invoke the run script from the bin directory
CURRENT_TEST="Test_bin__DML_script_with_path"
(
    printf "Running test \"${CURRENT_TEST}\"... "
    printf "\nTest case: \"${CURRENT_TEST}\"\n"   >> ${TEST_LOG}
    cd "${PROJECT_ROOT_DIR}/bin"
    echo "Working directory: $PWD"                >> ${TEST_LOG}
    rm -f "${DML_OUTPUT}"                         >  /dev/null    2>&1
    rm -f "../temp/${DML_OUTPUT}"                 >  /dev/null    2>&1
    CMD="./${RUN_SCRIPT} ../${DML_SCRIPT_PATH}/${DML_SCRIPT_WITH_ARGS}"
    echo "${CMD}"                                 >> ${TEST_LOG}  2>&1
    sh ${CMD}                                     >> ${TEST_LOG}  2>&1
    EXIT_CODE=$?
    if [ ${EXIT_CODE} -eq 0 ]
    then
        if [   -f "${DML_OUTPUT}"         ] ; then ERR_MSG="${ERR_MSG}, outputdata in bin folder" ; EXIT_CODE=1 ; fi
        if [ ! -f "../temp/${DML_OUTPUT}" ] ; then ERR_MSG="${ERR_MSG}, outputdata is missing" ;    EXIT_CODE=1 ; fi
    fi
    if [ ${EXIT_CODE} -eq 0 ] ;
        then printf "success\n";
        else printf "failed${ERR_MSG}\n"; if [ "${CONTINUE_ON_ERROR}" = "false" ] ; then kill -s TERM $PID ; fi
    fi
)
CURRENT_TEST="Test_bin__DML_script_file_name"
(
    printf "Running test \"${CURRENT_TEST}\"... "
    printf "\nTest case: \"${CURRENT_TEST}\"\n"  >> ${TEST_LOG}
    cd "${PROJECT_ROOT_DIR}/bin"
    echo "Working directory: $PWD"               >> ${TEST_LOG}
    rm -f "${DML_OUTPUT}"                        >  /dev/null    2>&1
    rm -f "../temp/${DML_OUTPUT}"                >  /dev/null    2>&1
    CMD="./${RUN_SCRIPT} ${DML_SCRIPT_WITH_ARGS}"
    echo "${CMD}"                                >> ${TEST_LOG}  2>&1
    sh ${CMD}                                    >> ${TEST_LOG}  2>&1
    EXIT_CODE=$?
    if [ ${EXIT_CODE} -eq 0 ]
    then
        if [   -f "${DML_OUTPUT}"         ] ; then ERR_MSG="${ERR_MSG}, outputdata in bin folder" ; EXIT_CODE=1 ; fi
        if [ ! -f "../temp/${DML_OUTPUT}" ] ; then ERR_MSG="${ERR_MSG}, outputdata is missing" ;    EXIT_CODE=1 ; fi
    fi
    if [ ${EXIT_CODE} -eq 0 ] ;
        then printf "success\n";
        else printf "failed${ERR_MSG}\n"; if [ "${CONTINUE_ON_ERROR}" = "false" ] ; then kill -s TERM $PID ; fi
    fi
)

# invoke the run script from a working directory outside of the project root
CURRENT_TEST="Test_out__DML_script_with_path"
(
    printf "Running test \"${CURRENT_TEST}\"... "
    printf "\nTest case: \"${CURRENT_TEST}\"\n" >> ${TEST_LOG}
    cd "${TEMP}"
    echo "Working directory: $PWD"              >> ${TEST_LOG}
    rm -f "${DML_OUTPUT}"                       >  /dev/null    2>&1
    CMD="\"${PROJECT_ROOT_DIR}/bin/${RUN_SCRIPT}\" \"${PROJECT_ROOT_DIR}/${DML_SCRIPT_PATH}/${DML_SCRIPT}\" ${DML_ARGS}"
    echo "${CMD}"                               >> ${TEST_LOG}  2>&1
    eval  ${CMD}                                >> ${TEST_LOG}  2>&1
    EXIT_CODE=$?
    if [ ${EXIT_CODE} -eq 0 ]
    then
        if [ ! -f "${DML_OUTPUT}" ] ; then ERR_MSG="${ERR_MSG}, outputdata is missing" ; EXIT_CODE=1 ; fi
    fi
    if [ ${EXIT_CODE} -eq 0 ] ;
        then printf "success\n";
        else printf "failed${ERR_MSG}\n"; if [ "${CONTINUE_ON_ERROR}" = "false" ] ; then kill -s TERM $PID ; fi
    fi
)
CURRENT_TEST="Test_out__DML_script_file_name"
(
    printf "Running test \"${CURRENT_TEST}\"... "
    printf "\nTest case: \"${CURRENT_TEST}\"\n"   >> ${TEST_LOG}
    cd "${TEMP}"
    echo "Working directory: $PWD"                >> ${TEST_LOG}
    rm -f "${DML_OUTPUT}"                         >  /dev/null   2>&1
    CMD="\"${PROJECT_ROOT_DIR}/bin/${RUN_SCRIPT}\" ${DML_SCRIPT_WITH_ARGS}"
    echo "${CMD}"                                 >> ${TEST_LOG}  2>&1
    eval ${CMD}                                   >> ${TEST_LOG}  2>&1
    EXIT_CODE=$?
    if [ ${EXIT_CODE} -eq 0 ]
    then
        if [ ! -f "${DML_OUTPUT}" ] ; then ERR_MSG="${ERR_MSG}, outputdata is missing" ; EXIT_CODE=1 ; fi
    fi
    if [ ${EXIT_CODE} -eq 0 ] ;
        then printf "success\n";
        else printf "failed${ERR_MSG}\n"; if [ "${CONTINUE_ON_ERROR}" = "false" ] ; then kill -s TERM $PID ; fi
    fi
)


# test again from a directory with spaces in its path name
echo "Running test cases again from a folder with spaces in path name..."

SPACE_DIR="${TEMP}/Space Folder/SystemDS"
if [ ! -d "${SPACE_DIR}" ]
then
    echo "mkdir -p ${SPACE_DIR}"    >> ${TEST_LOG}
    mkdir -p "${SPACE_DIR}"         >> ${TEST_LOG}
fi

printf "Copying project contents from \"${PROJECT_ROOT_DIR}\" to \"${SPACE_DIR}\"... "  >> ${TEST_LOG}
rsync -aqz --exclude '*.java' \
           --exclude 'Test*.*' \
           --exclude 'test-classes/' \
           --exclude 'hadoop-test/' \
           --exclude 'src/test' \
           --exclude 'docs/' \
           --exclude '.git' \
           --exclude '.idea' \
           --exclude '.settings' \
           "${PROJECT_ROOT_DIR}/" "${SPACE_DIR}"  >> ${TEST_LOG}
printf "done.\n"                                  >> ${TEST_LOG}


# invoke the run script from the project root directory
CURRENT_TEST="Test_space_root__DML_script_with_path"
(
    printf "Running test \"${CURRENT_TEST}\"... "
    printf "\nTest case: \"${CURRENT_TEST}\"\n"   >> ${TEST_LOG}
    cd "${SPACE_DIR}"
    echo "Working directory: \"$PWD\""            >> ${TEST_LOG}
    rm -f "${DML_OUTPUT}"                         >  /dev/null   2>&1
    rm -f "temp/${DML_OUTPUT}"                    >  /dev/null   2>&1
    CMD="./bin/${RUN_SCRIPT} ${DML_SCRIPT_PATH}/${DML_SCRIPT_WITH_ARGS}"
    echo "${CMD}"                                 >> ${TEST_LOG} 2>&1
    sh ${CMD}                                     >> ${TEST_LOG} 2>&1
    EXIT_CODE=$?
    if [ $EXIT_CODE -eq 0 ]
    then
        if [    -f "${DML_OUTPUT}"      ] ; then ERR_MSG="${ERR_MSG}, outputdata in project root" ; EXIT_CODE=1 ; fi
        if [ !  -f "temp/${DML_OUTPUT}" ] ; then ERR_MSG="${ERR_MSG}, outputdata is missing" ;      EXIT_CODE=1 ; fi
    fi
    if [ $EXIT_CODE -eq 0 ] ;
        then printf "success\n";
        else printf "failed${ERR_MSG}\n"; if [ "${CONTINUE_ON_ERROR}" = "false" ] ; then kill -s TERM $PID ; fi
    fi
)
CURRENT_TEST="Test_space_root__DML_script_file_name"
(
    printf "Running test \"${CURRENT_TEST}\"... "
    printf "\nTest case: \"${CURRENT_TEST}\"\n"   >> ${TEST_LOG}
    cd "${SPACE_DIR}"
    echo "Working directory: \"$PWD\""            >> ${TEST_LOG}
    rm -f "${DML_OUTPUT}"                         >  /dev/null   2>&1
    rm -f "temp/${DML_OUTPUT}"                    >  /dev/null   2>&1
    CMD="./bin/${RUN_SCRIPT} ${DML_SCRIPT_WITH_ARGS} "
    echo "${CMD}"                                 >> ${TEST_LOG} 2>&1
    sh ${CMD}                                     >> ${TEST_LOG} 2>&1
    EXIT_CODE=$?
    if [ ${EXIT_CODE} -eq 0 ]
    then
        if [   -f "${DML_OUTPUT}"      ] ; then ERR_MSG="${ERR_MSG}, outputdata in project root" ; EXIT_CODE=1 ; fi
        if [ ! -f "temp/${DML_OUTPUT}" ] ; then ERR_MSG="${ERR_MSG}, outputdata is missing" ;      EXIT_CODE=1 ; fi
    fi
    if [ ${EXIT_CODE} -eq 0 ] ;
        then printf "success\n";
        else printf "failed${ERR_MSG}\n"; if [ "${CONTINUE_ON_ERROR}" = "false" ] ; then kill -s TERM $PID ; fi
    fi
)

# invoke the run script from the bin directory
CURRENT_TEST="Test_space_bin__DML_script_with_path"
(
    printf "Running test \"${CURRENT_TEST}\"... "
    printf "\nTest case: \"${CURRENT_TEST}\"\n"   >> ${TEST_LOG}
    cd "${SPACE_DIR}/bin"
    echo "Working directory: \"$PWD\""            >> ${TEST_LOG}
    rm -f "${DML_OUTPUT}"                         >  /dev/null    2>&1
    rm -f "../temp/${DML_OUTPUT}"                 >  /dev/null    2>&1
    CMD="./${RUN_SCRIPT} ../${DML_SCRIPT_PATH}/${DML_SCRIPT_WITH_ARGS} "
    echo "${CMD}"                                 >> ${TEST_LOG}  2>&1
    sh ${CMD}                                     >> ${TEST_LOG}  2>&1
    EXIT_CODE=$?
    if [ ${EXIT_CODE} -eq 0 ]
    then
        if [   -f "${DML_OUTPUT}"         ] ; then ERR_MSG="${ERR_MSG}, outputdata in bin folder" ; EXIT_CODE=1 ; fi
        if [ ! -f "../temp/${DML_OUTPUT}" ] ; then ERR_MSG="${ERR_MSG}, outputdata is missing" ;    EXIT_CODE=1 ; fi
    fi
    if [ ${EXIT_CODE} -eq 0 ] ;
        then printf "success\n";
        else printf "failed${ERR_MSG}\n"; if [ "${CONTINUE_ON_ERROR}" = "false" ] ; then kill -s TERM $PID ; fi
    fi
)
CURRENT_TEST="Test_space_bin__DML_script_file_name"
(
    printf "Running test \"${CURRENT_TEST}\"... "
    printf "\nTest case: \"${CURRENT_TEST}\"\n"   >> ${TEST_LOG}
    cd "${SPACE_DIR}/bin"
    echo "Working directory: \"$PWD\""            >> ${TEST_LOG}
    rm -f "${DML_OUTPUT}"                         >  /dev/null    2>&1
    rm -f "../temp/${DML_OUTPUT}"                 >  /dev/null    2>&1
    CMD="./${RUN_SCRIPT} ${DML_SCRIPT_WITH_ARGS} "
    echo "${CMD}"                                 >> ${TEST_LOG}  2>&1
    sh ${CMD}                                     >> ${TEST_LOG}  2>&1
    EXIT_CODE=$?
    if [ ${EXIT_CODE} -eq 0 ]
    then
        if [   -f "${DML_OUTPUT}"         ] ; then ERR_MSG="${ERR_MSG}, outputdata in bin folder" ; EXIT_CODE=1 ; fi
        if [ ! -f "../temp/${DML_OUTPUT}" ] ; then ERR_MSG="${ERR_MSG}, outputdata is missing" ;    EXIT_CODE=1 ; fi
    fi
    if [ ${EXIT_CODE} -eq 0 ] ;
        then printf "success\n";
        else printf "failed${ERR_MSG}\n"; if [ "${CONTINUE_ON_ERROR}" = "false" ] ; then kill -s TERM $PID ; fi
    fi
)

# invoke the run script from a working directory outside of the project root
CURRENT_TEST="Test_space_out__DML_script_with_path"
(
    printf "Running test \"${CURRENT_TEST}\"... "
    printf "\nTest case: \"${CURRENT_TEST}\"\n"   >> ${TEST_LOG}
    cd "${TEMP}"
    echo "Working directory: \"$PWD\""            >> ${TEST_LOG}
    rm -f "${DML_OUTPUT}"                         >  /dev/null    2>&1
    CMD="\"${SPACE_DIR}/bin/${RUN_SCRIPT}\" \"${SPACE_DIR}/${DML_SCRIPT_PATH}/${DML_SCRIPT}\" ${DML_ARGS}"
    echo "${CMD}"                                 >> ${TEST_LOG}  2>&1
    eval ${CMD}                                   >> ${TEST_LOG}  2>&1
    EXIT_CODE=$?
    if [ ${EXIT_CODE} -eq 0 ]
    then
        if [ ! -f "${DML_OUTPUT}" ] ; then ERR_MSG="${ERR_MSG}, outputdata is missing" ; EXIT_CODE=1 ; fi
    fi
    if [ ${EXIT_CODE} -eq 0 ] ;
        then printf "success\n";
        else printf "failed${ERR_MSG}\n"; if [ "${CONTINUE_ON_ERROR}" = "false" ] ; then kill -s TERM $PID ; fi
    fi
)
CURRENT_TEST="Test_space_out__DML_script_file_name"
(
    printf "Running test \"${CURRENT_TEST}\"... "
    printf "\nTest case: \"${CURRENT_TEST}\"\n"   >> ${TEST_LOG}
    cd "${TEMP}"
    echo "Working directory: \"$PWD\""            >> ${TEST_LOG}
    rm -f "${DML_OUTPUT}"                         >  /dev/null    2>&1
    CMD="\"${SPACE_DIR}/bin/${RUN_SCRIPT}\" ${DML_SCRIPT_WITH_ARGS}"
    echo "${CMD}"                                 >> ${TEST_LOG}  2>&1
    eval ${CMD}                                   >> ${TEST_LOG}  2>&1
    EXIT_CODE=$?
    if [ ${EXIT_CODE} -eq 0 ]
    then
        if [ ! -f "${DML_OUTPUT}" ] ; then ERR_MSG="${ERR_MSG}, outputdata is missing" ; EXIT_CODE=1 ; fi
    fi
    if [ ${EXIT_CODE} -eq 0 ] ;
        then printf "success\n";
        else printf "failed${ERR_MSG}\n"; if [ "${CONTINUE_ON_ERROR}" = "false" ] ; then kill -s TERM $PID ; fi
    fi
)





# Cleanup

printf "Cleaning up temporary files and folders ..."
if [ -d "${TEMP}" ] ; then
  rm -rf "${TEMP}"
fi
printf "done.\n"

echo "Test log was written to file ${TEST_LOG}."

cd "${USER_DIR}"

#!/usr/bin/env bash
#-------------------------------------------------------------
#
# Licensed to the Apache Software Foundation (ASF) under one
# or more contributor license agreements.  See the NOTICE file
# distributed with this work for additional information
# regarding copyright ownership.  The ASF licenses this file
# to you under the Apache License, Version 2.0 (the
# "License"); you may not use this file except in compliance
# with the License.  You may obtain a copy of the License at
#
#   http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing,
# software distributed under the License is distributed on an
# "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
# KIND, either express or implied.  See the License for the
# specific language governing permissions and limitations
# under the License.
#
#-------------------------------------------------------------
#
# Apply the Eclipse formatter (dev/CodeStyle_eclipse.xml) to ONLY the lines you
# edited -- the exact scope the "Java Format" CI check enforces.
#
# A bare `mvn formatter:format` would reformat EVERY .java file under the source
# roots, and even scoping to changed *files* would reformat their pre-existing
# (not-yet-clean) lines. The existing tree is not fully formatter-clean, so both
# would produce a large unrelated diff. This delegates to dev/format_changed.py,
# which formats each changed file but keeps only the changes that land on the
# lines you actually edited.
#
# "Changed" = lines that differ from the base branch (the merge target),
# including your committed-on-branch, staged, unstaged and untracked edits. Run
# `git fetch upstream main` first so the diff is accurate, or pass an explicit,
# current base ref if the default is stale/behind your branch point. The base-ref
# fallback order lives in one place: see resolve_base() in dev/format_changed.py.
#
# Usage:
#   dev/format-changed.sh [base-ref]
#     base-ref  branch/commit to diff against (default: resolved by
#               dev/format_changed.py)
#
set -euo pipefail

cd "$(git rev-parse --show-toplevel)"

exec python3 dev/format_changed.py --fix "$@"

#!/usr/bin/env bash
#-------------------------------------------------------------
#
# Licensed to the Apache Software Foundation (ASF) under one
# or more contributor license agreements.  See the NOTICE file
# distributed with this work for additional information
# regarding copyright ownership.  The ASF licenses this file
# to you under the Apache License, Version 2.0 (the
# "License"); you may not use this file except in compliance
# with the License.  You may obtain a copy of the License at
#
#   http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing,
# software distributed under the License is distributed on an
# "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
# KIND, either express or implied.  See the License for the
# specific language governing permissions and limitations
# under the License.
#
#-------------------------------------------------------------

################################################################################
##  File:  release-build.sh
##  Desc:  Create Release artifacts
################################################################################

SELF=$(cd $(dirname $0) && pwd)
. "$SELF/release-utils.sh"

exit_with_usage() {

  cat << EOF
usage: release-build.sh <package|docs>

Create build deliverables from a commit
Top level targets are
  - package: create binary packages and commit them
             to staging repo.
  - docs: Build docs and commit them to staging repo
  - publish-release: Build maven artifacts and publish to Maven Release Repo
  - publish-staging: Publish to staging repository

GIT_REF - Release tag or commit to build from
PACKAGE_VERSION - Release identifier in top level package directory (eg. 2.1.2-rc1)
BUILD_VERSION - (optional) Version being built (eg. 2.1.2)
ASF_USERNAME - Username of ASF committer
ASF_PASSWORD - Password of ASF committer account
GPG_KEY - GPG key used to sign release artifacts
GPG_PASSPHRASE - Passphrase for GPG key
EOF
  exit 1
}

if [ $# -eq 0 ]; then
  echo "usage: release-build.sh <docs|publish-release>"
fi

error() {
  echo "$*"
  exit 1
}

if [ $# -eq 0 ]; then
  exit_with_usage
fi


if [[ $@ == *"help"* ]]; then
  exit_with_usage
fi


# Build docs (production)
if [[ "$1" == "docs" ]]; then
  cd systemds
  echo "Building SystemDS docs"

  cd docs

  bundle install
  PRODUCTION=1 RELEASE_VERSION="$RELEASE_VERSION" bundle exec jekyll build
fi

GPG_OPTS="-Dgpg.keyname=${GPG_KEY} -Dgpg.passphrase=${GPG_PASSPHRASE}"

cat <<EOF >../tmp-settings.xml
<settings><servers><server>
<id>apache.snapshots.https</id><username>${ASF_USERNAME}</username>
<password>${ASF_PASSWORD}</password>
</server>
<server>
<id>apache.releases.https</id><username>${ASF_USERNAME}</username>
<password>${ASF_PASSWORD}</password>
</server>
</servers>
</settings>
EOF


# Publishing to Sonatype repo, details:
NEXUS_ROOT=https://repository.apache.org/service/local/staging
NEXUS_PROFILE=1486a6e8f50cdf

# Apache SVN Repo, details:
RELEASE_STAGING_LOCATION="https://dist.apache.org/repos/dist/dev/systemds"
DEST_DIR_NAME="$PACKAGE_VERSION"

# NOTE:
# 1. Build files will be saved to this folder.
# This folder will be used by `publish-release`
# 
# 2. this directory is passed via `file` protocol with
#  file:///${path} (3 slashes, specifies empty name)
#  refer: https://en.wikipedia.org/wiki/File_URI_scheme#How_many_slashes.3F
mkdir temp
tmp_repo=$(mktemp -d temp/systemds-repo-tmp-XXXXX)

if [[ "$1" == "publish-release" ]]; then

  # cd systemds
  
  # Publishing spark to Maven Central Repo
  printf "\nRelease version is ${PACKAGE_VERSION} \n"
  
  mvn versions:set -DnewVersion=${RELEASE_VERSION}

  # if ! is_dry_run; then
    printf "Creating a Nexus staging repository \n"
    promote_request="<promoteRequest><data><description>Apache SystemDS</description></data></promoteRequest>"
    out=$(curl -X POST -d "$promote_request" -u $ASF_USERNAME:$ASF_PASSWORD \
      -H "Content-Type:application/xml" -v \
      $NEXUS_ROOT/profiles/$NEXUS_PROFILE/start)
    staged_repository_id=$(echo $out | sed -e "s/.*\(orgapachesystemds-[0-9]\{4\}\).*/\1/")
  # fi

  cat <<EOF >../tmp-settings-nexus.xml
<settings>
<activeProfiles>
    <activeProfile>local-temp</activeProfile>
  </activeProfiles>

  <profiles>
    <profile>
      <id>local-temp</id>
      <repositories>
        <repository>
          <id>local-temp</id>
          <url>file:///$PWD/${tmp_repo}</url>
        </repository>
      </repositories>
    </profile>
  </profiles>
</settings>
EOF

  mvn --settings ../tmp-settings-nexus.xml -Pdistribution deploy \
    -DaltDeploymentRepository=local-temp::default::file:///$PWD/${tmp_repo} \
    -Daether.checksums.algorithms='SHA-512,SHA-1,MD5'

  pushd "${tmp_repo}/org/apache/systemds"
  

  # if ! is_dry_run; then
    # upload files to nexus repo
    nexus_upload_id=$NEXUS_ROOT/deployByRepositoryId/$staged_repository_id
    printf "\nUpload files to $nexus_upload_id \n"

    for file in $(find . -type f)
    do
      # strip leading ./
      file_short=$(echo $file | sed -e "s/\.\///")
      dest_url="$nexus_upload_id/org/apache/systemds/$file_short"
      printf "\nUploading $file_short \n"
      curl -u $ASF_USERNAME:$ASF_PASSWORD --upload-file $file_short $dest_url
    done

    # Promote the staging repository
    promote_request="<promoteRequest><data><stagedRepositoryId>$staged_repository_id</stagedRepositoryId></data></promoteRequest>"
    out=$(curl -X POST -d "$promote_request" -u $ASF_USERNAME:$ASF_PASSWORD \
      -H "Content-Type:application/xml" -v \
      $NEXUS_ROOT/profiles/$NEXUS_PROFILE/finish)
    printf "Closed Nexus staging repository: $staged_repository_id"

    printf "\nAfter release vote passes make sure to hit release button.\n"

  # else
  #   printf "Files will uploaded to Nexus Repo at this step."
  # fi
    
    printf "\n ============== "
    printf "\n Upload artifacts to dist.apache.org \n"
    
    svn co --depth=empty $RELEASE_STAGING_LOCATION svn-systemds

    if ! is_dry_run; then
      stage_dir="svn-systemds/${PACKAGE_VERSION}"
      mkdir -p $stage_dir
    else
      stage_dir=$(mktemp -d svn-systemds/${DEST_DIR_NAME}-temp-XXXX)
    fi

    printf "\nCopy the release tarballs to svn repo \n"
    ls *
    
    # Remove extra files generated
    # Keep only .zip, .tgz, and javadoc
    find systemds -type f | grep -v -e \.zip -e \.tgz -e javadoc | xargs rm
    eval cp systemds/${RELEASE_VERSION}/systemds-* "${stage_dir}"
    svn add "${stage_dir}"
    
    eval cd svn-systemds
    svn ci --username "$ASF_USERNAME" --password "$ASF_PASSWORD" -m"Apache SystemDS $SYSTEMDS_PACKAGE_VERSION" --no-auth-cache
    eval cd ..
    rm -rf svn-systemds

  popd

  # NOTE: Do not delete any generated release artifacts
  # rm -rf "${tmp_repo}"
  eval cd ..
  exit 0
fi

#!/usr/bin/env bash
#-------------------------------------------------------------
#
# Licensed to the Apache Software Foundation (ASF) under one
# or more contributor license agreements.  See the NOTICE file
# distributed with this work for additional information
# regarding copyright ownership.  The ASF licenses this file
# to you under the Apache License, Version 2.0 (the
# "License"); you may not use this file except in compliance
# with the License.  You may obtain a copy of the License at
#
#   http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing,
# software distributed under the License is distributed on an
# "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
# KIND, either express or implied.  See the License for the
# specific language governing permissions and limitations
# under the License.
#
#-------------------------------------------------------------

# Deploy + run SystemDS on a Databricks cluster.
#
# Tested against DBR 16.4 LTS (Spark 3.5.2 / Scala 2.12), where the SystemDS
# jar runs unchanged.
#
# Quick start:
#   1. Copy scripts/databricks/.env.example to .env and edit it (or place the
#      .env at the root of your workspace; this script searches parent dirs).
#   2. Authenticate the Databricks CLI once, interactively:
#        databricks auth login --profile <your-profile>
#   3. Build the SystemDS jar (mvn -q -DskipTests package) so target/SystemDS.jar
#      exists, or point JAR_LOCAL at an existing jar.
#   4. Run a step:
#        ./deploy.sh upload     # create UC volume + copy SystemDS.jar into it
#        ./deploy.sh cluster    # create single-user cluster + install SystemDS.jar
#        ./deploy.sh libs       # install Delta Kernel Maven libraries on cluster
#        ./deploy.sh import     # import the demo notebook(s)
#        ./deploy.sh all        # upload + cluster + libs + import
#
# All configuration is read from environment variables (see .env.example).
# Anything already exported in your shell overrides the .env file.
#
# Hard-won requirements baked in below:
#   - Cluster creation requires a compute policy (e.g. Personal Compute) that
#     restricts node types and autotermination.
#   - UC clusters only accept JAR libraries from a UC Volume (not DBFS, not
#     /Workspace).
#   - Must be SINGLE_USER (Assigned) mode; shared/USER_ISOLATION blocks JAR libs.
#   - SystemDS needs the Vector API module + a full --add-opens set at JVM
#     launch, and an absolute scratch dir (the notebook sets sysds.scratch).

set -euo pipefail

HERE="$(cd "$(dirname "${BASH_SOURCE[0]}")" && pwd)"

#-------------------------------------------------------------
# Load configuration from a .env file.
# Resolution order:
#   1. $ENV_FILE if explicitly set.
#   2. The first .env found walking up from this script's directory
#      (script dir -> repo root -> workspace root -> ... -> /).
#-------------------------------------------------------------
find_env_file() {
  if [[ -n "${ENV_FILE:-}" ]]; then
    printf '%s\n' "$ENV_FILE"
    return 0
  fi
  local dir="$HERE"
  while [[ "$dir" != "/" ]]; do
    if [[ -f "$dir/.env" ]]; then
      printf '%s\n' "$dir/.env"
      return 0
    fi
    dir="$(dirname "$dir")"
  done
  return 1
}

if ENV_PATH="$(find_env_file)"; then
  echo ">> loading config from $ENV_PATH"
  set -a
  # shellcheck disable=SC1090
  source "$ENV_PATH"
  set +a
else
  echo ">> no .env found; relying on exported environment variables / defaults"
fi

#-------------------------------------------------------------
# Configuration (env var with sensible fallback).
#-------------------------------------------------------------
PROFILE="${PROFILE:-DEFAULT}"

# Repo root is used to locate the default jar (target/SystemDS.jar).
REPO_ROOT="${REPO_ROOT:-$(git -C "$HERE" rev-parse --show-toplevel 2>/dev/null || echo "$HERE/../..")}"
JAR_LOCAL="${JAR_LOCAL:-$REPO_ROOT/target/SystemDS.jar}"

db() { databricks -p "$PROFILE" "$@"; }

# Resolve the current user lazily (only needed for the notebook import target).
resolve_user() {
  if [[ -z "${USER_NAME:-}" ]]; then
    USER_NAME="$(db current-user me -o json \
      | python3 -c 'import sys,json;print(json.load(sys.stdin)["userName"])')"
  fi
}

CATALOG="${CATALOG:-main}"
SCHEMA="${SCHEMA:-default}"
VOLUME="${VOLUME:-systemds}"
VOL_DIR="/Volumes/$CATALOG/$SCHEMA/$VOLUME"
JAR_REMOTE="$VOL_DIR/SystemDS.jar"

POLICY_ID="${POLICY_ID:-}"
SPARK_VERSION="${SPARK_VERSION:-16.4.x-scala2.12}"
NODE_TYPE="${NODE_TYPE:-i3.xlarge}"
NUM_WORKERS="${NUM_WORKERS:-0}"
AUTOTERMINATION_MINUTES="${AUTOTERMINATION_MINUTES:-30}"
CLUSTER_NAME="${CLUSTER_NAME:-systemds}"
CLUSTER_ID_FILE="${CLUSTER_ID_FILE:-$HERE/.cluster_id}"

# Delta Kernel is not on the DBR classpath and is not bundled in SystemDS.jar
# (the uber jar shades only wink + antlr). The native Delta read/write path needs
# delta-kernel-api + delta-kernel-defaults installed as cluster Maven libraries.
# Use >= 3.3.2: earlier releases (3.3.0/3.3.1) subclass parquet-mr's
# package-private InternalParquetRecordReader, which breaks across Databricks'
# library/app classloaders (IllegalAccessError, then NoSuchMethodError against
# DBR's parquet). 3.3.2 (delta PR #4494) switched to parquet's public
# ParquetReader API, so Kernel works with DBR's own parquet. 4.x targets Spark 4
# (wrong for DBR 16.4 = Spark 3.5). Must match the delta-kernel.version in pom.xml.
DELTA_KERNEL_VERSION="${DELTA_KERNEL_VERSION:-3.3.2}"

# SystemDS JVM flags (mirror of <jvm.addopens> in pom.xml).
JVMOPTS="${JVMOPTS:---add-modules=jdk.incubator.vector \
--add-opens=java.base/java.nio=ALL-UNNAMED \
--add-opens=java.base/java.io=ALL-UNNAMED \
--add-opens=java.base/java.util=ALL-UNNAMED \
--add-opens=java.base/java.lang=ALL-UNNAMED \
--add-opens=java.base/java.lang.ref=ALL-UNNAMED \
--add-opens=java.base/java.util.concurrent=ALL-UNNAMED \
--add-opens=java.base/sun.nio.ch=ALL-UNNAMED}"

# Notebooks to import (space-separated, relative to this dir). Language is
# detected from the extension (.scala -> SCALA, .py -> PYTHON).
NB_FILES="${NB_FILES:-SystemDS_MLContext_Demo.scala SystemDS_Delta_E2E.scala}"

#-------------------------------------------------------------
# Steps.
#-------------------------------------------------------------
upload() {
  [[ -f "$JAR_LOCAL" ]] || { echo "!! jar not found: $JAR_LOCAL (build it or set JAR_LOCAL)"; exit 1; }
  echo ">> ensuring UC volume $CATALOG.$SCHEMA.$VOLUME"
  db volumes create "$CATALOG" "$SCHEMA" "$VOLUME" MANAGED 2>/dev/null || true
  echo ">> uploading $JAR_LOCAL -> $JAR_REMOTE"
  db fs cp --overwrite "$JAR_LOCAL" "dbfs:$JAR_REMOTE"
}

cluster() {
  resolve_user
  echo ">> creating cluster $CLUSTER_NAME ($SPARK_VERSION, $NODE_TYPE, single-user)"
  local policy_json=""
  if [[ -n "$POLICY_ID" ]]; then
    policy_json="\"policy_id\": \"$POLICY_ID\", \"apply_policy_default_values\": true,"
  fi
  CID=$(db clusters create --no-wait -o json --json "{
    \"cluster_name\": \"$CLUSTER_NAME\",
    $policy_json
    \"spark_version\": \"$SPARK_VERSION\",
    \"node_type_id\": \"$NODE_TYPE\",
    \"num_workers\": $NUM_WORKERS,
    \"autotermination_minutes\": $AUTOTERMINATION_MINUTES,
    \"data_security_mode\": \"SINGLE_USER\",
    \"single_user_name\": \"$USER_NAME\",
    \"spark_conf\": {
      \"spark.databricks.cluster.profile\": \"singleNode\",
      \"spark.master\": \"local[*]\",
      \"spark.driver.extraJavaOptions\": \"$JVMOPTS\",
      \"spark.executor.extraJavaOptions\": \"$JVMOPTS\"
    }
  }" | python3 -c 'import sys,json;print(json.load(sys.stdin)["cluster_id"])')
  echo "cluster_id=$CID"
  echo "$CID" > "$CLUSTER_ID_FILE"
  echo ">> installing library $JAR_REMOTE (queued; installs once RUNNING)"
  db libraries install --json "{\"cluster_id\":\"$CID\",\"libraries\":[{\"jar\":\"$JAR_REMOTE\"}]}"
}

# Resolve the target cluster id: prefer the one written by cluster(), else look
# it up by name.
resolve_cluster_id() {
  if [[ -n "${CLUSTER_ID:-}" ]]; then
    return 0
  fi
  if [[ -f "$CLUSTER_ID_FILE" ]]; then
    CLUSTER_ID="$(cat "$CLUSTER_ID_FILE")"
    return 0
  fi
  CLUSTER_ID="$(db clusters list -o json \
    | python3 -c 'import sys,json;
clusters=json.load(sys.stdin);
m=[c for c in clusters if c.get("cluster_name")=="'"$CLUSTER_NAME"'"];
print(m[0]["cluster_id"] if m else "")')"
  [[ -n "$CLUSTER_ID" ]] || { echo "!! could not resolve cluster id for $CLUSTER_NAME (run ./deploy.sh cluster first or set CLUSTER_ID)"; exit 1; }
}

# Install the Delta Kernel Maven libraries on the cluster. delta-kernel-defaults
# pulls delta-kernel-api transitively; both come from Maven Central. parquet,
# hadoop and jackson are excluded so Kernel uses DBR's own copies (avoids
# duplicate-class / split-package issues across the library/app classloaders).
libs() {
  resolve_cluster_id
  echo ">> installing Delta Kernel $DELTA_KERNEL_VERSION Maven libs on $CLUSTER_ID"
  db libraries install --json "{
    \"cluster_id\": \"$CLUSTER_ID\",
    \"libraries\": [
      {\"maven\": {
        \"coordinates\": \"io.delta:delta-kernel-defaults:$DELTA_KERNEL_VERSION\",
        \"exclusions\": [
          \"org.apache.parquet:parquet-hadoop\",
          \"org.apache.hadoop:hadoop-client-runtime\",
          \"org.apache.hadoop:hadoop-client-api\",
          \"com.fasterxml.jackson.core:jackson-databind\"
        ]
      }}
    ]
  }"
  echo ">> queued; check status with: db libraries cluster-status $CLUSTER_ID"
}

import() {
  resolve_user
  local dir="${NB_DIR:-/Users/$USER_NAME}"
  local nb lang base
  for nb in $NB_FILES; do
    case "$nb" in
      *.scala) lang="SCALA" ;;
      *.py)    lang="PYTHON" ;;
      *.sql)   lang="SQL" ;;
      *.r|*.R) lang="R" ;;
      *) echo "!! skipping $nb (unknown notebook language)"; continue ;;
    esac
    base="$(basename "${nb%.*}")"
    echo ">> importing $nb -> $dir/$base ($lang)"
    db workspace import --overwrite --language "$lang" --format SOURCE \
      --file "$HERE/$nb" "$dir/$base"
  done
}

case "${1:-all}" in
  upload)  upload ;;
  cluster) cluster ;;
  libs)    libs ;;
  import)  import ;;
  all)     upload; cluster; libs; import ;;
  *) echo "usage: $0 {upload|cluster|libs|import|all}"; exit 1 ;;
esac

#!/usr/bin/env bash
#-------------------------------------------------------------
#
# Licensed to the Apache Software Foundation (ASF) under one
# or more contributor license agreements.  See the NOTICE file
# distributed with this work for additional information
# regarding copyright ownership.  The ASF licenses this file
# to you under the Apache License, Version 2.0 (the
# "License"); you may not use this file except in compliance
# with the License.  You may obtain a copy of the License at
#
#   http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing,
# software distributed under the License is distributed on an
# "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
# KIND, either express or implied.  See the License for the
# specific language governing permissions and limitations
# under the License.
#
#-------------------------------------------------------------

function exit_with_usage {
  cat << EOF

simple-release-verify - Verifies the artifacts from a given directory.

SYNOPSIS

usage: simple-release-verify.sh [--compile | --verifyAll | verifyLic | verifyBin]

DESCRIPTION

Once artifacts are generated, this utility will verify the artifacts.

--compile
This will compile the utility source code which is not on regular source code path.

--verifyAll <--tag="Code based on Git tag will be validated."> [--workDir="Directory where output files will be created]
This will verify license, notice and binary files.

--verifyLic [--distDir="Directory Containing zip/tgz/tar.gz files]
This will verify license, notice in zip/tgz/tar.gz files.

--verifyBin <--tag="Code based on Git tag will be validated."> [--workDir="Directory where output files will be created]
This will verify binary distribution files for runtime correctness.

OPTIONS

--distDir            - Directory containing release artifacts (zip/tgz/tar.gz) files.

--workDir             - Directory where output files will be created.

EXAMPLES

# To compile utility source code
release-verify.sh --compile

# To verify release artifacts
release-verify.sh --verifyAll --tag=<tagName>
e.g. ./release-verify.sh --verifyAll --tag=v0.14.0-rc4

# To verify license and notices
release-verify.sh --verifyLic --distDir=<DistribLocation>
e.g. ./release-verify.sh --verifyLic --distDir=tmp/relValidation/downloads

# To verify binary files
release-verify.sh --verifyBin --tag=<tagName>
e.g. ./release-verify.sh --verifyBin --tag=v0.14.0-rc4


EOF
  exit 1
}

set -e

if [ $# -eq 0 ]; then
  echo "`date +%Y-%m-%dT%H:%M:%S`: ERROR: Insufficient parameters passed.";
  exit_with_usage
fi

# detect operating system to set correct directory separator
if [ "$OSTYPE" == "win32" ] ||  [ "$OSTYPE" == "msys" ] ; then
  echo "This script currently does not support Windows, as it makes use of symbolic linking via 'ln -s'"
  exit 1
fi

# Process each provided argument configuration
while [ "${1+defined}" ]; do
  IFS="=" read -ra PARTS <<< "$1"
  case "${PARTS[0]}" in
    --compile)
      COMPILE_CODE=true
      shift
      ;;
    --verifyAll)
      LIC_NOTICE_VERIFY=true
      BIN_VERIFY=true
      shift
      ;;
    --verifyLic)
      LIC_NOTICE_VERIFY=true
      shift
      ;;
    --verifyBin)
      BIN_VERIFY=true
      shift
      ;;
    --distDir)
      DIST_DIR="${PARTS[1]}"
      shift
      ;;
    --workDir)
      WORK_DIR="${PARTS[1]}"
      shift
      ;;
    --tag)
      TAG="${PARTS[1]}"
      shift
      ;;
    *help* | -h)
      exit_with_usage
     exit 0
     ;;
    -*)
     echo "`date +%Y-%m-%dT%H:%M:%S`: ERROR: Unknown option: $1" >&2
     exit_with_usage
     ;;
    *)  # No more options
     break
     ;;
  esac
done

if [[ -z "$SYSTEMDS_ROOT" ]]; then
    echo
    echo "-------------------------------------------------------------"
    echo 'The environment variable SYSTEMDS_ROOT is not set. This'
    echo 'variable needs to point to the base of your SystemDS source'
    echo 'tree.'
    echo "-------------------------------------------------------------"

    exit_with_usage
fi

ORIG_DIR=$(pwd)
EXEC_DIR="`dirname \"$0\"`"
if [[ ${EXEC_DIR:0:1} != "/" ]]; then
    EXEC_DIR=$ORIG_DIR/$EXEC_DIR
fi

if [[ -z "$WORK_DIR" ]]; then
    WORK_DIR="$EXEC_DIR/tmp/relValidation"
elif [[ ${WORK_DIR:0:1} != "/" ]]; then
    WORK_DIR="$ORIG_DIR/$WORK_DIR"
fi

BUILD_TARGET_DIR="$EXEC_DIR/target"
if [[ ! -d $BUILD_TARGET_DIR ]]; then
  ln -s "$SYSTEMDS_ROOT"/target "$BUILD_TARGET_DIR"
fi

if [[ "$BIN_VERIFY" == "true" && -z "$TAG" ]]; then
    echo "`date +%Y-%m-%dT%H:%M:%S`: ERROR: Argument --tag is a mandatory variable for binary verification."
    exit_with_usage
fi

if [[ -n $COMPILE_CODE && -z "$DIST_DIR" ]]; then
  echo "`date +%Y-%m-%dT%H:%M:%S`: ERROR: Argument --distDir is missing (path to release (zip/tgz/tar.gz) files)"
  exit_with_usage
fi

cd $EXEC_DIR/src/test/java
if [[ "$COMPILE_CODE" == "true" ]]; then
    echo "`date +%Y-%m-%dT%H:%M:%S`: INFO: Compiling release verify utility..."

    javac -Xlint:unchecked -classpath ../../../target/release/systemds/target/lib/commons-compress-1.4.1.jar:../../../target/release/systemds/target/lib/commons-io-2.4.jar:. org/apache/sysds/validation/*.java

    cd "$ORIG_DIR" # Return to directory from it was called.
    exit 0
fi

if [[ "$BIN_VERIFY" == "true" ]]; then
    echo "`date +%Y-%m-%dT%H:%M:%S`: INFO: Verifying binary files for runtime execution..."

    if [ -z $WORKING_DIR ] ; then
        WORKING_DIR="$EXEC_DIR/tmp/relValidation"
    fi

    rm -rf "$WORKING_DIR"/systemds
    mkdir -p "$WORKING_DIR"
    cd "$WORKING_DIR"

    ## Verify binary tgz files
    echo "`date +%Y-%m-%dT%H:%M:%S`: INFO: Verifying binary tgz files..."
    rm -rf systemds-$TAG-bin
    tar -xzf $DIST_DIR/systemds-$TAG-bin.tgz
    cd systemds-$TAG-bin
    echo "print('hello world');" > hello.dml
    ./systemds hello.dml
    cd ..
    echo "`date +%Y-%m-%dT%H:%M:%S`: INFO: Verification of tgz files completed successfully."

    ## Verify binary zip files
    echo "`date +%Y-%m-%dT%H:%M:%S`: INFO: Verifying binary zip files..."
    rm -rf systemds-$TAG-bin
    unzip -q $DIST_DIR/systemds-$TAG-bin.zip
    cd systemds-$TAG-bin
    echo "print('hello world');" > hello.dml
    ./systemds hello.dml
    cd ..
    echo "`date +%Y-%m-%dT%H:%M:%S`: INFO: Verification of zip files completed successfully."

    ## Verify src tgz files
    echo "`date +%Y-%m-%dT%H:%M:%S`: INFO: Verifying source tgz files..."
    rm -rf systemds-$TAG-src
    tar -xzf $DIST_DIR/systemds-$TAG-src.tgz
    cd systemds-$TAG-src
    mvn clean package -P distribution -DskipTests
    cd target
    java -cp "./lib/*:SystemDS.jar" org.apache.sysds.api.DMLScript -s "print('hello world');"
    cd ../..
    echo "`date +%Y-%m-%dT%H:%M:%S`: INFO: Verification of source archive completed successfully."

    echo "`date +%Y-%m-%dT%H:%M:%S`: INFO: Verification of all binary files for runtime execution completed successfully."
    echo "*********************************************************************************************************************"
fi

if [[ "$LIC_NOTICE_VERIFY" == "true" ]]; then
    echo "`date +%Y-%m-%dT%H:%M:%S`: INFO: Verifying license and notices from zip/tgz/tar.gz files..."

    java -classpath ../../../target/release/systemds/target/lib/commons-compress-1.4.1.jar:../../../target/release/systemds/target/lib/commons-io-2.4.jar:. org/apache/sysds/validation/ValidateLicAndNotice $DIST_DIR
    RET_CODE=$?
    if [[ $RET_CODE == 0 ]]; then
       echo "`date +%Y-%m-%dT%H:%M:%S`: INFO: Verification of license and notices completed successfully."
    else
       echo "`date +%Y-%m-%dT%H:%M:%S`: ERROR: Verification of license and notices failed."
    fi
    echo "*********************************************************************************************************************"
fi

cd "$ORIG_DIR" # Return to directory from it was called.
exit $RET_CODE

@ECHO OFF
::-------------------------------------------------------------
::
:: Licensed to the Apache Software Foundation (ASF) under one
:: or more contributor license agreements.  See the NOTICE file
:: distributed with this work for additional information
:: regarding copyright ownership.  The ASF licenses this file
:: to you under the Apache License, Version 2.0 (the
:: "License"); you may not use this file except in compliance
:: with the License.  You may obtain a copy of the License at
::
::   http://www.apache.org/licenses/LICENSE-2.0
::
:: Unless required by applicable law or agreed to in writing,
:: software distributed under the License is distributed on an
:: "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
:: KIND, either express or implied.  See the License for the
:: specific language governing permissions and limitations
:: under the License.
::
::-------------------------------------------------------------

:: This shell script compiles the required shared libraries for Windows on x86-64
:: Make sure to have run "\"%INTEL_ROOT%\"\compilervars.bat intel64 vs2019" and set OpenBLAS_HOME to where
:: libopenblas.lib is located

:: configure and compile INTEL MKL
cmake -S . -B INTEL -DUSE_INTEL_MKL=ON -DCMAKE_BUILD_TYPE=Release
cmake --build INTEL --target install --config Release
rmdir /Q /S INTEL

:: configure and compile OPENBLAS
cmake . -B OPENBLAS -DUSE_OPEN_BLAS=ON -DCMAKE_BUILD_TYPE=Release
cmake --build OPENBLAS --target install --config Release
rmdir /Q /S OPENBLAS

cmake he\ -B HE -DCMAKE_BUILD_TYPE=Release
cmake --build HE --target install --config Release
rmdir /Q /S HE

echo.
echo "Make sure to re-run mvn package to make use of the newly compiled libraries"

#!/usr/bin/env bash
#-------------------------------------------------------------
#
# Licensed to the Apache Software Foundation (ASF) under one
# or more contributor license agreements.  See the NOTICE file
# distributed with this work for additional information
# regarding copyright ownership.  The ASF licenses this file
# to you under the Apache License, Version 2.0 (the
# "License"); you may not use this file except in compliance
# with the License.  You may obtain a copy of the License at
#
#   http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing,
# software distributed under the License is distributed on an
# "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
# KIND, either express or implied.  See the License for the
# specific language governing permissions and limitations
# under the License.
#
#-------------------------------------------------------------

################################################################################
##  File:  do-release.sh
##  Desc:  Triggers the release workflow
################################################################################

SELF=$(cd $(dirname $0) && pwd)
. "$SELF/release-utils.sh"

# discussion on optional arguments
# https://stackoverflow.com/q/18414054
while getopts ":ng" opt; do
  case $opt in
    n) DRY_RUN=1 ;;
    g) GITHUB_CI=1 ;;
    \?) error "Invalid option: $OPTARG" ;;
  esac
done

DRY_RUN=${DRY_RUN:-0}
GITHUB_CI=${GITHUB_CI:-0}

cleanup_repo

# Ask for release information
get_release_info

if is_github_ci; then
  printf "\n Building via GITHUB actions \n"
fi

# tag
run_silent "Creating release tag $RELEASE_TAG..." "tag.log" \
    "$SELF/create-tag.sh"

cat tag.log

# run_silent "Publish Release Candidates to the Nexus Repo..." "publish-snapshot.log" \
#     "$SELF/release-build.sh" publish-snapshot

if ! is_dry_run; then
  git checkout $RELEASE_TAG
  printf "\n checking out $RELEASE_TAG for building artifacts \n"
fi

# NOTE:
# The following goals publishes the artifacts to
#  1) Nexus repo at repository.apache.org
#  2) SVN repo at dist.apache.org
# 
# are to be used together.

if ! is_github_ci; then
  run_silent "Publish Release Candidates to the Nexus Repo..." "publish.log" \
      "$SELF/release-build.sh" publish-release
fi

if is_dry_run; then
  # restore the pom.xml file updated during release step
  git restore pom.xml
fi

if is_github_ci; then
  printf "\n Release tag process is done via GITHUB actions \n"
  exit 0
fi

if ! is_dry_run; then
  
  printf "\n Release candidate artifacts are built and published to repository.apache.org, dist.apache.org \n"
  printf "\n Voting needs to be done for these artifacts for via the mailing list \n"
  exit 0
fi

# Dry run step
if is_dry_run; then
  
  printf "\n Release candidate artifacts are built and published to repository.apache.org, dist.apache.org \n"
  printf "\n Please delete these artifacts generated with dry run to ensure that the release scripts are generating correct artifacts. \n"
  exit 0
fi

#!/usr/bin/env bash
#-------------------------------------------------------------
#
# Licensed to the Apache Software Foundation (ASF) under one
# or more contributor license agreements.  See the NOTICE file
# distributed with this work for additional information
# regarding copyright ownership.  The ASF licenses this file
# to you under the Apache License, Version 2.0 (the
# "License"); you may not use this file except in compliance
# with the License.  You may obtain a copy of the License at
#
#   http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing,
# software distributed under the License is distributed on an
# "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
# KIND, either express or implied.  See the License for the
# specific language governing permissions and limitations
# under the License.
#
#-------------------------------------------------------------

function exit_with_usage {
  cat << EOF

simple-release-build.sh - A simplified version of the release scripts for producting versioned code/binary bundles

SYNOPSIS

usage: simple-release-build.sh [--overrideVersion=<version>] [--gitUrl=<repository-url]
                               [--gitCommitHash=<commit-or-branch-name>] [--force-download]

DESCRIPTION

This script omits all the bells and whistles to simply produce *-bin.tbz et al 

OPTIONS

-v=    --overrideVersion=<no-default>
         Specifies the version of the release
  
-u=    --gitUrl=https://github.com/apache/systemds.git
         The URL of the repository to clone
  
-g=    --gitCommitHash=master
         The tag, branch name or commit hash to check out

-f     --force-download
         Clone the repository again (to overwrite in consecutive runs)

-s     --skip-sign
         Skips signing with gnupg. Convenience option for internal use

-h     --help
         Call for help (print this text)
EXAMPLE

SYSTEMDS_ROOT=$(pwd) GNUPGHOME=<path-to-gnupg-dir> GPG_KEYID="<0xKeyID>" GPG_PASSPHRASE="<passphrase>"  dev/release/simple-release-build.sh --overrideVersion=1.2.3 -g=prep-release-0.2

<<
EOF
  exit 1
}

set -e

#if [ $# -eq 0 ]; then
#  exit_with_usage
#fi

# Process each provided argument configuration
while [ "${1+defined}" ]; do
  IFS="=" read -ra PARTS <<< "$1"
  case "${PARTS[0]}" in
    -g | --gitCommitHash)
      GIT_REF="${PARTS[1]}"
      shift
      ;;
    -v | --overrideVersion)
      RELEASE_VERSION="${PARTS[1]}"
      shift
      ;;
    -u | --gitUrl)
      GIT_URL="${PARTS[1]}"
      shift
      ;;
    -f | --force-download)
      FORCE_DL=1
      shift
      ;;
    -s | --skip-sign)
      SKIP_SIGN=1
      shift
      ;;
    *help* | -h)
      exit_with_usage
      exit 0
      ;;
    -*)
      echo "Error: Unknown option: $1" >&2
      exit 1
      ;;
    *)  # No more options
     break
     ;;
  esac
done

if [[ -z "$SYSTEMDS_ROOT" ]]; then
    echo
    echo "-------------------------------------------------------------"
    echo 'The environment variable SYSTEMDS_ROOT is not set. This'
    echo 'variable needs to point to the base of your SystemDS source'
    echo 'tree.'
    echo "-------------------------------------------------------------"

    exit_with_usage
fi

if [ -z ${SKIP_SIGN} ]; then
  if [[ -z "$GPG_PASSPHRASE" ]]; then
      echo 'The environment variable GPG_PASSPHRASE is not set. Enter the passphrase to'
      echo 'unlock the GPG signing key that will be used to sign the release!'
      echo
      stty -echo && printf "GPG passphrase: " && read GPG_PASSPHRASE && printf '\n' && stty echo
  fi

  if [[ -z "$GPG_KEYID" ]]; then
      echo 'The environment variable GPG_KEYID is not set. Enter the key ID for the '
      echo ' GPG signing key that will be used to sign the release!'
      echo
      stty -echo && printf "GPG key ID: " && read GPG_KEYID && printf '\n' && stty echo
  fi
fi

# Commit ref to checkout when building
GIT_REF=${GIT_REF:-master}
if [[ "$RELEASE_PUBLISH" == "true" && "$GIT_TAG" ]]; then
    GIT_REF="tags/$GIT_TAG"
fi

# Commit ref to checkout when building
GIT_REF=${GIT_REF:-master}
if [[ -z "$GIT_URL" ]]; then
    echo "Using default URL"
    GIT_URL="https://github.com/apache/systemds.git"
fi

BASE_DIR=$(pwd)
RELEASE_WORK_DIR=$BASE_DIR/target/release

MVN="mvn --batch-mode --errors"

if [ -z ${SKIP_SIGN} ]; then
  PUBLISH_PROFILES="-Pdistribution,rat"
else
  PUBLISH_PROFILES="-Pdistribution,rat,skip-sign"
fi

RELEASE_STAGING_LOCATION="${SYSTEMDS_ROOT}/temp"

echo "  "
echo "-------------------------------------------------------------"
echo "------- Release preparation with the following parameters ---"
echo "-------------------------------------------------------------"
echo
echo "SYSTEMDS_ROOT       ==> $SYSTEMDS_ROOT"
echo "Git reference       ==> $GIT_REF"
if [ -z "$RELEASE_VERSION" ]; then
  echo "release version     ==> (from pom.xml)"
  else
  echo "release version     ==> $RELEASE_VERSION"
fi
echo "Deploying to        ==> $RELEASE_STAGING_LOCATION"
echo

function checkout_code {
    # Checkout code
    rm -rf "$RELEASE_WORK_DIR"
    mkdir -p "$RELEASE_WORK_DIR"
    cd "$RELEASE_WORK_DIR"
    git clone $GIT_URL
    cd systemds
    git checkout "$GIT_REF"
    git_hash=$(git rev-parse --short HEAD)
    echo "Checked out SystemDS git hash $git_hash"

    git clean -d -f -x

    cd "$BASE_DIR" #return to base dir
}

if [[ ! -d $RELEASE_WORK_DIR || FORCE_DL -eq 1 ]]; then
    echo "Cloning source repo..."
    checkout_code
fi

if [[ ! -d $RELEASE_STAGING_LOCATION ]]; then
  mkdir -p "$RELEASE_STAGING_LOCATION"
fi

TIMESTAMP=$(date +%Y-%m-%dT%H:%M:%S)
LOG_OUTPUT=$RELEASE_STAGING_LOCATION/simple-release-build-output-$TIMESTAMP.log

cd "$RELEASE_WORK_DIR"/systemds

if [[ -n $RELEASE_VERSION ]]; then
    echo "resetting version in pom.xml..." ; sleep 3
    $MVN versions:set -DnewVersion="$RELEASE_VERSION"
fi

if [ -z ${SKIP_SIGN} ]; then
  GPG_OPTS="-Dgpg.keyname=$GPG_KEYID -Dgpg.passphrase=$GPG_PASSPHRASE"
fi

# skipped mvn clean verify release:update-versions verify install:install deploy:deploy
#CMD="$MVN $PUBLISH_PROFILES deploy \
#  -DskiptTests \
#  -DaltDeploymentRepository=altDepRepo::default::file://$RELEASE_STAGING_LOCATION \
#  ${GPG_OPTS}"

CMD="$MVN $PUBLISH_PROFILES deploy \
  -DskiptTests \
  -DaltDeploymentRepository=altDepRepo::default::file:///temp \
  ${GPG_OPTS}"

echo "Executing: " "$CMD"

$CMD | tee "$LOG_OUTPUT"

cd "$BASE_DIR"

#!/bin/bash
#-------------------------------------------------------------
#
# Licensed to the Apache Software Foundation (ASF) under one
# or more contributor license agreements.  See the NOTICE file
# distributed with this work for additional information
# regarding copyright ownership.  The ASF licenses this file
# to you under the Apache License, Version 2.0 (the
# "License"); you may not use this file except in compliance
# with the License.  You may obtain a copy of the License at
#
#   http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing,
# software distributed under the License is distributed on an
# "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
# KIND, either express or implied.  See the License for the
# specific language governing permissions and limitations
# under the License.
#
#-------------------------------------------------------------

# $1 Dml script name.
# $2 Args

# If number of arguments are not equal to 1.
if [[ ($# -ne 2 && $# -ne 1) ]] ; then
      echo "Usage: "$0" <DML script path> (<Arguments>)"
      exit 2
fi


source systemds_cluster.config

aws s3 cp $1 s3://${BUCKET} --exclude "*" --include "*.dml"

if [ ! -z "$2" ]
then
  args="-args,${2}"
fi

dml_filename=$(basename $1)

STEP_INFO=$(aws emr add-steps --cluster-id $CLUSTER_ID  --region $REGION --steps "Type=Spark,
  Name='SystemDS Spark Program',
  ActionOnFailure=CONTINUE,
  Args=[
        --deploy-mode,$SPARK_DEPLOY_MODE,
        --master,yarn,
        --driver-memory,$SPARK_DRIVER_MEMORY,
        --num-executors,$SPARK_NUM_EXECUTORS,
        --conf,spark.driver.maxResultSize=0,
        $SYSTEMDS_JAR_PATH, -f, s3://$BUCKET/$dml_filename, -exec, $SYSTEMDS_EXEC_MODE,$args,-stats, -explain]")

STEP_ID=$(echo $STEP_INFO | jq .StepIds | tr -d '"' | tr -d ']' | tr -d '[' | tr -d '[:space:]' )
echo "Waiting for the step to finish"
aws emr wait step-complete --cluster-id $CLUSTER_ID --step-id $STEP_ID --region $REGION

aws emr ssh --cluster-id $CLUSTER_ID --key-pair-file ${KEYPAIR_NAME}.pem --region $REGION --command "cat /mnt/var/log/hadoop/steps/$STEP_ID/stderr"
aws emr ssh --cluster-id $CLUSTER_ID --key-pair-file ${KEYPAIR_NAME}.pem --region $REGION --command "cat /mnt/var/log/hadoop/steps/$STEP_ID/stdout"

@ECHO OFF
::-------------------------------------------------------------
::
:: Licensed to the Apache Software Foundation (ASF) under one
:: or more contributor license agreements.  See the NOTICE file
:: distributed with this work for additional information
:: regarding copyright ownership.  The ASF licenses this file
:: to you under the Apache License, Version 2.0 (the
:: "License"); you may not use this file except in compliance
:: with the License.  You may obtain a copy of the License at
:: 
::   http://www.apache.org/licenses/LICENSE-2.0
:: 
:: Unless required by applicable law or agreed to in writing,
:: software distributed under the License is distributed on an
:: "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
:: KIND, either express or implied.  See the License for the
:: specific language governing permissions and limitations
:: under the License.
::
::-------------------------------------------------------------

setLocal EnableDelayedExpansion

:: directory to write test case specific data
SET TEMP=\temp\systemds_test

:: should this test suite continue after encountering an error? true false
SET CONTINUE_ON_ERROR=true

:: expecting this test script to be in directory %PROJECT_ROOT_DIR%\src\test\scripts
SET TEST_SCRIPT_REL_DIR=src\test\scripts

:: expecting the run script to be in directory %PROJECT_ROOT_DIR%\bin
SET RUN_SCRIPT=systemds-standalone.bat

:: the DML script with arguments we use to test the run script
SET DML_SCRIPT=genLinearRegressionData.dml
SET DML_SCRIPT_PATH=scripts\datagen
SET DML_OUTPUT=linRegData.csv
SET DML_ARGS=-nvargs numSamples=1000 numFeatures=50 maxFeatureValue=5 maxWeight=5 addNoise=FALSE b=0 sparsity=0.7 output=%DML_OUTPUT% format=csv perc=0.5
SET DML_SCRIPT_WITH_ARGS=%DML_SCRIPT% %DML_ARGS%

SET USER_DIR=%CD%

SET TEST_SCRIPT_PATH=%~dp0
SET TEST_SCRIPT_PATH=%TEST_SCRIPT_PATH:~0,-1%

SET PROJECT_ROOT_DIR=!TEST_SCRIPT_PATH:%TEST_SCRIPT_REL_DIR%=!
SET PROJECT_ROOT_DIR=%PROJECT_ROOT_DIR:~0,-1%

IF "%TEST_SCRIPT_PATH%"=="%PROJECT_ROOT_DIR%" (
    echo This test script "%~nx0" is expected to be located in folder "%TEST_SCRIPT_REL_DIR%" under the project root.
    echo Please update "%0" and correctly set the variable "TEST_SCRIPT_REL_DIR".
)
IF NOT EXIST "%PROJECT_ROOT_DIR%\bin\%RUN_SCRIPT%" (
  echo Could not find "bin\%RUN_SCRIPT%" in the project root directory. If the actual path of the run script is not "bin\%RUN_SCRIPT%", or if the actual project root directory is not "%PROJECT_ROOT_DIR%", please update this test script "%0".
  GOTO End
)

SET DATE_TIME=%date:/=-%-%time::=-%
SET DATE_TIME=%DATE_TIME: =-%
SET TEST_LOG="%PROJECT_ROOT_DIR%\Temp\test_runScript_%DATE_TIME%.log"

:: test setup

SET FAILED_TESTS=

IF NOT EXIST "%TEMP%" mkdir "%TEMP%"
IF NOT EXIST "%PROJECT_ROOT_DIR%\temp" mkdir "%PROJECT_ROOT_DIR%\temp"


:: start the test cases

echo Writing test log to file %TEST_LOG%.

:: invoke the run script from the project root directory

SET CURRENT_TEST=Test_root__DML_script_with_path
(
    echo Running test "%CURRENT_TEST%"
    echo Running test "%CURRENT_TEST%"                             >> %TEST_LOG%
    cd "%PROJECT_ROOT_DIR%"
    del /F /Q "%DML_OUTPUT%"                                       >  nul        2>&1
    del /F /Q "temp\%DML_OUTPUT%"                                  >  nul        2>&1
    call bin\%RUN_SCRIPT% %DML_SCRIPT_PATH%\%DML_SCRIPT_WITH_ARGS% >> %TEST_LOG% 2>&1
    IF ERRORLEVEL 1                  SET FAILED_TESTS=%FAILED_TESTS% %CURRENT_TEST% &                            IF "%CONTINUE_ON_ERROR%"=="false" GOTO Failure
    IF EXIST "%DML_OUTPUT%"          SET FAILED_TESTS=%FAILED_TESTS% %CURRENT_TEST%-outputdata-in-project-root & IF "%CONTINUE_ON_ERROR%"=="false" GOTO Failure
    IF NOT EXIST "temp\%DML_OUTPUT%" SET FAILED_TESTS=%FAILED_TESTS% %CURRENT_TEST%-missing-outputdata &         IF "%CONTINUE_ON_ERROR%"=="false" GOTO Failure
)

SET CURRENT_TEST=Test_root__DML_script_file_name
(
    echo Running test "%CURRENT_TEST%"
    echo Running test "%CURRENT_TEST%"            >> %TEST_LOG%
    cd "%PROJECT_ROOT_DIR%"
    del /F /Q "%DML_OUTPUT%"                      >  nul        2>&1
    del /F /Q "temp\%DML_OUTPUT%"                 >  nul        2>&1
    call bin\%RUN_SCRIPT% %DML_SCRIPT_WITH_ARGS%  >> %TEST_LOG% 2>&1
    IF ERRORLEVEL 1                  SET FAILED_TESTS=%FAILED_TESTS% %CURRENT_TEST% &                            IF "%CONTINUE_ON_ERROR%"=="false" GOTO Failure
    IF EXIST "%DML_OUTPUT%"          SET FAILED_TESTS=%FAILED_TESTS% %CURRENT_TEST%-outputdata-in-project-root & IF "%CONTINUE_ON_ERROR%"=="false" GOTO Failure
    IF NOT EXIST "temp\%DML_OUTPUT%" SET FAILED_TESTS=%FAILED_TESTS% %CURRENT_TEST%-missing-outputdata &         IF "%CONTINUE_ON_ERROR%"=="false" GOTO Failure
)


:: invoke the run script from the bin directory

SET CURRENT_TEST=Test_bin__DML_script_with_path
(
    echo Running test "%CURRENT_TEST%"
    echo Running test "%CURRENT_TEST%"                             >> %TEST_LOG%
    cd "%PROJECT_ROOT_DIR%\bin"
    del /F /Q "%DML_OUTPUT%"                                       >  nul         2>&1
    del /F /Q "..\temp\%DML_OUTPUT%"                               >  nul         2>&1
    call %RUN_SCRIPT% ..\%DML_SCRIPT_PATH%\%DML_SCRIPT_WITH_ARGS%  >> %TEST_LOG%  2>&1
    IF ERRORLEVEL 1                     SET FAILED_TESTS=%FAILED_TESTS% %CURRENT_TEST% &                          IF "%CONTINUE_ON_ERROR%"=="false" GOTO Failure
    IF EXIST "%DML_OUTPUT%"             SET FAILED_TESTS=%FAILED_TESTS% %CURRENT_TEST%-outputdata-in-bin-folder & IF "%CONTINUE_ON_ERROR%"=="false" GOTO Failure
    IF NOT EXIST "..\temp\%DML_OUTPUT%" SET FAILED_TESTS=%FAILED_TESTS% %CURRENT_TEST%-missing-outputdata &       IF "%CONTINUE_ON_ERROR%"=="false" GOTO Failure
)


SET CURRENT_TEST=Test_bin__DML_script_file_name
(
    echo Running test "%CURRENT_TEST%"
    echo Running test "%CURRENT_TEST%"        >> %TEST_LOG%
    cd "%PROJECT_ROOT_DIR%\bin"
    echo Working directory: %CD%              >> %TEST_LOG%
    del /F /Q "%DML_OUTPUT%"                  >  nul         2>&1
    del /F /Q "..\temp\%DML_OUTPUT%"          >  nul         2>&1
    call %RUN_SCRIPT% %DML_SCRIPT_WITH_ARGS%  >> %TEST_LOG%  2>&1
    IF ERRORLEVEL 1                     SET FAILED_TESTS=%FAILED_TESTS% %CURRENT_TEST% &                          IF "%CONTINUE_ON_ERROR%"=="false" GOTO Failure
    IF EXIST "%DML_OUTPUT%"             SET FAILED_TESTS=%FAILED_TESTS% %CURRENT_TEST%-outputdata-in-bin-folder & IF "%CONTINUE_ON_ERROR%"=="false" GOTO Failure
    IF NOT EXIST "..\temp\%DML_OUTPUT%" SET FAILED_TESTS=%FAILED_TESTS% %CURRENT_TEST%-missing-outputdata &       IF "%CONTINUE_ON_ERROR%"=="false" GOTO Failure
)



:: invoke the run script from a working directory outside of the project root

SET CURRENT_TEST=Test_out__DML_script_with_path
(
    echo Running test "%CURRENT_TEST%"
    echo Running test "%CURRENT_TEST%" >> %TEST_LOG%
    cd "%TEMP%"
    echo Working directory: %CD%       >> %TEST_LOG%
    del /F /Q "%DML_OUTPUT%"           >  nul 2>&1
    call "%PROJECT_ROOT_DIR%\bin\%RUN_SCRIPT%" "%PROJECT_ROOT_DIR%\%DML_SCRIPT_PATH%\%DML_SCRIPT%" %DML_ARGS%  >> %TEST_LOG%  2>&1
    IF ERRORLEVEL 1             SET FAILED_TESTS=%FAILED_TESTS% %CURRENT_TEST% &                    IF "%CONTINUE_ON_ERROR%"=="false" GOTO Failure
    IF NOT EXIST "%DML_OUTPUT%" SET FAILED_TESTS=%FAILED_TESTS% %CURRENT_TEST%-missing-outputdata & IF "%CONTINUE_ON_ERROR%"=="false" GOTO Failure
)

SET CURRENT_TEST=Test_out__DML_script_file_name
(
    echo Running test "%CURRENT_TEST%"
    echo Running test "%CURRENT_TEST%"                                 >> %TEST_LOG%
    cd "%TEMP%"
    echo Working directory: %CD%                                       >> %TEST_LOG%
    del /F /Q "%DML_OUTPUT%"                                           >  nul         2>&1
    call "%PROJECT_ROOT_DIR%\bin\%RUN_SCRIPT%" %DML_SCRIPT_WITH_ARGS%  >> %TEST_LOG%  2>&1
    IF ERRORLEVEL 1             SET FAILED_TESTS=%FAILED_TESTS% %CURRENT_TEST% &                    IF "%CONTINUE_ON_ERROR%"=="false" GOTO Failure
    IF NOT EXIST "%DML_OUTPUT%" SET FAILED_TESTS=%FAILED_TESTS% %CURRENT_TEST%-missing-outputdata & IF "%CONTINUE_ON_ERROR%"=="false" GOTO Failure
)



:: test again from a directory with spaces in path name

SET "SPACE_DIR=%TEMP%\Space Folder\SystemDS"

IF NOT EXIST "%SPACE_DIR%" (
    echo mkdir "%SPACE_DIR%" >> %TEST_LOG%
    mkdir "%SPACE_DIR%"
)

echo Copying project contents from "%PROJECT_ROOT_DIR%" to "%SPACE_DIR%"  >> %TEST_LOG%
robocopy "%PROJECT_ROOT_DIR%" "%SPACE_DIR%" /S /nfl /ndl /xf *.java Test*.* /xd .git .idea .settings  >> %TEST_LOG%


:: invoke the run script from the project root directory

SET CURRENT_TEST=Test_space_root__DML_script_with_path
(
    echo Running test "%CURRENT_TEST%"
    echo Running test "%CURRENT_TEST%"                              >> %TEST_LOG%
    cd "%SPACE_DIR%"
    echo Working directory: %CD%                                    >> %TEST_LOG%
    del /F /Q "%DML_OUTPUT%"                                        >  nul         2>&1
    del /F /Q "temp\%DML_OUTPUT%"                                   >  nul         2>&1
    call bin\%RUN_SCRIPT% %DML_SCRIPT_PATH%\%DML_SCRIPT_WITH_ARGS%  >> %TEST_LOG%  2>&1
    IF ERRORLEVEL 1                  SET FAILED_TESTS=%FAILED_TESTS% %CURRENT_TEST% &                            IF "%CONTINUE_ON_ERROR%"=="false" GOTO Failure
    IF EXIST "%DML_OUTPUT%"          SET FAILED_TESTS=%FAILED_TESTS% %CURRENT_TEST%-outputdata-in-project-root & IF "%CONTINUE_ON_ERROR%"=="false" GOTO Failure
    IF NOT EXIST "temp\%DML_OUTPUT%" SET FAILED_TESTS=%FAILED_TESTS% %CURRENT_TEST%-missing-outputdata &         IF "%CONTINUE_ON_ERROR%"=="false" GOTO Failure
)

SET CURRENT_TEST=Test_space_root__DML_script_file_name
(
    echo Running test "%CURRENT_TEST%"
    echo Running test "%CURRENT_TEST%"            >> %TEST_LOG%
    cd "%SPACE_DIR%"
    echo Working directory: %CD%                  >> %TEST_LOG%
    del /F /Q "%DML_OUTPUT%"                      >  nul         2>&1
    del /F /Q "temp\%DML_OUTPUT%"                 >  nul         2>&1
    call bin\%RUN_SCRIPT% %DML_SCRIPT_WITH_ARGS%  >> %TEST_LOG%  2>&1
    IF ERRORLEVEL 1                  SET FAILED_TESTS=%FAILED_TESTS% %CURRENT_TEST% &                            IF "%CONTINUE_ON_ERROR%"=="false" GOTO Failure
    IF EXIST "%DML_OUTPUT%"          SET FAILED_TESTS=%FAILED_TESTS% %CURRENT_TEST%-outputdata-in-project-root & IF "%CONTINUE_ON_ERROR%"=="false" GOTO Failure
    IF NOT EXIST "temp\%DML_OUTPUT%" SET FAILED_TESTS=%FAILED_TESTS% %CURRENT_TEST%-missing-outputdata &         IF "%CONTINUE_ON_ERROR%"=="false" GOTO Failure
)


:: invoke the run script from the bin directory

SET CURRENT_TEST=Test_space_bin__DML_script_with_path
(
    echo Running test "%CURRENT_TEST%"
    echo Running test "%CURRENT_TEST%"                             >> %TEST_LOG%
    cd "%SPACE_DIR%\bin"
    echo Working directory: %CD%                                   >> %TEST_LOG%
    del /F /Q "%DML_OUTPUT%"                                       >  nul         2>&1
    del /F /Q "..\temp\%DML_OUTPUT%"                               >  nul         2>&1
    call %RUN_SCRIPT% ..\%DML_SCRIPT_PATH%\%DML_SCRIPT_WITH_ARGS%  >> %TEST_LOG%  2>&1
    IF ERRORLEVEL 1                     SET FAILED_TESTS=%FAILED_TESTS% %CURRENT_TEST% &                          IF "%CONTINUE_ON_ERROR%"=="false" GOTO Failure
    IF EXIST "%DML_OUTPUT%"             SET FAILED_TESTS=%FAILED_TESTS% %CURRENT_TEST%-outputdata-in-bin-folder & IF "%CONTINUE_ON_ERROR%"=="false" GOTO Failure
    IF NOT EXIST "..\temp\%DML_OUTPUT%" SET FAILED_TESTS=%FAILED_TESTS% %CURRENT_TEST%-missing-outputdata &       IF "%CONTINUE_ON_ERROR%"=="false" GOTO Failure
)

SET CURRENT_TEST=Test_space_bin__DML_script_file_name
(
    echo Running test "%CURRENT_TEST%"
    echo Running test "%CURRENT_TEST%"        >> %TEST_LOG%
    cd "%SPACE_DIR%\bin"
    echo Working directory: %CD%              >> %TEST_LOG%
    del /F /Q "%DML_OUTPUT%"                  >  nul         2>&1
    del /F /Q "..\temp\%DML_OUTPUT%"          >  nul         2>&1
    call %RUN_SCRIPT% %DML_SCRIPT_WITH_ARGS%  >> %TEST_LOG%  2>&1
    IF ERRORLEVEL 1                     SET FAILED_TESTS=%FAILED_TESTS% %CURRENT_TEST% &                          IF "%CONTINUE_ON_ERROR%"=="false" GOTO Failure
    IF EXIST "%DML_OUTPUT%"             SET FAILED_TESTS=%FAILED_TESTS% %CURRENT_TEST%-outputdata-in-bin-folder & IF "%CONTINUE_ON_ERROR%"=="false" GOTO Failure
    IF NOT EXIST "..\temp\%DML_OUTPUT%" SET FAILED_TESTS=%FAILED_TESTS% %CURRENT_TEST%-missing-outputdata &       IF "%CONTINUE_ON_ERROR%"=="false" GOTO Failure
)


:: invoke the run script from a working directory outside of the project root

SET CURRENT_TEST=Test_space_out__DML_script_with_path
(
    echo Running test "%CURRENT_TEST%":
    echo Running test "%CURRENT_TEST%" >> %TEST_LOG%
    cd "%TEMP%"
    echo Working directory: %CD%       >> %TEST_LOG%
    del /F /Q "%DML_OUTPUT%"           >  nul 2>&1
    call "%SPACE_DIR%\bin\%RUN_SCRIPT%" "%SPACE_DIR%\%DML_SCRIPT_PATH%\%DML_SCRIPT%" %DML_ARGS%  >> %TEST_LOG%  2>&1
    IF ERRORLEVEL 1             SET FAILED_TESTS=%FAILED_TESTS% %CURRENT_TEST% &                    IF "%CONTINUE_ON_ERROR%"=="false" GOTO Failure
    IF NOT EXIST "%DML_OUTPUT%" SET FAILED_TESTS=%FAILED_TESTS% %CURRENT_TEST%-missing-outputdata & IF "%CONTINUE_ON_ERROR%"=="false" GOTO Failure
)

SET CURRENT_TEST=Test_space_out__DML_script_file_name
(
    echo Running test "%CURRENT_TEST%":
    echo Running test "%CURRENT_TEST%"                          >> %TEST_LOG%
    cd "%TEMP%"
    echo Working directory: %CD%                                >> %TEST_LOG%
    del /F /Q "%DML_OUTPUT%"                                    >  nul         2>&1
    call "%SPACE_DIR%\bin\%RUN_SCRIPT%" %DML_SCRIPT_WITH_ARGS%  >> %TEST_LOG%  2>&1
    IF ERRORLEVEL 1             SET FAILED_TESTS=%FAILED_TESTS% %CURRENT_TEST% &                    IF "%CONTINUE_ON_ERROR%"=="false" GOTO Failure
    IF NOT EXIST "%DML_OUTPUT%" SET FAILED_TESTS=%FAILED_TESTS% %CURRENT_TEST%-missing-outputdata & IF "%CONTINUE_ON_ERROR%"=="false" GOTO Failure
)






:Check_results


IF "%FAILED_TESTS%"=="" GOTO Success


:Failure
ECHO ================================================================================
ECHO Failed test cases: [%FAILED_TESTS%]
GOTO Cleanup


:Success
ECHO ================================================================================
ECHO Tests succeeded.
GOTO Cleanup


:Cleanup
cd %USER_DIR%
IF EXIST "%TEMP%" ( rmdir /Q /S "%TEMP%" )
GOTO End


:End
echo Test log was written to file %TEST_LOG%.

#!/usr/bin/env bash
#-------------------------------------------------------------
#
# Licensed to the Apache Software Foundation (ASF) under one
# or more contributor license agreements.  See the NOTICE file
# distributed with this work for additional information
# regarding copyright ownership.  The ASF licenses this file
# to you under the Apache License, Version 2.0 (the
# "License"); you may not use this file except in compliance
# with the License.  You may obtain a copy of the License at
#
#   http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing,
# software distributed under the License is distributed on an
# "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
# KIND, either express or implied.  See the License for the
# specific language governing permissions and limitations
# under the License.
#
#-------------------------------------------------------------

gcc_toolkit="libgcc_s.so\|libm.so\|libstdc++\|libc.so\|libdl.so\|libgomp.so\|libpthread.so"
linux_loader="linux-vdso.so\|ld-linux-x86-64.so"
intel_mkl="libmkl_rt.so"

echo "Build MKL:"

# configure and compile INTEL MKL
cmake . -B INTEL -DUSE_INTEL_MKL=ON -DCMAKE_BUILD_TYPE=Release -DCMAKE_CXX_COMPILER=g++ -DCMAKE_CXX_FLAGS="-DUSE_GNU_THREADING -m64"
cmake --build INTEL --target install --config Release
patchelf --add-needed libmkl_rt.so lib/libsystemds_mkl-Linux-x86_64.so
rm -R INTEL

echo ""

echo "Non-standard dependencies for libsystemds_mkl-linux-x86_64.so"
ldd lib/libsystemds_mkl-Linux-x86_64.so | grep -v $gcc_toolkit"\|$linux_loader\|"$intel_mkl

echo ""

echo "Sucessfull install of MKL"

#!/usr/bin/env bash
#-------------------------------------------------------------
#
# Licensed to the Apache Software Foundation (ASF) under one
# or more contributor license agreements.  See the NOTICE file
# distributed with this work for additional information
# regarding copyright ownership.  The ASF licenses this file
# to you under the Apache License, Version 2.0 (the
# "License"); you may not use this file except in compliance
# with the License.  You may obtain a copy of the License at
#
#   http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing,
# software distributed under the License is distributed on an
# "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
# KIND, either express or implied.  See the License for the
# specific language governing permissions and limitations
# under the License.
#
#-------------------------------------------------------------

MVN=mvn
PUBLISH_PROFILES="-Pdistribution,rat"
DRY_RUN=-DdryRun=true
GPG_PASSPHRASE=$1
RELEASE_TAG=v2.0
RELEASE_STAGING_LOCATION="/c/virtual\ D/SystemDS/systemds/temp"
BASE_DIR="/c/virtual\ D/SystemDS/systemds"
RELEASE_WORK_DIR="/c/virtual\ D/SystemDS/systemds/target/release2"
RELEASE_VERSION=2.0
RELEASE_RC=rc1
GIT_REF=-master
export GNUPGHOME="../../.gnupg_copy/" #relative path

function checkout_code {
    # Checkout code
    eval rm -rf $RELEASE_WORK_DIR
    eval mkdir -p $RELEASE_WORK_DIR
    eval cd $RELEASE_WORK_DIR
    git clone https://github.com/apache/systemds.git
    cd systemds
    git checkout $GIT_REF
    git_hash=`git rev-parse --short HEAD`
    echo "Checked out SystemDS git hash $git_hash"

    git clean -d -f -x
    #rm .gitignore
    #rm -rf .git

    eval cd "$BASE_DIR" #return to base dir
}


echo "Preparing release $RELEASE_VERSION"
# Checkout code
#checkout_code
eval cd $RELEASE_WORK_DIR/systemds

#Deploy to apache maven repo.
#settings.xml in maven home contains the username/passwd corresponding to ID apache.release.hattps
mvn -X -DaltDeploymentRepository=apache.releases.https::default::https://repository.apache.org/service/local/staging/deploy/maven2 \
clean package gpg:sign install:install deploy:deploy \
-DskiptTests -Darguments="-DskipTests -Dgpg.passphrase=\"$GPG_PASSPHRASE\"" -Dgpg.passphrase="$GPG_PASSPHRASE" $PUBLISH_PROFILES \

exit 0

#!/usr/bin/env bash
#-------------------------------------------------------------
#
# Licensed to the Apache Software Foundation (ASF) under one
# or more contributor license agreements.  See the NOTICE file
# distributed with this work for additional information
# regarding copyright ownership.  The ASF licenses this file
# to you under the Apache License, Version 2.0 (the
# "License"); you may not use this file except in compliance
# with the License.  You may obtain a copy of the License at
#
#   http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing,
# software distributed under the License is distributed on an
# "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
# KIND, either express or implied.  See the License for the
# specific language governing permissions and limitations
# under the License.
#
#-------------------------------------------------------------

# This shell script compiles the required shared libraries for 64-bit Linux on x86 machine

# yum whatprovides libgcc_s.so.1
# GNU Standard C++ Library: libstdc++.so.6
# GCC version 4.8 shared support library: libgcc_s.so.1
# The GNU libc libraries: libm.so.6, libdl.so.2, libc.so.6, libpthread.so.0
# GCC OpenMP v3.0 shared support library: libgomp.so.1
gcc_toolkit="libgcc_s.so\|libm.so\|libstdc++\|libc.so\|libdl.so\|libgomp.so\|libpthread.so"
linux_loader="linux-vdso.so\|ld-linux-x86-64.so"
intel_mkl="libmkl_rt.so"

# Fortran runtime: libgfortran.so.3
# GCC __float128 shared support library: libquadmath.so.0
openblas="libopenblas.so\|libgfortran.so\|libquadmath.so"

date

if ! [ -x "$(command -v cmake)" ]; then
  echo 'Error: cmake is not installed.' >&2
  exit 1
fi

if ! [ -x "$(command -v patchelf)" ]; then
  echo 'Error: patchelf is not installed.' >&2
  exit 1
fi

mkdir -p log

./build_mkl.sh > log/mkl_build.log  2>&1 & 
./build_BLAS.sh > log/BLAS_build.log 2>&1 &
./build_HE.sh > log/HE_build.log 2>&1 &
wait

if grep -q "Could NOT find MKL" log/mkl_build.log; then 
  echo "WARN: Missing MKL"
elif grep -q "Sucessfull install of MKL" log/mkl_build.log; then 
  echo "INFO: Sucessfull install of MKL"
else 
  cat log/mkl_build.log
fi

if grep -q "Could not find OpenBLAS lib" log/BLAS_build.log; then 
  echo "WARN: Missing OpenBLAS"
elif grep -q "Sucessfull install of OpenBLAS" log/BLAS_build.log; then 
  echo "INFO: Sucessfull install of OpenBLAS"
else 
  echo "ERROR: OpenBLAS install failed:"
  cat log/BLAS_build.log
fi

if grep -q 'Could not find a package configuration file provided by "SEAL"' log/HE_build.log; then
  echo "WARN: Missing SEAL install"
  echo "\
wget -qO- https://github.com/microsoft/SEAL/archive/refs/tags/v3.7.0.tar.gz | tar xzf - \
&& cd SEAL-3.7.0 \
&& cmake -S . -B build -DBUILD_SHARED_LIBS=ON \
&& cmake --build build \
&& cmake --install build"
elif grep -q "Sucessfull install of Homomorphic Encryption Liberary SEAL" log/HE_build.log; then 
  echo "INFO: Sucessfull install of HE SEAL"
else 
  cat log/HE_build.log
fi 

date

<!--
{% comment %}
Licensed to the Apache Software Foundation (ASF) under one or more
contributor license agreements.  See the NOTICE file distributed with
this work for additional information regarding copyright ownership.
The ASF licenses this file to you under the Apache License, Version 2.0
(the "License"); you may not use this file except in compliance with
the License.  You may obtain a copy of the License at

http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
{% end comment %}
-->

# Contribution Guidelines and Standards for `SystemDS`

Thank you for contributing to SystemDS. :smile:

> The following are mostly guidelines, not rules. Use your best judgement, and
> feel free to propose changes to this doc.

Before contributing a pull request for [review](https://github.com/apache/systemds/pulls),
let's make sure the changes are consistent with the guidelines and coding style.

## General Guidelines and Philosophy for contribution

*   Inclusion of unit tests when contributing new features, will help
    1. prove that the code works correctly, and
    2. guard against future breaking changes.
*   Formatting changes can be handled in a separate PR.
    Example [`bf4ba16b`](https://github.com/apache/systemds/commit/bf4ba16b9aaa9afee20a3f1c03b0ff49c5346a9d)
*   New features (e.g., a new cutting edge machine learning algorithm) typically will
    live in [`scripts/staging`](./scripts/staging) or its equivalent folder for specific
    feature to get some airtime and sufficient testing before a decision is made regarding
    whether they are to migrated to the top-level.
*   When a new contribution is made to SystemDS, the maintenance burden is (by default)
    transferred to the SystemDS team. The benefit of the contribution is to be compared
    against the cost of maintaining the feature.

## Code Style

We suggest applying a code formatter to the written code. Generally, this is done automatically.

We have provided at profile for java located in [Codestyle File `./dev/CodeStyle.eclipse.xml`](dev/CodeStyle_eclipse.xml). This can be loaded in most editors e.g.:

- [Eclipse](https://stackoverflow.com/questions/10432538/eclipse-import-conf-xml-files#10433986)
- [IntelliJ](https://imagej.net/Eclipse_code_style_profiles_and_IntelliJ)
- [Visual Studio Code](https://stackoverflow.com/questions/46030629/need-to-import-eclipse-java-formatter-profile-in-visual-studio-code)

## Commit Style

SystemDS project has linear history throughout. Rebase cleanly and verify that the commit-SHA's
of the Apache Repo are not altered.
A general guideline is never to change a commit inside the systemds official repo, which is
the standard practice. If you have accidentally committed a functionality or tag, let others know.
And create a new commit to revert the functionality of the previous commit but **do not force push**.


### Tags

The tags can be used in combination to one another. These are the only tags available.

* `[MINOR]`: Small changesets with additional functionality

  > Examples:
  >
  > This commit makes small software updates with refactoring
  > 
  > [`030fdab3`](https://github.com/apache/systemds/commit/030fdab3ebe6dedc3b4bb860e0ec5acfd9c38e5d) - `[MINOR] Added package to R dependency; updated Docker test image`
  >
  > This commit cleans up the redundant code for simplification
  > 
  > [`f4fa5650`](https://github.com/apache/systemds/commit/f4fa565013de13270df05dd37610382ca80f7354) - `[MINOR][SYSTEMDS-43] Cleanup scale builtin function (readability)`
  >

* `[SYSTEMDS-#]`: A changeset which will a specific purpose such as a bug, Improvement, 
   New feature, etc. The tag value is found from [SystemDS jira issue tracker](https://issues.apache.org/jira/projects/SYSTEMDS/issues).
   
* `[DOC]` also `[DOCS]`: Changes to the documentation
  
* `[HOTFIX]`: Introduces changes into the already released versions.
    
    > Example:
    > 
    > This commit fixes the corrupted language path
    > 
    > [`87bc3584`](https://github.com/apache/systemds/commit/87bc3584db2148cf78b2d46418639e88ca27ec64) - `[HOTFIX] Fix validation of scalar-scalar binary min/max operations`
    >

> Protip:
> Addressing multiple jira issues in a single commit, `[SYSTEMDS-123,SYSTEMDS-124]` or `[SYSTEMDS-123][SYSTEMDS-124]`

### Commit description

A commit or PR description is a public record of **what** change is being made and **why**.

#### Structure of the description

##### First Line

1. A summary of what the changeset.
2. A complete sentence, crafted as though it was an order.
    - an imperative sentence
    - Writing the rest of the description as an imperative is optional.
3. Follow by an empty line.

##### Body

It consists of the following.

1. A brief description of the problem solved.
2. Why this is the best approach?.
3. Shortcomings to the approach, if any (important!).

Additional info

4. background information
   - bug/issue/jira numbers
   - benchmark/test results
   - links to design documents
   - code attributions
5. Include enough context for
   - reviewers
   - future readers to understand the Changes.
6. Add PR number, like `Closes #1000`.

The following is a commit description with all the points mentioned.

[`1abe9cb`](https://github.com/apache/systemds/commit/1abe9cb79d8001992f1c79ba5e638e6b423a1382)

Commit message:
```txt
[SYSTEMDS-418] Performance improvements lineage reuse probing/spilling

This patch makes some minor performance improvements to the lineage
reuse probing and cache put operations. Specifically, we now avoid
unnecessary lineage hashing and comparisons by using lists instead of
hash maps, move the time computations into the reuse path (to not affect
the code path without lineage reuse), avoid unnecessary branching, and
materialize the score of cache entries to avoid repeated computation
for the log N comparisons per add/remove/constaints operation.
For 100K iterations and ~40 ops per iteration, lineage tracing w/ reuse
improved from 41.9s to 38.8s (pure lineage tracing: 27.9s).
```

#### Good commit description

The following are some of the types of code changes with examples.

##### Functionality change

[`1101533`](https://github.com/apache/systemds/commit/1101533fd1b2be4e475a18052dbb4bc930bb05d9)

Commit message:
```txt
[SYSTEMDS-2603] New hybrid approach for lineage deduplication

This patch makes a major refactoring of the lineage deduplication
framework. This changes the design of tracing all the
distinct paths in a loop-body before the first iteration, to trace
during execution. The number of distinct paths grows exponentially
with the number of control flow statements. Tracing all the paths
in advance can be a huge waste and overhead.
We now trace an iteration during execution. We count the number of
distinct paths before the iterations start, and we stop tracing
once all the paths are traced. Tracing during execution fits
very well with our multi-level reuse infrastructure.
Refer to JIRA for detailed discussions.
```


##### Refactoring

> Refactoring is a series of behaviour preserving changes with restructuring to
> existing code body. Refactoring does not alter the external behaviour or the
> output of a function, but the internal changes to the function to keep the code
> more organized, readable or to accomodate a more complex functionality.


[`e581b5a`](https://github.com/apache/systemds/commit/e581b5a6248b56a70e18ffe6ba699e8142a2d679)

Commit message:
```txt
[SYSTEMDS-2575] Fix eval function calls (incorrect pinning of inputs)

This patch fixes an issue of indirect eval function calls where wrong
input variable names led to missing pinning of inputs and thus too eager
cleanup of these variables (which causes crashes if the inputs are used
in other operations of the eval call).
The fix is simple. We avoid such inconsistent construction and
invocation of fcall instructions by using a narrower interface and
constructing the materialized names internally in the fcall.
```

##### Small Changeset still needs some context.

[`7af2ae0`](https://github.com/apache/systemds/commit/7af2ae04f28ddcb36158719a25a7fa34b22d3266)

Commit message:
```txt
[MINOR] Update docker images organization

Changes the docker images to use the docker organization systemds
add install dependency for R dbScan
Change the tests to use the new organizations docker images

Closes #1008
```

> Protip: to reference other commits use first 7 letters of the commit SHA-1.
> eg. `1b81d8c` for referencing `1b81d8cb19d8da6d865b7fca5a095dd5fec8d209`

## License

Including a license at the top of new files helps validate the consistency of license.

Examples:

- [C/C++/cmake/cuda](./src/main/cpp/libmatrixdnn.h#L1-L18)
- [Python](./src/main/python/create_python_dist.py#L1-L21)
- [Java](./src/main/java/org/apache/sysds/api/ConfigurableAPI.java#L1-L18)
- [Bash](./src/main/bash/sparkDML2.sh#L2-L21)
- [XML/HTML](./src/assembly/bin.xml#L2-L19)
- [dml/R](./scripts/algorithms/ALS-CG.dml#L1-L20)
- [Makefile/.proto](./src/main/python/docs/Makefile#L1-L20)
- Markdown - refer to the top of this file in raw format.

> Note: Generated code, like the Java classes generated from the `.proto` file and other such files can be excluded if needed
> for license checks unless the code generation tools generate a new license header different from the required license.
___

Thanks again for taking your time to help improve SystemDS! :+1:
